/
CREATE OR REPLACE PACKAGE search_gth IS
FUNCTION ins_wait(hostid IN NUMBER, proto IN VARCHAR2, hname IN VARCHAR2, pathn IN VARCHAR2,opath IN VARCHAR2, depth_level IN NUMBER) RETURN INTEGER;
FUNCTION ins_norm(hostid IN NUMBER, proto IN VARCHAR2, hname IN VARCHAR2, pathn IN VARCHAR2,		   depth_level IN NUMBER) RETURN INTEGER;
PROCEDURE ins_unflag(hostid IN NUMBER);
END search_gth;
/
CREATE OR REPLACE PACKAGE BODY search_gth IS
c NUMBER;
FUNCTION ins_wait(hostid IN NUMBER, proto IN VARCHAR2, hname IN VARCHAR2, pathn IN VARCHAR2,opath IN VARCHAR2,depth_level IN NUMBER) RETURN INTEGER IS
  test	NUMBER;
  retval INTEGER:=0;
  CURSOR c1 IS SELECT host_id FROM search WHERE host_id=hostid AND path=pathn;
  CURSOR c2 IS SELECT host_id FROM search_urls WHERE host_id=hostid AND path=pathn;
BEGIN
   OPEN c1;
   FETCH c1 INTO test;
   IF c1%NOTFOUND THEN
     retval:=1;
     OPEN c2;
     FETCH c2 INTO test;
     IF c2%NOTFOUND THEN
       retval:=4;
       INSERT INTO search_urls (host_id,fid,prot,host,path,oldpath,flag,priority,depth)
	 VALUES (hostid,0,proto,hname,pathn,opath,'R',50,depth_level);
     END IF;
     CLOSE c2;
   END IF;
  CLOSE c1;
  RETURN retval;
END ins_wait;

FUNCTION ins_norm(hostid IN NUMBER, proto IN VARCHAR2, hname IN VARCHAR2, pathn IN VARCHAR2,		   depth_level IN NUMBER) RETURN INTEGER IS
  test	NUMBER;
  retval INTEGER:=0;
  CURSOR c1 IS SELECT host_id FROM search WHERE host_id=hostid AND path=pathn;
  CURSOR c2 IS SELECT host_id FROM search_urls WHERE host_id=hostid AND path=pathn;
  CURSOR c3 IS SELECT host_id FROM search_disallow
        WHERE host_id=hostid AND path=SUBSTR(pathn,1,LENGTH(path));
BEGIN
  OPEN c1;
  FETCH c1 INTO test;
  IF c1%NOTFOUND THEN
    retval:=1;
    OPEN c2;
    FETCH c2 INTO test;
    IF c2%NOTFOUND THEN
      retval:=2;
      OPEN c3;
      FETCH c3 INTO test;
          IF c3%NOTFOUND THEN
	    retval:=3;
            INSERT INTO search_urls (host_id,fid,prot,host,path,flag,priority,depth)
              VALUES (hostid,0,proto,hname,pathn,'0',50,depth_level);
          END IF;
      CLOSE c3;
    END IF;
    CLOSE c2;
  END IF;
  CLOSE c1;
  RETURN retval;
END ins_norm;


PROCEDURE ins_unflag(hostid IN NUMBER) IS
  test      NUMBER;
  rowid_var ROWID;
  path_var  VARCHAR(250);
  CURSOR c1(h_id NUMBER) IS
    SELECT rowid,path FROM search_urls WHERE host_id=h_id;
  CURSOR c2(h_id NUMBER, p_var VARCHAR) IS
    SELECT host_id FROM search_disallow 
      WHERE host_id=h_id AND path=SUBSTR(p_var,1,LENGTH(path));

  BEGIN
    OPEN c1(hostid);
    LOOP
      FETCH c1 INTO rowid_var,path_var;
      IF c1%NOTFOUND THEN 
	EXIT;
      END IF;
      OPEN c2(hostid,path_var);
      FETCH c2 INTO test;
      IF c2%NOTFOUND THEN
	UPDATE search_urls SET flag='0' WHERE rowid=rowid_var;
      ELSE
        DELETE FROM search_urls WHERE rowid=rowid_var;
      END IF;
      CLOSE c2;
    END LOOP;
    CLOSE c1;
  END;

END;
/

show errors;
/
