drop package infosearch;
/
create or replace package infosearch is

procedure info_search;
procedure search_button(op integer);
procedure by_size(typein varchar2);
procedure by_img(typein varchar2);
procedure by_link(typein varchar2);
procedure by_date(typein varchar2);
procedure parse_date(typein varchar2);
procedure date_search;
procedure more_date(total number,seed integer,day1 date, day2 date);
procedure day(str varchar2,result out date,tag in out char);
procedure search_action(typein varchar2, op integer);

procedure parse_input(typein varchar2);
procedure other_search(op integer);
procedure more_size(total number, seed integer, s1 number, s2 number,
		op integer);
procedure get_size(str varchar2, res out number, op integer);

procedure search_img;
procedure more_img(total number, seed integer, s1 number, s2 number);

procedure search_link;
procedure more_link(total number, seed integer, s1 number, s2 number);

function url(curl in varchar2, cname in varchar2) return varchar2;
function td(name varchar2) return varchar2;
function th(name varchar2) return varchar2;
function tr(name varchar2) return varchar2;

server_name varchar(100) := apollosearch.server_name;
cgi_bin varchar2(200) := server_name||'cgi-bin/wow/';

end;
/
show errors;

create or replace package body infosearch is


res_html search.no_html%TYPE;
res_imgs  search.no_imgs%TYPE;
res_date search.time%TYPE;
res_size search.fsize%TYPE;
res_host search.host1%TYPE;
res_path search.path%TYPE;
res_title search.title%TYPE;

two search%ROWTYPE;
TYPE wordstype IS TABLE	OF varchar2(50) INDEX BY BINARY_INTEGER;
word_tab wordstype;
w_count BINARY_INTEGER;
date_tag char(1);
h_caption varchar2(600);

word_tab1 wordstype;
word_count BINARY_INTEGER;
size_tag char(1);
size_words varchar2(100);

total number(8);
function url    (curl   in varchar2, cname   in varchar2) return varchar2 is
begin return('<a href="' || curl || '">' || cname || '</a>'); end;

function td(name varchar2) return varchar2 is
begin
	return ('<td>'||name||'</td>');
end;

function th(name varchar2) return varchar2 is
begin
	return ('<th>'||name||'</th>');
end;

function tr(name varchar2) return varchar2 is
begin
	return ('<tr>'||name||'</tr>');
end;


procedure info_search is
begin
   search_button(3);
end;

procedure search_button(op integer) is


begin
	htp.p('<body background="http://mira.npac.syr.edu:9898/apollo/grey_profile.jpg">');
/*	htp.p('<center><table><tr><td align=center>');
	htp.p('<img src="http://mira.npac.syr.edu:9898/apollo/fwelc1.gif"><br>');
	htp.p('<img src="http://mira.npac.syr.edu:9898/apollo/search.old.gif"><br>');
	htp.p('<a href="http://apollo.wes.hpc.mil/"><img src="http://mira.npac.syr.edu:9898/apollo/msrc.gif" border=0 alt="CEWES MSRC Server"></a>');
	htp.p('</td><td>&nbsp &nbsp &nbsp &nbsp</td><td><a href="http://apollo.wes.hpc.mil"><img src="http://mira.npac.syr.edu:9898/apollo/picture.gif" border=0 alt="Apollo Home" width=256></a></td></tr></table>');*/
htp.p('<center>');
 	htp.p('<form action="http://mira.npac.syr.edu:9898/apollo/cgi-bin/wow/infosearch.search_action" method="GET">');
	htp.p('Input:');
	htp.p('<input name="typein" size=30>');
	htp.p('<input type="submit" value="Go">');
	htp.p('<a href="http://mira.npac.syr.edu:9898/apollo/info_help.html">Help</a>');
	htp.p('<br>Search Type:');
	htp.p('<select name="op">');
	if (op = 0) then
		htp.p('<option value="0" selected>Size(KB)');
	else 
		htp.p('<option value="0">Size(KB)');
	end if;
	if (op = 1) then
		htp.p('<option value="1" selected>Imag Number');
	else
		htp.p('<option value="1">Imag Number');
	end if;
	if (op = 2) then
		htp.p('<option value="2" selected>Link Number');
	else
		htp.p('<option value="2">Link Number');
	end if;
	if (op =3) then
		htp.p('<option value="3" selected>Date');
	else
		htp.p('<option value="3">Date');
	end if;

	htp.p('</select></form>');
	htp.p('<img src="http://mira.npac.syr.edu:9898/apollo/wavy.gif"><br></center>');

end;	

procedure search_action(typein varchar2, op integer) is

begin

	if (op = 0) then
		by_size(typein);
	elsif (op = 1) then
		by_img(typein);
	elsif (op = 2) then
		by_link(typein);
	elsif (op = 3) then
		by_date(typein);
	end if;
end;

procedure by_size(typein varchar2) is

begin

	parse_input(typein);
	if (word_count = 0 ) then
		htp.p('Nothing');
	else
		search_button(0);
--		htp.p('<HR WIDTH="60%" ALIGN="CENTER">');
		other_search(0);
	end if;

end;

procedure parse_input(typein varchar2) is

words varchar2(300);
i integer := 1;
j integer;
n integer;
begin
	word_count := 0;
	words := typein;
	while ((words IS NOT NULL) and (substr(words,1,1) = ' ')) loop
			words := substr(words,2);
	end loop;
	if (words IS NULL) then
		return;
	end if;
	n := length(words);
	-- 46 = '.'; 48-57 = '0'-'9'
	while (i<=n and ((ascii(substr(words,i,1)) = 46) or (ascii(substr(words,i,1)) between 48 and 57))) loop
		i := i + 1;
	end loop;
	if (i = 1) then
		words := substr(words,2); 	
		while ((words IS NOT NULL) and not ((ascii(substr(words,i,1)) = 46) or (ascii(substr(words,1,1)) between 48 and 57))) loop
			words := substr(words,2);
		end loop;
		-- when i>n word_count=0 is used to indicate the null typein
		if (words IS NOT NULL) then
			size_tag := '<'; -- before one date
			n := length(words);
			i := 1;
			while (i<=n and ((ascii(substr(words,i,1)) = 46) or (ascii(substr(words,i,1)) between 48 and 57))) loop
				i := i + 1;
			end loop;
			word_count := word_count + 1;
			word_tab1(word_count) := substr(words,1,i-1);
		end if;
	elsif (i > n) then
		size_tag := 'o';	-- one date item only
		word_count := word_count + 1;
		word_tab1(word_count) := words;
	else
		word_count := word_count + 1;
		word_tab1(word_count) := substr(words,1,i-1);
		words := substr(words,i);
		n := length(words);
		i := 1;
		while (i<=n and not ((ascii(substr(words,i,1)) = 46) or (ascii(substr(words,i,1)) between 48 and 57))) loop
			i := i + 1;
		end loop;		
		if (i > n) then
			size_tag := '>';	-- after one date
		else
			size_tag := 'b';	-- between two date items	
			words := substr(words,i);
			n := length(words);
			i := 1;
			while (i<=n and ((ascii(substr(words,i,1)) = 46) or (ascii(substr(words,i,1)) between 48 and 57))) loop
				i := i + 1;
			end loop;
			word_count := word_count + 1;
			word_tab1(word_count) := substr(words,1,i-1);
		end if;
	end if;
end;


procedure other_search(op integer) is

cursor csize(s1 number, s2 number) is
	select fsize,no_html,no_imgs,time,host1,path,title
	from search
	where (fsize between s1 and s2)
	order by fsize asc;

size1 number(8,2);
size2 number(8,2);
num integer :=0;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	get_size(word_tab1(1),size1,op);
	if (size1 = -1) then return; end if;
	if (size_tag = 'b') then
		get_size(word_tab1(2),size2,op);
		if (size2 = -1 ) then return; end if;
		size_words := 'Between <b>'||size1||'(KB)</b> and <b>'||size2||'(KB) </b>';
	elsif (size_tag = 'o') then
		size2 := size1;
		size_words := ' <b>'||size1|| '</b>';
	elsif (size_tag = '>') then
		select max(round((fsize/1024),2)) into size2 from search;
		size_words := ' no less than <b>'||size1||'(KB) </b>';
	else
		size2 := size1;
		size1 := 0;
		size_words := ' no more than <b>'||size2||'(KB) </b>';
	end if;

	size1 := (1024 * size1); 
	size2 := (1024 * size2); 
	h_caption := ' Size is '||size_words||'(KB)';
	select count(*) into num from search where (fsize between size1 and size2);
	htp.p('<center>');
	htp.p('<caption>The Documents '||h_caption||'</caption></center>');
	htp.p('<hr><DL>');
	if (num = 0) then
		htp.p('<p>The document '||h_caption||' dose not exist!</cneter>');
	   	return;
	end if;
	total := num;
	if (total > 0) then
		 next := 21;
		if ( next<=total) then
                    if ((next+20)<=total) then
                        next_str := (next+19);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
                else
                    curr_str := total;
                end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
		    htp.p(' <b>|</b> <td align=right>');
		    htp.p(url(cgi_bin||'infosearch.more_size?total='
			||total||'&seed='||next||'&s1='||size1||
			'&s2='||size2||'&op='||op,'Next '||next_str));
		end if;
		htp.p('</table></center><dl>');

		open csize(size1,size2);
		num := 0;

		loop
		   fetch csize into res_size,res_html,res_imgs,res_date,res_host,res_path,res_title;
--	   	   fetch csize into two;
		   exit when csize%NOTFOUND;
		   num := num + 1;
		   htp.p('<p><dt>');
		   htp.p('<img src="'||server_name||'green_dot.gif"  border=0>'); 
		   htp.p('<a href="http://'||res_host||res_path||'">'||
			res_title||'</a><br>');
		   htp.p('<b>&nbsp  &nbsp &nbsp &nbsp  Size:&nbsp</b>'||round((res_size/1024),1)||'KB');
		   htp.p('<b> &nbsp &nbsp &nbsp Last Update:&nbsp </b>'||to_char(res_date,'mm/dd/yy'));
		   htp.p('<b> &nbsp &nbsp &nbsp Link Num.:&nbsp </b>'||res_html);
		   htp.p('<b> &nbsp &nbsp &nbsp Image Num.:&nbsp </b>'||res_imgs);
		   if ((num = 20) or (num >= total)) then
			exit;
		   end if;
--htp.p('fftt and size2='||size2);if (num = 11) then exit; end if;
	    	end loop;

		close csize;
		htp.p('</DL>');
		htp.p('<img src="http://mira.npac.syr.edu:9898/apollo/wavy.gif">');
		htp.p('<center>');
		htp.p(' p.');
       		n := ceil(total/20);
        	if (n > 20) then n := 20; end if;
		for i in 1..n loop
		   iseed := (i-1)*20 + 1;
		   if (iseed = 0 ) then
			htp.p(' '||i);
		   else
			htp.p(' '||url(cgi_bin||'infosearch.more_size?
				total='||total||'&seed='||iseed||'&s1='||
				size1||'&s2='||size2||'&op='||op,i));
		   end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||url(cgi_bin||'infosearch.more_size?total='
			||total||'&seed='||next||'&s1='||size1||'&s2='||
			size2||'&op='||op,'Next')||']');
		end if;
		htp.p('</center>');
	else
		htp.p('No Such Document Found');
	end if;

end;

procedure more_size(total number, seed integer, s1 number, s2 number,
			op integer) is

cursor csize(s1 number, s2 number) is
	select fsize,no_html,no_imgs,time,host1,path,title
	from search
	where (fsize between s1 and s2)
	order by fsize asc;

num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin

	search_button(op);
/*	h_caption := ' Size is '||size_words;
--	htp.p('<hr width=80%>');
	htp.p('<center>');
	htp.p('<caption>The Documents '||h_caption||'</caption></center>');*/
	htp.p('<hr><DL>');

	next := seed + 20;
	if (next<=total) then
                if ((next+20)<=total) then
                        next_str := (next+19);
                else
                        next_str := total;
                end if;
                next_str := next||'-'||next_str;
                curr_str := next - 1;
        else
                curr_str := total;
        end if;
        prev := seed - 20;
        if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
        elsif (seed > 1) then
                        prev := 1;
                        prev_str := '1-'|| 20;
        end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(url(cgi_bin||'infosearch.more_size?total='||total||
			'&seed='||next||'&s1='||s1||'&s2='||s2||
			'&op='||op,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(url(cgi_bin||'infosearch.more_size?total='||total||
			'&seed='||prev||'&s1='||s1||'&s2='||s2||
			'&op='||op,'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
	open csize(s1,s2);
	num := 0;
	loop
	   fetch csize into res_size,res_html,res_imgs,res_date,res_host,res_path,res_title;
--	   fetch csize into two;
	   exit when csize%NOTFOUND;
	   num := num + 1;
	   if (num >= seed) then
		   htp.p('<p><dt>');
		   htp.p('<img src="'||server_name||'green_dot.gif"  border=0>'); 
		   htp.p('<a href="http://'||res_host||res_path||'">'||
			res_title||'</a><br>');
		   htp.p('<b>&nbsp &nbsp &nbsp Size: &nbsp </b>'||round((res_size/1024),1)||'KB');
		   htp.p('<b>&nbsp &nbsp &nbsp Last Update: &nbsp </b>'||to_char(res_date,'mm/dd/yy'));
		   htp.p('<b>&nbsp &nbsp &nbsp Link Num.: &nbsp </b>'||res_html);
		   htp.p('<b>&nbsp &nbsp &nbsp Image Num.: &nbsp </b>'||res_imgs);
            end if;
	    if ( num >= (seed + 19) ) then
	    	exit;
	    end if;
	end loop;	

	close csize;
	htp.p('</DL>');
	htp.p('<img src="http://mira.npac.syr.edu:9898/apollo/wavy.gif">');
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/20);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
	   iseed := (i-1)*20 + 1;
	   if (iseed = 0 ) then
		htp.p(' '||i);
	   else
		htp.p(' '||url(cgi_bin||'infosearch.more_size?total='||
			total||'&seed='||iseed||'&s1='||s1||'&s2='||
			s2||'&op='||op,i));
	   end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||url(cgi_bin||'infosearch.more_size?total='
			||total||'&seed='||next||'&s1='||s1||'&s2='||
			s2||'&op='||op,'Next')||']');
	end if;
	htp.p('</center>');

end;

procedure get_size(str varchar2, res out number, op integer) is

i integer := 1;
dot_flag integer := 0;
string varchar2(100);
n integer;

begin

	string := str;
	n := length(string);
	if ( op = 0) then

		while (i <= n) loop
			if (substr(string,i,1) = '.') then
				dot_flag := dot_flag + 1;
			end if;
			if (dot_flag = 2) then exit; end if;
			i := i + 1;
		end loop;
	else
		while ((i<=n) and substr(string,i,1) != '.') loop
			i := i + 1;
		end loop;
	end if;
	res := to_number(substr(string,1,i-1));
end;


procedure by_img(typein varchar2) is

begin
	parse_input(typein);
	if (word_count = 0) then
		htp.p('Please input the search range!');
	else
		search_button(1);
--		htp.p('<HR WIDTH="60%" ALIGN="CENTER">');
--		other_search(1);
		search_img;
	end if;

end;

procedure search_img is

cursor cimg(s1 number,s2 number) is
	select fsize,no_html,no_imgs,time,host1,path,title
	from search
	where (no_imgs between s1 and s2)
	order by no_imgs desc;

size1 number(8);
size2 number(8);
num integer :=0;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;


begin

	get_size(word_tab1(1),size1,1); 
	if (size1 = -1) then return; end if;
	if (size_tag = 'b') then
		get_size(word_tab1(2),size2,1);
		if (size2 = -1 ) then return; end if;
		size_words := 'Between <b>'||size1||'</b> and <b>'||size2||'</b>';
	elsif (size_tag = 'o') then
		size2 := size1;
		size_words := ' <b>'||size1|| '</b>';
	elsif (size_tag = '>') then
		select max(no_imgs) into size2 from search;
		size_words := ' no less than <b>'||size1||'</b>';
	else
		size2 := size1;
		size1 := 0;
		size_words := ' no more than <b>'||size2||'</b>';
	end if;

	h_caption := ' Image Number is '||size_words;
	select count(*) into total from search where (no_imgs between size1 and size2);
	
	if (total = 0) then
		htp.p('<p>The document '||h_caption||' dose not exist!</cneter>');
	   	return;
	end if;
	htp.p('<center>');
	htp.p('<caption>The Documents '||h_caption||'</caption></center>');
	htp.p('<hr><DL>');
	if (total > 0) then
		next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
                else
                    curr_str := total;
                end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
		    htp.p(' <b>|</b> <td align=right>');
		    htp.p(url(cgi_bin||'infosearch.more_img?total='
			||total||'&seed='||next||'&s1='||size1||
			'&s2='||size2,'Next '||next_str));
		end if;
		htp.p('</table></center></DL><dl>');
		open cimg(size1,size2);
		loop
		   fetch cimg into res_size,res_html,res_imgs,res_date,res_host,res_path,res_title;
		   exit when cimg%NOTFOUND;
			
	           num := num + 1;
		   htp.p('<p><dt>');
		   htp.p('<img src="'||server_name||'green_dot.gif"  border=0>'); 
		   htp.p('<a href="http://'||res_host||res_path||'">'||
			res_title||'</a><br>');
		   htp.p('<b>&nbsp &nbsp &nbsp &nbsp Image Num.:&nbsp</b>'||res_imgs);
		   htp.p('<b> &nbsp &nbsp &nbsp Last Update:&nbsp</b>'||to_char(res_date,'mm/dd/yy'));
		   htp.p('<b> &nbsp &nbsp &nbsp Size:&nbsp</b>'||round((res_size/1024),1)||'KB');
		   htp.p('<b> &nbsp &nbsp &nbsp Link Num.:&nbsp</b>'||res_html);
		   if (num = 10) then
			exit;
		   end if;
		end loop;
		close cimg;
		htp.p('</DL>');
		htp.p('<img src="http://mira.npac.syr.edu:9898/apollo/wavy.gif">');
		htp.p('<center>');
		htp.p(' p.');
       		n := ceil(total/10);
        	if (n > 10) then n := 10; end if;
		for i in 1..n loop
		   iseed := (i-1)*10 + 1;
		   if (iseed = 0 ) then
			htp.p(' '||i);
		   else
			htp.p(' '||url(cgi_bin||'infosearch.more_img?
				total='||total||'&seed='||iseed||'&s1='||
				size1||'&s2='||size2,i));
		   end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||url(cgi_bin||'infosearch.more_img?total='
			||total||'&seed='||next||'&s1='||size1||'&s2='||
			size2,'Next')||']');
		end if;
		htp.p('</center>');
	else
		htp.p('No Such Document Found');
	end if;

end;

procedure more_img(total number, seed integer, s1 number, s2 number) is

cursor cimg(s1 number,s2 number) is
	select fsize,no_html,no_imgs,time,host1,path,title
	from search
	where (no_imgs between s1 and s2)
	order by no_imgs desc;

num integer:=0;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin

	search_button(1);
/*	h_caption := ' Image Number is '||size_words;
	htp.p('<hr width=80%>');
	htp.p('<center>');
	htp.p('<caption>The Documents '||h_caption||'</caption></center>');*/
	htp.p('<hr><DL>');

	next := seed + 10;
	if (next<=total) then
                if ((next+10)<=total) then
                        next_str := (next+9);
                else
                        next_str := total;
                end if;
                next_str := next||'-'||next_str;
                curr_str := next - 1;
        else
                curr_str := total;
        end if;
        prev := seed - 10;
        if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
        elsif (seed > 1) then
                        prev := 1;
                        prev_str := '1-'|| 10;
        end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(url(cgi_bin||'infosearch.more_img?total='||total||
			'&seed='||next||'&s1='||s1||'&s2='||s2
			,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(url(cgi_bin||'infosearch.more_img?total='||total||
			'&seed='||prev||'&s1='||s1||'&s2='||s2
			,'Prev '||prev_str));
	end if;
	htp.p('</table></center></DL><dl>');
	open cimg(s1,s2);
	num := 0;
	loop
	   fetch cimg into res_size,res_html,res_imgs,res_date,res_host,res_path,res_title;
	   exit when cimg%NOTFOUND;
	   num := num + 1;
	   if (num >= seed) then
		htp.p('<p><dt>');
		htp.p('<img src="'||server_name||'green_dot.gif"  border=0>'); 
		htp.p('<a href="http://'||res_host||res_path||'">'||
			res_title||'</a><br>');
		htp.p('<b>&nbsp &nbsp &nbsp &nbsp Image Num.:&nbsp</b>'||res_imgs);
		htp.p('<b>&nbsp &nbsp &nbsp Last Update:&nbsp</b>'||to_char(res_date,'mm/dd/yy'));
		htp.p('<b>&nbsp &nbsp &nbsp Size:&nbsp</b>'||round((res_size/1024),1)||'KB');
		htp.p('<b>&nbsp &nbsp &nbsp Link Num.:&nbsp</b>'||res_html);
		if ( num >= (seed + 9) ) then
	    		exit;
		end if;
--		htp.p('num='||num||'seed='||seed);
--if (num = seed + 2 ) then exit; end if;
	    end if;
	end loop;
	close cimg;
	htp.p('</DL>');
	htp.p('<img src="http://mira.npac.syr.edu:9898/apollo/wavy.gif">');
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 10) then n := 10; end if;
	for i in 1..n loop
	   iseed := (i-1)*10 + 1;
	   if (iseed = 0 ) then
		htp.p(' '||i);
	   else
		htp.p(' '||url(cgi_bin||'infosearch.more_img?total='||
			total||'&seed='||iseed||'&s1='||s1||'&s2='||
			s2,i));
	   end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||url(cgi_bin||'infosearch.more_img?total='
			||total||'&seed='||next||'&s1='||s1||'&s2='||
			s2,'Next')||']');
	end if;
	htp.p('</center>');

end;


		   
procedure by_link(typein varchar2) is

begin
	parse_input(typein);
	if (word_count = 0) then
		htp.p('Please input the search range!');
	else
		search_button(2);
--		htp.p('<HR WIDTH="60%" ALIGN="CENTER">');
		search_link;
	end if;

end;


procedure search_link is

cursor clink(s1 number,s2 number) is
	select fsize,no_html,no_imgs,time,host1,path,title
	from search
	where (no_html between s1 and s2)
	order by no_html desc;

size1 number(8);
size2 number(8);
num integer :=0;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;


begin

	get_size(word_tab1(1),size1,2); 
	if (size1 = -1) then return; end if;
	if (size_tag = 'b') then
		get_size(word_tab1(2),size2,2);
		if (size2 = -1 ) then return; end if;
		size_words := 'Between <b>'||size1||'</b> and <b>'||size2||'</b>';
	elsif (size_tag = 'o') then
		size2 := size1;
		size_words := ' <b>'||size1|| '</b>';
	elsif (size_tag = '>') then
		select max(no_html) into size2 from search;
		size_words := ' no less than <b>'||size1||'</b>';
	else
		size2 := size1;
		size1 := 0;
		size_words := ' no more than <b>'||size1||'</b>';
	end if;
	
	h_caption := ' Link Number is '||size_words;
	select count(*) into total from search where (no_html between size1 and size2);

	if (total = 0) then
		htp.p('<p>The document '||h_caption||' dose not exist!</cneter>');
	   	return;
	end if;
	htp.p('<center>');
	htp.p('<caption>The Documents '||h_caption||'</caption></center>');
	htp.p('<hr><DL>');
	if (total > 0) then
		next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
                else
                    curr_str := total;
                end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
		    htp.p(' <b>|</b> <td align=right>');
		    htp.p(url(cgi_bin||'infosearch.more_link?total='
			||total||'&seed='||next||'&s1='||size1||
			'&s2='||size2,
			'Next '||next_str));
		end if;
		htp.p('</table></center><dl>');
		open clink(size1,size2);
		loop
		   fetch clink into res_size,res_html,res_imgs,res_date,res_host,res_path,res_title;
		   exit when clink%NOTFOUND;
			
	           num := num + 1;
		   htp.p('<p><dt>');
		   htp.p('<img src="'||server_name||'green_dot.gif"  border=0>'); 
		   htp.p('<a href="http://'||res_host||res_path||'">'||
			res_title||'</a><br>');
		   htp.p('<b>&nbsp &nbsp &nbsp &nbsp Link Num.:&nbsp</b>'||res_html);
		   htp.p('<b>&nbsp &nbsp &nbsp Last Update:&nbsp</b>'||to_char(res_date,'mm/dd/yy'));
		   htp.p('<b>&nbsp &nbsp &nbsp Size:&nbsp</b>'||round((res_size/1024),1)||'KB');
		   htp.p('<b>&nbsp &nbsp &nbsp Image Num.:&nbsp</b>'||res_imgs);
		   if (num = 10) then
			exit;
		   end if;
		end loop;
		close clink;
		htp.p('</DL>');
		htp.p('<img src="http://mira.npac.syr.edu:9898/apollo/wavy.gif">');
		htp.p('<center>');
		htp.p(' p.');
       		n := ceil(total/10);
        	if (n > 10) then n := 10; end if;
		for i in 1..n loop
		   iseed := (i-1)*10 + 1;
		   if (iseed = 0 ) then
			htp.p(' '||i);
		   else
			htp.p(' '||url(cgi_bin||'infosearch.more_link?
				total='||total||'&seed='||iseed||'&s1='||
				size1||'&s2='||size2,i));
		   end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||url(cgi_bin||'infosearch.more_link?total='
			||total||'&seed='||next||'&s1='||size1||'&s2='||
			size2,'Next')||']');
		end if;
		htp.p('</center>');
	else
		htp.p('No Such Document Found');
	end if;

end;


procedure more_link(total number, seed integer, s1 number, s2 number) is

cursor clink(s1 number,s2 number) is
	select fsize,no_html,no_imgs,time,host1,path,title
	from search
	where (no_html between s1 and s2)
	order by no_html desc;

num integer:=0;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin

	search_button(2);
/*	if (size_tag = 'b') then
		size_words := 'Between <b>'||s1||'(KB)</b> and <b>'||s2||'(KB) </b>';
	elsif (size_tag = 'o') then
		size_words := ' <b>'||s1|| '</b>';
	elsif (size_tag = '>') then
		size_words := ' no less than <b>'||s1||'</b>';
	else
		size_words := ' no more than <b>'||s1||'</b>';
	end if;*/
/*	h_caption := ' Link Number is '||size_words;
--	htp.p('<hr width=80%>');
	htp.p('<center>');
	htp.p('<caption>The Documents '||h_caption||'</caption></center>');*/
	htp.p('<hr><DL>');

	next := seed + 10;
	if (next<=total) then
                if ((next+10)<=total) then
                        next_str := (next+9);
                else
                        next_str := total;
                end if;
                next_str := next||'-'||next_str;
                curr_str := next - 1;
        else
                curr_str := total;
        end if;
        prev := seed - 10;
        if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
        elsif (seed > 1) then
                        prev := 1;
                        prev_str := '1-'|| 10;
        end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(url(cgi_bin||'infosearch.more_link?total='||total||
			'&seed='||next||'&s1='||s1||'&s2='||s2
			,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(url(cgi_bin||'infosearch.more_link?total='||total||
			'&seed='||prev||'&s1='||s1||'&s2='||s2
			,'Prev '||prev_str));
	end if;
	htp.p('</table></center></DL><dl>');
	open clink(s1,s2);
	num := 0;
	loop
	   fetch clink into res_size,res_html,res_imgs,res_date,res_host,res_path,res_title;
	   exit when clink%NOTFOUND;
	   num := num + 1;
	   if (num >= seed) then
		htp.p('<p><dt>');
		htp.p('<img src="'||server_name||'green_dot.gif"  border=0>'); 
		htp.p('<a href="http://'||res_host||res_path||'">'||
			res_title||'</a><br>');
		htp.p('<b>&nbsp &nbsp &nbsp &nbsp Link Num.:&nbsp </b>'||res_html);
		htp.p('<b>&nbsp &nbsp &nbsp Last Update:&nbsp </b>'||to_char(res_date,'mm/dd/yy'));
		htp.p('<b>&nbsp &nbsp &nbsp Size:&nbsp </b>'||round((res_size/1024),1)||'KB');
		htp.p('<b>&nbsp &nbsp &nbsp Image Num.:&nbsp </b>'||res_imgs);
		if ( num >= (seed + 9) ) then
	    		exit;
		end if;
	    end if;
	end loop;
	close clink;
	htp.p('</DL>');
	htp.p('<img src="http://mira.npac.syr.edu:9898/apollo/wavy.gif">');
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 10) then n := 10; end if;
	for i in 1..n loop
	   iseed := (i-1)*10 + 1;
	   if (iseed = 0 ) then
		htp.p(' '||i);
	   else
		htp.p(' '||url(cgi_bin||'infosearch.more_link?total='||
			total||'&seed='||iseed||'&s1='||s1||'&s2='||
			s2,i));
	   end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||url(cgi_bin||'infosearch.more_link?total='
			||total||'&seed='||next||'&s1='||s1||'&s2='||
			s2,'Next')||']');
	end if;
	htp.p('</center>');

end;



procedure by_date(typein varchar2) is

begin

	parse_date(typein);

	if (w_count = 0) then
		htp.p('Please input the date range!');
	else
		search_button(3);
--		htp.p('<HR WIDTH="60%" ALIGN="CENTER">');
		date_search;
	end if;
end;

procedure parse_date(typein varchar2) is

words varchar2(300);
i integer := 1;
j integer;
n integer;
begin
	w_count := 0;
	words := typein;
	while ((words IS NOT NULL) and (substr(words,1,1) = ' ')) loop
			words := substr(words,2);
	end loop;
	if (words IS NULL) then
		return;
	end if;
	n := length(words);
	-- 47 = '/'; 48-57 = '0'-'9'
	while (i<=n and (ascii(substr(words,i,1)) between 47 and 57)) loop
		i := i + 1;
	end loop;
	if (i = 1) then
		words := substr(words,2); 	
		while ((words IS NOT NULL) and not (ascii(substr(words,1,1)) between 47 and 57)) loop
			words := substr(words,2);
		end loop;
		-- when i>n w_count=0 is used to indicate the null typein
		if (words IS NOT NULL) then
			date_tag := '<'; -- before one date
			n := length(words);
			i := 1;
			while (i<=n and (ascii(substr(words,i,1)) between 47 and 57)) loop
				i := i + 1;
			end loop;
			w_count := w_count + 1;
			word_tab(w_count) := substr(words,1,i-1);
		end if;
	elsif (i > n) then
		date_tag := 'o';	-- one date item only
		w_count := w_count + 1;
		word_tab(w_count) := words;
	else
		w_count := w_count + 1;
		word_tab(w_count) := substr(words,1,i-1);
		words := substr(words,i);
		n := length(words);
		i := 1;
		while (i<=n and not (ascii(substr(words,i,1)) between 47 and 57)) loop
			i := i + 1;
		end loop;		
		if (i > n) then
			date_tag := '>';	-- after one date
		else
			date_tag := 'b';	-- between two date items	
			words := substr(words,i);
			n := length(words);
			i := 1;
			while (i<=n and (ascii(substr(words,i,1)) between 47 and 57)) loop
				i := i + 1;
			end loop;
			w_count := w_count + 1;
			word_tab(w_count) := substr(words,1,i-1);
		end if;
	end if;
end;

procedure date_search is
cursor cdate(date1 date,date2 date) is
	select fsize,no_html,no_imgs,time,host1,path,title
	from search 
	where (time between date1 and date2)
	order by time desc;
day1 date;
day2 date;
tag char(1);
num integer := 0;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

words varchar2(100);
begin
	day(word_tab(1),day1,tag);

	if (day1 = NULL) then return; end if;
	if (date_tag = 'b') then
		day(word_tab(2),day2,tag);
		if (day2 = NULL) then return; end if;
	
		if (tag = 'y') then
			day2 := to_date('3112'||to_char(day2,'yyyy'),'ddmmyyyy');
		elsif (tag = 'm') then
			day2 := to_date(to_char(last_day(day2),'dd')||to_char(day2,'mmyyyy'),'ddmmyyyy');
		end if;
		words := 'Between <b>'||to_char(day1,'mm/dd/yyyy')||
			'</b> And <b>'||
			to_char(day2,'mm/dd/yyyy')||'</b>';
	
	elsif (date_tag = 'o') then
		if (tag = 'y') then
			day2 := to_date('3112'||to_char(day1,'yyyy'),'ddmmyyyy');
			words := 'in <b>'||to_char(day1,'yyyy')||'</b>';
		elsif (tag = 'm') then
			day2 := to_date(to_char(last_day(day1),'dd')||to_char(day1,'mmyyyy'),'ddmmyyyy');
			words := 'in <b>'||to_char(day1,'Month yyyy')||'</b>';
		else
			day2 := day1;
			words := 'on <b>'||to_char(day1,'mm/dd/yyyy')||'</b>';
		end if;
	elsif (date_tag = '>') then
	--	day2 := to_date('2050','yyyy');
		day2 := to_date(to_char(sysdate,'ddmmyyyy'),'ddmmyyyy');
		words := 'After <b>'||to_char(day1,'mm/dd/yyyy')||'</b>';
	else
		day2 := day1;
		day1 := to_date('01011985','ddmmyyyy');
		words := 'Before <b>'||to_char(day2,'mm/dd/yyyy')||'</b>';
	end if;
--	open cdate(day1,day2);
	h_caption := 'last updated  between <b>'||day1||'</b> and <b>'||
			day2||'</b>';

	htp.p('<center>');
--	htp.p('day1='||day1||'day2='||day2||'</center>');
	htp.p('<caption>The Documents '||h_caption||'</caption></center>');
	htp.p('<hr><DL>');
/*	loop

	   fetch cdate into two;
	   exit when cdate%NOTFOUND;
	   num := num + 1;
	end loop;*/
	select count(*) into num from search where (time between day1 and day2);
	if ( num =0 ) then
	    htp.p('<center>');
--	    htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/ringyel.gif">');
	    htp.p('<p>The document '||h_caption||' dose not exist!</cneter>'||day1||' and '|| day2);
	    return; 
	end if;
	total := num;
--	total := cdate%ROWCOUNT;
--	close cdate;
	if (total > 0 ) then  
		next := 21;
		if ( next<=total) then
                    if ((next+20)<=total) then
                        next_str := (next+19);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
                else
                    curr_str := total;
                end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
		    htp.p(' <b>|</b> <td align=right>');
		    htp.p(url(cgi_bin||'infosearch.more_date?total='
			||total||'&seed='||next||'&day1='||day1||
			'&day2='||day2,'Next '||next_str));
		end if;
		htp.p('</table></center><dl>');
		open cdate(day1,day2);
		num := 0;
		loop
		   fetch cdate into res_size,res_html,res_imgs,res_date,res_host,res_path,res_title;
--		   fetch cdate into two;
		   exit when cdate%NOTFOUND;
		   num := num + 1;
		   htp.p('<p><dt>');
		   htp.p('<img src="'||server_name||'green_dot.gif"  border=0>'); 
		   htp.p('<a href="http://'||res_host||res_path||'">'||
			res_title||'</a><br>');
		   htp.p('<b>&nbsp &nbsp &nbsp &nbsp Last Update:&nbsp</b>'||to_char(res_date,'mm/dd/yy'));
		   htp.p('<b>&nbsp &nbsp &nbsp Size:&nbsp</b>'||round((res_size/1024),1)||'KB');
		   htp.p('<b>&nbsp &nbsp &nbsp Link Num.:&nbsp</b>'||res_html);
		   htp.p('<b>&nbsp &nbsp &nbsp Image Num.:&nbsp</b>'||res_imgs);

/*		   htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
		   if (two.url IS NOT NULL) then
			htp.ap('<i>'||url(two.url,two.title)||'</i>');
		   else 
			htp.bp('<i>'||two.title||'</i>');
		   end if;
		   htp.ap('<dd>'||two.author);

		   htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yyyy')||'</i>');
		   if (not ( two.type = 1)) then
			htp.p('<br>');
			htp.p(url(cgi_bin||'sccs2.show_info?docid='||two.id
			||'&doctype='||two.type,'Addition Information'));
		   end if;
		   if (two.abs IS NOT NULL) then
			htp.p('<br>');
			htp.ap(two.abs);
		   end if;
*/
		   if ( num = 20 ) then
			exit;
		    end if;
	    	end loop;			

	htp.p('</DL>');
	htp.p('<img src="http://mira.npac.syr.edu:9898/apollo/wavy.gif">');
		htp.p('<center>');
		htp.p(' p.');
       		n := ceil(total/20);
        	if (n > 20) then n := 20; end if;
		for i in 1..n loop
		   iseed := (i-1)*20 + 1;
		   if (iseed = 0 ) then
			htp.p(' '||i);
		   else
			htp.p(' '||url(cgi_bin||'infosearch.more_date?
				total='||total||'&seed='||iseed||'&day1='||
				day1||'&day2='||day2,i));
		   end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||url(cgi_bin||'infosearch.more_date?total='
			||total||'&seed='||next||'&day1='||day1||'&day2='||
			day2,'Next')||']');
		end if;
		htp.p('</center>');
	else
		htp.p('No Such Document Found');
	end if;
	close cdate;

end;


procedure more_date(total number,seed integer,day1 date, day2 date) is
cursor cdate(date1 date,date2 date) is
	select fsize,no_html,no_imgs,time,host1,path,title
	from search
	where (time between date1 and date2)
	order by time desc;


num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	search_button(3);
	h_caption := 'Last Updated between <b>  '||day1||' <b> and  <b>'||
			day2||'</b>';
--	htp.p('<hr width=80%>');
	htp.p('<center>');
	htp.p('<caption>The Documents '||h_caption||'</caption></center>');
	htp.p('<hr><DL>');

	next := seed + 20;
	if (next<=total) then
                if ((next+20)<=total) then
                        next_str := (next+19);
                else
                        next_str := total;
                end if;
                next_str := next||'-'||next_str;
                curr_str := next - 1;
        else
                curr_str := total;
        end if;
        prev := seed - 20;
        if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
        elsif (seed > 1) then
                        prev := 1;
                        prev_str := '1-'|| 20;
        end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(url(cgi_bin||'infosearch.more_date?total='||total||
			'&seed='||next||'&day1='||day1||'&day2='||day2
			,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(url(cgi_bin||'infosearch.more_date?total='||total||
			'&seed='||prev||'&day1='||day1||'&day2='||day2
			,'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
	open cdate(day1,day2);
	num := 0;
	loop
		fetch cdate into res_size,res_html,res_imgs,res_date,res_host,res_path,res_title;
		exit when cdate%NOTFOUND;
		num := num + 1;
		if (num >= seed) then
		   htp.p('<p><dt>');
		   htp.p('<img src="'||server_name||'green_dot.gif"  border=0>'); 
		   htp.p('<a href="http://'||res_host||res_path||'">'||
			res_title||'</a><br>');
		   htp.p('<b>&nbsp &nbsp &nbsp &nbsp Last Update:&nbsp</b>'||to_char(res_date,'mm/dd/yy'));
		   htp.p('<b>&nbsp &nbsp &nbsp Size:&nbsp</b>'||round((res_size/1024),1)||'KB');
		   htp.p('<b>&nbsp &nbsp &nbsp Link Num.:&nbsp</b>'||res_html);
		   htp.p('<b>&nbsp &nbsp &nbsp Image Num.:&nbsp</b>'||res_imgs);
		   
/*
			htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
			if (two.url IS NOT NULL) then
				htp.ap('<i>'||url(two.url,two.title)||'</i>');
			else 
				htp.bp('<i>'||two.title||'</i>');
			end if;
			htp.ap('<dd>'||two.author);
			htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yyyy')||'</i>');
			if (not ( two.type = 1)) then
				htp.p('<br>');
				htp.p(url(cgi_bin||'sccs2.show_info?docid='					||two.id||'&doctype='||
				two.type,'Addition Information'));
		  	end if;
*/
/*			if (two.abs IS NOT NULL) then
				htp.p('<br>');
				htp.ap(two.abs);
				htp.p('</h3>');
			end if;
*/
		end if;
		if ( num >= (seed + 19) ) then
		    	exit;
		end if;
	end loop;	
	close cdate;
	htp.p('</DL>');
	htp.p('<img src="http://mira.npac.syr.edu:9898/apollo/wavy.gif">');
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/20);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
	   iseed := (i-1)*20 + 1;
	   if (iseed = 0 ) then
		htp.p(' '||i);
	   else
		htp.p(' '||url(cgi_bin||'infosearch.more_date?total='||
			total||'&seed='||iseed||'&day1='||day1||'&day2='||
			day2,i));
	   end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||url(cgi_bin||'infosearch.more_date?total='
			||total||'&seed='||next||'&day1='||day1||'&day2='||
			day2,'Next')||']');
	end if;
	htp.p('</center>');

end;




procedure day(str varchar2,result out date,tag in out char) is
i integer := 1;
one varchar2(8) := null;
two varchar2(8) := null;
three varchar2(8) := null;
n integer;
j integer := 1;
string varchar2(100);
begin
	string := str;
	while ( string IS NOT NULL and (substr(string,1,1) = '/')) loop
		string := substr(string,2);
	end loop;
	n := length(string);
	while ((i <= n) and (substr(string,i,1) != '/')) loop
		i := i + 1;
	end loop;
	one := substr(string,1,i-1);
	if (i > n) then
		tag := 'y';
	else
		string := substr(string,i+1);
		n := length(string);
		i := 1;
		while (i <= n and (substr(string,i,1) != '/')) loop
			i := i + 1;
		end loop;
		two := substr(string,1,i-1);
		if (i > n) then
			tag := 'm';
		else
			string := substr(string,i+1);
			n := length(string);
			i := 1;
			while (i <= n and (substr(string,i,1) != '/')) loop
				i := i + 1;
			end loop;
			three := substr(string,1,i-1);
			tag := 'd';
		end if;
	end if;		

	-- check the validated date format
	if (tag = 'y') then
		i := length(one);
		one := substr(one,-4,4);
		result := to_date('0101'||one,'ddmmyyyy');
	else
		one := lpad(one,2,'0');
		if ((to_number(one) < 1) or (to_number(one) > 12)) then
			htp.p('<center>Date format <b>error</b>2: <b>'||str||'</b></center><p>');
			result := NULL;
		else
		 	if (tag = 'm') then
				two := substr(two,-4,4);
				result := to_date(one||two,'FXFMmmyyyy');
			else
				two := lpad(two,2,'0');
				if (to_number(two) > to_char(last_day(to_date(one,'mm')),'dd')) then
					htp.p('<center>Date format <b>error</b>2: <b>'||str||'</b></center><p>');
					result := NULL;
					return;
				end if;
				i := length(three);
				if (i <= 4) then
					three := substr(three,-4,4);
					result := to_date(one||two||three,'FXFMmmddyyyy');
				end if;
			end if;
		end if;
	end if;
end;

end infosearch;
/
show errors;
/










