include $(ORACLE_HOME)/precomp/lib/env_precomp.mk

.SUFFIXES: .pc .c .o

LDSTRING=
PRODUCT_LIBHOME=
MAKEFILE=proc.mk
PROCPLSFLAGS= sqlcheck=semantics userid=$(USERID) CHAR_MAP=VARCHAR2 dbms=v7
PROCPPFLAGS= code=cpp include=/usr/include include=/opt/SUNWspro/SC3.0.1/include/CC
USERID=apollo/apollo
INCLUDE=$(I_SYM). $(PRECOMPPUBLIC)

PROCFLAGS = sqlcheck=semantics userid=$(USERID)

SAMPLES=view
CPPSAMPLES=

# Rule to compile any program (specify EXE= and OBJS= on command line)

build: $(OBJS)
	$(CC) -o $(EXE) $(OBJS) util.o -L$(LIBHOME) $(PROLDLIBS)

cppbuild:
	$(PROC) $(PROCPPFLAGS) iname=$(EXE)
	CC -c $(INCLUDE) $(EXE).c
	CC -o $(EXE) $(OBJS) -L$(LIBHOME) $(PROLDLIBS)

samples: $(SAMPLES)
cppsamples: $(CPPSAMPLES)

$(SAMPLES): util.o
	$(MAKE) -f $(MAKEFILE) build OBJS=$@.o EXE=$@

$(CPPSAMPLES):
	$(MAKE) -f $(MAKEFILE) cppbuild OBJS=$@.o EXE=$@


.pc.c:
	$(PROC) $(PROCFLAGS)  iname=$*.pc

.pc.o:
	$(PROC) $(PROCFLAGS)  iname=$*.pc
	$(CC) $(CFLAGS) -c $*.c

.c.o:
	$(CC) $(CFLAGS) -c $*.c

view.o: view.pc util.c
	$(PROC) mode=ansi varchar=yes dbms=v6_char sqlcheck=semantics userid=$(USERID) iname=$*.pc
	$(CC) $(CFLAGS) $(PRECOMPPUBLIC) -c $*.c
util.o: util.c
	$(CC) $(CFLAGS) -c util.c
