/*
** Accept user's registration and put the information into DB
** Class: InsertUser
** Author: Yuping
** Date: 11-03-1999
*/

package ascdb.pub;

//import package java.sql to use JDBC
import java.sql.*;

//import package javax.servlet.http to get URL parameters
import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import java.util.Hashtable;

import ascdb.conf;
import ascdb.admin.msgManager;
import ascdb.users.UserValidation;

import oracle.html.*;


public class InsertUser extends HttpServlet
{
    private Hashtable UserTable = new Hashtable();
    private Connection conn;
    private Statement stmt;
    private msgManager msg = new msgManager();

    public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
    {
    // Output HTML page header
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();    
    conf dbconf = new conf(req);
    int sponsorEmail = 0;
    UserValidation UserV = new UserValidation();

    try {
    // connect to DB
    openDB(req);
 
    // Read User parameters from request
    if (((req.getParameter("op")).equals("10")) ||((req.getParameter("op")).equals("11"))) 
	//readSponsorInfo(req);
	out.println("OK");
    else
    {
	readParameters(req);
	UserSponsorPage(out);
	return;
    }
    
    UserTable.put("admph",dbconf.AdminPhone);
    UserTable.put("freephone",dbconf.FreePhone);
    UserTable.put("TMDemail",dbconf.TMDEmail);

    // Check if user exists in DB
    if ((UserExist() == 0) && ((String)UserTable.get("op")).equals("0"))
    {
	msg.putHashTable(UserTable);
	msg.UserExist(res);
	return;
    }
    
    // Get address ID from addresses table or generate new one
    getAddressID();
    

    // Generate new user ID
    if (((String)UserTable.get("op")).equals("0"))
         getUserID((String)UserTable.get("l_name"),"uid");
    else  
     	 UserTable.put("uid",req.getParameter("uid"));
   
    //    out.println("UsreID: "+ (String)UserTable.get("uid") + " and Address ID:"+ UserTable.get("addr_id"));

    // If need sponsor, get sponsor info.
    if (! ((String)UserTable.get("business")).equals("GOVERNMENT ORGANIZATION"))
    {
        if (SponsorExist() != 0)
	{
	    getUserID((String)UserTable.get("slname"),"suid");
	    LoadSponsor();
	}
	sponsorEmail = 1;
	//	msg.putHashTable(UserTable);
	//	msg.msgSender((String)UserTable.get("semail"),(String)UserTable.get("TMDemail"),(String)UserTable.get("TMDemail"),"Sponsor TMD",dbconf.EmailServer);
    }
    
    // create new user record
    if (((String)UserTable.get("op")).equals("0"))
    {	
	LoadUser();
	if (((String)UserTable.get("purpose")).equals("Student"))
	    LoadCtas();
      	UserTable.put("officer",dbconf.OfficerName);
	UserTable.put("officerPH",dbconf.OfficerPh);
	UserTable.put("officerEmail",dbconf.OfficerEmail);
	UserTable.put("officerFax",dbconf.OfficerFax);
	UserTable.put("dsn",dbconf.DSN);
	msg.putHashTable(UserTable);
	msg.UserRegisterOk(res);
	/*	  	String cta2[] = req.getParameterValues("cta2");
		int len = cta2.length;
      		for (int i = 0; i < len ; i++)
		  out.println(cta2[i]);
	*/
	//send email to register
      	msg.msgSender((String)UserTable.get("email"),(String)UserTable.get("TMDemail"),"yuzhu@mailbox.syr.edu","Register",dbconf.EmailServer);

	// send email to administrator
       	msg.msgSender((String)UserTable.get("TMDemail"),(String)UserTable.get("TMDemail"),"",(String)UserTable.get("purpose"),dbconf.EmailServer);

	//send email to sponsor
	if (sponsorEmail == 1) {
	    msg.msgSender((String)UserTable.get("semail"),(String)UserTable.get("TMDemail"),(String)UserTable.get("TMDemail"),"Sponsor TMD",dbconf.EmailServer);
	    if (RecordEmail() == 0)
		out.println("Can not load into Sponsor_email_tracking");
	}
    } 

    // update existing user record
    else 
    {	
	if (! UserV.UserLogin((String)UserTable.get("uid"),req))
	{
	    out.println("You are logout, please login again!");
	    return;
	}
       
        boolean SponChange =  SponUpdate();
	//out.println(" sponsor login "+ sponlogin());
	if (CheckRole((String)UserTable.get("uid")) == 1)
       	    if (UpdateUser()==1) {
		if (((String)UserTable.get("purpose")).equals("Student"))
		    UpdateCtas();
		out.println("<body bgcolor=\"#ffffff\">");
		out.println("Your user infomation has been updated!");
		if ((sponsorEmail == 1) && (SponChange))
		{    out.println("<br>Send email to sponsor...");
		     msg.putHashTable(UserTable);
		     msg.msgSender((String)UserTable.get("semail"),(String)UserTable.get("TMDemail"),(String)UserTable.get("TMDemail"),"Sponsor TMD",dbconf.EmailServer);
		     if (RecordEmail() == 0)
		       out.println("Can not load into Sponsor_email_tracking");
		}
	    }
            else
		out.println("Can not update your user information!");
       else
	   out.println("You do not have the privillege!");
    }
    // out.println(" oooosponsor login "+ sponlogin());
    //  sponlogin();
    BackHome(out);

    }catch (SQLException e) {
	out.println(e.getMessage());
    }
    catch (ClassNotFoundException e) {
	out.println("Can not load JDBC Driver!");
    }
    }


    private void openDB(HttpServletRequest req) 
           throws ClassNotFoundException,SQLException
    {
	//	try{
	conf dbconf = new conf(req);
	// Load the Oracle JDBC driver
	Class.forName (dbconf.JdbcDriver);
	
	// Connect to the database
	conn =
	    DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);

	// Create a Statement
	stmt = conn.createStatement ();
    
    }


    private void readParameters(HttpServletRequest req)
    {
	UserTable.put("surtit",(String)req.getParameter("surtitle"));
       	UserTable.put("l_name",req.getParameter("lastname"));
	UserTable.put("f_name",req.getParameter("firstname"));
        UserTable.put("m_name",req.getParameter("middlename"));
       	UserTable.put("address",req.getParameter("address"));
      	UserTable.put("address2",req.getParameter("address2"));
	UserTable.put("room",req.getParameter("room"));
        UserTable.put("mail",req.getParameter("mail"));
	UserTable.put("city",req.getParameter("city"));
	UserTable.put("state",req.getParameter("state"));
	UserTable.put("zip",req.getParameter("zip"));
	UserTable.put("country",req.getParameter("country"));
	UserTable.put("phone",req.getParameter("phone"));
	UserTable.put("ext",req.getParameter("ext"));
	UserTable.put("alt_phone",req.getParameter("alt_phone"));
	UserTable.put("fax",req.getParameter("fax"));
       	UserTable.put("email",req.getParameter("email"));
	UserTable.put("shared",req.getParameter("shared"));
	UserTable.put("list",req.getParameter("list"));
	UserTable.put("cta",req.getParameter("cta"));
       	UserTable.put("cta2",req.getParameterValues("cta2"));
	UserTable.put("comment",req.getParameter("comments"));
	UserTable.put("citizenship",req.getParameter("citizenship"));
	if (((String)UserTable.get("citizenship")).compareTo("United States") != 0)
	    {
		UserTable.put("ptype",req.getParameter("permit"));
		UserTable.put("pnum",req.getParameter("p_num"));
		UserTable.put("pdate",req.getParameter("exp_date"));
	    }
	
	UserTable.put("nac",req.getParameter("nac"));
	UserTable.put("business",req.getParameter("B_type"));
       	UserTable.put("b_name",req.getParameter("b_name"));

	/*	if (((String)UserTable.get("business")).equals("GOVERNMENT ORGANIZATION")) 
       	   UserTable.put("org",req.getParameter("userType")); 
	else
	{
	    UserTable.put("sfname",req.getParameter("s_f_name"));
	    UserTable.put("slname",req.getParameter("s_l_name"));
       	    UserTable.put("org",req.getParameter("org"));
	    UserTable.put("sphone",req.getParameter("s_phone"));
	    UserTable.put("sext",req.getParameter("s_ext"));
       	    UserTable.put("sfax",req.getParameter("s_fax"));
	    UserTable.put("semail",req.getParameter("s_email"));
	}    
*/
       	UserTable.put("userType",req.getParameter("userType"));
       	UserTable.put("ssn",req.getParameter("ssn"));
	
       	UserTable.put("op",req.getParameter("op"));
	UserTable.put("msrc",req.getParameter("msrc"));

	/*	if (((String)UserTable.get("citizenship")).compareTo("United States") == 0)
	    UserTable.put("fn_indctr","N");
	else
	UserTable.put("fn_indctr","Y");*/
    }
	
    private int SponsorExist()
       throws SQLException
    {
	ResultSet allSponsor =stmt.executeQuery("select oracle_uid from users where first_nam = '" + (String)UserTable.get("sfname") + "' and last_nam = '" + (String)UserTable.get("slname") + "'");
	if (allSponsor.next())
	{
	    UserTable.put("suid",allSponsor.getString(1));
	    return 0;
	}
	return 1;
    }


    private int UserExist()
          throws SQLException
    {

	ResultSet allUser = stmt.executeQuery("select oracle_uid from users where first_nam = '" + (String)UserTable.get("f_name") + "' and last_nam = '" + (String)UserTable.get("l_name") + "'");
   //+ "' and middle_nam = '" + (String)UserTable.get("m_name") + "'");
        if (allUser.next())
              return 0;
	return 1;
    }


    private void getAddressID()
          throws SQLException
    {
	int fg = 0;
	String Code = "";
	ResultSet CountryCode = stmt.executeQuery("select char_code from domain where expsn = '" + (String)UserTable.get("country") + "'");
	if (CountryCode.next())
	       Code = CountryCode.getString(1);

	ResultSet addr = stmt.executeQuery("select * from addresses order by address_id asc");
	while (addr.next())
	    if (((String)UserTable.get("address")).equals(addr.getString(2))
	      && ((String)UserTable.get("city")).equals(addr.getString(3))
	      && ((String)UserTable.get("state")).equals(addr.getString(4))
	      && ((String)UserTable.get("zip")).equals(addr.getString(5))
	      && (Code.equals(addr.getString(6))))
	     {
		UserTable.put("addr_id",addr.getString(1));
		fg = 1;
		break;
	     }
	// generate a new address record
	if (fg == 0)
	{
	    ResultSet newAddr = stmt.executeQuery("select address_seq.nextval from dual");
	    if (newAddr.next())
		UserTable.put("addr_id",newAddr.getString(1));
	    AddAddress(Code);
	}
    }

	private void AddAddress(String Code)
	      throws SQLException
	{
      	    String QueryString = "insert into addresses values ('" 
		                   + (String)UserTable.get("addr_id") + "','"
                                   + (String)UserTable.get("address") + "','"
                                   + (String)UserTable.get("city") + "','"
                                   + (String)UserTable.get("state") + "','"
                                   + (String)UserTable.get("zip") + "','"
                                   + Code + "','"
                                   + (String)UserTable.get("room") + 
                                   "',null)";

	    int addrcount = stmt.executeUpdate(QueryString);
	}

	private void getUserID(String lName, String id)
	      throws SQLException
	{
	    String LastName = lName;
	    int Index = LastName.indexOf('\'');
	    while ((Index > 0) && (Index < 4))
	    {
		LastName = LastName.substring(1, Index-1) + LastName.substring(Index+1,LastName.length());
		Index = LastName.indexOf('\'');
	    }
	    Index = LastName.length();
      	    if (LastName.length() > 3)
	        Index = 3;
	    String UserID = "";
	    ResultSet UserIdrset = stmt.executeQuery("select users_seq.nextval from dual");
	    if (UserIdrset.next())
    		UserID = UserIdrset.getString(1);
	    UserIdrset.close();
	    UserID = LastName.substring(0,Index) + UserID;
	    UserTable.put(id,UserID);
	}
	    
	private void LoadSponsor()
	     throws SQLException
	{
	    String SponsorString = "insert into users(oracle_uid,create_date,user_status,user_type,address_id,submitter,first_nam,last_nam,purpose,phone,phone_ext,fax,email,organization) values ('"
		+ (String)UserTable.get("suid") 
		+ "',sysdate,'Disable','Goverment',0,'"
		+ (String)UserTable.get("uid") + "','"
		+ (String)UserTable.get("sfname") + "','"
		+ (String)UserTable.get("slname") 
		+ "','Sponsor','"
		+ (String)UserTable.get("sphone") + "','"
		+ (String)UserTable.get("sext") + "','"
		+ (String)UserTable.get("sfax") + "','"
		+ (String)UserTable.get("semail") + "','"
		+ (String)UserTable.get("org")
		+ "')";
	    int count1 = stmt.executeUpdate(SponsorString);
	    
	    String addlStr = "insert into addl_users values('"
		+ (String)UserTable.get("suid") 
		+ "','N','N','N','123"
		+ (String)UserTable.get("suid")
		+ "')";
	    count1 = stmt.executeUpdate(addlStr);
	}
	
        private boolean SponUpdate()
	      throws SQLException
        {
	    ResultSet rset = stmt.executeQuery("select spons_agency_uid from users where oracle_uid='" +(String)UserTable.get("uid") + "'");
	    if (rset.next())
		if (((String)UserTable.get("suid")).equals(rset.getString(1)))
		    return false;
	    return true;
	}
	    
	
	private int CheckRole(String me)
	      throws SQLException
	{            
	    ResultSet rset = stmt.executeQuery("select oracle_uid from users where oracle_uid='" + me + "'");
	    while (rset.next())
     		if ((rset.getString(1)).equals("Administrator") 
		    || me.equals((String)UserTable.get("uid")))
		    return 1;
	    return 0;
	}
	       

	private void LoadUser()
	     throws SQLException
	{
	     String InsertString = "insert into users values ('" 
		+ (String)UserTable.get("uid") + "',sysdate,'Disabled','"
       		+ (String)UserTable.get("userType") + "',"
       		+ (new Integer((String)UserTable.get("addr_id"))).intValue() + ",null,'"
		+ (String)UserTable.get("f_name") + "','"
		+ (String)UserTable.get("l_name") + "','"
		+ (String)UserTable.get("m_name") + "','"
		+ (String)UserTable.get("surtit") + "','"
	       	+ (String)UserTable.get("purpose") + "',null,null,null,'"
		+ (String)UserTable.get("citizenship") + "','"
		+ (String)UserTable.get("fn_indctr") + "','"
      		+ (String)UserTable.get("business") + "','"
		+ (String)UserTable.get("b_name") + "',null,null,'"
       		+ (String)UserTable.get("mail") + "','"
		+ (String)UserTable.get("room") + "','"
		+ (String)UserTable.get("phone") + "','"
		+ (String)UserTable.get("ext") + "','"
		+ (String)UserTable.get("alt_phone") + "','"
		+ (String)UserTable.get("fax") +"','"
		+ (String)UserTable.get("email") + "','"
		+ (String)UserTable.get("uid") + "','"
		+ (String)UserTable.get("suid") 
		+ "','N',null,null,'N',null,'N','N','"
	      	+ (String)UserTable.get("org") + "','"
		+ (String)UserTable.get("nac") + "','"
		+ (String)UserTable.get("ssn") + "','"
		+ (String)UserTable.get("comment")
		+ "')";

	    int count = stmt.executeUpdate(InsertString);
	    // load additional user table
	    String AddlString = "insert into addl_users values ('"
		+ (String)UserTable.get("uid") + "','"
		+ (String)UserTable.get("shared") + "','"
		+ (String)UserTable.get("list") + "','Y','"
		+ (String)UserTable.get("passwd1")
		+ "')";
	    int count1 = stmt.executeUpdate(AddlString);
	}
		
	private int UpdateUser()
	     throws SQLException
	{
	    String UpdateString = "update users set user_type='" 
		+ (String)UserTable.get("userType") 
		+ "',address_id='" + (String)UserTable.get("addr_id") 
		+ "',first_nam='" + (String)UserTable.get("f_name") 
		+ "',last_nam='" + (String)UserTable.get("l_name") 
		+ "',middle_nam='" + (String)UserTable.get("m_name") 
		+ "',surtitle='" + (String)UserTable.get("surtit") 
		+ "',purpose='" + (String)UserTable.get("purpose") 
		+ "',citizenship='" + (String)UserTable.get("citizenship") 
		+ "',fn_indctr='" + (String)UserTable.get("fn_indctr") 
		+ "',business_type='" + (String)UserTable.get("business") 
		+ "',business_name='" + (String)UserTable.get("b_name") 
		+ "',mail_stop='" + (String)UserTable.get("mail") 
		+ "',room_num='" + (String)UserTable.get("room") 
		+ "',phone='" + (String)UserTable.get("phone") 
		+ "',phone_ext='" + (String)UserTable.get("ext") 
		+ "',alt_phone='" + (String)UserTable.get("alt_phone") 
		+ "',fax='" + (String)UserTable.get("fax") 
		+ "',email='" + (String)UserTable.get("email") 
		+ "',spons_agency_uid='" + (String)UserTable.get("suid") 
		+ "',organization='" + (String)UserTable.get("org") 
		+ "',nac_type='" + (String)UserTable.get("nac") 
		+ "',ssan_last4='" + (String)UserTable.get("ssn") 
		+ "',user_comment='" + (String)UserTable.get("comment")
		+ "' where oracle_uid='" + (String)UserTable.get("uid") + "'";
	    int count = stmt.executeUpdate(UpdateString);
	
	    // Update additional user table
	    String AddlUpdateString = "update addl_users set share_email='" 
		+ (String)UserTable.get("shared")
		+ "',list_email='" + (String)UserTable.get("list")
		//+ "',tmd_password='" + (String)UserTable.get("passwd1")
		+ "'where oracle_uid='" + (String)UserTable.get("uid") + "'";
	    int count1 = stmt.executeUpdate(AddlUpdateString);

	    if ((count == 1) && (count1 == 1))
		return 1;
	    else
		return 0;
	}


        private int RecordEmail() 
	       throws SQLException
        {
	    String InsertString = "insert into sponsor_email_tracking values('"
		+ (String)UserTable.get("uid") + "',sysdate,'"
		+ (String)UserTable.get("suid") 
		+ "','N','nobody',sysdate)";
	    int count = stmt.executeUpdate(InsertString);
	    return count;
	}
    
        private void LoadCtas()
	        throws SQLException
        {
	    String cta = (String)UserTable.get("cta");
	    String CtaCode = getCtaCode(cta); 
	    String queryStr = "insert into student_ctas values('"
		+ (String)UserTable.get("uid") + "','"
		+ CtaCode + "','PRIMARY')";
	    int count = stmt.executeUpdate(queryStr);
	
	    String cta2[] = (String[])UserTable.get("cta2");
	    int len = cta2.length;
	    for (int i=0; i<len; i++) {
		CtaCode = getCtaCode(cta2[i]);
		queryStr = "insert into student_ctas(student_uid,cta) values('"
		    + (String)UserTable.get("uid") + "','"
		    + CtaCode + "')";
		count =  stmt.executeUpdate(queryStr);
		}
	}

        private String getCtaCode(String cta) 
        {
	    return cta.substring(0,3);
	}

        private void UpdateCtas() 
	       throws SQLException
        {
	    int count = stmt.executeUpdate("delete from student_ctas where student_uid='" + (String)UserTable.get("uid") + "'");
	    LoadCtas();
	}

        private void BackHome(PrintWriter out) 
        {
	    out.println("<form method=\"POST\" action=\"ascdb.users.FrontPage\">");
	    out.println("<input type=hidden name=\"uid\" value=\"" + (String)UserTable.get("uid") + "\">");
	    out.println("<input type=submit name=\"submit\" value=\"Back Main Menu\">");
	}

        private void UserSponsorPage(PrintWriter out)
	     throws SQLException
        {
	    HtmlStringBuffer HTMLBuf = new HtmlStringBuffer();
	    HTMLBuf.appendln("<HTML>");
	    HTMLBuf.appendln("<HEAD>");
	    HTMLBuf.appendln("<TITLE>TMD Registration Form </TITLE>");
	    
	    //Create a JavaScript Object
	    Script js = new Script("JavaScript");
	    js.setCode("function Validation(form) {\n"
		 + "   if ( form.org[0].selected) {\n"
		 + "      if (myEmpty(form.s_f_name)) {\n"
		 + "         ErrorSponsor(\"First Name\")\n"
		 + "         return false\n"
                 + "      }\n"
                 + "      if (myEmpty(form.s_l_name)) {\n"
		 + "         ErrorSponsor(\"Last Name\")\n"
		 + "         return false\n"
                 + "      }\n"
                 + "      if (myEmpty(form.s_phone)) {\n"
		 + "         ErrorSponsor(\"Phone\")\n"
		 + "         return false\n"
                 + "      }\n"
                 + "      if (myEmpty(form.s_email)) {\n"
		 + "         ErrorSponsor(\"Email\")\n"
		 + "         return false\n"
                 + "      }\n"
		 + "   }\n" 
		 + "   return true\n\n"
		 + "}\n\n"
		 + "function myEmpty(str) {\n"
		 + "   var typein = new String(str.value)\n"
		 + "   if (typein.length == 0) return true\n"
		 + "   while(typein.charCodeAt(0) == 32)\n"
		 + "        typein = typein.substring(1)\n"
                 + "   if (typein.length == 0) return true\n"
		 + "   return false\n"
		 + "}\n\n"      
		 + "function ErrorSponsor(err) {\n"
		 + "   alert(\"Since your Employment is not DoD, you must provide Sponsor Information. Sponsor's \" + err + \" was blank. Please go back to the form and correct the error.\")\n"
		 + "}\n");

	    HTMLBuf.append(js);
	    HTMLBuf.appendln("</HEAD>");
	    //Create an HtmlBody Object
	    HtmlBody bd = new HtmlBody();
	    // Sets various attributes of HtmlBody
	    bd.setBackgroundColor("#ffffe6");

	    HTMLBuf.append("<form method=\"POST\" action=\"ascdb.pub.InsertUser\">");
	    bd.addItem(new SimpleItem("TMD Registration Form").setBold().setFontSize(5).setCenter())
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("IF APPLICANT IS NOT A DOD EMPLOYEE, COMPLETE THE FOLLOWING SECTION:").setBold())
               .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("Sponsor Information:").setBold().setFontColor(Color.red).setFontSize(3))
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("Please select your Organization from the list. By typing it in part way, you will narrow your selections. Once you have selected your Organization, a list of Sponsors will be available by using the drop-down list on the Last Name. If you do not see your Organization or sponsor listed, please provide the information denoted with *").setBold())
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("Organitation* ").setBold());
	    
	    ResultSet orgSet = stmt.executeQuery("select * from domain where domain_name='ORGANIZATIONS' order by order_num asc");
	    Select orgS = new Select("org");
while (orgSet.next())
            orgS.addOption(new Option(orgSet.getString("char_code")));
            orgSet.close();
 
            bd
	       .addItem(orgS)
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("If your Organization or Sponsor is not on the above lists, you must provide the following information for a Sponsor.").setBold())
	       .addItem(SimpleItem.LineBreak);

	    ResultSet SurtitleRset = stmt.executeQuery("select * from domain where domain_name='SURTITLES' order by order_num asc");

	    Select Surtitle = new Select("s_surtitle");
	    while (SurtitleRset.next())
	    Surtitle.addOption(new Option(SurtitleRset.getString("char_code")));
	    Surtitle.addOption(new Option("Surtitle*","surtit",true));
	    SurtitleRset.close();

	    bd
	       .addItem(Surtitle)
	       .addItem(new SimpleItem("First Name*: ").setBold())
	       .addItem(new TextField("s_f_name",35,35,""))
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("Middle Name: ").setBold())
	       .addItem(new TextField("s_m_name",35,35,""))
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("Last Name*: ").setBold())
	       .addItem(new TextField("s_l_name",35,35,""))
	       .addItem(SimpleItem.LineBreak)
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("Primary Street Address*: ").setBold())
	       .addItem(new TextField("s_address",50,30,""))
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("Secondary Address: ").setBold())
	       .addItem(new TextField("s_address2",50,30,""))
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("Room Number: ").setBold())
	       .addItem(new TextField("s_room",10,10,""))
	       .addItem(new SimpleItem("Mail Stop: ").setBold())
	       .addItem(new TextField("s_mail", 20, 20, ""))
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("City*: ").setBold())
	       .addItem(new TextField("s_city",30,30,""));

	    bd.addItem(new SimpleItem("State*: ").setBold());

	    ResultSet StateRset = stmt.executeQuery("select * from domain where domain_name='STATES' order by expsn asc");

	    Select StateSelect = new Select("s_state");

	    while (StateRset.next())
		StateSelect.addOption(new Option(StateRset.getString("expsn")));

	    bd.addItem(StateSelect);
	    StateRset.close();


	    bd
		.addItem(new SimpleItem("Zip Code*: ").setBold())
		.addItem(new TextField("s_zip", 11, 11, ""))
		.addItem(SimpleItem.LineBreak);

	    bd.addItem(new SimpleItem("Country*: ").setBold());

	    ResultSet CRset = stmt.executeQuery("select * from domain where domain_name='COUNTRIES' order by order_num asc");

	    Select CountrySelect = new Select("s_country");

	    while (CRset.next())
		CountrySelect.addOption(new Option(CRset.getString("expsn")));
	    bd
		.addItem(CountrySelect)
		.addItem(SimpleItem.LineBreak);

	    CRset.close();   

	    bd
		.addItem(new SimpleItem("Phone*: ").setBold())
		.addItem(new TextField("s_phone", 15, 15, ""))
		.addItem(new SimpleItem("Phone Extension: ").setBold())
		.addItem(new TextField("s_ext", 5, 5, ""))
		.addItem(SimpleItem.LineBreak)
		.addItem(new SimpleItem("Alternate Phone: ").setBold())
		.addItem(new TextField("s_alt_phone", 15, 15, ""))
		.addItem(new SimpleItem("FAX: ").setBold())
		.addItem(new TextField("s_fax", 15, 15, ""))
		.addItem(SimpleItem.LineBreak)
		.addItem(new SimpleItem("Email Address*:").setBold()) 
		.addItem(new TextField("s_email", 50, 50, ""))
		.addItem(SimpleItem.Paragraph)
		.addItem(new Submit("submit", "Submit!").setBold())
		.addItem(new Reset("Reset").setBold());
	    HTMLBuf.append(bd);
	    out.println(HTMLBuf);
	}

        public void doGet(HttpServletRequest req, HttpServletResponse res)
	    throws ServletException, IOException
        {
	    doPost(req,res);
	}

}
	 


	    
