/*
** This is uer login page for Training System
** Class: LoginPage
** Author: Yuping Zhu
** Date: 03-11-1999
** Modified Date: 06-17-1999
**          Action: Add information line
** Modified Date: 10-06-1999
**          Action: Redesign web interface
*/

package ascdb;

import oracle.html.*;
import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import ascdb.conf;
import java.text.Collator;

public class WelcomePage extends HttpServlet {

    public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
	{
	
        // Output HTML page header
        res.setContentType("text/html");
	PrintWriter out = res.getWriter();
	conf dbconf= new conf(req);
	Collator cl = Collator.getInstance();

       try {
	  // Creates an HtmlHead Object
	HtmlHead hd = new HtmlHead("Training System Welcome Page");
	
        // Create an HtmlBody Object
	HtmlBody bd = new HtmlBody();

	// Sets various attributes of HtmlBody
     	bd.setBackgroundColor("#fffff2");
//	bd.setBackgroundColor(new Color(10,10,10));	

	// Creates an HtmlPage object using hd and bd
	HtmlPage hp = new HtmlPage(hd, bd);
	Font f = new Font(Color.red,"myfont","+5");

 	hp
	  .addItem(new Image(dbconf.ImageBase + "pet.gif","PET",IVAlign.TOP,false).setCenter())
          .addItem(SimpleItem.Paragraph)
//	  .addItem(new SimpleItem("Welcome To Training System").setCenter().setBold().setFontColor(Color.red))
	  .addItem(new SimpleItem(f.toHTML()))
	  .addItem(new SimpleItem("Welcome To the Training System").setCenter().setBold().setHeading(3))
//	  .addItem(SimpleItem.LineBreak)
	  .addItem(SimpleItem.HorizontalRule)
	  .addItem(SimpleItem.Paragraph);

	Font bf = new Font(Color.teal,null,"+1");
	hp.addItem(new SimpleItem(bf.toHTML()));	

	Form loginUser = new Form("GET",dbconf.ServerURLBase + "ascdb.pub.LoginPage");
	loginUser.addItem(new Submit("submit", "Login as User"));
	Form loginAdmin = new Form("GET",dbconf.ServerURLBase + "ascdb.pub.LoginPage");
	loginAdmin.addItem(new Submit("submit", "Login as Administrator"));
	Form searchfm = new Form("POST",dbconf.ServerURLBase + "ascdb.pub.PublicPage");
	searchfm
		.addItem(new Hidden("op","0"))
		.addItem(new Hidden("me","u"))
		.addItem(new Submit("submit","View Training Schedule"));

        Form FirstStudent = new Form("GET",dbconf.ServerURLBase + "ascdb.pub.UserRegister");
	FirstStudent
	        .addItem(new Hidden("op","0"))
	        .addItem(new Submit("submit","Login as First Time Student"));
	
	Form FirstInst = new Form("GET", dbconf.ServerURLBase + "ascdb.pub.UserRegister");
	FirstInst
	        .addItem(new Hidden("op","1"))
	        .addItem(new Submit("submit","Login as First Time Instructor"));
	Form ChangePasswd = new Form("GET",dbconf.ServerURLBase + "ascdb.users.ChangePasswd");
	ChangePasswd.addItem(new Submit("submit","Change Your Password"));
	
	// Create table to hold all these links
	DynamicTable tab = new DynamicTable(2);
	tab.setBackgroundColor (Color.pink);
        tab.setBorderColor (Color.navy);
	tab.setCellSpacing(2);
	tab.setCellPadding(5);
	TableRow[] rows = new TableRow[3];
	rows[0]
	    .addCell(new TableDataCell(FirstStudent))
	    .addCell(new TableDataCell(FirstInst));
	rows[1]
	    .addCell(new TableDataCell(loginUser))
	    .addCell(new TableDataCell(ChangePasswd));
	rows[2]
	    .addCell(new TableDataCell(loginAdmin))
	    .addCell(new TableDataCell(searchfm));
	
	bd.addItem(tab.setCenter());

	//bd.addItem(loginfm.setCenter());
	//bd.addItem(searchfm.setCenter());
	
	Font addrf = new Font(Color.black,null,"-1");
	hp.addItem(new SimpleItem(addrf.toHTML()));

	hp
	  .addItem(new Image(dbconf.ImageBase + "wavy.gif").setCenter())
	  .addItem(new SimpleItem("<center><address>The Training System is developed by "))
	  .addItem(new SimpleItem("Yuping Zhu").setBold())
	  .addItem(new SimpleItem(" at "))
	  .addItem(new Link("http://www.npac.syr.edu","Northeast Parallel Architecture Center"))
	  .addItem(new SimpleItem(" <br>at Syracuse University. "))
	  .addItem(new SimpleItem("Please send comments to "))
	  .addItem(new Link("mailto:yuzhu@npac.syr.edu", "Yuping Zhu"));
	if (!(cl.equals(dbconf.AdminEmail,"yuzhu@npac.syr.edu") & cl.equals(dbconf.AdminName, "Yuping Zhu")))
	{
	 hp
	  .addItem(new SimpleItem(" or "))
	  .addItem(new Link("mailto:" + dbconf.AdminEmail, dbconf.AdminName));
	}
	hp.addItem(new SimpleItem(" </address></center>"));
//	  .addItem(SimpleItem.LineBreak)
//	  .addItem(new SimpleItem("Please send comments to <a mailto = '" + dbconf.AdminEmail + "'>" + dbconf.AdminName + "</a>").setItal().setCenter());

//	String ServerHome = req.getRealPath("/");
//	hp.addItem(new SimpleItem(ServerHome));
	out.println(hp);
	}
	catch (Exception e) {
	 out.println("Could not generate Welcome Page!");
	}
}
}
	
	
