/*
** Provide a new interface to add a record to a look up table
** Class: AddRow
** Author: Yuping Zhu
** Date: 04-09-1999
*/

package ascdb.admin;

// import package oracle.html to generate dynamic HTML page
import oracle.html.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.pub.UserCheck;
import java.text.Collator;

public class AddRow extends HttpServlet {
     public void doPost(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	String me = req.getParameter("me");
	UserCheck u = new UserCheck(me,req);
	String TableName = req.getParameter("name");

	try {
	   if (u.UserRole(1) != 0)
	   {
		out.println(u.userid + "! You have no privilege!");
		return;
	   }
	   // Creates an HtmlHead Object
            HtmlHead hd = new HtmlHead("View look up table: " + TableName);
        
           // Create an HtmlBody Object
           HtmlBody bd = new HtmlBody();

           // Sets various attributes of HtmlBody
           bd.setBackgroundColor("#fffff2");
             
           // Creates an HtmlPage object using hd and bd
           HtmlPage hp = new HtmlPage(hd, bd);
	
	   Collator cl = Collator.getInstance();
	
	   Form frm = new Form("POST","ascdb.admin.InsertRow");

	   if (cl.equals(TableName,"v_surtitles"))
		frm
		  .addItem(new SimpleItem("Surtitle: ").setBold().setFontColor(Color.olive))
		  .addItem(new TextField("name",7,7,""));
	   else if (cl.equals(TableName,"v_states"))
		frm
		  .addItem(new SimpleItem("State Code: ").setBold().setFontColor(Color.olive))
		  .addItem(new TextField("code",50,40,""))
		  .addItem(SimpleItem.LineBreak)
		  .addItem(new SimpleItem("State Name: ").setBold().setFontColor(Color.olive))
		  .addItem(new TextField("name",50,40,""));
	   else
		frm
		  .addItem(new SimpleItem("Country Abbreviation: ").setBold().setFontColor(Color.olive))
		  .addItem(new TextField("code",2,2,""))
		  .addItem(SimpleItem.LineBreak)
		  .addItem(new SimpleItem("Country Name: ").setBold().setFontColor(Color.olive))
		  .addItem(new TextField("name",60,40,""));
	
	   frm
		.addItem(SimpleItem.LineBreak)
		.addItem(new Hidden("TName",TableName))
		.addItem(new Hidden("me",me))
		.addItem(new Submit("submit","Insert!"));
	   hp
		.addItem(new SimpleItem("Add A New Record Into " + TableName).setBold().setFontColor(Color.red))
		.addItem(SimpleItem.Paragraph);
	   bd.addItem(frm);
	   // output HTML page
	   out.println(hp);
	   }
           catch(ClassNotFoundException e) {
                 out.println("Couldn't load database driver: " + e.getMessage());
           }
	   catch(Exception e) {
		out.println(e.getMessage());
	   }
   }
}