/*
** For user to view Course/Class schedule
** Class: ClassList
** Author: Yuping Zhu
** Date: 02-04-2000
*/

package ascdb.classes;

// import package java.sql to use JDBC
import java.sql.*;

// import oracle.html and javax.servlet package to generate dynamic HTML page
import oracle.html.*;
import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import ascdb.conf;
import ascdb.users.UserValidation;
 
import java.util.Calendar;
import java.text.SimpleDateFormat;
import java.util.TimeZone;

public class ClassList extends HttpServlet {
	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException
	{
	
        // Output HTML page header
        res.setContentType("text/html");
	PrintWriter out = res.getWriter();
	conf dbconf= new conf(req);
	int op = (new Integer(req.getParameter("op"))).intValue();

	String uid = req.getParameter("uid");
	UserValidation UserV = new UserValidation();	
	
	String tit = "Current Class Schedule";
	
	if (op == 4)
	    tit = "All Verified Classes";

	// Class List
	/*	if ( op == 0) 
		tit = "Training Class Schedule";
	else
	tit = "Training Class List";*/
	
       try {
	HtmlStringBuffer HTMLBuf = new HtmlStringBuffer();
	HTMLBuf.appendln("<HTML>");
	HTMLBuf.appendln("<HEAD>");
	HTMLBuf.appendln("<TITLE>Class Schedule</TITLE>");
	
	//Create a JavaScript Object
	Script js = new Script("JavaScript");

	if (op ==9)
	{
	    //	    Script js = new Script("JavaScript");
	    js.setCode("function myConfirm() {\n"
		    + "     if (confirm(\"Are you sure you want to cancel your registration?\")) {\n"
		    + "         return true\n"
		    + "      }\n"
		    + "      return false\n"
		    + " }\n"
	            + "function LogoutConfirm(frm) {\n"
		    + "     if (confirm(\"Are you sure you want to logout TMD?\")) {\n"
		    + "         return true\n"
		    + "      }\n"
		    + "      return false\n"
		    + " }\n");
	 }
	else
	{
	js.setCode("function LogoutConfirm(frm) {\n"
		    + "     if (confirm(\"Are you sure you want to logout TMD?\")) {\n"
		    + "         return true\n"
		    + "      }\n"
		    + "      return false\n"
		    + " }\n");
	}
	HTMLBuf.append(js);
        HTMLBuf.appendln("</HEAD>");

        // Create an HtmlBody Object
	HtmlBody bd = new HtmlBody();

	// Sets various attributes of HtmlBody
     	bd.setBackgroundColor("#fffff2");

	int TabRow = UserV.Validation(req);
	// Modify or Delete a class
	if ((op == 5) | (op == 4))	
	   if (TabRow < 5 )
	   {
		bd.addItem(new SimpleItem("You do not have this privilege!").setBold());
		HTMLBuf.append(bd);
		out.println(HTMLBuf);
		return;
	   }
	   else
	     if (op == 5)
		 bd.addItem(new SimpleItem("Click on Course Number to modify the class ...").setBold().setFontColor(Color.red));
	     else
		 bd.addItem(new SimpleItem("Click on Course Number to post the class ...").setBold().setFontColor(Color.red)); 
	
	// Register the class
	if ((op == 2)| (op == 3) | (op == 9)) 
	   if (TabRow < 4)
	   {
		bd.addItem(new SimpleItem("You do not have this privilege!"));
		bd.addItem(new SimpleItem(TabRow));
		HTMLBuf.append(bd);
		out.println(HTMLBuf);
		return;
	   }
	   else
	       if (op == 2)
		  bd.addItem(new SimpleItem("Click on Course Number to register for the class ...").setBold().setFontColor(Color.red));
	       else if (op == 3)
		  bd.addItem(new SimpleItem("Click on Course Number to veiw the enrollment for the class ...").setBold().setFontColor(Color.red));
	       else
		  bd.addItem(new SimpleItem("Click on Course Number to veiw the enrollment for the class ...").setBold().setFontColor(Color.red));
	  
       	Font f = new Font(Color.olive,"myfont","+5");
	
 
	bd
	  .addItem(new SimpleItem(f.toHTML()))
	  .addItem(new SimpleItem(tit).setCenter())
	  .addItem(SimpleItem.HorizontalRule);
	
	Font bf = new Font(Color.black,null,"+1");
	bd.addItem(new SimpleItem(bf.toHTML()));

	// Load the Oracle JDBC driver
	Class.forName (dbconf.JdbcDriver);

	// Connect to the database
	Connection conn =
		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	
	// Create a Statement
	Statement stmt = conn.createStatement ();
	
        // get class count
	String QueryStr = "select count(*) from class_schedule where class_type='N'";
	if (op ==4 )
	    QueryStr = "select count(*) from class_schedule where class_type='V'";
	ResultSet  tot = stmt.executeQuery(QueryStr);
	
	int ClassTot = 0;
	if (tot.next())
		ClassTot = tot.getInt(1);
	if (ClassTot == 0)
	{
		bd.addItem(new SimpleItem("No Class in Database").setBold().setCenter());
		HTMLBuf.append(bd);
	        out.println(HTMLBuf);
		return;
	}
	tot.close();

	// Get all verified classes from TMD
	String QueryString = "select class_id, course_num, class_start_date, duration, title from class_schedule where class_type='V' order by class_start_date desc";

	// Get all posted classes from Traning DB
	if (op != 4)
	   QueryString = "select class_id, course_num, class_start_date, duration, title from class_schedule where (not course_num = 'N/A') and class_type='N' and catalog_type='N' order by class_start_date desc";

	// execute query
        ResultSet rset = stmt.executeQuery (QueryString);
	
	//Creates the table with 6 columns
      	DynamicTable tab = new DynamicTable(3);
	tab.setBackgroundColor (Color.pink);
        tab.setBorderColor (Color.navy);
	tab.setCellSpacing(2);
	tab.setCellPadding(5);
	
	TableRow[] rows = new TableRow[ClassTot + 1];
	for(int i=0; i <= ClassTot; i++)
	    rows[i] = new TableRow();
	rows[0]
	  .addCell(new TableDataCell(new SimpleItem("Date").setBold().setFontColor(Color.maroon).setCenter()))
	  .addCell(new TableDataCell(new SimpleItem("Course Number").setBold().setFontColor(Color.maroon).setCenter()))
	  .addCell(new TableDataCell(new SimpleItem("Title").setBold().setFontColor(Color.maroon).setCenter()));
	
	//Create table by listing all course from courses
	int i = 1;
	String DateStr1;
	String DateStr2;
	//	Calendar cld = new Calendar();

	// Get Timezone
	TimeZone tz = TimeZone.getTimeZone("EST");

	// Format the current time.
        SimpleDateFormat formatter
          = new SimpleDateFormat ("MMM d");
	
	formatter.setTimeZone(tz);

	Calendar cld = Calendar.getInstance(tz);
	while (rset.next())
	{
	    
	  cld.setTime(rset.getDate("class_start_date"));
	  //	  DateStr1 = cld.get(Calendar.MONTH) + " " + cld.get(Calendar.DAY_OF_MONTH);
	  DateStr1 = formatter.format(rset.getDate("class_start_date"));
	  
	  cld.add(Calendar.DATE, rset.getInt("duration"));
	  //	  DateStr = (cld.getTime()).toString();
	  //	  DateStr2 = cld.get(Calendar.MONTH) + " " + cld.get(Calendar.DAY_OF_MONTH);
	  DateStr2 = formatter.format(cld.getTime());

	  //	  rows[i].addCell(new TableDataCell(new SimpleItem((rset.getDate("class_start_date")).toString() + " - " + DateStr)));
	  rows[i].addCell(new TableDataCell(new SimpleItem(DateStr1 + " - " + DateStr2)));
	  if (op == 1)
            rows[i]	
		.addCell(new TableDataCell(new Link("ascdb.pub.ClassDetail?cid=" + rset.getInt("class_id"), new SimpleItem(rset.getString("course_num")).setBold())));
	  else if (op == 2)
	    rows[i]
		.addCell(new TableDataCell(new Link("ascdb.classes.RegisterClass?cid=" + rset.getInt("class_id") + "&uid=" + uid, new SimpleItem(rset.getString("course_num")).setBold())));
	  else if (op == 3)
	    rows[i]
		.addCell(new TableDataCell(new Link("ascdb.classes.Enrollment?cid=" + rset.getInt("class_id") + "&uid=" + uid, new SimpleItem(rset.getString("course_num")).setBold())));
	  else if (op == 4)
	    rows[i]
		.addCell(new TableDataCell(new Link("ascdb.classes.DoVerifyClass?op=1&cid=" + rset.getInt("class_id") + "&uid=" + uid, new SimpleItem(rset.getString("course_num")).setBold())));
	  else if (op == 5)
	    rows[i]
		.addCell(new TableDataCell(new Link("ascdb.classes.DoVerifyClass?op=2&cid=" + rset.getInt("class_id") + "&uid=" +uid, new SimpleItem(rset.getString("course_num")).setBold())));
	  else if (op == 9)
	    rows[i]
		.addCell(new TableDataCell("<a href=\"ascdb.classes.CancelRegister?cid=" + rset.getInt("class_id") + "&uid=" + uid + "\" onClick=\"return myConfirm()\">" + rset.getString("course_num") + "</a>"));
		//		.addCell(new TableDataCell(new Link("ascdb.classes.CancelRegister?cid=" + rset.getInt("class_id") + "&uid=" + uid + " onClick=myConfirm()", new SimpleItem(rset.getString("course_num")).setBold())));
	  rows[i++]
		.addCell(new TableDataCell(new SimpleItem(rset.getString("title")).setBold()));
	}

	bd.addItem(new SimpleItem("Total: " + ClassTot).setCenter().setItal().setFontColor(Color.orange).setBold());

	//       Add new row to table
	for(i=0; i< ClassTot + 1; i++)
	    tab.addRow(rows[i]);

	// Add the table to Html Body
	bd.addItem(tab.setCenter());
	
	bd
	 .addItem(SimpleItem.Paragraph)
	 .addItem(SimpleItem.HorizontalRule)
	 .addItem(SimpleItem.Paragraph);

	bd.addItem("<center><FORM METHOD=\"POST\" ACTION=\"ascdb.users.UserLogout\" OnSubmit=\"return LogoutConfirm(this)\">");
	bd
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Hidden("uid",uid))
	  .addItem(new Submit("submit", "Logout"))
	  .addItem("</FORM>");
	
	// output HTML page
	HTMLBuf.append(bd);
	out.println(HTMLBuf);
        }
	catch(ClassNotFoundException e) {
	out.println("Couldn't load database driver: " + e.getMessage());
        }
        catch (SQLException e) { 
	out.println(e.getMessage());
	}
	catch(Exception e) {
	out.println(e.getMessage());
	}
    }
    public void doGet(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {doPost(req,res);}
}

