/*
** View class roster
** Class: Enrollment
** Author: Yuping Zhu
** Date: 04-01-1999
** Modified: 08-13-1999 By Yuping Zhu
** 		Add student to view enrollment
** Modified: 01-28-2000 By Yuping Zhu
**              Change Display format
*/

package ascdb.classes;

// import package oracle.html to generate dynamic HTML Page
import oracle.html.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

// import package java.sql to use JDBC
import java.sql.*;

import ascdb.conf;
//import ascdb.pub.UserCheck;
import ascdb.users.UserValidation;

public class Enrollment extends HttpServlet {
    public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException
	{
	
        // Output HTML page header
        res.setContentType("text/html");
	PrintWriter out = res.getWriter();
	conf dbconf= new conf(req);
	String uid = req.getParameter("uid");
	String cid = req.getParameter("cid");
	int ClassId = (new Integer(cid)).intValue();
	//	UserCheck u = new UserCheck(uid);
	UserValidation UserV = new UserValidation();	

	try {
/*	    if ((u.UserRole(1) != 0) & (u.UserRole(2) !=  0) & (u.UserRole(3) != 0))
	   {
		out.println("Sorry! You do not have this privillege!");
		return;
	   }*/
	    
	   int TabRow = UserV.Validation(req);
	   if (TabRow < 4 )
	   {
		out.println("You do not have this privilege!");
		return;
	   }

	   // Load the Oracle JDBC driver
	   Class.forName (dbconf.JdbcDriver);

	   // Connect to the database
	   Connection conn =
		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	
	   // Create a Statement
	   Statement stmt = conn.createStatement ();
	
           int tot = 0;		
	   ResultSet rset1 = stmt.executeQuery("select count(*) from class_roster where class_id = " + ClassId);
	   if (rset1.next())
 	   {
		tot = rset1.getInt(1);
		if (tot == 0)
		{ 
		out.println("No students are registered for the class yet!");
		return;
		}
	   }
	   
	   // Query all students who registered the class
	   ResultSet rset2 = stmt.executeQuery("select * from class_roster where class_id = " + ClassId);

           // Creates an HtmlHead Object
           HtmlHead hd = new HtmlHead("Class List");
        
           // Create an HtmlBody Object
           HtmlBody bd = new HtmlBody();

           // Sets various attributes of HtmlBody
           bd.setBackgroundColor("#fffff2");

           // Creates an HtmlPage object using hd and bd
           HtmlPage hp = new HtmlPage(hd, bd);
	   
	   //Creates the table with 3 columns
           DynamicTable tab = new DynamicTable(3);
           tab.setBackgroundColor (Color.pink);
           tab.setBorderColor (Color.navy);
           tab.setCellSpacing(2);
           tab.setCellPadding(5);

	   TableRow[] rows = new TableRow[tot + 1];
           for(int i=0; i <= tot; i++)
           	rows[i] = new TableRow();
           rows[0]
          	.addCell(new TableDataCell(new SimpleItem("Name").setBold().setFontColor(Color.maroon).setCenter()))
	        .addCell(new TableDataCell(new SimpleItem("Phone Number").setBold().setFontColor(Color.maroon).setCenter()))
          	.addCell(new TableDataCell(new SimpleItem("Email Address").setBold().setFontColor(Color.maroon).setCenter()));
          	
        	
           int i = 1;
	   String Ph;
	   String PhExt;
	   String Email;

	   while (rset2.next())
	   {
	      Ph =  rset2.getString("phone");
	      if (Ph == null)
		Ph = "N/A";		
	      else {
		  PhExt = rset2.getString("phone_ext");
		  if (PhExt != null)
		  {
		      Ph.concat(new String(" Ex "));
		      Ph.concat(PhExt);
		  }
	      }
	      if ((rset2.getString("share_email")).equals("Y"))
		  Email = rset2.getString("email");
	      else
		  Email = "Private";
	      
	      rows[i++]
		.addCell(new TableDataCell(new SimpleItem(rset2.getString("first_nam") + " " + rset2.getString("last_nam")).setFontColor(Color.navy)))
		.addCell(new TableDataCell(new SimpleItem(Ph)))
		.addCell(new TableDataCell(new SimpleItem(Email)));
	    }

	     hp
		.addItem(new SimpleItem("Class List").setCenter().setFontColor(Color.olive).setBold().setFontSize(4))
	   	.addItem(SimpleItem.HorizontalRule)
	        .addItem(new SimpleItem("Total Student: " + tot).setCenter().setItal().setFontColor(Color.red).setBold());
	    //       Add new row to table
            for(i=0; i<  tot + 1; i++)
            	tab.addRow(rows[i]);

            // Add the table to Html Body
            bd.addItem(tab.setCenter());
        
            bd
              .addItem(SimpleItem.Paragraph)
              .addItem(SimpleItem.HorizontalRule)
              .addItem(SimpleItem.Paragraph);

	    Font addrf = new Font(Color.black,null,"-1");
	    hp.addItem(new SimpleItem(addrf.toHTML()));

	    hp
	      .addItem(new Image(dbconf.ImageBase + "wavy.gif").setCenter())
	      .addItem(new SimpleItem("<center><address>For questions, contact "))
	      .addItem(new Link("mailto:" + dbconf.AdminEmail, dbconf.AdminName))
	      .addItem(new SimpleItem(" or call toll-free 1-888-MSRC-ASC (1-888-677-2272)."))
	      .addItem(new SimpleItem(" </address></center>"));
	    // output HTML page
            out.println(hp); 
	    }
	    catch(ClassNotFoundException e) {
       		 out.println("Couldn't load database driver: " + e.getMessage());
            }
            catch (SQLException e) { 
        	out.println(e.getMessage());
            }
            catch(Exception e) {
        	out.println(e.getMessage());
            }
	}
}

	   
		
