/*
** Delete a course record and its relative class sessions from DB
** Class: CourseDelete
** Author: Yuping Zhu
** Date: 03-29-1999
*/

package ascdb.courses;

//import oracle.html to generate dynamic HTML page
import oracle.html.*;

//import package java.sql to use JDBC
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;
import ascdb.pub.UserCheck;

public class CourseDelete extends HttpServlet{
    public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException
    {
     // Output HTML page header
     res.setContentType("text/html");
     PrintWriter out = res.getWriter();
     conf dbconf= new conf(req);
     String uid = req.getParameter("me");
     UserCheck u = new UserCheck(uid);
 	

     String cidStr = req.getParameter("cid");
     int cid = (new Integer(cidStr)).intValue();
     
 try {
	// Creates an HtmlHead Object
	HtmlHead hd = new HtmlHead("Confirm to delete a course record");
	
        // Create an HtmlBody Object
 	HtmlBody bd = new HtmlBody();

	// Sets various attributes of HtmlBody
        bd.setBackgroundColor("#fffff2");

	// Creates an HtmlPage object using hd and bd
	HtmlPage hp = new HtmlPage(hd, bd);
	
	if (u.UserRole(1) < 0) 
	{
	  hp.addItem(new SimpleItem("You have no this privilege!").setBold());
	  out.println(hp);
	  return;
        }
	bd.addItem(new SimpleItem("The relative class sessions will also be deleted, please click on button to confirm delete:").setBold().setFontColor(Color.red));
	Form frm = new Form("POST",dbconf.ServerURLBase + "ascdb.courses.RealDelete");
	
	frm
	  .addItem(new Hidden("me",uid))
	  .addItem(new Hidden("cid",cidStr))
	  .addItem(new Submit("submit", "Delete!"));
	
	bd.addItem(frm.setCenter().setBold());
	//output HTML page
	out.println(hp);
     }
     catch (Exception e) {
	out.println(e.getMessage());
     }
}
}


	