/*
** Used by administrator to create a new catalog (course) 
** Class: CreateCatalog
** Author: Yuping Zhu
** Date: 12-01-1999
*/

package ascdb.courses;

import oracle.html.*;
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
//import ascdb.conf;

import ascdb.users.UserValidation;

public class CreateCatalog extends HttpServlet {
    public void doGet(HttpServletRequest req, HttpServletResponse res)
                throws ServletException, IOException
    {
    // Output HTML page header
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    //conf dbconf= new conf(req);
    String uid = req.getParameter("uid");
    UserValidation UserV = new UserValidation();
	
    try {   
    // Creates an HtmlHead Object
       //   HtmlHead hd = new HtmlHead("Create new course");

    // Create an HtmlBody Object
    HtmlBody bd = new HtmlBody();

    // Sets various attributes of HtmlBody
     bd.setBackgroundColor("#fffff2");
     Font f = new Font(Color.olive,"myfont","+5");
	
    // Creates an HtmlPage object using hd and bd
     //   HtmlPage hp = new HtmlPage(hd, bd);

    int TabRow = UserV.Validation(req);

    if (TabRow != 7)      
    {
	out.println("You do not have this privilege!");
	out.println(BackMainHome());
	return;
    }
    HtmlStringBuffer HTMLBuf = new HtmlStringBuffer();
    HTMLBuf.appendln("<HTML>");
    HTMLBuf.appendln("<HEAD>");
    HTMLBuf.appendln("<TITLE>Create a new Catalog</TITLE>");

    //Create a JavaScript Object
    Script js = new Script("JavaScript");
    js.setCode("function Validation(form) {\n"
	       + "  if (Isempty(form.courseNum.value)) {\n"
	       + "      alert(\"Course Number can not be blank!\")\n"
	       + "      return false\n"
	       + "  }\n"
	       + "  if (Isempty(form.tit.value)) {\n"
	       + "     alert(\"Title can not be blank!\")\n"
	       + "     return false\n"
	       + "  }\n"
	       + "  if (Isempty(form.overview.value)) {\n"
	       + "     alert(\"Overview can not be blank!\") \n"
	       + "     return false\n"
	       + "  }\n"
               + "  if (Isempty(form.days.value)) {\n"
	       + "     alert(\"Course duration can not be blank!\")\n"
	       + "     return false\n"
	       + "  }\n"
               + "  if (Isempty(form.size.value)) {\n"
	       + "     alert(\"Class Size can not be blank!\")\n"
               + "     return false\n"
               + " }\n"
               + "}\n"
	       + "function Isempty(str) {\n"
	       + "  var typein = new String(str)\n"
	       + "  if (typein.length == 0) return true\n"
	       + "  while(typein.charCodeAt(0) == 32)\n"
	       + "     typein = typein.substring(1)\n"
	       + "  if (typein.length == 0) return true\n"
	       + "  return false\n"
               + "}\n");

    HTMLBuf.append(js);
    HTMLBuf.appendln("</HEAD>");
    HTMLBuf.appendln("<FORM METHOD=\"POST\" ACTION=\"ascdb.courses.AddCourse\" onSubmit=\"return Validation(this)\">");

   bd
     .addItem(new SimpleItem(f.toHTML()))
     .addItem(new SimpleItem("Create a new Catalog").setBold().setCenter())
     .addItem(SimpleItem.Paragraph);
     
     Font bf = new Font(Color.black,null,"+1");
     bd.addItem(new SimpleItem(bf.toHTML()));
	
     bd
	.addItem(new SimpleItem("All required fields are marked *...").setBold().setFontColor(Color.red))
	.addItem(SimpleItem.HorizontalRule)
        .addItem(SimpleItem.LineBreak)
        .addItem(new SimpleItem("Course Number*:  ").setBold().setFontColor(Color.black))
	.addItem(new TextField("courseNum",10,10,""))
        .addItem(SimpleItem.LineBreak)
        .addItem(new SimpleItem("Title*:  ").setBold().setFontColor(Color.black))
      	.addItem(SimpleItem.LineBreak)
	.addItem(new TextArea("tit",60,10))
        .addItem(SimpleItem.LineBreak)
        .addItem(new SimpleItem("Overview*:  ").setBold().setFontColor(Color.black))
      	.addItem(SimpleItem.LineBreak)
	.addItem(new TextArea("overview", 60, 10))
        .addItem(SimpleItem.LineBreak)
        .addItem(new SimpleItem("Duration (in days)*: ").setBold().setFontColor(Color.black))
       .addItem(new TextField("days", 32, 16, ""))
       .addItem(SimpleItem.LineBreak)
       .addItem(new SimpleItem("Agenda: ").setBold().setFontColor(Color.black))
       .addItem(SimpleItem.LineBreak)
       .addItem(new TextArea("agenda", 60, 10))
       .addItem(SimpleItem.LineBreak)
       .addItem(new SimpleItem("Prerequisites:  ").setFontColor(Color.black))
       .addItem(SimpleItem.LineBreak)
       .addItem(new TextArea("prereq", 60, 10))
       .addItem(SimpleItem.LineBreak)
       .addItem(new SimpleItem("Class Size*:  ").setFontColor(Color.black))
       .addItem(new TextField("size",10,10,""))
       .addItem(SimpleItem.LineBreak)
       .addItem(new Hidden("uid",uid))
       .addItem(new Submit("submit", "Submit!"))
       .addItem(new Reset("Reset"));

      HTMLBuf.append(bd);
      out.println(HTMLBuf);
    }
    catch(ClassNotFoundException e) {
	out.println("Can not load JDBC driver!");
    }
    catch(SQLException e) {
	 out.println(e.getMessage());
    }
    }
    
     private HtmlStringBuffer BackMainHome()
    {
       HtmlStringBuffer BackMain = new HtmlStringBuffer();
       BackMain.appendln("<form method=\"GET\" action=\"ascdb.pub.WelcomePage\">");
       BackMain.appendln("<input type=submit name=\"submit\" value=\"Back Main Menu\">");
       return BackMain;
    }
}
