/*
** Public view class session detail
** Class: ClassDetail
** Author: Yuping Zhu
** Date: 03-15-1999
** Modified By Yuping Zhu At: 01-25-2000
**          Action: Modify the display format
**           
*/

package ascdb.pub;

//import package java.sql to use JDBC
import java.sql.*;

//import package oracle.html to generate dynamic HTML page
import oracle.html.*;

import java.lang.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import ascdb.conf;

public 
    class ClassDetail extends HttpServlet {
    public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
	{
	
        // Output HTML page header
        res.setContentType("text/html");
	PrintWriter out = res.getWriter();
	conf dbconf= new conf(req);
	String ClassId = req.getParameter("cid"); 
	
       try {
	// Creates an HtmlHead Object
	HtmlHead hd = new HtmlHead("The Description of Class: " + ClassId);
	
        // Create an HtmlBody Object
	HtmlBody bd = new HtmlBody();

	// Sets various attributes of HtmlBody
     	bd.setBackgroundColor("#fffff2");

	// Creates an HtmlPage object using hd and bd
	HtmlPage hp = new HtmlPage(hd, bd);
	Font f = new Font(Color.olive,"myfont","+5");

        bd
	  .addItem(new SimpleItem(f.toHTML()))
	  .addItem(new SimpleItem("Class Overview").setCenter())
	  .addItem(SimpleItem.Paragraph);
	
 	// Load the Oracle JDBC driver
	Class.forName (dbconf.JdbcDriver);

	// Connect to the database
	Connection conn =
		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	
	// Create a Statement
	Statement stmt = conn.createStatement ();
	
	//Check if signed an instructor to the class
	ResultSet InstructorRset = stmt.executeQuery("select count(*) from class_instructors where class_id ='" + ClassId + "'");

	String QueryStr = "select * from class_schedule where  class_id ='" + ClassId + "'";
	int flag = 0;
	String inst = "N/A";
	
	if(! InstructorRset.next())
	{
	   hp.addItem(new SimpleItem("Can not happen!").setCenter().setFontColor(Color.red));
	   out.println(hp);	
	   return;
	}	
	if (InstructorRset.getInt(1) == 0)
	{ 
		flag = 1;
		QueryStr = "select * from simple_class where  class_id ='" + ClassId + "'";
	}
//	String QueryStr = "select * from class_schedule";
        ResultSet rset = stmt.executeQuery(QueryStr);

	if ( !rset.next() )
	{
           hp.addItem(new SimpleItem("Something Wrong!").setCenter().setFontColor(Color.red));
	   out.println(hp);	
//	   out.println("Something Wrong!");
	   return;
	}
	
  	if ( flag == 0 )
		inst = rset.getString("first_nam") + " " + rset.getString("last_nam");
	//Creates the table with 2 columns
	DynamicTable tab = new DynamicTable(2);
	tab.setBackgroundColor (Color.pink);
        tab.setBorderColor (Color.navy);
	tab.setCellSpacing(2);
	tab.setCellPadding(5);
	
	TableRow[] rows = new TableRow[10];
	for(int i=0; i < 10; i++)
	    rows[i] = new TableRow();
	
	rows[0]
	    .addCell(new TableDataCell(new SimpleItem(rset.getString("course_num")).setFontColor(Color.maroon).setBold()))
	    .addCell(new TableDataCell(new SimpleItem(rset.getString("Title")).setBold().setCenter()));
	rows[1]
	    .addCell(new TableDataCell(new SimpleItem("Overview").setBold().setFontColor(Color.maroon)))
	    .addCell(new TableDataCell(new SimpleItem(rset.getString("overview"))));
	rows[2]
	    .addCell(new TableDataCell(new SimpleItem("Duration").setBold().setFontColor(Color.maroon)))
	    .addCell(new TableDataCell(new SimpleItem(rset.getString("duration"))));

	String Syllabus = rset.getString("agenda");
	if (Syllabus == null)
		Syllabus = "N/A";
	rows[3]
	     .addCell(new TableDataCell(new SimpleItem("Agenda").setBold().setFontColor(Color.maroon)))
	     .addCell(new TableDataCell(new SimpleItem(Syllabus)));
	
	String Preq = rset.getString("prerequisites");
	if (Preq == null)
		Preq = "N/A";
	rows[4]
	    .addCell(new TableDataCell(new SimpleItem("Prerequisities").setBold().setFontColor(Color.maroon)))
	    .addCell(new TableDataCell(new SimpleItem(Preq)));
	rows[5]
	    .addCell(new TableDataCell(new SimpleItem("Class Size").setBold().setFontColor(Color.maroon)))
	    .addCell(new TableDataCell(new SimpleItem(rset.getString("class_size"))));
	String Bldg = rset.getString("building");
	String Room = rset.getString("room");
	String location = rset.getString("location");
	String city = rset.getString("city");
	String state = rset.getString("state");

	if (Bldg == null )
		Bldg = "ASC/HP ";
	if (Room == null)
		Room = " ";
	if (location.equals("N/A"))
	        location = "Building 676 Area B";
	if (city.equals("N/A"))
	        city = "Wright-Patterson AFB";
	if (state.equals("NA"))
	        state = "OH";
	
	
	rows[6]
	    .addCell(new TableDataCell(new SimpleItem("Location").setBold().setFontColor(Color.maroon)))
//	    .addCell(new TableDataCell(new SimpleItem(rset.getString("building") + " " + rset.getString("room") + ", " + rset.getString("location") + ", " + rset.getString("city") + " " + rset.getString("state"))));
	    // .addCell(new TableDataCell(new SimpleItem(Bldg + " " + Room + ", " + location + ", " + city + " " + state)));
	    .addCell(new TableDataCell(new SimpleItem(Bldg + " " + Room + "," + city + " " + state))); 
	    
        rows[7]
	    .addCell(new TableDataCell(new SimpleItem("Instructor").setBold().setFontColor(Color.maroon)))
	    .addCell(new TableDataCell(new SimpleItem(inst)));
	
	// Add new row to table
	for(int i=0; i< 10; i++)
	    tab.addRow(rows[i]);

	// Add the table to Html Body
	bd.addItem(tab.setCenter());
	
	bd
	  .addItem(SimpleItem.Paragraph)
	 .addItem(SimpleItem.HorizontalRule)
	 .addItem(SimpleItem.Paragraph);
	
	// output HTML page
	out.println(hp);

	}
	catch(ClassNotFoundException e) {
	out.println("Couldn't load database driver: " + e.getMessage());
        }
       catch (SQLException e) { 
	out.println(e.getMessage());
	}
}
    public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
	{
	doPost(req,res);
	}
}


		
	
