/*
** List all users in System
** Class: UserList
** Author: Yuping Zhu
** Date: 04-05-1999
** Modified 05-10-1999
**	Admin views the user's info. before apporve it
*/

package ascdb.users;

// import package java.sql to use JDBC
import java.sql.*;
 
// import package oracle.html to generate dynamic HTML page
import oracle.html.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.pub.UserCheck;
import ascdb.conf;

public class ListUser extends HttpServlet {
     public void doGet(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	conf dbconf = new conf(req);
	String uid = req.getParameter("me");
	UserCheck u = new UserCheck(uid);
	int op = (new Integer(req.getParameter("op"))).intValue();

        try {
	   // Creates an HtmlHead Object
	   HtmlHead hd = new HtmlHead("Training System User List");
	
           // Create an HtmlBody Object
	   HtmlBody bd = new HtmlBody();

	   // Sets various attributes of HtmlBody
     	   bd.setBackgroundColor("#fffff2");

	   // Creates an HtmlPage object using hd and bd
	   HtmlPage hp = new HtmlPage(hd, bd);
	
	   Form frm = new Form("POST","ascdb.users.ModifyUser");
	   if ((u.UserRole(1) != 0 ) & (op == 3))
	   {
		frm
		  .addItem(new Hidden("uid",u.userid))
		  .addItem(new Hidden("me",uid))
		  .addItem(new Submit("submit","Go!"));
		hp
		  .addItem(new SimpleItem("You only can modify your information, Click on the button to modify...").setBold().setFontColor(Color.red).setCenter())
		  .addItem(SimpleItem.LineBreak)	
		  .addItem(frm.setCenter());
		out.println(hp);
		return;
	   }
	   
	   if ((u.UserRole(1) != 0) & ! ((u.UserRole(2) == 0) & (op == 1)))
	   {
		hp.addItem(new SimpleItem("You do not have this privilege!").setBold());
		out.println(hp);
		return;
	   }

	   if ( op == 2) 
		hp.addItem(new SimpleItem("Click on User ID to view the user's info. and approve the user ...").setBold().setFontColor(Color.red));
	   else if (op == 3)
		hp.addItem(new SimpleItem("Click on User ID to modify the user ...").setBold().setFontColor(Color.red));
	   else if (op == 4)
		hp.addItem(new SimpleItem("Click on User ID to delete the user ...").setBold().setFontColor(Color.red));
	   
	   
	   Font f = new Font(Color.olive,"myfont","+3");
	  
 	   String tit = "All Users in Training System";
	   if (op == 2)
		tit = "All New Users in Training System";
	   hp
	     .addItem(new SimpleItem(f.toHTML()))
	     .addItem(new SimpleItem(tit).setCenter())
	     .addItem(SimpleItem.HorizontalRule);
	
	   Font bf = new Font(Color.black,null,"+1");
	   hp.addItem(new SimpleItem(bf.toHTML()));

	   // Load the Oracle JDBC driver
	   Class.forName (dbconf.JdbcDriver);

	   // Connect to the database
	   Connection conn =
		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	
	   // Create a Statement
	   Statement stmt = conn.createStatement ();
	
           //get the total user count
	   String QueryStr = "select count(*) from user_info";
	   ResultSet  rset1 = stmt.executeQuery(QueryStr);
	
	   int tot = 0;
	   if (rset1.next())
		tot = rset1.getInt(1);
	   if (tot == 0)
	   {
		hp.addItem(new SimpleItem("No User in Training System!"));
		out.println(hp);
		return;
	   }
	   rset1.close();

	   // List all users
	   String QueryString = "select oracle_uid,first_nam,last_nam,role,approved_date,position from user_info order by oracle_uid";

	   // execute query
           ResultSet rset = stmt.executeQuery (QueryString);
	
	   //Creates the table with 5 columns
      	   DynamicTable tab = new DynamicTable(5);
	   tab.setBackgroundColor (Color.pink);
           tab.setBorderColor (Color.navy);
	   tab.setCellSpacing(2);
	   tab.setCellPadding(5);
	
	   TableRow[] rows = new TableRow[tot + 1];
	   for(int i=0; i <= tot; i++)
	    	rows[i] = new TableRow();
	   rows[0]
	  	.addCell(new TableDataCell(new SimpleItem("User ID").setBold().setFontColor(Color.maroon))) 
	  	.addCell(new TableDataCell(new SimpleItem("Name").setBold().setFontColor(Color.maroon)))
	  	.addCell(new TableDataCell(new SimpleItem("System Role").setBold().setFontColor(Color.maroon)))
	  	.addCell(new TableDataCell(new SimpleItem("Position").setBold().setFontColor(Color.maroon)))
	  	.addCell(new TableDataCell(new SimpleItem("Approved Date").setBold().setFontColor(Color.maroon)));
	
	   //Create table by listing all course from courses
	   String Pos = "N/A";
	   String ApproveDate = "N/A";

	   int i = 1;
	   int r;
	   String role;
	   while (rset.next())
	   {  
	   r = rset.getInt("role");	   
	   if ( r==1 ) 
		role = "Admin";
	    else if (r==2)
		role = "CTA";
	    else if (r==3)
		role = "Instructor";
	    else 
		role = "Student";

	   if ((op !=2 ) | (rset.getDate("approved_date")) == null)
	    {	
	     if (op == 1)
		rows[i].addCell(new TableDataCell(new Link("ascdb.users.UserDetail?uid=" + rset.getString("oracle_uid") + "&me=" + uid + "&role=" + role + "&op=0", new SimpleItem(rset.getString("oracle_uid")).setBold())));
	     else if (op == 2)
//		rows[i].addCell(new TableDataCell(new Link("ascdb.users.ApproveUser?uid=" + rset.getString("oracle_uid") + "&me=" + uid, new SimpleItem(rset.getString("oracle_uid")).setBold())));
		rows[i].addCell(new TableDataCell(new Link("ascdb.users.UserDetail?uid=" + rset.getString("oracle_uid") + "&me=" + uid + "&role=" + role + "&op=1", new SimpleItem(rset.getString("oracle_uid")).setBold())));
	     else if (op == 3)
		rows[i].addCell(new TableDataCell(new Link("ascdb.users.ModifyUser?uid=" + rset.getString("oracle_uid") + "&me=" + uid + "&role=" + role, new SimpleItem(rset.getString("oracle_uid")).setBold())));
	     else if (op == 4 )
		rows[i].addCell(new TableDataCell(new Link("ascdb.users.DeleteUser?uid=" + rset.getString("oracle_uid") + "&me=" + uid, new SimpleItem(rset.getString("oracle_uid")).setBold())));

	    if ((rset.getString("position")) != null)
		  Pos = rset.getString("position");
	    else
		  Pos = "N/A";

	    if ((rset.getDate("approved_date")) != null)
		  ApproveDate = (rset.getDate("approved_date")).toString();
	    else
		  ApproveDate = "N/A";
	    
	    rows[i++]
		.addCell(new TableDataCell(new SimpleItem(rset.getString("first_nam") + " " + rset.getString("last_nam")).setBold()))
		.addCell(new TableDataCell(new SimpleItem(role).setBold()))
		.addCell(new TableDataCell(new SimpleItem(Pos).setBold()))
		.addCell(new TableDataCell(new SimpleItem(ApproveDate).setBold()));
	   } 
	   }

	   if ((i == 1 )&(op==2)) 
		hp.addItem(new SimpleItem("There are no new users who need registration approval").setCenter().setItal().setFontColor(Color.orange).setBold());
	   else
	   {
	        hp.addItem(new SimpleItem("Total: " + (i-1)).setCenter().setItal().setFontColor(Color.orange).setBold());

	        //Add new row to table
	        for(i=0; i< tot + 1; i++)
	    	 	tab.addRow(rows[i]);

	        // Add the table to Html Body
	        bd.addItem(tab.setCenter());
	
	        bd
	     	.addItem(SimpleItem.Paragraph)
	     	.addItem(SimpleItem.HorizontalRule)
	     	.addItem(SimpleItem.Paragraph);
	   }

	   // output HTML page
	   out.println(hp);
	   }  
	   catch(ClassNotFoundException e) {
		out.println("Couldn't load database driver: " + e.getMessage());
           }
           catch (SQLException e) { 
		out.println(e.getMessage());
	   }
	   catch(Exception e) {
		out.println(e.getMessage());
	   }
     }
}
	