/*
** The operation index on course
** Class: CourseIndex
** Author: Yuping Zhu
** Date: 03-24-1999
** Modify: 04-29-1999
**	   Add Help index
*/

package ascdb.admin;

// import package oracle.html to generate HTML page
import oracle.html.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import ascdb.conf;

public class CourseIndex extends HttpServlet {
   public void doGet(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	conf dbconf = new conf(req);	

	String uid = req.getParameter("me");
	// Create the HTML Page head
	HtmlHead hd = new HtmlHead("Training DB Course Index");
	
	// Create an HtmlBody Object
        HtmlBody bd = new HtmlBody();

        // Sets various attributes of HtmlBody
        bd.setBackgroundColor(Color.orange);

        // Creates an HtmlPage object using hd and bd
        HtmlPage hp = new HtmlPage(hd, bd);

//	bd.addItem(new SimpleItem("Training DB").setCenter().setBold().setFontColor(Color.black));
	bd.addItem(new Image(dbconf.ImageBase + "pet.gif","PET",IVAlign.TOP,false).setCenter());
	bd.addItem(SimpleItem.LineBreak);
//	bd.setFollowedLinkColor(Color.red);
	bd.setUnfollowedLinkColor(Color.white);
	bd.setActivatedLinkColor(Color.white);

	bd.addItem(new Link("ascdb.admin.TopIndex?me=" + uid,"Courses").setBold().setFontSize(4));
		
	Container dterms = new Container();
	DefinitionList dl = new DefinitionList();
	dl.addDef(dterms, new Link("ascdb.courses.CourseList?me=" + uid + "&op=0", new SimpleItem("List"),"content").setFontSize(2))
	  .addDef(dterms, new Link("ascdb.courses.CourseList?me=" + uid + "&op=1", new SimpleItem("Info. Input"),"content").setFontSize(2))
	  .addDef(dterms, new Link("ascdb.courses.CreateCourse?me=" + uid, new SimpleItem("Add"),"content").setFontSize(2))
	  .addDef(dterms, new Link("ascdb.courses.CourseList?me=" + uid + "&op=2", new SimpleItem("Modify"),"content").setFontSize(2))
	  .addDef(dterms, new Link("ascdb.courses.CourseList?me=" + uid + "&op=3", new SimpleItem("Delete"),"content").setFontSize(2));
	bd.addItem(dl);

	bd.addItem(new Link("ascdb.admin.ClassIndex?me=" + uid,"Classes").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.admin.UserIndex?me=" + uid, "Users").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.admin.EvaluateIndex?me=" + uid, "Evaluations").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.admin.LookupIndex?me=" + uid, "LookUp Tables").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.pub.Help?", new SimpleItem("Help"),"content").setBold().setFontSize(4));
	out.println(hp);
   }
}