/*
** Insert a new record into a look up table
** Class: InsertRow
** Author: Yuping Zhu
** Date: 04-09-1999
** Modified Date: 06-17-1999
**          Action: Filter blank required fields
 */

package ascdb.admin;

// import package java.sql to use JDBC
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;
import ascdb.pub.UserCheck;
import java.text.Collator;

public class InsertRow extends HttpServlet {
     public void doPost(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	conf dbconf = new conf(req);
	String me = req.getParameter("me");
	UserCheck u = new UserCheck(me);
	String TableName = req.getParameter("TName");
	String name = req.getParameter("name");
	String code = req.getParameter("code");

	try {
	   if (u.UserRole(1) != 0)
	   {
		out.println(u.userid + "! You have no privilege!");
		return;
	   }
	   // Load the Oracle JDBC driver
           Class.forName (dbconf.JdbcDriver);
        
           // Connect to the database
           Connection conn =
                DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
             
           // Create a Statement
           Statement stmt = conn.createStatement ();
             
           Collator cl = Collator.getInstance();

	   String ValueClause = name + "')";

	   ResultSet CountNum;
	   if (cl.equals(TableName,"v_states"))
	   {
		CountNum = stmt.executeQuery("select count(*) from v_states where state = '" + code + "' or state_nam = '" + name + "'");
		if (CountNum.next())
		   if (CountNum.getInt(1) != 0)	
		   {		
			   out.println("The state code or state name already exists!");
			   return;
		   }
	   }
	   else if (cl.equals(TableName,"v_countries"))
	   {
		CountNum = stmt.executeQuery("select count(*) from v_countries where country_abbr = '" + code + "' or country_nam = '" + name + "'");
		if (CountNum.next())
		   if (CountNum.getInt(1) != 0)	
		   {
		      out.println("The country abbreviation or country name already exists!");
		      return;
		   }
	   }
	   else
	   {
		CountNum = stmt.executeQuery("select count(*) from v_surtitles where surtitle = '" + name + "'");
		if (CountNum.next())
		   if (CountNum.getInt(1) != 0)	
		   {
		      out.println("The surtitle already exists!");
		      return;
		   }
	   }
	   if (cl.equals(TableName,"v_states") | cl.equals(TableName,"v_countries"))
                ValueClause = code + "','" + ValueClause;
		
	   String InsertString = "insert into " + TableName + " values('" + ValueClause; 
	   int rount = stmt.executeUpdate(InsertString);
	   out.println(InsertString + "<br>");
	   if (rount == 1)
		out.println("A new record has been inserted into table: " + TableName);

	   }
	    catch(ClassNotFoundException e) {
                 out.println("Couldn't load database driver: " + e.getMessage());
           }
	   catch (SQLException e) {
		out.println(e.getMessage());
	   }
	   catch(Exception e) {
		out.println(e.getMessage());
	   }
   }
}	   
	   