/*
** Modify a record in the look up table
** Class: ModifyRow
** Author: Yuping Zhu
** Date: 04-08-1999
*/

package ascdb.admin;

// import package oracle.html to generate dynamic HTML page
import oracle.html.*;

// import package java.sql to use JDBC
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;
import ascdb.pub.UserCheck;
import java.text.Collator;

public class ModifyRow extends HttpServlet {
     public void doGet(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	conf dbconf = new conf(req);
	String me = req.getParameter("me");
	UserCheck u = new UserCheck(me);
	String TableName = req.getParameter("name");
	String Id = req.getParameter("id"); 
//	int op = (new Integer(req.getParameter("op"))).intValue();

	try {
	   if (u.UserRole(1) != 0)
	   {
		out.println(u.userid + "! You have no this privilege!");
		return;
	   }
	
	   // Creates an HtmlHead Object
            HtmlHead hd = new HtmlHead("Modify look up table: " + TableName);
        
           // Create an HtmlBody Object
           HtmlBody bd = new HtmlBody();

           // Sets various attributes of HtmlBody
           bd.setBackgroundColor("#fffff2");
             
           // Creates an HtmlPage object using hd and bd
           HtmlPage hp = new HtmlPage(hd, bd);
 
	   // Load the Oracle JDBC driver
	   Class.forName (dbconf.JdbcDriver);
	
	   // Connect to the database
 	   Connection conn =
    		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);

	   // Create a Statement
	   Statement stmt = conn.createStatement ();
	    
	   
	   Collator cl = Collator.getInstance();
	   String QueryString = "select * from " + TableName + " where country_abbr = '" + Id + "'";
	   if (cl.equals(TableName,"v_states"))
		QueryString = "select * from " + TableName + " where state = '" + Id + "'";
	   else if (cl.equals(TableName,"v_surtitles"))
			QueryString = "select * from " + TableName + " where surtitle = '" + Id + "'";

  	   ResultSet rset = stmt.executeQuery(QueryString);

	   Form frm = new Form("POST","ascdb.admin.UpdateRow");

	   while (rset.next())
		if (cl.equals(TableName,"v_surtitles"))
		frm
		  .addItem(new SimpleItem("Surtitle: ").setBold().setFontColor(Color.olive))
		  .addItem(new TextField("name",7,7,rset.getString(1)));
		else if (cl.equals(TableName,"v_states"))
		frm
		  .addItem(new SimpleItem("State Code: ").setBold().setFontColor(Color.olive))
		  .addItem(new TextField("code",50,40,rset.getString(1)))
		  .addItem(SimpleItem.LineBreak)
	   	  .addItem(new SimpleItem("State Name: ").setBold().setFontColor(Color.olive))
		  .addItem(new TextField("name",50,40,rset.getString(2)));
		  
  		else
		frm
		  .addItem(new SimpleItem("Country Abbreviate: ").setBold().setFontColor(Color.olive))
		  .addItem(new TextField("code",2,2,rset.getString(1)))
		  .addItem(SimpleItem.LineBreak)
	   	  .addItem(new SimpleItem("Country Name: ").setBold().setFontColor(Color.olive))
		  .addItem(new TextField("name",60,40,rset.getString(2)));
	  
	   frm
		.addItem(SimpleItem.LineBreak)
		.addItem(new Hidden("me",me))
		.addItem(new Hidden("id",Id))
		.addItem(new Hidden("TName", TableName))
		.addItem(new Submit("submit","Update!"));

	   hp.addItem(new SimpleItem("Modify a record in Table: " + TableName).setBold().setFontColor(Color.red));

	   // Add the form to html body
	   bd.addItem(frm);
	   //output HTML page
	   out.println(hp);
 	   }
	   catch(ClassNotFoundException e) {
                 out.println("Couldn't load database driver: " + e.getMessage());
           }
           catch (SQLException e) { 
                out.println(e.getMessage());
           }
	   catch(Exception e) {
		out.println(e.getMessage());
	   }
   }
}