/*
** For administrator to send emails to new register
** Class: SendEmail
** Author: Yuping Zhu
** Date: 04-05-2000
*/

package ascdb.admin;

// import package java.sql to use JDBC
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.Hashtable;

import ascdb.conf;
import ascdb.users.UserValidation;
import ascdb.admin.msgManager;

public class SendEmail extends HttpServlet {

    private msgManager msg = new msgManager();
    private Hashtable UserTable = new Hashtable();
    private Connection conn;
    private Statement stmt;

    private String uid;
    private conf dbconf;
    private String me;
    private String op;
    PrintWriter out;

    public void doGet (HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        out = res.getWriter();
	dbconf = new conf(req);
	uid = req.getParameter("u");
	me = req.getParameter("uid");
	op = req.getParameter("op");
	UserValidation UserV = new UserValidation();
	int ret = 0;

	try {
	   int TabRow = UserV.Validation(req);
	   if (TabRow != 7)
	   {
	        out.println("You do not have this privillege!");
		BackMainHome();
		return;
	   }
	   	   
	   if ( op.compareTo("1") == 0)
	       ret = RegisterReceived();
	   else if (op.compareTo("2") == 0)
	       ret = NacNotOnFile();
	   else if (op.compareTo("3") == 0)
	       ret = NacRegisterConfirmed();
	   else if (op.compareTo("4") == 0)
	       ret = SponVerify();
	   else if (op.compareTo("5") == 0)
	       ret = RegisterConfirmed();
	   else
	       ret = Reminder();
   
	   if ( ret != 0)
	   {
	       LogEmail(ret);
	       if (ret == 4)
		   EmailTrack();
	       BackToApprovePage("The Email has been sent out");
	   }
	   else 
	   BackToApprovePage("The user did not provide email");
        }
	catch (ClassNotFoundException e) {
	    out.println("Can not load JDBC Driver!");
	}
	catch (SQLException e) {
	    out.println(e.getMessage());
	    return;
	}
    }

    private void LogEmail(int EmailType)
            throws ClassNotFoundException,SQLException
    {
	int count = stmt.executeUpdate("insert into user_emails values ('"
				       + uid + "',sysdate,'"
				       + me + "'," 
				       + EmailType + ")");
    }

    private void EmailTrack()
            throws ClassNotFoundException,SQLException
    {
	int count = stmt.executeUpdate("insert into sponsor_email_tracking values ('" 
				       + uid + "',sysdate,'"
				       + (String)UserTable.get("sponUid") 
				       + "','N',null,null)");
    }

    private void openDB()
            throws ClassNotFoundException,SQLException
    {
 	// Load the Oracle JDBC driver
	   Class.forName (dbconf.JdbcDriver);
	
	// Connect to the database
	   Connection conn =
     		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	   stmt = conn.createStatement();
    }

    private String getEmail() 
            throws ClassNotFoundException,SQLException
    {
	openDB();
	// Get the user's email
	ResultSet rset = stmt.executeQuery("select email from users where oracle_uid='" + uid + "'");
	   
        if (rset.next())
	   return rset.getString(1);
	return null;
    }

    private String getSponEmail()
             throws ClassNotFoundException,SQLException
    {
	openDB();
	// Get Sponsor's uid from users
	ResultSet rset = stmt.executeQuery("select spons_agency_uid,last_nam,first_nam from users where oracle_uid='" + uid + "'");
	
	if (rset.next())
	{
	    String SponUid = rset.getString(1);
	    UserTable.put("sponUid",rset.getString(1));
	    UserTable.put("f_name",rset.getString(3));
	    UserTable.put("l_name",rset.getString(2));
	    rset.close();
	    ResultSet rset1 = stmt.executeQuery("select * from users where oracle_uid='" + SponUid +"'");
	    if (rset1.next())
	    {
	      	UserTable.put("slname",rset1.getString("last_nam"));
		UserTable.put("sfname",rset1.getString("first_nam"));
		UserTable.put("org",rset1.getString("organization"));
	       	UserTable.put("sphone",rset1.getString("phone"));
		if (rset1.getString("phone_ext") != null)
		    UserTable.put("sext",rset1.getString("phone_ext"));
		else 
		    UserTable.put("sext","N/A");
	       	UserTable.put("sfax",rset1.getString("fax"));
		UserTable.put("semail",rset1.getString("email"));
		return rset1.getString("email");
	    }
	}
	return null;
    }
	

    private int RegisterReceived()
           throws ClassNotFoundException,SQLException
    {
      	String uEmail = getEmail();

	if (uEmail != null)
	{
	    UserTable.put("admph",dbconf.AdminPhone);
	    UserTable.put("freephone",dbconf.FreePhone);
	    UserTable.put("TMDemail",dbconf.TMDEmail);
	    UserTable.put("officer",dbconf.OfficerName);
	    UserTable.put("officerPH",dbconf.OfficerPh);
	    UserTable.put("officerEmail",dbconf.OfficerEmail);
	    UserTable.put("officerFax",dbconf.OfficerFax);
	    UserTable.put("dsn",dbconf.DSN);
	    msg.putHashTable(UserTable);

	    msg.msgSender(uEmail,dbconf.TMDEmail,"yuzhu@mailbox.syr.edu","Register",dbconf.EmailServer);
	    return 1;
	    }
	return 0;
    }

    private int NacNotOnFile()
          throws ClassNotFoundException,SQLException
    {
	String uEmail = getEmail();
	if (uEmail != null)
	{
	    msg.msgSender(uEmail,dbconf.TMDEmail,"yuzhu@mailbox.syr.edu","NacNotOnFile",dbconf.EmailServer);
	    return 1;
	}
	return 0;
    }

    private int NacRegisterConfirmed()
          throws ClassNotFoundException,SQLException
    {
	String uEmail = getEmail();
	if (uEmail != null)
	{
	    msg.msgSender(uEmail,dbconf.TMDEmail,"yuzhu@mailbox.syr.edu","NacRegisterConfirmed",dbconf.EmailServer);
	    return 1;
	}
	return 0;
    }

    private int SponVerify()
          throws ClassNotFoundException,SQLException
    {
	String uEmail = getEmail();
	String SponEmail = getSponEmail();

	if (uEmail != null)
	{
	    if (SponEmail != null)
	    {
		UserTable.put("admph",dbconf.AdminPhone);
		UserTable.put("freephone",dbconf.FreePhone);
		msg.putHashTable(UserTable);
		msg.msgSender(uEmail,dbconf.TMDEmail,"yuzhu@mailbox.syr.edu","Sponsor TMD",dbconf.EmailServer);
	        return 1;
	    }
	    return 2;
	}
	return 0;
    }

    private int RegisterConfirmed()
          throws ClassNotFoundException,SQLException
    {
	String uEmail = getEmail();
	if (uEmail != null)
	{
	    msg.msgSender(uEmail,dbconf.TMDEmail,"yuzhu@mailbox.syr.edu","RegisterConfirmed",dbconf.EmailServer);
	    return 1;
	}
	return 0;
    }

    private int Reminder()
          throws ClassNotFoundException,SQLException
    {
	String uEmail = getEmail();
	if (uEmail != null)
	{
	    msg.msgSender(uEmail,dbconf.TMDEmail,"yuzhu@mailbox.syr.edu","Reminder",dbconf.EmailServer);
	    return 1;
	}
	return 0;
    }

    private void BackToApprovePage(String Str)
    {
	out.println("<body bgcolor=\"#ffffff\">");
	out.println("<center>");
	out.println("<font size=+4 color=red>" + Str + "</font>");
	out.println("<form method=\"GET\" action=\"ascdb.users.DoVerifyUser\">");
        out.println("<input type=hidden name=\"uid\" value=\"" + me + "\">");
	out.println("<input type=hidden name=\"u\" value=\"" + uid + "\">");
	out.println("<input type=hidden name=\"op\" value=\"1\">");
	 out.println("<input type=submit name=\"submit\" value=\"Back To Approve Page\">");
    }

     private void BackMainHome()
    {
	out.println("<body bgcolor=\"#ffffff\">");
	out.println("<form method=\"GET\" action=\"ascdb.users.WelcomePage\">");
	out.println("<input type=submit name=\"submit\" value=\"Back Main Menu\">");
    }
    
}
