/*
** Delete a class session record from DB 
** Class: ClassDelete
** Author: Yuping Zhu
** Date: 04-02-1999
*/

package ascdb.classes;

// import package java.sql to use JDBC
import java.sql.*;

// import oracle.html and javax.servlet package to generate dynamic HTML page
import oracle.html.*;
import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import ascdb.conf;
import ascdb.pub.UserCheck;
import java.text.Collator;

public class ClassDelete extends HttpServlet{

    public static String uid = null;

    
    public void doGet(HttpServletRequest req, HttpServletResponse res)
                throws ServletException, IOException
        {
        
        // Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
        conf dbconf= new conf(req);
        uid = req.getParameter("me");
        String cidStr = req.getParameter("cid");
	int cid = (new Integer(cidStr)).intValue();
        UserCheck u = new UserCheck(uid);
	String opStr = req.getParameter("op");
 	int op = 0;
        
        try {
	    // Creates an HtmlHead Object
    	    HtmlHead hd = new HtmlHead("Delete a Course");
 
    	    // Create an HtmlBody Object
            HtmlBody bd = new HtmlBody();

    	    // Sets various attributes of HtmlBody
            bd.setBackgroundColor("#fffff2");

            // Creates an HtmlPage object using hd and bd
            HtmlPage hp = new HtmlPage(hd, bd);


            if (u.UserRole(1) < 0) {
                hp.addItem(new SimpleItem("You have no this privilegel"));
                out.println(hp);
                return;
            }
            // Load the Oracle JDBC driver
            Class.forName (dbconf.JdbcDriver);

            // Connect to the database
            Connection conn =
                DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
        
            // Create a Statement
            Statement stmt = conn.createStatement ();
	
	    if (opStr == null)
		out.print(DeleteWarning(cidStr,bd,hp));
	    else {
		 op = (new Integer(opStr)).intValue();
	         if (op==1) {
		    // Delete class instructor from table : class_instructors
		    int instCount = stmt.executeUpdate("delete from class_instructors where class_id = " + cid);
		    //Delete registered students
		    int studentCount = stmt.executeUpdate("delete from class_students where class_id = " + cid);
            	    // Delete class session 
            	    int classCount = stmt.executeUpdate("delete from classes where class_id = " + cid);

	    	    hp.addItem(new SimpleItem("The Class session: " + cid + " has been deleted!").setBold());
	    	  }
	    	 else if (op ==2) 
		    hp.addItem(new SimpleItem("The Class session: " + cid + " is not deleted!").setBold());
            	 out.println(hp);
	    }
         }
         catch (ClassNotFoundException e) {
          out.println("Can not load the JDBC Driver: "+ e.getMessage());
         }
         catch (SQLException e) {
          out.println(e.getMessage());
         }
         catch (Exception e) {
          out.println(e.getMessage());
         }
    }
    public static HtmlPage DeleteWarning(String c,HtmlBody bd, HtmlPage hp) {
	Collator cl = Collator.getInstance();
	Form frm1 = new Form("GET","ascdb.classes.ClassDelete");
	frm1
	   .addItem(SimpleItem.LineBreak)
	   .addItem(new Hidden("me",uid))
	   .addItem(new Hidden("cid",c))
	   .addItem(new Hidden("op","1"))
	   .addItem(new Submit("submit","Delete!"));
	
	Form frm2 = new Form("GET","ascdb.classes.ClassDelete");
	frm2
	   .addItem(new Hidden("cid",c))  
	   .addItem(new Hidden("me",uid))
	   .addItem(new Hidden("op","2"))
	   .addItem(new Submit("submit","No!"));
	bd
	  .addItem(new SimpleItem("Class Session: " + c +" and relative instructor/student enrollment information will be deleted from system ...!").setBold().setFontColor(Color.red))
	  .addItem(frm1.setCenter().setBold())
	  .addItem(frm2.setCenter().setBold());
        
  	return(hp);
    }	
}



  