/*
** Provide web interface to modify class information
** Class: ClassModify
** Author: Yuping Zhu
** Date: 04-02-1999
*/

package ascdb.classes;

//import package java.sql to use JDBC
import java.sql.*;

//import package oracle.html to generate dynamic HTML page
import oracle.html.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import ascdb.conf;
import ascdb.pub.UserCheck;

import java.text.Collator;

public class ClassModify extends HttpServlet {
    public void doGet(HttpServletRequest req, HttpServletResponse res)
                throws ServletException, IOException
        {
        
        // Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
        conf dbconf= new conf(req);
        String cidStr = req.getParameter("cid");
        int cid = (new Integer(cidStr)).intValue();
        String uid = req.getParameter("me");
        UserCheck u = new UserCheck(uid);
	Collator cl = Collator.getInstance();
        
	try {
        // Creates an HtmlHead Object
        HtmlHead hd = new HtmlHead("Modify Course Information");
        
        // Create an HtmlBody Object
        HtmlBody bd = new HtmlBody();

        // Sets various attributes of HtmlBody
        bd.setBackgroundColor("#fffff2");
             
        // Creates an HtmlPage object using hd and bd
        HtmlPage hp = new HtmlPage(hd, bd);
  
        if (u.UserRole(1) < 0) {
                hp.addItem(new SimpleItem("You have no this privilegel"));
                out.println(hp);
                return;
        }

	hp
	  .addItem(new SimpleItem("Please modify class information").setBold().setFontColor(Color.red))
          .addItem(SimpleItem.HorizontalRule);
	  
	// Load the Oracle JDBC driver
        Class.forName (dbconf.JdbcDriver);

        // Connect to the database
        Connection conn =
                DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
        
        // Create a Statement
        Statement stmt = conn.createStatement ();

        // Pick up the course info. from DB
	// First check if signed an instructor to the class
	ResultSet InstructorRset = stmt.executeQuery("select count(*) from class_instructors where class_id =" + cid);
	
	String QueryString = "select * from class_schedule where  class_id =" + cid;
	int flag = 0;
	String OldInst = "N/A";
	
	if(! InstructorRset.next())
	{
	   hp.addItem(new SimpleItem("Can not happen!").setCenter().setFontColor(Color.red));
	   out.println(hp);	
	   return;
	}	
	if (InstructorRset.getInt(1) == 0)
	{ 
		flag = 1;
		QueryString = "select * from simple_class where  class_id =" + cid;
	}
//        String QueryString = "select * from class_schedule where class_id = " + cid;
        // execute query
        ResultSet rset = stmt.executeQuery (QueryString);

//	String OldInst;
	String OldState;
	String CourseId;

	if (rset.next()) 
        {
	    if ( flag == 0 )
		OldInst =  rset.getString("instructor_uid");	
	
            Form frm = new Form("POST",dbconf.ServerURLBase + "ascdb.classes.InsertClass");
	    frm
                .addItem(SimpleItem.LineBreak)
                .addItem(new SimpleItem("Class ID: ").setBold().setItal().setFontColor(Color.olive))
		.addItem(new SimpleItem(cidStr).setBold().setFontColor(Color.red))
		.addItem(SimpleItem.LineBreak)
		.addItem(new SimpleItem("Course ID: ").setBold().setItal().setFontColor(Color.olive))
		.addItem(new SimpleItem(rset.getString("course_id")).setBold().setFontColor(Color.red))
		.addItem(SimpleItem.LineBreak)
		.addItem(new SimpleItem("Class Start Date(YYYY-MM-DD):").setBold())
	  	.addItem(new TextField("c_start_date", 32, 16, (rset.getDate("class_start_date")).toString()))
		.addItem(SimpleItem.LineBreak)
   	  	.addItem(new SimpleItem("Class Size:").setBold())
   	  	.addItem(new TextField("c_size", 32, 16, (rset.getString("class_size"))))
		.addItem(SimpleItem.LineBreak)	
   	  	.addItem(new SimpleItem("Location:").setBold())
   	  	.addItem(new TextField("c_site", 50, 25, rset.getString("location")))
   	  	.addItem(SimpleItem.LineBreak)
   	  	.addItem(new SimpleItem("City:").setBold())
   	  	.addItem(new TextField("c_city", 30, 20, rset.getString("city")))
   	  	.addItem(SimpleItem.LineBreak)
   	  	.addItem(SimpleItem.LineBreak)
		.addItem(new SimpleItem("Building:").setBold())
   	  	.addItem(new TextField("c_building", 30, 20, rset.getString("building")))
   	  	.addItem(SimpleItem.LineBreak)
   	  	.addItem(new SimpleItem("Room:").setBold())
   	  	.addItem(new TextField("c_room", 20, 20, rset.getString("room")))
   	  	.addItem(SimpleItem.LineBreak);

//	    OldInst = rset.getString("instructor_uid");		
	    OldState = rset.getString("state");
	    CourseId = rset.getString("course_id");

	    // List all instructors
	    frm.addItem(new SimpleItem("Select an Instructor: ").setBold());
	    ResultSet Instrset = stmt.executeQuery("select * from user_info where role = 1 or role = 3 or role = 5");
	    Select instSelect = new Select("inst");
	    while(Instrset.next())
		if (cl.equals(Instrset.getString("oracle_uid"),OldInst))
		   instSelect.addOption(new Option(Instrset.getString("oracle_uid") + "(" +Instrset.getString("first_nam") + " " + Instrset.getString("last_nam") + ")",Instrset.getString("oracle_uid"),true));
		else
		   instSelect.addOption(new Option(Instrset.getString("oracle_uid") + "(" +Instrset.getString("first_nam") + " " + Instrset.getString("last_nam") + ")",Instrset.getString("oracle_uid"),false));
	   
	    // If old instructor is not available
	    if ( flag == 1)
		   instSelect.addOption(new Option("N/A","N/A",true));
	    else 
		   instSelect.addOption(new Option("N/A","N/A",false));

	    frm
	  	.addItem(instSelect)
	   	.addItem(SimpleItem.LineBreak);
	   
	    // List all valid state from table v_states	
	    frm 
   	  	.addItem(new SimpleItem("Select a State:").setBold());
	    ResultSet Staterset = stmt.executeQuery("select * from v_states");

	    Select  StateSelect = new Select("c_state");
	
//	    flag = 0;

	    while(Staterset.next())
		if (cl.equals(Staterset.getString(1),OldState))
		{
		   flag = 1;
		   StateSelect.addOption(new Option(Staterset.getString(1),Staterset.getString(1),true));
		}
		else
    		   StateSelect.addOption(new Option(Staterset.getString(1),Staterset.getString(1),false));
/*	    if ( flag == 0)
		   StateSelect.addOption(new Option("N/A","N/A",true));
	    else 
		   StateSelect.addOption(new Option("N/A","N/A",false));
*/
	    
	    frm
		.addItem(StateSelect)
   	   	.addItem(SimpleItem.Paragraph);

	    frm.addItem(new Hidden("op","1"))
	       .addItem(new Hidden("courseid",CourseId))
	       .addItem(new Hidden("classid",cidStr));

	    frm
    	  	.addItem(new Submit("submit", "Modify!"))
    	  	.addItem(new Reset("Reset"));             

	    bd.addItem(frm);
	    //output HTML page
	    out.println(hp);
            }
	}
	catch(ClassNotFoundException e) {
	    out.println("Can not load JDBC driver: " + e.getMessage());
	}
	catch(SQLException e) {
	    out.println(e.getMessage());
	}
     	catch (Exception e) {
  	    out.println(e.getMessage());
        }
}
}
          
	



