/*
** Create a new class session
** Class: CreateClass
** Author: Yuping Zhu
** Date: 03-29-1999
*/

package ascdb.classes;

// import package java.sql to use JDBC;
import java.sql.*;

// import package oracle.html to generate dynamic HTML Page
import oracle.html.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;
import ascdb.pub.UserCheck;

public class CreateClass extends HttpServlet {
    public void doGet(HttpServletRequest req, HttpServletResponse res)
                throws ServletException, IOException
    {
    // Output HTML page header
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    conf dbconf= new conf(req);
    String CourseId = req.getParameter("cid");
    String uid = req.getParameter("me");
    UserCheck u = new UserCheck(uid);

    try {
    	// Creates an HtmlHead Object
    	HtmlHead hd = new HtmlHead("Create new class");

    	// Create an HtmlBody Object
    	HtmlBody bd = new HtmlBody();

    	// Sets various attributes of HtmlBody
     	bd.setBackgroundColor("#fffff2");
 	Font f = new Font(Color.olive,"myfont","+5");

    	// Creates an HtmlPage object using hd and bd
   	HtmlPage hp = new HtmlPage(hd, bd);


     	if (u.UserRole(1) != 0)
     	{
	    hp.addItem(new SimpleItem("You have no privilege to create new class!").setBold());
	    out.println(hp);
	    return;
	}

	// Load the Oracle JDBC driver
        Class.forName (dbconf.JdbcDriver);
             
        // Connect to the database
        Connection conn =
                DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
             
        // Create a Statement
        Statement stmt = conn.createStatement ();
	
	// Get class ID from class_seq
	ResultSet ClassIdrset = stmt.executeQuery("select classes_seq.nextval from dual");
	String ClassId = null;

	if (ClassIdrset.next())
    	   ClassId = ClassIdrset.getString(1);

	ClassIdrset.close();

	hp
     	  .addItem(new SimpleItem(f.toHTML()))
     	  .addItem(new SimpleItem("Create a new Class").setBold().setCenter())
     	  .addItem(SimpleItem.Paragraph)
     	  .addItem(SimpleItem.HorizontalRule)
     	  .addItem(SimpleItem.Paragraph);
	
	Font bf = new Font(Color.black,null,"+1");
     	hp.addItem(new SimpleItem(bf.toHTML()));
	
	// Creates the main form
	Form frm = new Form("POST",dbconf.ServerURLBase + "ascdb.classes.InsertClass");
	frm
	  .addItem(new SimpleItem("Course ID:  ").setBold())
   	  .addItem(new SimpleItem(CourseId).setBold().setFontColor(Color.red))
   	  .addItem(SimpleItem.LineBreak)
   	  .addItem(new SimpleItem("Class ID:  ").setBold())
   	  .addItem(new SimpleItem(ClassId).setBold().setFontColor(Color.red))
   	  .addItem(SimpleItem.LineBreak)
   	  .addItem(new SimpleItem("Class Start Date(MM-DD-YYYY):").setBold())
   	  .addItem(new TextField("c_start_date", 32, 16, ""))
   	  .addItem(SimpleItem.LineBreak)
   	  .addItem(new SimpleItem("Class Size:").setBold())
   	  .addItem(new TextField("c_size", 32, 16, ""))
   	  .addItem(SimpleItem.LineBreak);

	// List all instructors
	frm.addItem(new SimpleItem("Select an Instructor: ").setBold());
	ResultSet Instrset = stmt.executeQuery("select * from user_info where role = 1 or role = 3 or role = 5");
	Select instSelect = new Select("inst");
	while(Instrset.next())
		instSelect.addOption(new Option(Instrset.getString("oracle_uid") + "(" +Instrset.getString("first_nam") + " " + Instrset.getString("last_nam") + ")"));
	instSelect.addOption(new Option("N/A","N/A",true));
	
	frm
	  .addItem(instSelect)
	  .addItem(SimpleItem.LineBreak)	
   	  .addItem(new SimpleItem("Location:").setBold())
   	  .addItem(new TextField("c_site", 50, 25, ""))
   	  .addItem(SimpleItem.LineBreak)
   	  .addItem(new SimpleItem("City:").setBold())
   	  .addItem(new TextField("c_city", 30, 20, ""))
   	  .addItem(SimpleItem.LineBreak);

	// List all valid state from table v_states	
	frm 
   	  .addItem(new SimpleItem("Select a State:").setBold());
	ResultSet Staterset = stmt.executeQuery("select * from v_states");

	Select  StateSelect = new Select("c_state");

	while(Staterset.next())
    		StateSelect.addOption(new Option(Staterset.getString(1)));
//	StateSelect.addOption(new Option("N/A","N/A",true));
	

	frm.addItem(StateSelect)
   	   .addItem(SimpleItem.LineBreak);
        
	frm 
   	  .addItem(new SimpleItem("Building:").setBold())
   	  .addItem(new TextField("c_building", 30, 20, ""))
   	  .addItem(SimpleItem.LineBreak)
   	  .addItem(new SimpleItem("Room:").setBold())
   	  .addItem(new TextField("c_room", 20, 20, ""))
   	  .addItem(SimpleItem.Paragraph);

	frm.addItem(new Hidden("op","0"))
	   .addItem(new Hidden("courseid",CourseId))
	   .addItem(new Hidden("classid",ClassId));

	frm
    	  .addItem(new Submit("submit", "Submit!"))
    	  .addItem(new Reset("Reset"));             

	bd.addItem(frm);
	//output HTML page
	out.println(hp);
     }
     catch (Exception e) {
	out.println(e.getMessage());
     }
}
}


     	
