/*
** For administrator to verify class
** Class: DoVerifyClass
** Author: Yuping Zhu
** Date: 04-12-2000
*/

package ascdb.classes;

import oracle.html.*;
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.users.UserValidation;
import ascdb.conf;

import java.util.Calendar;
import java.text.SimpleDateFormat;
import java.util.TimeZone;

public class DoVerifyClass extends HttpServlet {
    public void doGet(HttpServletRequest req, HttpServletResponse res)
                throws ServletException, IOException
    {
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    conf dbconf = new conf(req);
    UserValidation UserV = new UserValidation();
    String uid = req.getParameter("uid");
    String cid = req.getParameter("cid");
    String op = req.getParameter("op");

    try {

	int TabRow = UserV.Validation(req);

	if (TabRow < 5)
	{
	    out.println("You do not have this privilege!");
	    out.println(BackMainHome());
	    return;
	}

	HtmlStringBuffer HTMLBuf = new HtmlStringBuffer();
	HTMLBuf.appendln("<HTML>");
	HTMLBuf.appendln("<HEAD>");
	if (op.compareTo("0") == 0)
	    HTMLBuf.appendln("<TITLE>Verify new Course/Class</TITLE>");
	else
	   if (op.compareTo("1") == 0)
	       HTMLBuf.appendln("<TITLE>Post a Class</TITLE>");
	else
	    HTMLBuf.appendln("<TITLE>Change a Course/Class</TITLE>");

	//Create a JavaScript Object
	Script js = new Script("JavaScript");
	js.setCode("function Validation(form) {\n"
		 + "   if (form.copres[0].checked) {\n"
		 + "      var fg = 0\n"
		 + "      if (form.copresex.value.length == 0) \n"
                 + "         fg = 1 \n"
                 + "      var coName = form.copresex.value\n"
                 + "      while (coName.charCodeAt(0) == 32)\n"
                 + "            coName = coName.substring(1)\n"
                 + "      if (coName.length == 0) \n"
                 + "         fg = 1\n"
                 + "      if (fg == 0) return true\n"
		 + "      alert(\"You must give the names of your co-presentors.\")\n"
		 + "      return false\n"
		 + "   }\n"
                 + "}\n");
	HTMLBuf.append(js);
	HTMLBuf.appendln("</HEAD>");
        HTMLBuf.appendln("<FORM METHOD=\"POST\" ACTION=\"ascdb.classes.DoneVerifyClass\" onSubmit=\"return Validation(this)\">");
	

	// Create an HtmlBody Object
	HtmlBody bd = new HtmlBody();

	// Sets various attributes of HtmlBody
	bd.setBackgroundColor("#fffff2");
	Font f = new Font(Color.olive,"myfont","+5");

	bd
	    .addItem(new SimpleItem(f.toHTML()))
	    .addItem(new SimpleItem("Verify new Course/Class").setBold().setCenter())
	    .addItem(SimpleItem.Paragraph);
     
	Font bf = new Font(Color.black,null,"+1");
	bd.addItem(new SimpleItem(bf.toHTML()));

	bd
	.addItem(new SimpleItem("All inputs are required...").setBold().setFontColor(Color.red))
	.addItem(SimpleItem.HorizontalRule)
        .addItem(SimpleItem.LineBreak)
	.addItem(new SimpleItem("Require use of our system?  ").setBold().setFontColor(Color.black));
	
	//Load JDBC Driver
	Class.forName(dbconf.JdbcDriver);
	// Connect to DB
	Connection conn =
	    DriverManager.getConnection(dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	// Create a statement
	Statement stmt = conn.createStatement ();

	// Get Class info. from DB
	ResultSet classSet = stmt.executeQuery("select * from classes where class_id='" + cid + "' order by class_start_date");

	if (! classSet.next())
	{
	   bd.addItem(new SimpleItem("No such class!"));
	   HTMLBuf.append(bd);
	   out.println(HTMLBuf);
	   return;
	}
	
	// Create another statement
	Statement stmt1 = conn.createStatement ();

	ResultSet instSet = stmt1.executeQuery("select instructor_uid from class_instructors where class_id ='" + classSet.getString("class_id") + "'");
	
	String instName = "";
	String instId = "";
	if (instSet.next())
	{
	    instId = instSet.getString(1);
	    ResultSet NameSet = stmt1.executeQuery("select last_nam,first_nam from users where oracle_uid ='" + instId + "'");
	    if (NameSet.next())
		instName = NameSet.getString(2) + " " + NameSet.getString(1);
	}
	
	String courseId = classSet.getString("course_id");

	ResultSet courseSet = stmt1.executeQuery("select * from catalog where course_id='" +  courseId + "'");
	
	if (! courseSet.next())
	{
	   bd.addItem(new SimpleItem("No such course!"));
	   HTMLBuf.append(bd);
	   out.println(HTMLBuf);
	   return;
	}

	if ((classSet.getString("system_use")).compareTo("Y") == 0)
	    bd
		.addItem(new SimpleItem("Yes"))
		.addItem(new Radio("system","Y",true))
		.addItem(new SimpleItem("No"))
		.addItem(new Radio("system","N"));
	else
	    bd
		.addItem(new SimpleItem("Yes"))
		.addItem(new Radio("system","Y"))
		.addItem(new SimpleItem("No"))
		.addItem(new Radio("system","N",true));
	bd
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Need materials handed out to students or files loaded into the student accounts?  ").setBold().setFontColor(Color.black));
	if ((classSet.getString("student_materials")).compareTo("Y") == 0)	
	    bd
		.addItem(new SimpleItem("Yes"))
		.addItem(new Radio("stuff","Y",true))
		.addItem(new SimpleItem("No"))
		.addItem(new Radio("stuff","N"));
	else
	    bd
		.addItem(new SimpleItem("Yes"))
		.addItem(new Radio("stuff","Y"))
		.addItem(new SimpleItem("No"))
		.addItem(new Radio("stuff","N",true));
	bd
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Permission to video tape this class?  ").setBold().setFontColor(Color.black));
	if ((classSet.getString("tape")).compareTo("Y") == 0)
	     bd
		.addItem(new SimpleItem("Yes"))
		.addItem(new Radio("tape","Y",true))
		.addItem(new SimpleItem("No"))
		.addItem(new Radio("tape","N"));
	else
	    bd
		.addItem(new SimpleItem("Yes"))
		.addItem(new Radio("tape","Y"))
		.addItem(new SimpleItem("No"))
		.addItem(new Radio("tape","N",true));

	bd
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Permission to use this class on our website?  ").setBold().setFontColor(Color.black));
	if ((classSet.getString("webhost")).compareTo("Y") == 0)
	     bd
		.addItem(new SimpleItem("Yes"))
		.addItem(new Radio("web","Y",true))
		.addItem(new SimpleItem("No"))
		.addItem(new Radio("web","N"));
	else
	    bd
		.addItem(new SimpleItem("Yes"))
		.addItem(new Radio("web","Y"))
		.addItem(new SimpleItem("No"))
		.addItem(new Radio("web","N",true));

	// Get Timezone
	TimeZone tz = TimeZone.getTimeZone("EST");

	// Format the current time.
        SimpleDateFormat formatter
          = new SimpleDateFormat ("MM/dd/yyyy");
	
	formatter.setTimeZone(tz);

	Calendar cld = Calendar.getInstance(tz);

	bd
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("The beginning date of class?(mm/dd/yyyy)  ").setBold().setFontColor(Color.black))
	    .addItem(new TextField("start_date",10,10,formatter.format(classSet.getDate("class_start_date"))))
      	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Instructor:  ").setBold().setFontColor(Color.black))
	    .addItem(new TextField("inst",20,20,instId + "(" + instName + ")"))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Have any co-presentors?  ").setBold().setFontColor(Color.black));

	if ((classSet.getString("copresentor")).compareTo("Y") == 0)
	    bd
		.addItem(new SimpleItem("Yes"))
		.addItem(new Radio("copres","Y",true))
		.addItem(new SimpleItem("No"))
		.addItem(new Radio("copres","N"));
	else
	    bd
		.addItem(new SimpleItem("Yes"))
		.addItem(new Radio("copres","Y"))
		.addItem(new SimpleItem("No"))
		.addItem(new Radio("copres","N",true));
	bd
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Co-presentors' names:  ").setBold().setFontColor(Color.black))
	    .addItem(new TextField("copresex",200,50,classSet.getString("copresentor_names")))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Room:  ").setBold().setFontColor(Color.black))
	    .addItem(new TextField("room",20,20,classSet.getString("room")))
	    .addItem(new SimpleItem("Building:  ").setBold().setFontColor(Color.black))
	    .addItem(new TextField("building",30,20,classSet.getString("building")))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("City:  ").setBold().setFontColor(Color.black))
	    .addItem(new TextField("city",20,30,classSet.getString("city")))
	    .addItem(new SimpleItem("State:  ").setBold().setFontColor(Color.black))
	    .addItem(new TextField("state",2,2,classSet.getString("state")))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Course Number:  ").setBold().setFontColor(Color.black))
	    .addItem(new TextField("num",10,10,courseSet.getString("course_num")))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Course Title:  ").setBold().setFontColor(Color.black))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new TextArea("tit",60,10,courseSet.getString("title")))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Please provide a Course Description of up to four paragraphs for advertising your class on our web site.").setBold().setFontColor(Color.black))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new TextArea("overview", 60, 10,courseSet.getString("overview")))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Duration (in days): ").setBold().setFontColor(Color.black))
	    .addItem(new TextField("days", 32, 16, courseSet.getString("duration")))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Agenda: ").setBold().setFontColor(Color.black))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new TextArea("agenda", 60, 10,courseSet.getString("agenda")))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("Prerequisites description: ").setBold().setFontColor(Color.black))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new TextArea("description", 60, 10,courseSet.getString("prerequisites")))
	    .addItem(SimpleItem.LineBreak)
	    .addItem(new SimpleItem("The maximum number of students to attend?  ").setBold().setFontColor(Color.black))
	    .addItem(new TextField("size",5,5,courseSet.getString("class_size")))
	    .addItem(SimpleItem.HorizontalRule)
	    .addItem(new Hidden("uid",uid))
	    .addItem(new Hidden("cid",cid))
	    .addItem(new Hidden("op",op))
	    .addItem(new Hidden("csid",courseId));
	String FormAction = "Verify!";
	if (op.compareTo("1") == 0)
	     FormAction = "Post!";
	else
	     FormAction = "Change!";
	bd
	    .addItem(new Submit("submit", FormAction))
	    .addItem(new Reset("Reset"));	      

	 HTMLBuf.append(bd);
     out.println(HTMLBuf);
     }
     catch(ClassNotFoundException e) {
	out.println("Can not load JDBC driver!");
     }
     catch(SQLException e) {
	 out.println(e.getMessage());
     }
}
    private HtmlStringBuffer BackMainHome()
    {
       HtmlStringBuffer BackMain = new HtmlStringBuffer();
       BackMain.appendln("<form method=\"GET\" action=\"ascdb.pub.WelcomePage\">");
       BackMain.appendln("<input type=submit name=\"submit\" value=\"Back Main Menu\">");
       return BackMain;
    }
}
       

	
