/*
** Insert a new class information into DB
** Class: InsertClass
** Author: Yuping Zhu
** Date: 03-31-1999
*/

package ascdb.classes;

// import package java.sql to use JDBC 
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;
import java.text.Collator;

public class InsertClass extends HttpServlet {
    public void doPost(HttpServletRequest req, HttpServletResponse res)
                throws ServletException, IOException
    {
    // Output HTML page header
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    conf dbconf= new conf(req);


    // Get all URL parameters from query string

    int op = (new Integer(req.getParameter("op"))).intValue();
    String CourseIdStr = req.getParameter("courseid");
    int CourseId = (new Integer(CourseIdStr)).intValue();
    String ClassIdStr = req.getParameter("classid");
    int ClassId = (new Integer(ClassIdStr)).intValue();
    String StartDate = req.getParameter("c_start_date");
    int ClassSize = (new Integer(req.getParameter("c_size"))).intValue();
    String inst = req.getParameter("inst");
    String Loc = req.getParameter("c_site");
    String City = req.getParameter("c_city");
    String State = req.getParameter("c_state");
    String Building = req.getParameter("c_building");
    String Room = req.getParameter("c_room");

    try {
	// Load the Oracle JDBC driver
   	Class.forName (dbconf.JdbcDriver);

	// Connect to the database
     	Connection conn =
          DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	
	// Create statement
	Statement stmt = conn.createStatement ();

	// Get class ID from class_seq
/*	ResultSet ClassIdrset;
	if (op == 0)
	{	
		ClassIdrset = stmt.executeQuery("select classes_seq.nextval from dual");
		ClassIdStr = null;

		if (ClassIdrset.next())
    	   		ClassIdStr = ClassIdrset.getString(1);

		ClassIdrset.close();
	}	
*/
	
	int rcount1 = 0;
	// Insert into table: Courses
	if (op == 0)
	{
	   rcount1 = stmt.executeUpdate("insert into classes values(" + ClassId + "," + CourseId + ",to_date('" + StartDate + "','mm-dd-yyyy')," + ClassSize + ",'" + Loc + "','" + City + "','" + State + "','" + Building + "','" + Room + "')");
	   out.println("Class: " + ClassId + " of Course: " + CourseId + " has been created!");
	}
	else if (op == 1)
	{
	   rcount1 = stmt.executeUpdate("update classes set class_start_date = to_date('" + StartDate + "','yyyy-mm-dd'),class_size=" + ClassSize + ",location='" + Loc + "',city='" + City + "',state='" + State + "',building='" + Building + "',room='" + Room + "' where class_id=" + ClassId);
	   out.println("Class: " + ClassId + " of Course: " + CourseId + " has been modified!");
	}
//	out.println(inst.substring(0,inst.indexOf('(')));
	
	// Insert into table: class_instructors
	int rcount2 = 0;
	Collator cl = Collator.getInstance();

	if ((inst != null) & ( ! cl.equals(inst,"N/A")))
	{
	   if (op == 1)
	     {
		rcount2 = stmt.executeUpdate("update class_instructors set instructor_uid = '" + inst + "' where class_id=" + ClassId);
	        if (rcount2 == 0)
		    rcount2 = stmt.executeUpdate("insert into  class_instructors values(" + ClassId + ",'" + inst +"')");
	     }
	   if (op == 0)
	        {
	 	rcount2 = stmt.executeUpdate("insert into class_instructors values(" + ClassId + ",'" + inst.substring(0,inst.indexOf('(')) + "')");
//		out.println(inst.substring(0,inst.indexOf('(')));
//		out.println(rcount2);
		}
	 }
	 else if (op==0)
	   	out.println(" But without instructor!");
	 else if ( op == 1 )
	 {
		rcount2 = stmt.executeUpdate("delete from class_instructors where class_id=" + ClassId);	
		out.println(" But without instructor!");
	 }	

     }
     catch(ClassNotFoundException e) {
	out.println("Can not load JDBC driver: " + e.getMessage());
     }
     catch(Exception e) {
	out.println(e.getMessage());
     }
}
}

    