/*
** Add Course and Class information into tables from instructor input
** Class: AddCourseClass
** Author: Yuping Zhu
** Date: 12-01-1999
*/

package ascdb.courses;

import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.users.UserValidation;
import ascdb.conf;

public class AddCourseClass extends HttpServlet {
    public void doPost(HttpServletRequest req, HttpServletResponse res)
                throws ServletException, IOException
    {
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    conf dbconf = new conf(req);
    UserValidation UserV = new UserValidation();
    
    try {
	//Load JDBC Driver
	Class.forName(dbconf.JdbcDriver);
	// Connect to DB
	Connection conn =
	    DriverManager.getConnection(dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	// Create a statement
	Statement stmt = conn.createStatement ();

	// Get the course_id from seg
	ResultSet IdSeq = stmt.executeQuery ("select courses_seq.nextval from dual");
	int CourseId = 0;
	if (IdSeq.next ())
	    CourseId = IdSeq.getInt(1);
	
	// insert course informtaion into table catalog
	String CourseStr = "insert into catalog values ("
	                   + CourseId + ",'N/A','N/A','"
	                   + req.getParameter("overview") + "','"
	                   + req.getParameter("days") + "','"
	                   + req.getParameter("agenda") + "','"
	                   + req.getParameter("description") + "','"
	                   + req.getParameter("size")
	                   + "','Y')";
	int count1 = stmt.executeUpdate(CourseStr);

	ResultSet IdSet = stmt.executeQuery ("select classes_seq.nextval from dual");
	int ClassId = 0;
	if (IdSet.next ())
	    ClassId = IdSet.getInt(1);

	String startDate = req.getParameter("dd");
	if (startDate.length() == 1)
	    startDate = new String("0") + startDate;
	startDate = startDate + new String("-") 
	    + req.getParameter("mm") + new String("-")
	    + req.getParameter("yy");

	//	out.println(startDate);

	//insert class information into table class
	String ClassStr = "insert into classes values ("
	              + ClassId + ","
	              + CourseId 
      	              + ",to_date('" + startDate + "','dd-mm-yyyy'),"
	              + req.getParameter("size") 
	              + ",'N/A','N/A','NA',null,'"
                      + req.getParameter("room") + "','"
	              + req.getParameter("system") + "','"
	              + req.getParameter("stuff") + "','"
	              + req.getParameter("tape") + "','"
	              + req.getParameter("web") + "','"
	              + req.getParameter("copres") + "','Y','"
                      + req.getParameter("copresex") + "')";
	int count2 = stmt.executeUpdate(ClassStr);

	ResultSet instSet = stmt.executeQuery("select oracle_uid,last_nam,first_nam from users where purpose='Instructor' order by last_nam");
      
	String instId = "nobody";
	while (instSet.next())
	    if ((instSet.getString("first_nam") + " " + instSet.getString("last_nam")).compareTo(req.getParameter("instructor")) == 0)
		instId = instSet.getString(1);

	// insert into table class_instructors
        int count3 = stmt.executeUpdate("insert into class_instructors values("
		     + ClassId + ",'"
		     + instId + "')");
	out.println("<body bgcolor=white>");
        if ((count1 == 1) && (count2 == 1) && (count3 == 1))
	    out.println("New Course/Class record has been created!");
	else
	    if (count1 == 0)
		out.println("Can not create Course record!");
	    else if (count2 == 0) 
		out.println("Can not create Class record!");
	    else if (count3 == 0) 
		out.println("Can not create class_instructor record!");
	out.println(BackHome(req.getParameter("uid")));
    }
    catch(ClassNotFoundException e) {
	out.println("Can not load JDBC driver!");
    }
    catch(SQLException e) {
         out.println(e.getMessage());
    }
    }

    private String BackHome(String uid)
    {
	StringBuffer StrBuf = new StringBuffer(1500);
	StrBuf.append("<form method=\"POST\" action=\"ascdb.users.FrontPage\">\n");
	StrBuf.append("<input type=hidden name=\"uid\" value=\"" + uid + "\">\n");
	StrBuf.append("<input type=submit name=\"submit\" value=\"Back Menu\">\n");
	String BackStr = new String(StrBuf);
	return BackStr;
    }
}
