/*
** Public View Course Detail
** Class: CourseDetail
** Author: Yuping Zhu
** Date: 05-10-1999
*/

package ascdb.courses;

//import package java.sql to use JDBC
import java.sql.*;

//import package oracle.html to generate dynamic HTML page
import oracle.html.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import ascdb.conf;
//import ascdb.pub.UserCheck;

public class CourseDetail extends HttpServlet {
    public void doGet(HttpServletRequest req, HttpServletResponse res)
                throws ServletException, IOException
        {    
             
        // Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
        conf dbconf= new conf(req);
        String cidStr = req.getParameter("cid");
        int cid = (new Integer(cidStr)).intValue();

	try {
        // Creates an HtmlHead Object
        HtmlHead hd = new HtmlHead("Course Detail");
             
        // Create an HtmlBody Object
        HtmlBody bd = new HtmlBody();
             
        // Sets various attributes of HtmlBody
        bd.setBackgroundColor("#fffff2");
             
        // Creates an HtmlPage object using hd and bd
        HtmlPage hp = new HtmlPage(hd, bd);

	hp   
          .addItem(new SimpleItem("Course " + cidStr + " description").setBold().setCenter().setFontSize(5).setFontColor(Color.red))
          .addItem(SimpleItem.HorizontalRule);
             
        // Load the Oracle JDBC driver
        Class.forName (dbconf.JdbcDriver);
             
        // Connect to the database
        Connection conn =
                DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
             
        // Create a Statement
        Statement stmt = conn.createStatement ();
             
        // Pick up the course info. from DB
        String QueryString = "select * from courses where course_id = " + cid;
        // execute query
        ResultSet rset = stmt.executeQuery (QueryString);

	if ( !rset.next() )
	{
           hp.addItem(new SimpleItem("Something Wrong!").setCenter().setFontColor(Color.red));
	   out.println(hp);	
	   return;
	}

	String Agenda = "N/A";
	String Prereq = "N/A";

	//Creates the table with 2 columns
	DynamicTable tab = new DynamicTable(2);
	tab.setBackgroundColor (Color.pink);
        tab.setBorderColor (Color.navy);
	tab.setCellSpacing(2);
	tab.setCellPadding(5);
	
	TableRow[] rows = new TableRow[7];
	for(int i=0; i < 7; i++)
	    rows[i] = new TableRow();

	rows[0]
	    .addCell(new TableDataCell(new SimpleItem("Course ID").setBold().setFontColor(Color.maroon)))
	    .addCell(new TableDataCell(new SimpleItem(cidStr)));
	rows[1]
	    .addCell(new TableDataCell(new SimpleItem("Course Number").setBold().setFontColor(Color.maroon)))
	    .addCell(new TableDataCell(new SimpleItem(rset.getString("course_num"))));
	rows[2]
	    .addCell(new TableDataCell(new SimpleItem("Title").setBold().setFontColor(Color.maroon)))
	    .addCell(new TableDataCell(new SimpleItem(rset.getString("title"))));
	rows[3]
	    .addCell(new TableDataCell(new SimpleItem("Overview").setBold().setFontColor(Color.maroon)))
	    .addCell(new TableDataCell(new SimpleItem(rset.getString("overview"))));
	rows[4]
	    .addCell(new TableDataCell(new SimpleItem("Duration").setBold().setFontColor(Color.maroon)))
	    .addCell(new TableDataCell(new SimpleItem(rset.getString("duration"))));
	if (rset.getString("agenda") != null)
		Agenda = rset.getString("agenda");
	if (rset.getString("prerequisites") !=null)
		Prereq = rset.getString("prerequisites");

	rows[5]
	    .addCell(new TableDataCell(new SimpleItem("agenda").setBold().setFontColor(Color.maroon)))
	    .addCell(new TableDataCell(new SimpleItem(Agenda)));
	rows[6]
	    .addCell(new TableDataCell(new SimpleItem("prerequisites").setBold().setFontColor(Color.maroon)))
	    .addCell(new TableDataCell(new SimpleItem(Prereq)));
	
	// Add new row to table
	for(int i=0; i< 7; i++)
	    tab.addRow(rows[i]);

	// Add the table to Html Body
	bd.addItem(tab.setCenter());
	
	bd
	 .addItem(SimpleItem.Paragraph)
	 .addItem(SimpleItem.HorizontalRule)
	 .addItem(SimpleItem.Paragraph);
	
	// output HTML page
	out.println(hp);

	}
	catch(ClassNotFoundException e) {
	out.println("Couldn't load database driver: " + e.getMessage());
        }
       catch (SQLException e) { 
	out.println(e.getMessage());
	}
}
}