/*
** List all course to view, modify, delete or input course syllabus
** Class: CourseList
** Author: Yuping Zhu
** Date: 11-12-1999
*/

package ascdb.courses;

// import package java.sql to use JDBC
import java.sql.*;

// import oracle.html and javax.servlet package to generate dynamic HTML page
import oracle.html.*;
import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import ascdb.conf;
import ascdb.users.UserValidation;

public class CourseList extends HttpServlet {

    public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException
    {
	
        // Output HTML page header
        res.setContentType("text/html");
	PrintWriter out = res.getWriter();
	conf dbconf= new conf(req);
	String uid = req.getParameter("uid");
	String opStr = req.getParameter("op");
        int op = (new Integer(opStr)).intValue();
	UserValidation UserV = new UserValidation();

        try {
	int TabRow = UserV.Validation(req);
	// check if instructor or administrator user
	if (TabRow < 5)
	    {
	        out.println("You do not have this privillege!");
		out.println(BackMainHome());
		return;
	   }

	// Creates an HtmlHead Object
        HtmlHead hd = new HtmlHead("Course List");
	
        // Create an HtmlBody Object
        HtmlBody bd = new HtmlBody();

	// Sets various attributes of HtmlBody
     	bd.setBackgroundColor("#fffff2");

	// Creates an HtmlPage object using hd and bd
	HtmlPage hp = new HtmlPage(hd, bd);

	bd.addItem(new SimpleItem("If your class is not in the list, you can register a new course/class").setBold().setFontColor(Color.red));
	Form frm = new Form("GET","ascdb.courses.CreateCourse");
	frm
	    .addItem(new Hidden("uid",uid))
	    .addItem(new Hidden("op","1"))
	    .addItem(new Submit("submit","Creat New Class/Course!").setBold().setFontColor(Color.olive));
	bd.addItem(frm.setCenter());

	if (op == 1)
	        hp.addItem(new SimpleItem("Click on Course_ID to input the course syllabus ...").setBold().setFontColor(Color.red));
	else if (op == 2)
		hp.addItem(new SimpleItem("Click on Course_ID to modify the course ...").setBold().setFontColor(Color.red));
	else if (op ==3)
		hp.addItem(new SimpleItem("Click on Course_ID to delete the course ...").setBold().setFontColor(Color.red));
	else if (op == 9)
		hp.addItem(new SimpleItem("Click on Course_ID to create a new class session of the course ...").setBold().setFontColor(Color.red));
		
 	hp.addItem(SimpleItem.Paragraph);
	Font f = new Font(Color.olive,"myfont","+5");
	
	bd
	  .addItem(new SimpleItem(f.toHTML()))
	  .addItem(new SimpleItem("Training Course List").setCenter())
	  .addItem(SimpleItem.HorizontalRule);
	
	Font bf = new Font(Color.black,null,"+1");
	bd.addItem(new SimpleItem(bf.toHTML()));

	// Load the Oracle JDBC driver
	Class.forName (dbconf.JdbcDriver);

	// Connect to the database
	Connection conn =
		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	
	// Create a Statement
	Statement stmt = conn.createStatement ();

	//get the total course count
	String QueryStr = "select count(*) from catalog where title != 'N/A'";
	ResultSet  tot = stmt.executeQuery(QueryStr);
	
	int CourseTot = 0;
	if (tot.next())
		CourseTot = tot.getInt(1);
	if (CourseTot == 0)
	{
		bd.addItem(new SimpleItem("No Course in Database").setBold().setCenter());
		out.println(hp);
		return;
	}
	tot.close();
   
	// Get all courses from Traning DB
	String QueryString = "select * from catalog where title != 'N/A' order by course_id";
	// execute query
        ResultSet rset = stmt.executeQuery (QueryString);
	
	//Creates the table with 5 columns
      	DynamicTable tab = new DynamicTable(5);
	tab.setBackgroundColor (Color.pink);
        tab.setBorderColor (Color.navy);
	tab.setCellSpacing(2);
	tab.setCellPadding(5);
	
	TableRow[] rows = new TableRow[CourseTot + 1];
	for(int i=0; i <= CourseTot; i++)
	    rows[i] = new TableRow();
	rows[0]
	  .addCell(new TableDataCell(new SimpleItem("Course_ID").setBold().setFontColor(Color.maroon))) 
	  .addCell(new TableDataCell(new SimpleItem("Course_Num").setBold().setFontColor(Color.maroon)))
	  .addCell(new TableDataCell(new SimpleItem("Title").setBold().setFontColor(Color.maroon)))
	  .addCell(new TableDataCell(new SimpleItem("Overview").setBold().setFontColor(Color.maroon)))
	  .addCell(new TableDataCell(new SimpleItem("Duration(days)").setBold().setFontColor(Color.maroon)));
	
	//Create table by listing all course from courses
	int i = 1;
	while (rset.next())
	    {
	    if (op == 0)
	       rows[i]
// 		.addCell(new TableDataCell(new SimpleItem(rset.getString("course_id")).setBold()));
		.addCell(new TableDataCell(new Link("ascdb.courses.CourseDetail?cid=" + rset.getInt("course_id"), new SimpleItem(rset.getString("course_id")).setBold())));
	    else if (op == 1)
	       rows[i]
		.addCell(new TableDataCell(new Link("ascdb.courses.AgendaInput?cid=" + rset.getInt("course_id") + "&me=" + uid, new SimpleItem(rset.getString("course_id")).setBold())));
	    else if (op == 2)
	       rows[i]
	   	.addCell(new TableDataCell(new Link("ascdb.courses.CourseModify?cid=" + rset.getInt("course_id") + "&me=" + uid, new SimpleItem(rset.getString("course_id")).setBold())));
	    else if (op == 3)
	       rows[i]
		.addCell(new TableDataCell(new Link("ascdb.courses.CourseDelete?cid=" + rset.getInt("course_id") + "&me=" + uid, new SimpleItem(rset.getString("course_id")).setBold())));
	    else if (op == 9)
		rows[i]
		.addCell(new TableDataCell(new Link("ascdb.courses.CreateClass?cid=" + rset.getInt("course_id") + "&uid=" + uid, new SimpleItem(rset.getString("course_id")).setBold())));
	
	       rows[i++]
		.addCell(new TableDataCell(new SimpleItem(rset.getString("course_num")).setBold()))
		.addCell(new TableDataCell(new SimpleItem(rset.getString("title")).setBold()))
		.addCell(new TableDataCell(new SimpleItem(rset.getString("overview")).setBold()))
		.addCell(new TableDataCell(new SimpleItem(rset.getString("duration")).setBold()));
	    }

	bd.addItem(new SimpleItem("Total: " + CourseTot).setCenter().setItal().setFontColor(Color.orange).setBold());

	//       Add new row to table
	for(i=0; i< CourseTot + 1; i++)
	    tab.addRow(rows[i]);

	// Add the table to Html Body
	bd.addItem(tab.setCenter());
	
	bd
	 .addItem(SimpleItem.Paragraph)
	 .addItem(SimpleItem.HorizontalRule);	
	
    // output HTML page
	out.println(hp);
	}
	catch (SQLException e) { 
	out.println(e.getMessage());
	}
	catch(ClassNotFoundException e) {
	out.println("Couldn't load database driver: " + e.getMessage());
        }
	catch(Exception e) {
	out.println(e.getMessage());
        }
    }


        private HtmlStringBuffer BackMainHome()
        {
	   HtmlStringBuffer BackMain = new HtmlStringBuffer();
	   BackMain.appendln("<form method=\"GET\" action=\"ascdb.pub.WelcomePage\">");
	   BackMain.appendln("<input type=submit name=\"submit\" value=\"Back Main Menu\">");
          return BackMain;
       }
}	
