/*
** Accept user's registration and put the information into DB
** Class: InsertUser
** Author: Yuping
** Date: 11-03-1999
** Modified by Yuping Zhu on 03-08-2000
** Modified by Yuping Zhu on 04-26-2000
*/

package ascdb.pub;

//import package java.sql to use JDBC
import java.sql.*;

//import package javax.servlet.http to get URL parameters
import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import java.util.Hashtable;

import ascdb.conf;
import ascdb.admin.msgManager;
import ascdb.users.UserValidation;

public class InsertUser extends HttpServlet
{
    private Hashtable UserTable = new Hashtable();
    private Connection conn;
    private Statement stmt;
    private msgManager msg = new msgManager();
    private PrintWriter out;

    public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
    {
    // Output HTML page header
    res.setContentType("text/html");
    out = res.getWriter();    
    conf dbconf = new conf(req);
    int sponsorEmail = 0;
    UserValidation UserV = new UserValidation();

    try {
    // connect to DB
    openDB(req);
 
    // Read parameters from request
    readParameters(req);

    /*   if (((String)UserTable.get("op")).equals("0"))
	{
	    out.println(req.getParameter("comments") + " " + (String)UserTable.get("comment"));return;}
    */

    UserTable.put("admph",dbconf.AdminPhone);
    UserTable.put("freephone",dbconf.FreePhone);
    UserTable.put("TMDemail",dbconf.TMDEmail);

    // Check if user exists in DB
    if ((UserExist() == 0) && ((String)UserTable.get("op")).equals("0"))
    {
	msg.putHashTable(UserTable);
	msg.UserExist(res);
	return;
    }
    
        // Check if have all required fields
    // It finished using JavaScript on client side now
    /*  String NullField = getNullField(req)
    if (NullField.length() != 0) {
	out.println(NullField + " is required field, please complete it!");
	return;
	}
    
    if (CheckPassword() == 0)
    {
	out.println("Your Password Confirm is not the same as your password input! Please Input again!");
	return;
    } 
    */

    // Get address ID from addresses table or generate new one
    getAddressID(0);

    // Generate new user ID
    if (((String)UserTable.get("op")).equals("0"))
         getUserID((String)UserTable.get("l_name"),"uid");
    else  
     	 UserTable.put("uid",req.getParameter("uid"));
   
    //    out.println("UsreID: "+ (String)UserTable.get("uid") + " and Address ID:"+ UserTable.get("addr_id"));
    
    // If need sponsor, get sponsor info.
    if (((String)UserTable.get("userType")).compareTo("MILITARY") != 0)
    {
        if (SponsorExist() != 0)
	{
	    getUserID((String)UserTable.get("slname"),"suid");
	    getAddressID(1);
	    LoadSponsor();
	}
	sponsorEmail = 1;
	//	msg.putHashTable(UserTable);
	//	msg.msgSender((String)UserTable.get("semail"),(String)UserTable.get("TMDemail"),(String)UserTable.get("TMDemail"),"Sponsor TMD",dbconf.EmailServer);
    }
    // create new user record
    if (((String)UserTable.get("op")).equals("0"))
    {	
	LoadUser();
      	//if (((String)UserTable.get("purpose")).equals("Student"))
	LoadCtas();
      	UserTable.put("officer",dbconf.OfficerName);
	UserTable.put("officerPH",dbconf.OfficerPh);
	UserTable.put("officerEmail",dbconf.OfficerEmail);
	UserTable.put("officerFax",dbconf.OfficerFax);
	UserTable.put("dsn",dbconf.DSN);
	msg.putHashTable(UserTable);
	msg.UserRegisterOk(res);
	/*	  	String cta2[] = req.getParameterValues("cta2");
		int len = cta2.length;
      		for (int i = 0; i < len ; i++)
		  out.println(cta2[i]);
	*/
	//send email to register
      	msg.msgSender((String)UserTable.get("email"),(String)UserTable.get("TMDemail"),"yuzhu@mailbox.syr.edu","Register",dbconf.EmailServer);

	// send email to administrator
       	//msg.msgSender((String)UserTable.get("TMDemail"),(String)UserTable.get("TMDemail"),"",(String)UserTable.get("purpose"),dbconf.EmailServer);
	msg.msgSender((String)UserTable.get("TMDemail"),(String)UserTable.get("TMDemail"),"","Student",dbconf.EmailServer);

	//send email to sponsor
	if (sponsorEmail == 1) {
	    msg.msgSender((String)UserTable.get("semail"),(String)UserTable.get("TMDemail"),(String)UserTable.get("TMDemail"),"Sponsor TMD",dbconf.EmailServer);
	    if (RecordEmail() == 0)
		out.println("Can not load into Sponsor_email_tracking");
	}
    } 

    // update existing user record
    else 
    {	
	if (! UserV.UserLogin((String)UserTable.get("uid"),req))
	{
	    out.println("You are logout, please login again!");
	    return;
	}

        boolean SponChange =  SponUpdate();
	//out.println(" sponsor login "+ sponlogin());
	
	/*	if (((String)UserTable.get("op")).equals("1"))
	{
	out.println("Ok!");
	return;
	}
	*/

	if (CheckRole((String)UserTable.get("uid")) == 1)
       	    if (UpdateUser()==1) 
	    {
	       	//if (((String)UserTable.get("purpose")).equals("Student"))
       	        UpdateCtas();
		out.println("<body bgcolor=\"#ffffff\">");
		out.println("Your user infomation has been updated!");
		if ((sponsorEmail == 1) && (SponChange))
		{    out.println("<br>Send email to sponsor...");
		     msg.putHashTable(UserTable);
		     msg.msgSender((String)UserTable.get("semail"),(String)UserTable.get("TMDemail"),(String)UserTable.get("TMDemail"),"Sponsor TMD",dbconf.EmailServer);
		     if (RecordEmail() == 0)
		       out.println("Can not load into Sponsor_email_tracking");
		}
	    }
            else
		out.println("Can not update your user information!");
	 else
	    out.println("You do not have the privillege!");
    }
    // out.println(" oooosponsor login "+ sponlogin());
    //  sponlogin();
    BackHome(out);

    }catch (SQLException e) {
	out.println(e.getMessage());
    }
    catch (ClassNotFoundException e) {
	out.println("Can not load JDBC Driver!");
    }
    }


    private void openDB(HttpServletRequest req) 
           throws ClassNotFoundException,SQLException
    {
	//	try{
	conf dbconf = new conf(req);
	// Load the Oracle JDBC driver
	Class.forName (dbconf.JdbcDriver);
	
	// Connect to the database
	conn =
	    DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);

	// Create a Statement
	stmt = conn.createStatement ();
    
    }

    /*     private String sponlogin()
        throws SQLException
    {
	ResultSet rset = stmt.executeQuery("select logged_in from addl_users where oracle_uid='" +(String)UserTable.get("suid") + "'");
	if (rset.next())
	    return rset.getString(1);
	return "X";
	}*/

    private void readParameters(HttpServletRequest req)
    {
	UserTable.put("surtit",(String)req.getParameter("surtitle"));
       	UserTable.put("l_name",req.getParameter("lastname"));
	UserTable.put("f_name",req.getParameter("firstname"));
        UserTable.put("m_name",req.getParameter("middlename"));
       	UserTable.put("address",req.getParameter("address"));
      	UserTable.put("address2",req.getParameter("address2"));
	UserTable.put("room",req.getParameter("room"));
        UserTable.put("mail",req.getParameter("mail"));
	UserTable.put("city",req.getParameter("city"));
	UserTable.put("state",req.getParameter("state"));
	UserTable.put("zip",req.getParameter("zip"));
	UserTable.put("country",req.getParameter("country"));
	UserTable.put("phone",req.getParameter("phone"));
	UserTable.put("ext",req.getParameter("ext"));
	UserTable.put("alt_phone",req.getParameter("alt_phone"));
	UserTable.put("fax",req.getParameter("fax"));
       	UserTable.put("email",req.getParameter("email"));
	UserTable.put("shared",req.getParameter("shared"));
	UserTable.put("list",req.getParameter("list"));
	if (req.getParameter("cta") != null)
	    UserTable.put("cta",req.getParameter("cta"));
	if (req.getParameterValues("cta2") != null)
            UserTable.put("cta2",req.getParameterValues("cta2"));
	UserTable.put("comment",req.getParameter("comments"));
	UserTable.put("citizenship",req.getParameter("citizenship"));
	
	UserTable.put("nac",req.getParameter("nac_type"));
	UserTable.put("business",req.getParameter("B_type"));
       	UserTable.put("b_name",req.getParameter("b_name"));
	UserTable.put("ssn",req.getParameter("ssn"));
	UserTable.put("msrc",req.getParameter("msrc_acct"));


	//	if (((String)UserTable.get("business")).equals("GOVERNMENT ORGANIZATION")) 
	UserTable.put("userType",req.getParameter("userType"));
	if (((String)UserTable.get("userType")).compareTo("MILITARY") != 0)
	{
	    UserTable.put("org",req.getParameter("org"));
	    UserTable.put("stit",req.getParameter("s_surtitle"));
	    UserTable.put("sfname",req.getParameter("s_f_name"));
	    UserTable.put("slname",req.getParameter("s_l_name"));
	    UserTable.put("smname",req.getParameter("s_m_name"));
	    UserTable.put("sphone",req.getParameter("s_phone"));
	    UserTable.put("sext",req.getParameter("s_ext"));
       	    UserTable.put("sfax",req.getParameter("s_fax"));
	    UserTable.put("semail",req.getParameter("s_email"));
	    UserTable.put("saddr1",req.getParameter("s_address"));
	    UserTable.put("saddr2",req.getParameter("s_address2"));
	    UserTable.put("sroom",req.getParameter("s_room"));
	    UserTable.put("scity",req.getParameter("s_city"));
	    UserTable.put("sstate",req.getParameter("s_state"));
	    UserTable.put("scountry",req.getParameter("s_country"));
	    UserTable.put("szip",req.getParameter("s_zip"));
	    UserTable.put("salt",req.getParameter("s_alt_phone"));
	}    

	/*	
	if ((req.getParameter("op")).equals("0")) {
	    UserTable.put("passwd1",req.getParameter("passwd1"));
	    UserTable.put("passwd2",req.getParameter("passwd2"));
	    }*/

       	UserTable.put("op",req.getParameter("op"));
	if (((String)UserTable.get("citizenship")).compareTo("UNITED STATES") == 0)
	    UserTable.put("fn_indctr","N");
	else
	{
	    UserTable.put("fn_indctr","Y");
	    UserTable.put("pType",req.getParameter("permit"));
	    UserTable.put("pnum",req.getParameter("p_num"));
	    UserTable.put("pdate",req.getParameter("exp_date"));
	}
    }
	
    private int SponsorExist()
       throws SQLException
    {
	ResultSet allSponsor =stmt.executeQuery("select oracle_uid from users where first_nam = '" + (String)UserTable.get("sfname") + "' and last_nam = '" + (String)UserTable.get("slname") + "'");
	if (allSponsor.next())
	{
	    UserTable.put("suid",allSponsor.getString(1));
	    return 0;
	}
	return 1;
    }


    private int UserExist()
          throws SQLException
    {

	ResultSet allUser = stmt.executeQuery("select oracle_uid from users where first_nam = '" + (String)UserTable.get("f_name") + "' and last_nam = '" + (String)UserTable.get("l_name") + "'");
   //+ "' and middle_nam = '" + (String)UserTable.get("m_name") + "'");
        if (allUser.next())
              return 0;
	return 1;
    }
	
    // Check if get all required fields
    /*   Private String getNullField()
    {
	String tmp;
	if ((String)UserTable.get("f_name").length() == 0) 
	    tmp = tmp + ",First Name";
	if ((String)UserTable.get("l_name").length() == 0)
	    tmp = tmp + ",Last Name";
	if ((String)UserTable.get("address").length() == 0) 
	    tmp = tmp + ",Primary Address";
	if ((String)UserTable.get("city").length() == 0) 
	    tmp = tmp + ",City";
	if ((String)UserTable.get("zip").length() == 0) 
	    tmp = tmp + ",Zip";
	if ((String)UserTable.get("phone").length() == 0) 
	    tmp = tmp + ",Phone";
	if ((String)UserTable.get("email").length() == 0)
	    tmp = tmp + ",Email";
	if ((String)UserTable.get("citizenship").length() == 0)
	    tmp = tmp + ",Citizenship";
	if ((String)UserTable.get("passwd1").length() == 0)
	    tmp = tmp + ",Password";
	if ((String)UserTable.get("passwd2").length() == 0)
	    tmp = tmp + ",Password Confirm";
	
	if (cl.compare((String)UserTable.get("business"),"GOVERNMENT ORGANIZATION") == 0)
	    return tmp;
	if ((String)UserTable.get("sfname").length() == 0)
	    tmp = tmp + ",Sponsor's First Name";
	if ((String)UserTable.get("slname").length() == 0)
	    tmp = tmp + ",Sponsor's Last Name";
	if ((String)UserTable.get("sphone").length() == 0)
	    tmp = tmp + ",Sponsor's Phone";
	if ((String)UserTable.get("semail").length() == 0)
	    tmp = tmp + ",Sponsor's Email";
	return tmp;
    }
  
    
    private int CheckPassword() 
    {
	if (((String)UserTable.get("passwd1")).equals((String)UserTable.get("passwd2")))
	    return 1;
	return 0;
    }
    */


    private void getAddressID(int op)
          throws SQLException
    {
	int fg = 0;
	String Code = "";
	String queryStr = "select char_code from domain where expsn = '";
	if (op == 0 )
	    queryStr = queryStr + (String)UserTable.get("country") + "'";
	else
	    queryStr = queryStr + (String)UserTable.get("scountry") + "'";

	ResultSet CountryCode = stmt.executeQuery(queryStr);
	if (CountryCode.next())
	       Code = CountryCode.getString(1);

	String addrStr = "select address_id from addresses where address = '";
	if ( op == 0)
	    addrStr = addrStr + (String)UserTable.get("address") 
		      + "' and city ='" + (String)UserTable.get("city")
		      + "' and state ='" + (String)UserTable.get("state")
		      + "' and zip ='" + (String)UserTable.get("zip")
		      + "' and country ='" + Code +"'";
	else
	    addrStr = addrStr + (String)UserTable.get("saddr1") 
		      + "' and city ='" + (String)UserTable.get("scity")
		      + "' and state ='" + (String)UserTable.get("sstate")
		      + "' and zip ='" + (String)UserTable.get("szip")
		      + "' and country ='" + Code +"'";
	ResultSet addr = stmt.executeQuery(addrStr);
	if (addr.next())
	{  
	    if ( op == 0)
		UserTable.put("addr_id",addr.getString(1));
	    else
		UserTable.put("saddr_id",addr.getString(1));
	    return;
	}
	     
	// generate a new address record
	ResultSet newAddr = stmt.executeQuery("select address_seq.nextval from dual");
	    if (newAddr.next())
		if (op == 0)
		    UserTable.put("addr_id",newAddr.getString(1));
	        else
		    UserTable.put("saddr_id",newAddr.getString(1));
	    AddAddress(Code,op);
    }

	private void AddAddress(String Code, int op)
	      throws SQLException
	{
      	    String QueryString = "insert into addresses values ('";
	    if (op == 0)
		QueryString = QueryString
		                   + (String)UserTable.get("addr_id") + "','"
                                   + (String)UserTable.get("address") + "','"
                                   + (String)UserTable.get("city") + "','"
                                   + (String)UserTable.get("state") + "','"
                                   + (String)UserTable.get("zip") + "','"
                                   + Code + "','"
                                   + (String)UserTable.get("room") + 
                                   "',null)";
	    else
		QueryString = QueryString
		                   + (String)UserTable.get("saddr_id") + "','"
                                   + (String)UserTable.get("saddr1") + "','"
                                   + (String)UserTable.get("scity") + "','"
                                   + (String)UserTable.get("sstate") + "','"
                                   + (String)UserTable.get("szip") + "','"
                                   + Code + "','"
                                   + (String)UserTable.get("sroom") + 
                                   "',null)";

	    int addrcount = stmt.executeUpdate(QueryString);
	}

	private void getUserID(String lName, String id)
	      throws SQLException
	{
	    String LastName = lName;
	    int Index = LastName.indexOf('\'');
	    while ((Index > 0) && (Index < 4))
	    {
		LastName = LastName.substring(1, Index-1) + LastName.substring(Index+1,LastName.length());
		Index = LastName.indexOf('\'');
	    }
	    Index = LastName.length();
      	    if (LastName.length() > 3)
	        Index = 3;
	    String UserID = "";
	    ResultSet UserIdrset = stmt.executeQuery("select users_seq.nextval from dual");
	    if (UserIdrset.next())
    		UserID = UserIdrset.getString(1);
	    UserIdrset.close();
	    UserID = LastName.substring(0,Index) + UserID;
	    UserTable.put(id,UserID);
	}
	    
	private void LoadSponsor()
	     throws SQLException
	{
	    String SponsorString = "insert into users(oracle_uid,create_date,user_status,user_type,fn_indctr,citizenship,nac_type,address_id,submitter,first_nam,middle_nam,last_nam,surtitle,phone,phone_ext,fax,email,organization,room_num,alt_phone) values ('"
		+ (String)UserTable.get("suid") 
		+ "',sysdate,'Disable','MILITARY','N','UNITED STATES','NONE','"
                + (String)UserTable.get("saddr_id") + "','"
		+ (String)UserTable.get("uid") + "','"
		+ (String)UserTable.get("sfname") + "','"
		+ (String)UserTable.get("smname") + "','"
		+ (String)UserTable.get("slname") + "','"
		+ (String)UserTable.get("stit") + "','"
		+ (String)UserTable.get("sphone") + "','"
		+ (String)UserTable.get("sext") + "','"
		+ (String)UserTable.get("sfax") + "','"
		+ (String)UserTable.get("semail") + "','"
		+ (String)UserTable.get("org") + "','"
		+ (String)UserTable.get("sroom") + "','"
		+ (String)UserTable.get("salt")
		+ "')";
	    int count1 = stmt.executeUpdate(SponsorString);
	   
	    /*	    ResultSet mSet = stmt.executeQuery("select middle_nam from users where oracle_uid='" + (String)UserTable.get("suid") + "'");
	    
	    if (mSet.next())
		out.println((String)UserTable.get("smname") + " " + mSet.getString(1));
	    else
	    out.println((String)UserTable.get("smname"));*/

	    String addlStr = "insert into addl_users values('"
		+ (String)UserTable.get("suid") 
		+ "','N','N','N',null,null,null,null,null,null,null)";
	    count1 = stmt.executeUpdate(addlStr);
	}
	
        private boolean SponUpdate()
	      throws SQLException
        {
	    if (((String)UserTable.get("userType")).compareTo("MILITARY") == 0)
		return false;
	    ResultSet rset = stmt.executeQuery("select spons_agency_uid from users where oracle_uid='" +(String)UserTable.get("uid") + "'");
	    if (rset.next())
		if (((String)UserTable.get("suid")).equals(rset.getString(1)))
		    return false;
	    return true;
	}
	    
	
	private int CheckRole(String me)
	      throws SQLException
	{            
	    ResultSet rset = stmt.executeQuery("select oracle_uid from users where oracle_uid='" + me + "'");
	    while (rset.next())
     		if ((rset.getString(1)).equals("Administrator") 
		    || me.equals((String)UserTable.get("uid")))
		    return 1;
	    return 0;
	}
	       

	private void LoadUser()
	     throws SQLException
	{
	     String InsertString = "insert into users values ('" 
		+ (String)UserTable.get("uid") + "',sysdate,'Disabled','"
       		+ (String)UserTable.get("userType") + "',"
       		+ (new Integer((String)UserTable.get("addr_id"))).intValue() + ",null,'"
		+ (String)UserTable.get("f_name") + "','"
		+ (String)UserTable.get("l_name") + "','"
		+ (String)UserTable.get("m_name") + "','"
		+ (String)UserTable.get("surtit") 
		+ "',null,null,null,";
	    
       	    if ((String)UserTable.get("pdate") != null)
		InsertString = InsertString + "to_date('" 
		    + (String)UserTable.get("pdate") + "','dd/mm/yyyy'),'";
	    else
		InsertString = InsertString + "null,'";
	    
	    InsertString = InsertString
		+ (String)UserTable.get("citizenship") + "','"
		+ (String)UserTable.get("fn_indctr") + "','"
      		+ (String)UserTable.get("business") + "','"
		+ (String)UserTable.get("b_name") + "','"
		+ (String)UserTable.get("pType") +"','"
		+ (String)UserTable.get("pnum") + "','"
		 //		+ (String)UserTable.get("pdate") +"','"
       		+ (String)UserTable.get("mail") + "','"
		+ (String)UserTable.get("room") + "','"
		+ (String)UserTable.get("phone") + "','"
		+ (String)UserTable.get("ext") + "','"
		+ (String)UserTable.get("alt_phone") + "','"
		+ (String)UserTable.get("fax") +"','"
		+ (String)UserTable.get("email") + "','"
		+ (String)UserTable.get("uid") + "','"
		+ (String)UserTable.get("suid") 
		+ "','N',null,null,'N',null,'N','N','"
	      	+ (String)UserTable.get("org") + "','"
		+ (String)UserTable.get("nac") + "','"
		+ (String)UserTable.get("ssn") + "','"
		+ (String)UserTable.get("comment")
		+ "')";

	    /*debug 04-22-2000	    
	    ResultSet cSet = stmt.executeQuery("select user_comment from users where oracle_uid='" + (String)UserTable.get("uid") + "'");

	    if (cSet.next())
		out.println((String)UserTable.get("comment") + " " + cSet.getString(1));
	    else
		out.println((String)UserTable.get("comment") + "NO");
	    */

	     // used to debug
 	    
		/*	    String InsertString = "insert into users values ('" 
//(oracle_uid,create_date,user_status,user_type,address_id,submitter,first_nam,last_nam,middle_nam,surtitle,purpose,position,approved_date,expiration_date,citizenship,fn_indctr,business_type,business_name,permit_type,permit_num,mail_stop,room_num,phone,phone_ext,alt_phone,fax,email,poc_uid,spons_agency_uid,kdc_enabled,home_msrc,kerberos_realm,sctn_3_recd_indctr,removed_date,tech_indctr,tracker_indctr,organization,nac_type,ssan_last4,user_comment) values ('" 

		+ (String)UserTable.get("uid") + "',sysdate,'Disabled','"
       		+ (String)UserTable.get("userType") + "',"
       		+ (new Integer((String)UserTable.get("addr_id"))).intValue() + ",null,'"
		+ (String)UserTable.get("f_name") + "','"
		+ (String)UserTable.get("l_name") + "','"
		+ (String)UserTable.get("m_name") + "','"
		+ (String)UserTable.get("surtit") + "','"
	       	+ (String)UserTable.get("purpose") + "',null,null,null,'"
		+ (String)UserTable.get("citizenship") + "','"
		+ (String)UserTable.get("fn_indctr") + "','"
      		+ (String)UserTable.get("business") + "','"
		+ (String)UserTable.get("b_name") + "',null,null,'"
       		+ (String)UserTable.get("mail") + "','"
	       	+ (String)UserTable.get("room") + "','"
		+ (String)UserTable.get("phone") + "','"
		+ (String)UserTable.get("ext") + "','"
		+ (String)UserTable.get("alt_phone") + "','"
		+ (String)UserTable.get("fax") + "','"
		+ (String)UserTable.get("email") + "','"
		//	+ (String)UserTable.get("uid") + "','"
		+ (String)UserTable.get("suid")
     		+ "','N',null,null,'N',null,'N','N','"
		+ (String)UserTable.get("org") + "','"
		+ (String)UserTable.get("nac") + "','"
		+ (String)UserTable.get("ssn") + "','"
		+ (String)UserTable.get("comment") + "','"
		+ (String)UserTable.get("uid") + 
		+ "')";
	    */

       	    int count = stmt.executeUpdate(InsertString);
	    // load additional user table
	    String AddlString = "insert into addl_users values ('"
		+ (String)UserTable.get("uid") + "','"
		+ (String)UserTable.get("shared") + "','"
		+ (String)UserTable.get("list") + "','Y',null,null,null,'"
		+ (String)UserTable.get("msrc")
      		+ "',null,null,null)";
	    int count1 = stmt.executeUpdate(AddlString);
	}
		
	private int UpdateUser()
	     throws SQLException
	{
	    String UpdateString = "update users set user_type='" 
		+ (String)UserTable.get("userType") 
		+ "',address_id='" + (String)UserTable.get("addr_id") 
		+ "',first_nam='" + (String)UserTable.get("f_name") 
		+ "',last_nam='" + (String)UserTable.get("l_name") 
		+ "',middle_nam='" + (String)UserTable.get("m_name") 
		+ "',surtitle='" + (String)UserTable.get("surtit") 
	       	+ "',permit_type='" + (String)UserTable.get("pType")
	       	+ "',permit_num='" + (String)UserTable.get("pnum")
		+ "',citizenship='" + (String)UserTable.get("citizenship") 
		+ "',fn_indctr='" + (String)UserTable.get("fn_indctr") 
		+ "',business_type='" + (String)UserTable.get("business") 
		+ "',business_name='" + (String)UserTable.get("b_name") 
		+ "',mail_stop='" + (String)UserTable.get("mail") 
		+ "',room_num='" + (String)UserTable.get("room") 
		+ "',phone='" + (String)UserTable.get("phone") 
		+ "',phone_ext='" + (String)UserTable.get("ext") 
		+ "',alt_phone='" + (String)UserTable.get("alt_phone") 
		+ "',fax='" + (String)UserTable.get("fax") 
		+ "',email='" + (String)UserTable.get("email") 
		+ "',spons_agency_uid='" + (String)UserTable.get("suid") 
		+ "',organization='" + (String)UserTable.get("org") 
		+ "',nac_type='" + (String)UserTable.get("nac") 
		+ "',ssan_last4='" + (String)UserTable.get("ssn") 
		+ "',user_comment='" + (String)UserTable.get("comment")
		+ "' where oracle_uid='" + (String)UserTable.get("uid") + "'";
       	    int count = stmt.executeUpdate(UpdateString);

	    // Update additional user table
	    String AddlUpdateString = "update addl_users set share_email='" 
		+ (String)UserTable.get("shared")
		+ "',list_email='" + (String)UserTable.get("list")
		//	+ "',permit_date=to_date('" + (String)UserTable.get("pdate")
		//	+ "','dd/mm/yyyy') "
		+ "' where oracle_uid='" + (String)UserTable.get("uid") + "'";
	    int count1 = stmt.executeUpdate(AddlUpdateString);

	    if ((count == 1) && (count1 == 1))
		return 1;
	    else
		return 0;
	}


        private int RecordEmail() 
	       throws SQLException
        {
	    String InsertString = "insert into sponsor_email_tracking values('"
		+ (String)UserTable.get("uid") + "',sysdate,'"
		+ (String)UserTable.get("suid") 
		+ "','N','nobody',sysdate)";
	    int count = stmt.executeUpdate(InsertString);
	    return count;
	}
    
        private void LoadCtas()
	        throws SQLException
        {
	    String cta = (String)UserTable.get("cta");
	    String CtaCode = "";
	    String queryStr = "";
	    
	    /*	    out.println((String)UserTable.get("uid"));
	    ResultSet uSet = stmt.executeQuery("select first_nam from users where oracle_uid='" + (String)UserTable.get("uid") +"'");
	    if (uSet.next())
		out.println(uSet.getString(1));
	    else
		{
		    out.println("Wrong");
		    return;
		}
	    */

	    if (cta !=null )
	    {
		CtaCode = getCtaCode(cta); 
		queryStr = "insert into student_ctas values('"
		    + (String)UserTable.get("uid") + "','"
		    + CtaCode + "','PRIMARY')";
		int count = stmt.executeUpdate(queryStr);
	    }
	
	    String cta2[] = (String[])UserTable.get("cta2");
	    if (cta2 !=null)
	    {
		int len = cta2.length;
		for (int i=0; i<len; i++) {
		    CtaCode = getCtaCode(cta2[i]);
		    queryStr = "insert into student_ctas(student_uid,cta) values('"
			+ (String)UserTable.get("uid") + "','"
			+ CtaCode + "')";
		    int count =  stmt.executeUpdate(queryStr);
		}
	    }
	}

        private String getCtaCode(String cta) 
        {
	    return cta.substring(0,3);
	}

        private void UpdateCtas() 
	       throws SQLException
        {
	    int count = stmt.executeUpdate("delete from student_ctas where student_uid='" + (String)UserTable.get("uid") + "'");
	    LoadCtas();
	}

        private void BackHome(PrintWriter out) 
        {
	    if (((String)UserTable.get("op")).equals("1"))
		out.println("<form method=\"POST\" action=\"ascdb.users.FrontPage\">");
	    else
		out.println("<form method=\"POST\" action=\"ascdb.pub.WelcomePage\">");
	    out.println("<input type=hidden name=\"uid\" value=\"" + (String)UserTable.get("uid") + "\">");
	    out.println("<input type=submit name=\"submit\" value=\"Back Main Menu\">");
	}
	    
        public void doGet(HttpServletRequest req, HttpServletResponse res)
	    throws ServletException, IOException
        {
	    doPost(req,res);
	}

}
	 


	    
