/*
** Display a user's detail information
** Class: UserDetail
** Author: Yuping Zhu
** Date: 04-05-1999
** Modified: 05-10-1999
**	Before approve a new register user,
**	admin can view the user's info. first. 
*/

package ascdb.users;

//import package java.sql to use JDBC
import java.sql.*;

//import package oracle.hmtl to generate dynamic HTML page
import oracle.html.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;
import ascdb.pub.UserCheck;

public class UserDetail extends HttpServlet {
     public void doGet(HttpServletRequest req, HttpServletResponse res)
    	throws  ServletException, IOException
     {
     // Output HTML page header
     res.setContentType("text/html");
     PrintWriter out = res.getWriter();
     conf dbconf= new conf(req);
     String uidStr = req.getParameter("uid");
     String me = req.getParameter("me");
     UserCheck u = new UserCheck(me);
     String role = req.getParameter("role");
     int op = (new Integer(req.getParameter("op"))).intValue();

//	out.println("lll");
     try {
	// Creates an HtmlHead Object 
	HtmlHead hd = new HtmlHead("User: " + uidStr + "'s information");

	//Create an HtmlBody Object
  	HtmlBody bd = new HtmlBody();

	// Sets various attributes of HtmlBody
  	bd.setBackgroundColor("#ffffe6");

	// Creates an HtmlPage object using hd and bd
  	HtmlPage hp = new HtmlPage(hd, bd);

	if (u.UserRole(1) != 0)
	{
	   hp.addItem(new SimpleItem("You do not have this privilege!"));
	   out.println(hp);
	   return;
	}
	// Load the Oracle JDBC driver
	Class.forName (dbconf.JdbcDriver);
        
	// Connect to the database
	Connection conn =
     	DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);

	// Create a Statement
	Statement stmt = conn.createStatement ();
	
	ResultSet rset = stmt.executeQuery("select * from user_info where oracle_uid='" + uidStr + "'");
	if (! rset.next())
	{
	   hp.addItem(new SimpleItem("Something Wrong!"));
	   out.println(hp);
	   return;
	}

	hp
	 .addItem(new SimpleItem("User: " + uidStr + "'s Information").setBold().setItal().setFontColor(Color.olive).setFontSize(5))
   	 .addItem(SimpleItem.LineBreak)
   	 .addItem(new Image(dbconf.ImageBase + "wavy.gif"))
   	 .addItem(SimpleItem.Paragraph) 
	 .addItem(new SimpleItem("User ID: ").setBold().setFontColor(Color.red))
   	 .addItem(new SimpleItem(uidStr))
   	 .addItem(SimpleItem.LineBreak)
   	 .addItem(new SimpleItem("Institution: ").setBold().setFontColor(Color.red));
	if (rset.getString("institution") == null)
	   hp.addItem(new SimpleItem("N/A"));
	else
    	   hp.addItem(new SimpleItem(rset.getString("institution")));
	hp
	 .addItem(SimpleItem.LineBreak)
  	 .addItem(new SimpleItem("Submitter: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("submitter")))
  	 .addItem(SimpleItem.LineBreak)
  	 .addItem(new SimpleItem("First Name: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("first_nam")))
  	 .addItem(SimpleItem.LineBreak)
  	 .addItem(new SimpleItem("Last Name: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("last_nam")))
 	 .addItem(SimpleItem.LineBreak);
	
	if (rset.getString("middle_nam") != null)
	hp
	 .addItem(new SimpleItem("Middle Name: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("middle_nam")))
  	 .addItem(SimpleItem.LineBreak);
	
	hp
  	 .addItem(new SimpleItem("Created Date: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem((rset.getDate("create_date")).toString()))
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Surtitle: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("surtitle")))
  	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Approved Date: ").setBold().setFontColor(Color.red));
	if (rset.getDate("approved_date") == null)
	    hp.addItem(new SimpleItem("N/A"));
	else
            hp.addItem(new SimpleItem((rset.getDate("approved_date")).toString()));
	hp
  	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Expiration Date: ").setBold().setFontColor(Color.red));
	if (rset.getDate("expiration_date") == null)
	    hp.addItem(new SimpleItem("N/A"));
	else
            hp.addItem(new SimpleItem((rset.getDate("expiration_date")).toString()));
	hp
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Citizenship: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("citizenship")))
         .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Company: ").setBold().setFontColor(Color.red));
	if (rset.getString("company_nam") == null)
	   hp.addItem(new SimpleItem("N/A"));
	else
    	   hp.addItem(new SimpleItem(rset.getString("company_nam")));
	hp
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Is US Company?").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("us_or_foreign")))
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("University: ").setBold().setFontColor(Color.red));
	 if (rset.getString("univ_nam") == null)
	     hp.addItem(new SimpleItem("N/A"));
	 else
  	     hp.addItem(new SimpleItem(rset.getString("univ_nam")));
        hp
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Is Contractor?").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("contractor")))
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Is Foreign?").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("foreign_national")))
	 .addItem(SimpleItem.LineBreak);
	
	if (rset.getString("asylum_num") != null)
	hp
	 .addItem(new SimpleItem("Asylum No.: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("asylum_num")))
	 .addItem(SimpleItem.LineBreak);

	if (rset.getString("green_card_num") != null )
	hp
	 .addItem(new SimpleItem("Green Card No.: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("green_card_num")))
	 .addItem(SimpleItem.LineBreak);
	
	if (rset.getString("temp_res_num") != null)
	hp
	 .addItem(new SimpleItem("Temporay Resident No.: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("temp_res_num")))
	 .addItem(SimpleItem.LineBreak);
	
	if (rset.getString("perm_res_num") != null)
	hp
	 .addItem(new SimpleItem("Permanent Resident No.: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("perm_res_num")))
	 .addItem(SimpleItem.LineBreak);
	
	if (rset.getString("refugee_num") != null )
	hp
	 .addItem(new SimpleItem("Refugee No.: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("refugee_num")))
	 .addItem(SimpleItem.LineBreak);

	hp
	 .addItem(new SimpleItem("Organization: ").setBold().setFontColor(Color.red));
	if (rset.getString("organization") == null)
	    hp.addItem(new SimpleItem("N/A"));
	 else
   	    hp.addItem(new SimpleItem(rset.getString("organization")));
	hp
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Password received? ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("passwd_received")))
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Purpose: ").setBold().setFontColor(Color.red));
	if (rset.getString("purpose")==null)
	    hp.addItem(new SimpleItem("N/A"));
	else
  	    hp.addItem(new SimpleItem(rset.getString("purpose")));
        hp
	 .addItem(SimpleItem.LineBreak) 
	 .addItem(new SimpleItem("System Role: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(role))
	 .addItem(SimpleItem.LineBreak)
       	 .addItem(new SimpleItem("Sponsoring Agency ID: ").setBold().setFontColor(Color.red));
	if (rset.getString("spons_agency_uid") == null)
	   hp.addItem(new SimpleItem("N/A"));
	else
  	   hp.addItem(new SimpleItem(rset.getString("spons_agency_uid")));
        hp
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Position: ").setBold().setFontColor(Color.red));
	if (rset.getString("position") == null)
	   hp.addItem(new SimpleItem("N/A"));
	else
  	   hp.addItem(new SimpleItem(rset.getString("position")));
	hp
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("POC UID: ").setBold().setFontColor(Color.red));
	if (rset.getString("poc_uid") == null)
	   hp.addItem(new SimpleItem("N/A"));
	else
  	   hp.addItem(new SimpleItem(rset.getString("poc_uid")));
	hp
	 .addItem(SimpleItem.LineBreak);
 	if (rset.getString("special_reqs") != null)
	hp
	 .addItem(new SimpleItem("Special Requirements: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("special_reqs")))
	 .addItem(SimpleItem.Paragraph);
	
	hp
//	 .addItem(new Image(dbconf.ImageBase + "wavy.gif"))
	 .addItem(SimpleItem.Paragraph)
	 .addItem(new SimpleItem("Address Information: ").setBold().setFontColor(Color.olive).setItal().setFontSize(5))
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new Image(dbconf.ImageBase + "wavy.gif"))
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Address: ").setBold().setFontColor(Color.red));
	if (rset.getString("address") == null) 
	   hp.addItem(new SimpleItem("N/A"));
	else
  	   hp.addItem(new SimpleItem(rset.getString("address")));
	hp
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("City: ").setBold().setFontColor(Color.red));
	if (rset.getString("city") == null)
	   hp.addItem(new SimpleItem("N/A"));
	else	
  	   hp.addItem(new SimpleItem(rset.getString("city")));
	hp
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("State: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("state")))
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Zip: ").setBold().setFontColor(Color.red));
	if (rset.getString("zip") == null)
	   hp.addItem(new SimpleItem("N/A"));
	else
  	   hp.addItem(new SimpleItem(rset.getString("zip")));
	hp
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Country: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("country")))
	 .addItem(SimpleItem.LineBreak)
	 .addItem(new SimpleItem("Phone: ").setBold().setFontColor(Color.red));
	if (rset.getString("phone") != null)
  	 hp.addItem(new SimpleItem(rset.getString("phone")));
	else
	 hp.addItem(new SimpleItem("N/A"));
	
	hp
	 .addItem(SimpleItem.LineBreak);
	if (rset.getString("phone_ext") != null)
	hp
 	 .addItem(new SimpleItem("Phone Ext.: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("phone_ext")))
	 .addItem(SimpleItem.LineBreak);
	
	if (rset.getString("alt_phone") != null)
	hp
 	 .addItem(new SimpleItem("Alternate Phone: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("alt_phone")))
	 .addItem(SimpleItem.LineBreak);

	if (rset.getString("fax") != null)
	hp
 	 .addItem(new SimpleItem("Fax.: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("fax")))
	 .addItem(SimpleItem.LineBreak);

	if (rset.getString("email") != null)
	hp
 	 .addItem(new SimpleItem("Email: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("email")))
	 .addItem(SimpleItem.LineBreak);
	
	if (rset.getString("alt_poc") != null)
	hp
 	 .addItem(new SimpleItem("Alternate POC UID: ").setBold().setFontColor(Color.red))
  	 .addItem(new SimpleItem(rset.getString("alt_poc")))
	 .addItem(SimpleItem.LineBreak);

	Form frm = new Form("GET","ascdb.users.ApproveUser");
	frm
	   .addItem(new Hidden("uid",uidStr))
	   .addItem(new Hidden("me",me))
	   .addItem(new Submit("Submit","Approve!"));

	if (op==1)
	   hp.addItem(frm.setBold());	    

	// Display HTML page
	out.println(hp);
	}
	catch (ClassNotFoundException e) {
           out.println("Couldn't load database driver: " + e.getMessage());
	}
	catch (SQLException e) {
           out.println(e.getMessage());
	}
	catch(Exception e) {
	   out.println(e.getMessage());
	}
    }
}
