drop package adm;
/
create or replace package adm is
procedure check_header_body;
procedure delete_by_date(deadline date);
--procedure copy_table(mdate date);
procedure rn_folder;
procedure set_min_max;
procedure delete_mail(days integer);

end;
/
show errors;
/
create or replace package body adm is

procedure check_header_body is

cursor cfolder is select id,name from folder order by id;
cursor cheader(lower_id number,upper_id number) is 
	select id from header where id between lower_id and upper_id order by id;
cursor cbody(bid number) is select id from body where id=bid;

lid header.id%TYPE;
uid header.id%TYPE;
fid integer;
n header.id%TYPE;
bid header.id%TYPE;
total header.id%TYPE;
maxid header.id%TYPE;
fname varchar(200);
junkid header.id%TYPE;

begin
	total := 0;
	open cfolder;
	loop
		fetch cfolder into fid,fname;
		exit when cfolder%NOTFOUND;
		htp.p('working on '||fname||'...');
		n := 0;
		maxid := 0;
		uid := fid*MAILS.maxmsg;
		lid := uid - MAILS.maxmsg + 1;
		open cheader(lid,uid);	
		loop
			fetch cheader into bid;
		 	exit when cheader%NOTFOUND;
			open cbody(bid);
			fetch cbody into junkid;
			if (cbody%NOTFOUND) then
				n := n + 1;
				delete from header where id=bid;
				--htp.p('delete id='||bid);
				commit;
			else
				if (bid > maxid) then
					maxid := bid;
				end if;
			end if;
			close cbody;
		end loop;
		close cheader;
		if (n > 0) then
			maxid := maxid - lid + 1;
			update folder set max_msgid=maxid,
					  n_msg=n_msg-n
				where id=fid;
			commit;
			htp.p('Delete '||n||' mail headers from <'||fname||'>');
			total := total + n;	
		end if;
	end loop;
	close cfolder; 
	htp.p('Total '||total||' mail headers deleted from the mailbox !');	
end;

procedure delete_by_date(deadline date) is
	cursor cdate(lid number,uid number,ddate date) is select id from header
		where (id between lid and uid) and (msg_date > ddate) order by id desc;
	cursor fdate is select id from folder;
	mid header.id%TYPE;
	uid header.id%TYPE;
	lid header.id%TYPE;
	n header.id%TYPE;
	m integer;
	maxid header.id%TYPE;
	fid header.id%TYPE;
begin

	open fdate;
	loop 
		fetch fdate into fid;
		exit when fdate%NOTFOUND;
		uid := fid*MAILS.maxmsg;
		lid := uid - MAILS.maxmsg + 1;
		n := 0;
		m := 0;
		open cdate(lid,uid,deadline);
		loop 
			fetch cdate into mid;
			exit when cdate%NOTFOUND;
			n := n + 1;
			m := m + 1;
			delete from header where id=mid;
			delete from body where id=mid;
			if (m > 3) then
				commit;
				m := 0;
			end if;
		end loop;
		if (n > 0) then
			maxid := mid - lid;
			update folder set max_msgid=maxid,n_msg=(n_msg-n) where id=fid;
			commit;
		end if;
		close cdate;
	end loop;	
	close fdate;
end;

--procedure copy_table(mdate date) is
--	cursor cdate(ddate date) is select id from header
--		where  (msg_date < ddate) and not (id >51000 and id <61000) order by id asc;
--begin
--	for header in cdate(mdate) loop
--		insert into temp 
--			select id,body_type,chars,words,lines,msg_body1,msg_body2,msg_body3,
--			msg_body4,msg_body5,msg_body6,msg_body7,msg_body8,msg_body9,msg_body10 
--			from body where id=header.id;
--		commit;
--		htp.p('id='||header.id);
--	end loop;
--end;		

procedure rn_folder is
--cursor cfolder is select id,name from folder order by id;
begin
--		update folder set name=substr(name,instr(name,'/',-1,1)+1);
		update folder set name=(substr(name,instr(name,'/',-1,1)+1)||
			' (mailing-list)');
		commit;
end;

procedure set_min_max is
	cursor cfolder is select id from folder order by id;
	fid folder.id%TYPE;
	min_id header.id%TYPE;
	max_id header.id%TYPE;
	uid header.id%TYPE;
	lid header.id%TYPE;
	total header.id%TYPE;
	begin
	
	open cfolder;
	loop
		fetch cfolder into fid;
		exit when cfolder%NOTFOUND;
		uid := fid*MAILS.maxmsg;
		lid := uid - MAILS.maxmsg + 1;
		select (min(id)-lid+1),(max(id)-lid+1),count(*) into min_id,max_id,total 
			from header where id between lid and uid;		
		update folder set min_msgid=min_id,max_msgid=max_id,n_msg=total
			 where id=fid;
		commit;
	end loop;
	close cfolder;	
end;

procedure delete_mail(days integer) is
	cursor cdate(cdays integer) is select id from header
		where msg_date < (sysdate - cdays);
	cid header.id%TYPE;
	n integer := 0;	
	m integer := 0;
begin
	open cdate(days);
	loop
		fetch cdate into cid;
		exit when cdate%NOTFOUND;
		delete from header where id=cid;
		delete from body where id=cid;
		n := n + 1;
		m := m + 1;
		if (m = 5) then
			commit;
			m := 0;
		end if;
	end loop;
	commit;
	--delete from body where id in (select id from 
	--	header where msg_date < (sysdate - days));
	--delete from header where msg_date < (sysdate - days);
	--commit;
	set_min_max;
	htp.p('total mails deleted: '||n);
end;

end adm;
/
show errors;
/
