drop package hypermail;
/
create or replace package hypermail is
procedure home(host in char,address in char,user in char);
procedure list_folder;
  procedure listheader(fid number,op integer,hit number);
  procedure lthread(fid number,hit number,lo number,high number);
  procedure hlist_author(id number,subject in out varchar2,h_date date,h_bytes number);
  procedure header_list(id number,bytes number,
		sender varchar2,subject in out varchar2,msg_date date);
  procedure keyword(typein varchar2, fid number);
procedure showbody(bid number);
procedure copyright;

owner_uid constant varchar2(10) := MAILS.owner_uid;
cgi_bin constant varchar2(30) := MAILS.cgi_bin;
maxmsg constant number(8) := MAILS.maxmsg;
my_url  constant varchar2(50) := MAILS.my_url;

end hypermail;
/
show errors;
/
create or replace package body hypermail is
h_id header.id%TYPE;
h_msg_date header.msg_date%TYPE;
h_subject header.subject%TYPE;
h_sender header.sender%TYPE;
h_bytes header.bytes%TYPE;
h_name people.email%TYPE;
--h_name varchar2(100);
h_email people.email%TYPE;
total_visitors number(7);

procedure home(host in char,address in char,user in char) is
	total_visitors number(7);
	begin
		insert into visitor
			values (new_time(sysdate,'EST','EST'),host,address,user);
		update mailbox set visitors = (visitors + 1);
		commit;
		--select count(*) into total_visitors from visitor;
		select visitors into total_visitors from mailbox;
	        htp.p('You are the '||htf.bold('<blink>'||total_visitors||'th</blink>')||' visitor to this database.');
		htp.p('Click <a href = "'||cgi_bin||
			'stats.stats">here</a> to see all visitors history.');
	        htp.p(htf.line);
		list_folder;
	        copyright;
	end;

 procedure list_folder is
   total number := 0;
   n integer := 1;
   cursor cfolder is select id,name,n_msg from folder order by name;
   host varchar2(60) := 'http://128.230.3.'; -- new to SP2
   --instance_id integer := 9;		     -- new to SP2
 begin

	select sum(n_msg),count(*) into total,n from folder;
	htp.htitle('Newsgroups and Mailing Lists Available');
	--htp.p('<h1>Newsgroups and Mailing Lists Available</h1>');	

	/* try to find out instance id (NEW stuff to SP2) */
	--select instance.nextval into instance_id from dual;
	--host := host||(2*mod(instance_id,4)+39)||cgi_bin;
        host := MAILS.root_url||cgi_bin;

	htp.p('<dl>');
	for folder in cfolder loop
	   --htp.p('<dt>'||htf.url(cgi_bin||'hypermail.listheader?fid='||folder.id||'&op=1&hit=20',
		htp.p('<dt>'||htf.url(host||'hypermail.listheader?fid='||folder.id||'&op=1&hit=20',
		folder.name)||' ('||folder.n_msg||')');
	end loop;
	htp.p('</dl>');
	htp.line;
	htp.p('Total archives: '||htf.bold(n)||' Total Messages: '||htf.bold(total));
 end;

procedure copyright is
	begin
	
	htp.line;
	htp.p('<address>This package is developed by '||
	   htf.url('http://www.npac.syr.edu/homepages/gcheng/gcheng.html','Gang Cheng')
	   ||' at '||htf.url('http://www.npac.syr.edu/',
           'Northeast Parallel Architectures Center')||
	   ', Syracuse University.');
	htp.p('Send comment to '||htf.url('mailto:gcheng@npac.syr.edu',
	   'gcheng@npac.syr.edu')||'. </address></html>');

	end;

 procedure listheader(fid number,op integer,hit number) is
	f_id number(7);	
	f_name varchar2(150);
	f_path varchar2(150);
	f_n_msg number(8);
	f_logo varchar2(150);
	total number(8);
    	cursor cname2(lower in number,upper in number) is 
		SELECT id,msg_date,subject,sender,bytes 
		from header where (id between lower and upper) 
		order by msg_date desc;
	cursor cname3(lowerid in number,upperid in number) is
		SELECT id,msg_date,subject,sender,bytes from header where 
		(id between lowerid and upperid) order by replace(LOWER(subject),'re: ') asc,msg_date desc;
	cursor cname4(lower in number,upper in number) is
		SELECT id,msg_date,subject,sender,name,email,bytes from header,people where 
		(id between lower and upper) and sender=email order by name asc,msg_date desc;
	upper_id header.id%TYPE := 0;
	lower_id header.id%TYPE := 0;
	n integer;
	limit number(8);
	max_date date;
	min_date date;
	tmp_sender header.sender%TYPE;
	tmp_subject header.subject%TYPE;
	cursor cpeople(csender varchar2) is
		select name,email from people where email=csender;
	high header.id%TYPE;
	lo header.id%TYPE;
   begin

	SELECT name,n_msg into f_name,f_n_msg from folder where id = fid;
	if (hit = 0 or hit >= f_n_msg) then limit := f_n_msg;
	else limit := hit;
	end if;

	select max_msgid into high from folder where id = fid;
	high := (fid-1)*maxmsg + high;
	lo := high - limit + 1;
	
	if (op = 1) then
		lthread(fid,hit,lo,high);
		return;
	else
		MAILS.button;
		upper_id := fid*maxmsg;
		lower_id := upper_id - maxmsg + 1;
		select max(msg_date),min(msg_date) into max_date,min_date from header where  
		id between lower_id and upper_id;	
	      if (op = 2) then
		htp.p('<title>'||f_name||' by date</title>');
		htp.p('<a name="start"><h1>'||f_name||' by date</h1></a>');
		htp.p('<ul><li><b>Messages sorted by:</b> ');
		htp.p(htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo||'&high='||high,'[ thread ]')||
			htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=3&hit='||limit,'[ subject ]'));
		htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=4&hit='||limit,'[ author ]'));
		htp.formOpen(cgi_bin||'hypermail.keyword');
		htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
			'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
		htp.p(htf.formClose);

		htp.p('</ul><p>');
		htp.p(htf.bold('Starting:')||' <i>'||to_char(min_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Ending:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Messages: ')||
			htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=2&hit='||f_n_msg,htf.bold(f_n_msg))
			||' ('||limit||' listed)');
		open cname2(lower_id,upper_id);
		fetch cname2 into h_id,h_msg_date,h_subject,h_sender,h_bytes;
		if (cname2%FOUND) then
			total := 1;
			htp.p('<p><ul>');
			loop
				header_list(h_id,h_bytes,h_sender,h_subject,h_msg_date);	
				if (total = limit) then exit; end if;
				fetch cname2 into h_id,h_msg_date,h_subject,h_sender,h_bytes;
	                	exit when cname2%NOTFOUND;
				total := total + 1;
			end loop;
			htp.p('</ul>');
		end if;
		close cname2;
		htp.p('<p>');
		htp.p(htf.bold('Last message date:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Archived on:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Messages: ')||
			htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=2&hit='||f_n_msg,htf.bold(f_n_msg))
			||' ('||limit||' listed)');
		htp.p('<ul><li><b>Messages sorted by:</b> ');
				htp.p(htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo||'&high='||high,'[ thread ]')||
		htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=3&hit='||limit,'[ subject ]'));
		htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=4&hit='||limit,'[ author ]'));
		htp.formOpen(cgi_bin||'hypermail.keyword');
		htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
			'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
		htp.p(htf.formClose);

		htp.p('</ul><p>');
	elsif (op = 3) then
		htp.p('<title>'||f_name||' by subject</title>');
		htp.p('<a name="start"><h1>'||f_name||' by subject</h1></a>');
		htp.p('<ul><li><b>Messages sorted by:</b> ');

		htp.p(htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
			'&lo='||lo||'&high='||high,'[ thread ]')||
			htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=2&hit='||limit,'[ date ]'));
			htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=4&hit='||limit,'[ author ]'));
		htp.formOpen(cgi_bin||'hypermail.keyword');
		htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
			'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
		htp.p(htf.formClose);

		htp.p('</ul><p>');
		htp.p(htf.bold('Starting:')||' <i>'||to_char(min_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Ending:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Messages: ')||
			htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=3&hit='||f_n_msg,htf.bold(f_n_msg))
			||' ('||limit||' listed)');
		open cname3(lower_id,upper_id);
		fetch cname3 into h_id,h_msg_date,h_subject,h_sender,h_bytes;
		if (cname3%FOUND) then
			total := 1;
			htp.p('<p><ul>');
			loop	
				if (replace(h_subject,' ') IS NULL) then
					h_subject := '(no subject)';
					tmp_subject := h_subject;					
				else
					tmp_subject := replace(lower(h_subject),'re: ');
					h_subject := replace(h_subject,'&','&amp');
					h_subject := replace(h_subject,'<','&lt');
					h_subject := replace(h_subject,'>','&gt');
					h_subject := replace(h_subject,'"','&quot');
					h_subject := replace(h_subject,'Re: ');
					h_subject := replace(h_subject,'RE: ');
					h_subject := replace(h_subject,'re: ');	
				end if;
				htp.p('<li>'||htf.bold(h_subject));
				htp.p('<ul>');
				loop
					open cpeople(h_sender);
					fetch cpeople into h_name,h_email;
					if (cpeople%NOTFOUND) then 
						h_name := '(no name)';
					else
						if (h_name IS NULL) then
							h_name := h_email;
						end if;
					end if;
					close cpeople;
					htp.p('<li>'||htf.url(cgi_bin||'hypermail.showbody?bid='||
						h_id,h_name)||'<i> '||
						to_char(new_time(h_msg_date,'EST','EST'),'Dy, DD Mon YYYY "-" hh24:mi:ss')||
						' EST ('||to_char(h_bytes/1024.,'FM99D9')||'K)</i>');
					total := total + 1;				
					if (total = limit) then exit; end if;
					fetch cname3 into h_id,h_msg_date,h_subject,h_sender,h_bytes;
	                		exit when (cname3%NOTFOUND);
					if (replace(h_subject,' ') IS NULL) then
						h_subject := '(no subject)';
					end if;
					exit when (replace(lower(h_subject),'re: ') != tmp_subject);
				end loop;
				htp.p('</ul>');
				if (total = limit) then exit; end if;
				exit when cname3%NOTFOUND;
			end loop;
			htp.p('</ul>');
		end if;
		close cname3;		

		htp.p('<p>');
		htp.p(htf.bold('Last message date:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Archived on:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Messages: ')||
			htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=3&hit='||f_n_msg,htf.bold(f_n_msg))
			||' ('||limit||' listed)');
		htp.p('<ul><li><b>Messages sorted by:</b> ');
		htp.p(htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo||'&high='||high,'[ thread ]')||
		htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=2&hit='||limit,'[ date ]'));
		htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=4&hit='||limit,'[ author ]'));
		htp.formOpen(cgi_bin||'hypermail.keyword');
		htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
			'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
		htp.p(htf.formClose);

		htp.p('</ul><p>');
	elsif (op = 4) then
		htp.p('<title>'||f_name||' by author</title>');
		htp.p('<a name="start"><h1>'||f_name||' by author</h1></a>');
		htp.p('<ul><li><b>Messages sorted by:</b> ');
		htp.p(htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo||'&high='||high,'[ thread ]')||
		htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=2&hit='||limit,'[ date ]'));
		htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=3&hit='||limit,'[ subject ]'));
		htp.formOpen(cgi_bin||'hypermail.keyword');
		htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
			'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
		htp.p(htf.formClose);

		htp.p('</ul><p>');
		htp.p(htf.bold('Starting:')||' <i>'||to_char(min_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Ending:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Messages: ')||
			htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=4&hit='||f_n_msg,htf.bold(f_n_msg))
			||' ('||limit||' listed)');

		open cname4(lower_id,upper_id);
		fetch cname4 into h_id,h_msg_date,h_subject,h_sender,h_name,h_email,h_bytes;
		if (cname4%FOUND) then
			total := 1;
			htp.p('<p><ul>');
			loop	
				tmp_sender := h_sender;
				if (h_name IS NULL) then
					htp.p('<li>'||htf.bold(h_email));
				else
					htp.p('<li>'||htf.bold(h_name));
				end if;

				htp.p('<ul>');
				loop
					hlist_author(h_id,h_subject,h_msg_date,h_bytes);
					total := total + 1;				
					if (total = limit) then exit; end if;
					fetch cname4 into h_id,h_msg_date,h_subject,h_sender,h_name,h_email,h_bytes;
	                		exit when (cname4%NOTFOUND or (h_sender != tmp_sender));
				end loop;
				htp.p('</ul>');
				if (total = limit) then exit; end if;
				exit when cname4%NOTFOUND;
			end loop;
			htp.p('</ul>');
		end if;
		close cname4;		

		htp.p('<p>');
		htp.p(htf.bold('Last message date:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Archived on:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Messages: ')||
			htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=4&hit='||f_n_msg,htf.bold(f_n_msg))
			||' ('||limit||' listed)');
		htp.p('<ul><li><b>Messages sorted by:</b> ');
		htp.p(htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
			'&lo='||lo||'&high='||high,'[ thread ]')||
		htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=2&hit='||limit,'[ date ]'));
		htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=3&hit='||limit,'[ subject ]'));
		htp.formOpen(cgi_bin||'hypermail.keyword');
		htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
			'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
		htp.p(htf.formClose);

		htp.p('</ul><p>');		
	end if; 
    end if;

	wow.sig;
end;	 

procedure lthread(fid number,hit number,lo number,high number) is
	f_id number(7);	
	f_name varchar2(150);
	f_n_msg number(8);
    	cursor cname(lower in number,upper in number) is 
		SELECT id,msg_date,subject,sender,bytes 
		from header where (id between lower and upper) 
		order by id desc;
	n header.id%TYPE;
	limit number(8);
	max_id header.id%TYPE;
	min_id header.id%TYPE;
	hi_id_next header.id%TYPE;
	lo_id_next header.id%TYPE;
	hi_id_prev header.id%TYPE;
	lo_id_prev header.id%TYPE;
	max_date date;
	min_date date;
	base  header.id%TYPE;
begin

	MAILS.button;
	SELECT name,n_msg,max_msgid,min_msgid into f_name,f_n_msg,max_id,min_id 
		from folder where id = fid;
	base := (fid-1)*maxmsg;
	max_id := base + max_id;
	min_id := base + min_id;

	--if (high > max_id) then high := max_id; end if;
	--if (lo < min_id) then lo := min_id; end if;

	if (hit = 0 or hit >= f_n_msg) then limit := f_n_msg;
	else limit := hit;
	end if;
		
	htp.p('<title>'||f_name||' by thread</title>');
	htp.p('<a name="start"><h1>'||f_name||' by thread</h1></a>');
	htp.p('<ul><li><b>Messages sorted by:</b> ');
	htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=2&hit='||limit,'[ date ]'));
	htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=3&hit='||limit,'[ subject ]')||
	htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=4&hit='||limit,'[ author ]'));
	htp.formOpen(cgi_bin||'hypermail.keyword');
	htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
		'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
	htp.p(htf.formClose);

	htp.p('</ul><p>');
	select max(msg_date),min(msg_date) into max_date,min_date from header where  
		id between min_id and max_id;
	htp.p(htf.bold('Starting:')||' <i>'||to_char(min_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i> ');
	htp.p(htf.bold('Ending:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
	htp.p(htf.bold('Messages: ')||f_n_msg||' ('||
		htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||min_id||'&high='||max_id,(max_id-base)||'-'||(min_id-base))||')');

	if (high < max_id) then
		lo_id_prev := high + 1;
		hi_id_prev := lo_id_prev + limit - 1;
		if (hi_id_prev > max_id) then hi_id_prev := max_id; end if;
		if (lo_id_prev < min_id) then lo_id_prev := min_id; end if;
		htp.p(htf.bold(' Previous: ')||htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo_id_prev||'&high='||hi_id_prev,(hi_id_prev-base)||'-'||(lo_id_prev-base)));
	end if;
	htp.p(htf.bold(' Current: ')||(high-base)||'-'||(lo-base));
	if (lo > min_id) then
		hi_id_next := lo - 1;
		lo_id_next := hi_id_next - limit + 1;
		if (hi_id_next > max_id) then hi_id_next := max_id; end if;
		if (lo_id_next < min_id) then lo_id_next := min_id; end if;
		htp.p(htf.bold(' Next: ')||htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo_id_next||'&high='||hi_id_next,(hi_id_next-base)||'-'||(lo_id_next-base)));
	end if;	
	htp.p(htf.bold(' Threads/page: '));
	if (limit=20) then
		htp.p('20 |');
	else
		htp.p(htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||20||
		'&lo='||(high-19)||'&high='||high,'20')||' |');
	end if;
	if (limit=50) then
		htp.p('50| ');
	else
		htp.p(htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||50||
		'&lo='||(high-49)||'&high='||high,'50')||' |');
	end if;
	if (limit=100) then
		htp.p('100 |');
	else
		htp.p(htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||100||
		'&lo='||(high-99)||'&high='||high,'100')||' |');
	end if;
	if (limit=f_n_msg) then
		htp.p('all');
	else
		htp.p(htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||f_n_msg||
		'&lo='||min_id||'&high='||high,'all'));
	end if;
	
	if (high < max_id) then
		n := (hi_id_prev - lo_id_prev + 1);
		if (n >= limit) then n := limit; end if;
		htp.p('<p><i>...<= '||htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo_id_prev||'&high='||hi_id_prev,'previous '||n||' threads')||
		' ('||(hi_id_prev-base)||'-'||(lo_id_prev-base)||')</i>');
		htp.p(' <i>'||htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||(max_id-limit+1)||'&high='||max_id,(max_id-base))||'<=...</i>');
	end if;
	open cname(lo,high);
	fetch cname into h_id,h_msg_date,h_subject,h_sender,h_bytes;
	if (cname%FOUND) then
		htp.p('<p><ul>');
		loop
			header_list(h_id,h_bytes,h_sender,h_subject,h_msg_date);	
			fetch cname into h_id,h_msg_date,h_subject,h_sender,h_bytes;
	               	exit when cname%NOTFOUND;
		end loop;
		htp.p('</ul>');
	end if;
	close cname;
	if (lo > min_id) then
		n := (hi_id_next - lo_id_next + 1);
		if (n >= limit) then n := limit; end if;
		htp.p('<i>=>... '||htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo_id_next||'&high='||hi_id_next,'next '||n||' threads')||
		' ('||(hi_id_next-base)||'-'||(lo_id_next-base)||')</i>');
		htp.p(' <i>...=>'||htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||min_id||'&high='||(min_id+limit-1),(min_id-base))||'</i>');
	end if;

	htp.p('<p>');
	htp.p(htf.bold('Last message date:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i> ');
	htp.p(htf.bold('Archived on:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
	htp.p(htf.bold('Messages: ')||f_n_msg||' ('||
		htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||min_id||'&high='||max_id,(max_id-base)||'-'||(min_id-base))||')');
	if (high < max_id) then
		htp.p(htf.bold(' Previous: ')||htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo_id_prev||'&high='||hi_id_prev,(hi_id_prev-base)||'-'||(lo_id_prev-base)));
	end if;
	htp.p(htf.bold(' Current: ')||(high-base)||'-'||(lo-base));
	if (lo > min_id) then
		htp.p(htf.bold(' Next: ')||htf.url(cgi_bin||'hypermail.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo_id_next||'&high='||hi_id_next,(hi_id_next-base)||'-'||(lo_id_next-base)));
	end if;	

	htp.p('<ul><li><b>Messages sorted by:</b> ');
	htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=2&hit='||limit,'[ date ]'));
		htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=3&hit='||limit,'[ subject ]'));
	htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&op=4&hit='||limit,'[ author ]'));
	htp.formOpen(cgi_bin||'hypermail.keyword');
	htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
		'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
	htp.p(htf.formClose);
	htp.p('</ul><p>');
	wow.sig;
end;	 

procedure hlist_author(id number,subject in out varchar2,h_date date,h_bytes number) is
	begin
		if (subject IS NOT NULL) then
			subject := replace(subject,'&','&amp');
			subject := replace(subject,'<','&lt');
			subject := replace(subject,'>','&gt');
			subject := replace(subject,'"','&quot');
		else
			subject := '(no subject)';
		end if;
		htp.p('<li>'||htf.url(cgi_bin||'hypermail.showbody?bid='||id,
			htf.bold(subject))||'<i> '||
			to_char(new_time(h_date,'EST','EST'),'Dy, DD Mon YYYY "-" hh24:mi:ss')||
			' EST ('||to_char(h_bytes/1024.,'FM99D9')||'K)</i>');

	end;

  procedure header_list(id number,bytes number,
		sender varchar2,subject in out varchar2,msg_date date) is
	h_name varchar2(100);
	h_email varchar2(100);
	begin
		subject := replace(subject,'&','&amp');
		subject := replace(subject,'<','&lt');
		subject := replace(subject,'>','&gt');
		subject := replace(subject,'"','&quot');	
		if (replace(subject,' ') IS NULL) then
			subject := '(no subject)';
		end if;
		SELECT name,email into h_name,h_email from people where email=sender;
		if (h_name IS NULL) then
			h_name := h_email;
		end if;
		htp.p('<li>'||htf.url(cgi_bin||'hypermail.showbody?bid='||id,
			htf.bold(subject))||' - '||
			htf.bold(h_name)||' - <i>'||to_char(msg_date,'Dy, dd Mon yy hh24:mi')||
			'</i> ('||to_char(bytes/1024.,'FM99D9')||'K)');

  exception
	when NO_DATA_FOUND then
		htp.p('<li>'||htf.url(cgi_bin||'hypermail.showbody?bid='||id,
			htf.bold(subject))||' - '||
			htf.bold(sender)||' - <i>'||to_char(msg_date,'Dy, dd Mon yy hh24:mi')||
			'</i> ('||to_char(bytes/1024.,'FM99D9')||'K)');		 
	end;

procedure keyword(typein varchar2, fid number) is
	TYPE wordstype IS TABLE
		OF varchar2(20) INDEX BY BINARY_INTEGER;
	word_tab wordstype;
    	cursor cbody(wordin varchar2,lowerid number,upperid number) is SELECT id
		from body where (id between lowerid and upperid) and 
		(lower(msg_body1) like wordin or 
		 lower(msg_body2) like wordin or
		 lower(msg_body3) like wordin or
		 lower(msg_body4) like wordin or
		 lower(msg_body5) like wordin or
		 lower(msg_body6) like wordin or
		 lower(msg_body7) like wordin or
		 lower(msg_body8) like wordin or
		 lower(msg_body9) like wordin or
		 lower(msg_body10) like wordin )
		order by id desc;

	upper_id header.id%TYPE := 0;
	lower_id header.id%TYPE := 0;
	f_id number(8);
	typeinword varchar2(40);
	wordshow varchar2(200);
	word_junk varchar2(100);
	total number(8) := 0;
	words varchar2(200);
	i integer;
	k integer;
	ii BINARY_INTEGER;
	w_count BINARY_INTEGER;
	last_word boolean := false;
	tmp varchar2(200);
	body_all long;
	body_rec body%ROWTYPE;
	begin

	MAILS.button;
	tmp := replace(typein,' ','');
	if (tmp IS NULL) then
		htp.p('<p>You must choose a word to start the search. Try again.');	
		wow.sig;
		return;
	else
		words := typein;
	end if;

     	i := 1;
     	last_word := false;
    	w_count := 0;
	    tmp := NULL;
     	while (1 = 1) loop
		k := instr(words,' ',i);
		if (k = i) then 
			i := i + 1;
		else
			if (k = 0) then
				last_word := true;
				typeinword := words;	
			else
				typeinword := substr(words,1,k);
				words := substr(words,k+1);
				i := 1;					
			end if;
	
			typeinword := replace(typeinword,' ',''); 
			if (typeinword IS NULL) then
				last_word := true; 
			else
				w_count := w_count + 1;
				word_tab(w_count) := typeinword;					
				if (tmp IS NULL) then
					tmp := typeinword;
				else
					tmp := tmp||'+'||typeinword;
				end if;
			end if;
			if (last_word) then exit; end if;
		end if;
	end loop;
	last_word := false;

	upper_id := fid*maxmsg;
	lower_id := upper_id - maxmsg + 1;
	
	typeinword := word_tab(1);
	if (w_count = 1) then last_word := true; end if;
		
	typeinword := lower(typeinword);
	wordshow := typeinword;
	typeinword := '%'||typeinword||'%';

	htp.p(htf.line);
	open cbody(typeinword,lower_id,upper_id);
	fetch cbody into h_id;
	if (cbody%NOTFOUND) then
		close cbody;
		htp.p('<p>The key word '||htf.bold(wordshow)
			||' is not found in any mail<br>');
		wow.sig;
	        return;
	end if;	
	total := 0;
	if (not last_word) then wordshow := tmp; end if;
	htp.p('<p>The key word '||htf.bold(wordshow)
		||' is found in the following mails:');

	htp.p('<ul>');
	loop

		if (not last_word) then
			select id,BODY_TYPE,CHARS,WORDS,LINES,msg_body1,msg_body2,
			msg_body3,msg_body4,msg_body5,msg_body6,
			msg_body7,msg_body8,msg_body9,msg_body10,msg_body11 into body_rec
			from body where id=h_id;
			ii := 2;
			body_all := body_rec.msg_body1||body_rec.msg_body2||
				body_rec.msg_body3||body_rec.msg_body4||body_rec.msg_body5||
				body_rec.msg_body6||body_rec.msg_body7||body_rec.msg_body8||
				body_rec.msg_body9||body_rec.msg_body10;
			while (ii <= w_count) loop
				k := instr(lower(body_all),lower(word_tab(ii)));
				if (k = 0) then exit; end if;
				ii := ii + 1;
			end loop;
			if (ii <= w_count) then goto no_if2; end if;
		end if;

		select id,msg_date,subject,sender,bytes into 
		h_id,h_msg_date,h_subject,h_sender,h_bytes
		from header where id = h_id;	      
		if (not last_word) then
			MAILS.header_list(h_id,h_bytes,h_sender,h_subject,h_msg_date,tmp);
		else
			MAILS.header_list(h_id,h_bytes,h_sender,h_subject,h_msg_date,wordshow);
		end if;
		    	total := total + 1;
<<no_if2>>
			fetch cbody into h_id;
                	exit when cbody%NOTFOUND;
	end loop;
	close cbody;
		
	htp.p('</ul>');
	htp.p('<p>Total '||htf.bold(total)||' mails found.');
		
	wow.sig;
        end;

procedure showbody(bid number) is
	fid number(8);
	body_all long;
	h_msg_date date;
	h_cc varchar2(1000);
	h_receiver varchar2(2000);
	h_replied_id varchar2(200);
	h_msg_id varchar2(200);
	url varchar2(254);
	n1 header.id%TYPE;
	k header.id%TYPE;
	m header.id%TYPE;	
	n header.id%TYPE;
	i header.id%TYPE;
	j header.id%TYPE;
	out_string varchar2(254);
	cursor next(low_id number,high_id number) is
		select id,subject from header where (id between low_id and high_id) 
		and (rownum=1);
	cursor prev(pid number) is
		select id,subject from header where id = pid;

	cursor cbody(bid number) is
		select id,BODY_TYPE,CHARS,WORDS,LINES,msg_body1,msg_body2,
			msg_body3,msg_body4,msg_body5,msg_body6,
			msg_body7,msg_body8,msg_body9,msg_body10,msg_body11
			from body where id=bid;		
	body_rec body%ROWTYPE;
	tmp long;
	next_id header.id%TYPE;
	next_subject header.subject%TYPE;
	prev_id header.id%TYPE;
	prev_subject header.subject%TYPE;
	rid header.id%TYPE;
	reply_subject header.subject%TYPE;
	cursor reply(low_id number,high_id number,repid char) is
		select id,subject from header where (id between low_id and high_id) 
		and (msg_id = repid);
	min_id header.id%TYPE;
	begin

	fid := floor(bid/maxmsg) + 1;
		
	open cbody(bid);
	fetch cbody into body_rec;
	if (cbody%FOUND) then
		body_all := body_rec.msg_body1||body_rec.msg_body2||
				body_rec.msg_body3||body_rec.msg_body4||body_rec.msg_body5||
				body_rec.msg_body6||body_rec.msg_body7||body_rec.msg_body8||
				body_rec.msg_body9||body_rec.msg_body10;
	else
		body_all := NULL;
	end if;
	close cbody;

   	SELECT msg_date,subject,sender,receiver,cc,msg_id,replied_id into 
		h_msg_date,h_subject,h_sender,h_receiver,h_cc,h_msg_id,h_replied_id
		from header where id = bid;
	SELECT name,email into h_name,h_email from people where email=h_sender;

	h_subject := replace(h_subject,'\$','$');
	h_subject := replace(h_subject,'&','&amp');
	h_subject := replace(h_subject,'<','&lt');
	h_subject := replace(h_subject,'>','&gt');
	h_subject := replace(h_subject,'"','&quot');	

	htp.htitle(h_subject);
	htp.p(h_name||' (<i>'||h_email||'</i>)<br>');
	htp.p('<i>'||to_char(new_time(h_msg_date,'EST','EST'),'Dy, DD Mon YYYY hh24:mi:ss')||' EST</i>');

	htp.p('<p><ul><li><b>Messages sorted by:</b> ');
	htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&hit=20&op=1','[ thread ]')||
		htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&hit=0&op=2','[ date ]'));
	htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&hit=0&op=3','[ subject ]')||
		htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&hit=0&op=4','[ author ]'));
	open next(bid+1,fid*maxmsg);
	fetch next into next_id,next_subject;
	if (next%FOUND) then
		htp.p('<li>'||htf.bold('Next message: ')||htf.url(cgi_bin||'hypermail.showbody?bid='
			||next_id,next_subject));
	else
		next_id := 0;
	end if;
	close next;
	open prev(bid-1);
	fetch prev into prev_id,prev_subject;
	if (prev%FOUND) then
		htp.p('<li>'||htf.bold('Previous message: ')||htf.url(cgi_bin||'hypermail.showbody?bid='
			||prev_id,prev_subject));
		close prev;
	else
		close prev;
		select min(id) into min_id from header
			where (id between ((fid-1)*maxmsg+1) and bid);
		prev_id := bid - 1;
		while (prev_id > min_id) loop
			prev_id := prev_id - 1;
			open prev(prev_id);	
			fetch prev into prev_id,prev_subject;
			if (prev%FOUND) then
				htp.p('<li>'||htf.bold('Previous message: ')||htf.url(cgi_bin||'hypermail.showbody?bid='
					||prev_id,prev_subject));
				close prev;
				goto out_loop;
			else		
				close prev;
			end if;	
		end loop;
		prev_id := 0; 
	end if;
<<out_loop>> 
	rid := 0;
	if (h_replied_id IS NOT NULL) then
		m := (fid-1)*maxmsg + 1;
		n := m + maxmsg - 1;
		h_replied_id := replace(h_replied_id,chr(10));
		open reply(m,n,h_replied_id);
		fetch reply into rid,reply_subject;	
		if (reply%FOUND) then
			htp.p('<li>'||htf.bold('In reply to: ')||htf.url(cgi_bin||'hypermail.showbody?bid='
			||rid,reply_subject));
		else 
			rid := 0;
		end if;
		close reply;
	end if;
	
	
	htp.p('</ul><p><pre>');
	
	body_all := replace(body_all,'&','&amp');
	body_all := replace(body_all,'<','&lt');
	body_all := replace(body_all,'>','&gt');
	body_all := replace(body_all,'"','&quot'); 
	body_all := replace(body_all,'&ltbr&gt','');	
	body_all := replace(body_all,'\$','$'); --- left by the perl parser

	i := 1;
	m := instr(body_all,'http://',i,1);
	while ( m != 0) loop		
			tmp := substr(body_all,m);
			k := instr(tmp,' ');
			n1 := instr(tmp,'&');	
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,')');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,',');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,'|');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,';');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,'''');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,chr(10));
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			if (k != 0) then
				url := substr(tmp,1,k-1);
				body_all := substr(body_all,1,m-1)||htf.url(url,url)||substr(tmp,k);
				i := m + 2*length(url)+11;
			else
				i := m + 5;
			end if;
			m := instr(body_all,'http://',i,1);
	end loop;
	
	n := length(body_all);
	i := 1;
	while ( (i+253) <= n) loop
		out_string := substr(body_all,i,254);
		k := instr(out_string,chr(10),-1,1);
		if (k = 0) then
			htp.p(out_string);
			i := i + 254;
		else
		 	htp.p(substr(out_string,1,k-1));
			i := i + k;
		end if;
	end loop;
	if (i <= n) then
		htp.p(substr(body_all,i));
	end if;

	body_all := body_rec.msg_body11;
	if (body_all IS NOT NULL) then
		body_all := replace(body_all,'&','&amp');
		body_all := replace(body_all,'<','&lt');
		body_all := replace(body_all,'>','&gt');
		body_all := replace(body_all,'"','&quot'); 
		body_all := replace(body_all,'&ltbr&gt');	
		n := length(body_all);
		i := 1;
		while ( (i+253) <= n) loop
			out_string := substr(body_all,i,254);
			k := instr(out_string,chr(10),-1,1);
			if (k = 0) then
				htp.p(out_string);
				i := i + 254;
			else
		 		htp.p(substr(out_string,1,k-1));
				i := i + k;
			end if;
		end loop;
		if (i <= n) then
			htp.p(substr(body_all,i));
		end if;
	end if;

	htp.p('</pre>');	

	htp.p('<p><ul><li><b>Messages sorted by:</b> ');
	htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&hit=20&op=1','[ thread ]')||
		htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&hit=0&op=2','[ date ]'));	
	htp.p(htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&hit=0&op=3','[ subject ]')||
		htf.url(cgi_bin||'hypermail.listheader?fid='||fid||'&hit=0&op=4','[ author ]'));

	if (next_id != 0) then
		htp.p('<li>'||htf.bold('Next message: ')||htf.url(cgi_bin||'hypermail.showbody?bid='
			||next_id,next_subject));
	else
		next_id := 0;
	end if;
	if (prev_id != 0) then
		htp.p('<li>'||htf.bold('Previous message: ')||htf.url(cgi_bin||'hypermail.showbody?bid='
			||prev_id,prev_subject));
	else
		prev_id := 0;
	end if;
	if (rid != 0) then
		htp.p('<li>'||htf.bold('In reply to: ')||htf.url(cgi_bin||'hypermail.showbody?bid='
			||rid,reply_subject));
	end if;
	htp.p('</ul>');
	wow.sig;

  exception
	when NO_DATA_FOUND then
		htp.p(htf.line);
		wow.sig;
		
end;

end hypermail;
/
show errors;
/
