drop package MAILS0;
/
create or replace package MAILS0 is

  mailbox_name constant varchar2(50) := 'Chemistry Mailing and Newsgroup';
  mailbox_path constant varchar2(50) := 'NNTP server: newstand.syr.edu';
  mailbox_logo constant varchar2(50) := '/images/mailbox.gif';
  inbox_path constant varchar2(50) := mailbox_path||'/inbox';
  inbox_logo constant varchar2(50) := mailbox_logo;
  owner_uid constant varchar2(10) := 'chem';
  cgi_bin1 constant varchar2(30) := '/cgi-bin/'||owner_uid||'/';
  cgi_bin constant varchar2(30) := '/cgi-bin/'||owner_uid||'/wow/';
  owner_name constant varchar2(20) := owner_uid;
  username constant varchar2(10) := owner_uid;
  password constant varchar2(20) := 'npac'||owner_uid;
  maxmsg constant number(8) := 1000000;
  my_url  constant varchar2(50) := '/'||owner_uid||'/index.html';
  root_url constant varchar2(50) := 'http://osprey8.npac.syr.edu:1963';
default_folder folder.name%TYPE := 'chemistry';
  procedure home;
  procedure create_mailbox;
  procedure create_folder;
  procedure find_folder(f_path in varchar2, start_id out number, f_id in out number);
  procedure insert_folder(f_path in varchar2,f_name in varchar2, f_id in out number);
  procedure update_folder(f_path in varchar2,maxid in number);
  procedure insert_header(i_id in number,i_msg_date in varchar2,
	    i_subject in varchar2,i_sender in varchar2,
	    i_receiver in varchar2,i_msg_id in varchar2,i_bytes in number,
	    i_body_type in char,i_folder in varchar2,
	    i_replied_id in char,i_timezone in char,i_cc in varchar2,
	    uid in varchar2,sname in varchar2,email in varchar2);
  procedure insert_people(uid in varchar2,sname in varchar2,semail in varchar2,msgid in number);
  procedure insert_body(i_id in number,i_body_type in char,i_chars in number,
	    i_words in number,i_lines in number,i_folder in varchar2);
  procedure AddVisitor(host in varchar2,address in varchar2,user in varchar2,name varchar2);
  procedure showmailbox;
  procedure showfolders;
  procedure folderinfo (fid in number);

  end;
/
show errors;
/
create or replace package body MAILS0 is

procedure home is
--  host1 varchar2(40) := 'http://merlin';
  host1 varchar2(40) := root_url;
  host varchar2(60);
  instance_id integer := 9;
  dot varchar2(40) := '<IMG ALT="*" SRC="/images/dot.gif">';
begin
		host := host1||cgi_bin;
		htp.p('<title>Chemistry Mailing and Newsgroups Archive</title>');
		htp.p('<center><h1>Chemistry Mailing and Newsgroups Archive</h1>');
		htp.p('<p><h2>'||dot||htf.url(host||'MAILS.index_subject',
			'Query By Keyword')||dot||'</h2>');
		htp.p('<p><h2>'||dot||
			htf.url(host||'MAILS.showheader',
			'Query By Mail Header')||dot||'</h2>');
		htp.p('<p><h2>'||dot||
			htf.url(host||'MAILS1.index_date',
			'Query By Date')||dot||'</h2>');
		htp.p('<p><h2>'||dot||
			htf.url(host||'MAILS.index_sender',
			'Query By Sender')||dot||'</h2>');
		htp.p('<p><h2>'||dot||
			htf.url(host||'MAILS4.index_url',
			'Query the URLs')||dot||'</h2>');

		htp.p('<p><h2>'||dot||
			htf.url(host||'MAILS.index_people',
			'Query the People')||dot||'</h2>');

		htp.p('<p><h2>'||dot||
			htf.url(host||'MAILS0.showfolders',
			'Newsgroups Info')||dot||'</h2>');

		htp.p('<p><h2>'||dot||
			htf.url(host||'MAILS0.showmailbox',
			'Archive Database Info')||dot||'</h2>');
		htp.p('<p><h2>'||dot||
			htf.url(host1||cgi_bin1||'hypermail_home',
			'A Hypermail-like Interface')||dot||'</h2>');

		htp.p('<p><h2>'||dot||
			htf.url(host1||cgi_bin1||'index_chat',
			'Your Feedback')||dot||'</h2>');

		htp.p('</center><hr>');

		htp.p('<address>This system is developed by '||
			htf.url('http://www.npac.syr.edu/homepages/gcheng/gcheng.html',
			'Gang Cheng'));
		htp.p(' at '||htf.url('http://www.npac.syr.edu/','Northeast Parallel Architectures Center'));
		htp.p(', Syracuse University. Send comment to '||
			htf.url('mailto:gcheng@npac.syr.edu','gcheng@npac.syr.edu')||'. Read ');
		htp.p(htf.url('/disclaim.html','NPAC Disclaimer')||'.</address></html>');
	end;

procedure create_mailbox is  
	begin

	insert into mailbox(name,path,owner,n_folder,creation_time,logo,visitors,urls)
	   values(mailbox_name,mailbox_path,owner_uid,0,sysdate,mailbox_logo,0,0);
	commit;
--	create_folder;

	end;

  procedure create_folder is
	begin

	insert into folder(id,name,path,creation_time,logo,n_msg,max_msgid,min_msgid)
		values (1,inbox_path,inbox_path,sysdate,inbox_logo,0,0,0);
	commit;

	end;

  procedure find_folder(f_path in varchar2, start_id out number, f_id in out number) is

	begin
		select id into f_id from folder where path=f_path;
		start_id := (f_id - 1)*maxmsg;

		exception
		    when no_data_found then
			insert_folder(f_path,f_path,f_id) ;
			commit;
			start_id := (f_id - 1)*maxmsg;
	end;


 procedure update_folder(f_path in varchar2,maxid in number) is
	begin
		update folder
			set max_msgid = maxid where path=f_path;
		commit;
	end;

  procedure insert_folder(f_path in varchar2,f_name in varchar2, f_id in out number) is

	begin

		select n_folder+1 into f_id from mailbox;
		--select max(id)+1 into f_id from folder;
		insert into folder(id,name,path,creation_time,logo,n_msg,max_msgid,min_msgid)
		   values (f_id,f_name,f_path,sysdate,inbox_logo,0,0,0);
		update mailbox
			set n_folder = n_folder+1;	
		commit;

		exception
		    when no_data_found then
			htp.p('ERROR: wrong mailbox initilization !');	
	end;	

  procedure insert_header(i_id in number,i_msg_date in varchar2,
	    i_subject in varchar2,i_sender in varchar2,
	    i_receiver in varchar2,i_msg_id in varchar2,i_bytes in number,
	    i_body_type in char,i_folder in varchar2,
	    i_replied_id in char,i_timezone in char,i_cc in varchar2,
	    uid in varchar2,sname in varchar2,email in varchar2) is

	f_id header.id%TYPE;
	start_id header.id%TYPE;
	hid header.id%TYPE;
	junk_id header.id%TYPE;
	m_date date;
	cursor cheader(idin in number) is select id from header where id=idin;	
	begin

	if (i_id <= maxmsg) then
		find_folder(i_folder,start_id,f_id);
		hid := i_id+start_id;
		open cheader(hid);
		fetch cheader into junk_id;	
		if (cheader%NOTFOUND) then	
			m_date := new_time(to_date(i_msg_date,'dd mon yyyy hh24:mi'),
				i_timezone,'EST');
			insert into header(id,msg_date,subject,sender,receiver,
				msg_id,bytes,body_type,replied_id,cc) 
		  		values (hid,m_date,replace(i_subject,'\$','$'),
				lower(i_sender),i_receiver,i_msg_id,i_bytes,i_body_type,
				i_replied_id,i_cc);
			update folder set n_msg = n_msg + 1 where id = f_id;
			update folder set max_msgid = i_id where (id=f_id) and (max_msgid < i_id);
			update folder set min_msgid = i_id where (id=f_id) and ((min_msgid > i_id) or (min_msgid=0));
			commit;
			insert_people(uid,sname,lower(email),hid);	
		end if;
		close cheader;
	end if;

	end;	
  
  procedure insert_people(uid in varchar2,sname in varchar2,semail in varchar2,msgid in number) is
	junk_uid people.userid%TYPE;
	cursor cpeople(emailin varchar2) is select userid from people where email=emailin;
	begin

	open cpeople(semail);
	fetch cpeople into junk_uid;
	if (cpeople%NOTFOUND) then
		insert into people(email,name,userid,msg_received,creation_time)
		values(semail,sname,uid,msgid,new_time(sysdate,'EST','EST'));
	else
		update people set msg_received = msgid where email=semail;	
	end if;
	commit;
 	close cpeople;

	end;
  procedure insert_body(i_id in number,i_body_type in char,i_chars in number,
	    i_words in number,i_lines in number,i_folder in varchar2) is

	f_id header.id%TYPE;
	hid header.id%TYPE;
	start_id header.id%TYPE;
	junk_id header.id%TYPE;
	cursor cbody(idin in number) is select id from body where id=idin;
	begin

	if (i_id <= maxmsg) then
		find_folder(i_folder,start_id,f_id);
		hid := i_id+start_id;
		open cbody(hid);
		fetch cbody into junk_id;
		if (cbody%NOTFOUND) then
			select id into junk_id from header where id=hid;
			insert into body(id,body_type,chars,words,lines)
			values (i_id+start_id,i_body_type,i_chars,i_words,i_lines);
			commit;
		end if;
		close cbody;
	end if;

	end;

procedure AddVisitor(host in varchar2,address in varchar2,user in varchar2,name varchar2) is
	begin
		insert into visitor
			values (sysdate,host,address,user);
		update mailbox set visitors = (visitors + 1);
		commit;
		stats.announce(host,name);
		mails0.home;
	end;

procedure showmailbox is
	m_name varchar2(100);
	m_path varchar2(200);
	m_owner varchar2(100);
	m_n_msg number(8);
	m_creation_time date;
	m_logo varchar2(200);
	m_n_folder number(6);
/*	cursor cmax is select id,msg_date from header
		where msg_date=(select max(msg_date) from header);
	cursor cmin is select id,msg_date from header
		where msg_date=(select min(msg_date) from header); */

        mid header.id%TYPE := 0;
        lower_id header.id%TYPE := 0;
	fname folder.name%TYPE;
        mdate date;
   begin

	mails.button;
	select name,path,owner,n_folder,creation_time,logo into
		m_name,m_path,m_owner,m_n_folder,m_creation_time,m_logo from mailbox;

	htp.htitle('Mailbox Information');	
	htp.p(htf.line);
	htp.p(htf.gif(m_logo));
	htp.ulistOpen;

        htp.item;
		htp.p('Mailbox Name: '||htf.bold(m_name));
    	htp.item;
		htp.p('Top-level UNIX Path: '||htf.bold(m_path));
   	htp.item;
		htp.p('Owner of this mailbox is: '||htf.bold(m_owner));
   	htp.item;
		htp.p('Current Total Number of Folders: '||htf.bold(m_n_folder));
   	htp.item;
		--open cmax;
		--fetch cmax into mid,mdate;
		select id,msg_date into mid,mdate from header where 
			msg_date=(select max(msg_date) from header where
			id in (select max_msgid+(id-1)*maxmsg from folder)
			and (msg_date-sysdate) <=2) and rownum=1;
		lower_id := ceil(mid/maxmsg);
		select name into fname from folder where id=lower_id;
		htp.p(htf.url(cgi_bin1||'showbody?bid='||mid||'&word=~1',
			'Most Recent Mail')||
			': '||htf.bold(to_char(mdate,'Day, Month dd, yyyy hh24:mi'))||', in '||
			htf.bold(fname));
		--close cmax;
   	htp.item;
		--open cmin;
		--fetch cmin into mid,mdate;
		select id,msg_date into mid,mdate from header where 
			msg_date=(select min(msg_date) from header where
			id in (select min_msgid+(id-1)*maxmsg from folder)) and rownum=1;
		lower_id := ceil(mid/maxmsg);
		select name into fname from folder where id=lower_id;
		htp.p(htf.url(cgi_bin1||'showbody?bid='||mid||'&word=~1',
			'Least Recent Mail')||
			': '||htf.bold(to_char(mdate,'Day, Month dd, yyyy hh24:mi'))||', in '||
		htf.bold(fname));
   	htp.item;
		select sum(n_msg) into m_n_msg from folder;
		htp.p('Current Total Number of Mails: '||htf.bold(m_n_msg));
    	htp.item;
		htp.p('Created at: '||htf.bold(to_char(m_creation_time,'Day, Month dd, yyyy hh24:mi')));
	HTP.ulistClose;

	wow.sig;
   end;	   

 procedure showfolders is
   c_name varchar2(50);
   total_folder number := 0;
 begin
	select count(*) into total_folder from folder;
	mails.button;
	htp.htitle('Query Folder');
	htp.p(htf.line);
	htp.p('There are total <b>'||total_folder||'</b> folders in your mailbox.');
	htp.formOpen(cgi_bin||'MAILS0.folderinfo');
	htp.p('Which folder you would like to know ?'||htf.para); 
	mails.list_folder(22);
	htp.p(htf.para||htf.formDo('Query Folder Information'));
	htp.p(htf.formClose);
	wow.sig;
 end;
   procedure folderinfo ( fid in number) is
	f_id number(7);
	f_name varchar2(150);
	f_path varchar2(150);
	f_n_msg number(8);
	f_creation_time date;
	f_logo varchar2(150);
	f_desc folder.description%TYPE;
	tmp varchar2(256);
    	cursor cname1 is SELECT id,name,path,n_msg,creation_time,logo,description,
		(max_msgid+(id-1)*maxmsg),(min_msgid+(id-1)*maxmsg)
		from folder order by name;
	total number(5) := 0;
	flag boolean := false;
	maxid header.id%TYPE := 0;
	minid header.id%TYPE := 0;
	upper_id header.id%TYPE := 0;
	lower_id header.id%TYPE := 0;
	mdate date;
	n number(4);
	i integer;
	k integer;

   begin
	mails.button;
	htp.htitle('Folder Information');
	if (fid = 0) then
		open cname1;
	end if;

        loop

	if (fid = 0) then
               		fetch cname1 into f_id,f_name,f_path,f_n_msg,
			f_creation_time,f_logo,f_desc,maxid,minid;
                	exit when cname1%NOTFOUND;
		else			
                	SELECT name,path,n_msg,creation_time,logo,description,
				(max_msgid+(id-1)*maxmsg),(min_msgid+(id-1)*maxmsg)
				into f_name,f_path,f_n_msg,f_creation_time,f_logo,f_desc,maxid,minid	
				from folder where id = fid;
			f_id := fid;
  		end if;

	htp.p(htf.line);
	htp.p(htf.gif(f_logo));
	htp.ulistOpen;

        htp.item;
		htp.p('Folder Name: '||htf.bold(f_name));
    	htp.item;
		htp.p('Original UNIX Path: '||htf.bold(f_path));
   	htp.item;
		select msg_date into mdate from header where id = maxid
			and (msg_date-sysdate) <=2;
		htp.p(htf.url(cgi_bin1||'showbody?bid='||maxid||'&word=~1',
			'Most Recent Mail')||': '||htf.bold(to_char(mdate,'Day, Month dd, yyyy hh24:mi')));

   	htp.item;
		select msg_date into mdate from header where id = minid;			
		htp.p(htf.url(cgi_bin1||'showbody?bid='||minid||'&word=~1',
			'Least Recent Mail')||': '||htf.bold(to_char(mdate,'Day, Month dd, yyyy hh24:mi')));

    	htp.item;
		htp.p('Current Total Number of Mails: '||htf.bold(f_n_msg));
    	htp.item;
		htp.p('Created at: '||htf.bold(to_char(f_creation_time,'Day, Month dd, yyyy hh24:mi')));
	if (f_desc IS NOT NULL) then
		htp.item;
		htp.p(htf.bold('Newsgroup Topic and Statistics')||':<pre><br>');
		n := length(f_desc);
		i := 1;
		while (i <= n) loop
			tmp := substr(f_desc,i,254);
			k := instr(tmp,chr(10),-1);
			if (k != 0) then
				htp.p(substr(tmp,1,k-1));
				i := i + k;
			else
				htp.p(tmp);
				i := i + 254;
			end if;
		end loop;
		htp.p('</pre>');		
	end if;
	HTP.ulistClose;
	total := total + 1;
	if (fid != 0) then exit; end if;
       end loop;

        if (fid = 0) then
		close cname1;
		htp.p('Total <blink><b>'||total||'</b></blink> Folders !');
	end if;
	
	wow.sig;
   end;	 

end;
/
show errors;
/
