drop package MAILS1;
/
create or replace package MAILS1 is

  procedure clearvisitors(userid in char,passwd in char);
  procedure clear_action(clear in number);

  procedure inc_index(userid varchar2,passwd varchar2);
  procedure inc(path varchar2,typein varchar2);
  procedure find_maxid(f_path in varchar2, max_id out number);
  procedure inc_subfolder(path in varchar2);

  procedure modify_index (code in number) ;
  procedure chkpassword(userid in char,passwd in char,passed out boolean);
  procedure modify_mailbox(userid in char,passwd in char);
  procedure modify_mailbox_do(mname char,mowner varchar2,mlogo varchar2);
  procedure index_date;
  procedure by_today(no integer,op integer,fid number,hit number);
  procedure by_now(op integer,fid number,hit number);
  procedure by_date(hour integer,day integer,week integer,month integer, fid number,hit number);
  procedure by_a_date(month integer,day integer,year integer, fid in number,hit number); 
  procedure by_alphabet(aindex char,sort int,i int); 
  procedure by_sender(uid varchar2,fid in number);
  procedure index_allsender(sort int,i int);
  procedure by_domain(domain varchar2,sort int,i int);
  procedure by_senderkey(sender varchar2,sort int,i int);
  procedure index_sender_main(i int);
  procedure by_people(uid varchar2);
  procedure sender_group(domain varchar2,fid number);

  end;
/
show errors;
/
create or replace package body MAILS1 is
total_visitors number(7);
sysdate_est date;
h_id header.id%TYPE;
h_msg_date header.msg_date%TYPE;
h_subject header.subject%TYPE;
h_sender header.sender%TYPE;
h_bytes header.bytes%TYPE;

  procedure inc_index(userid varchar2,passwd varchar2) is
   cursor cfolder is select path from folder order by path;
   passed boolean := FALSE;
  begin

     chkpassword(userid,passwd,passed);
     if (passed) then
	htp.formOpen(MAILS.cgi_bin||'MAILS1.inc');
	htp.p('<p>Choose a UNIX folder path from which your new mails will be incorporated');
	htp.p('<select name="path" size=10>');
	for folder in cfolder loop
	   htp.p('<option value="'||folder.path||'">'||folder.path);
	end loop;
	htp.p(htf.formSelectClose);
	htp.p('<br>Or you may enter a path: <input name="typein" size=30 value="">');
	htp.p(htf.formDo||' or '||htf.formUndo);
 	htp.p(htf.formClose);	
	wow.sig;
     end if;
  end;

 procedure inc(path varchar2,typein varchar2) is
  path_name varchar2(200);
  max_id header.id%TYPE;

  begin  

		if (typein IS NULL) then
	  		path_name := path;
		else
	    		path_name := typein;
		end if;
		find_maxid(path_name,max_id);

		htp.p('<form ACTION="/cgi-bin/'||MAILS.owner_uid||'/inc.csh'||
			path_name||'" METHOD="GET">');
		htp.p('<p>Make sure you have read permission for the UNIX file directory '||
			htf.bold(path_name)||'.<br>');
		htp.p('<INPUT TYPE="hidden" NAME="maxid" VALUE="'||max_id||'">');
		htp.p('Press '||htf.formDo('Incorporate!')||' to start incorporating.');
		htp.p('<p>The most recent mail id in the database = '||htf.bold(max_id)||'<br>');	
		htp.p('It may take a while to incorporate large number of mails.');
		htp.p(htf.formClose);	

	wow.sig;

  end;

  procedure find_maxid(f_path in varchar2, max_id out number) is
  	cursor cid(sid number) is select (max(id)-sid) from header 
			where id between (sid+1) and sid+MAILS.maxmsg;
  	start_id header.id%TYPE;
  	f_id header.id%TYPE;
	begin
		select id into f_id from folder where path=f_path;
		start_id := (f_id - 1)*MAILS.maxmsg;
		open cid(start_id);
		fetch cid into max_id;
		if (cid%NOTFOUND) then
			max_id := 0;
		end if;
		close cid;
		exception
		    when no_data_found then
			max_id := 0;
	end;

 procedure inc_subfolder(path in varchar2) is
  max_id header.id%TYPE;

  begin  
		find_maxid(path,max_id);
	
		htp.p('<form ACTION="/cgi-bin/'||MAILS.owner_uid||'/inc.csh'||
			path||'" METHOD="GET">');
		htp.p('<p>Make sure you have read permission for the UNIX file directory '||
			htf.bold(path)||'.<br>');
		htp.p('<INPUT TYPE="hidden" NAME="maxid" VALUE="'||max_id||'">');
		htp.p('Press '||htf.formDo('Incorporate!')||' to start incorporating.');
		htp.p('The most recent mail id in the database = '||htf.bold(max_id));
		htp.p('<p>It may take a while to incorporate large number of mails.');
		htp.p(htf.formClose);	
	wow.sig;
  end;


  procedure modify_index (code in number) is

	begin

	htp.p(htf.line);
	
	if (code=1) then
		htp.formOpen(MAILS.cgi_bin||'MAILS1.modify_mailbox');	
	elsif (code=2) then
		htp.formOpen(MAILS.cgi_bin||'MAILS1.modify_folder');	
	elsif (code=3) then
		htp.formOpen(MAILS.cgi_bin||'MAILS1.modify_people');	
	elsif (code=4) then
		htp.formOpen(MAILS.cgi_bin||'MAILS1.clearvisitors');	
	elsif (code=5) then
		htp.formOpen(MAILS.cgi_bin||'MAILS1.inc_index');
	end if;

	htp.p('Your Username: <input name="userid" size=10 value="'||MAILS.username||'"><br>');
	htp.p('Your Password: <input type="password" name="passwd" size=10><p>');
	htp.p(htf.para||htf.formDo('Submit'));

	htp.p(htf.formClose);
	
	wow.sig;
   end;	   
	
  procedure chkpassword(userid in char,passwd in char,passed out boolean) is
	begin

	if (userid IS NULL) or (passwd IS NULL) or (userid != MAILS.username) or (passwd != MAILS.password) then
           htp.p('You have the wrong userid/password !');
--	   htp.p('userid='||userid||'passwd='||passwd);
	   passed := FALSE;
	else	
	   passed := TRUE;
	end if;

--	wow.sig;
   end;	  

  procedure modify_mailbox(userid in char,passwd in char) is
	passed boolean := FALSE;
	m_name char(100);
	m_path varchar2(200);
 	m_owner varchar2(100);
 	m_n_folder number(5);
 	m_creation_time date;
 	m_logo char(200);

	begin
	
	chkpassword(userid,passwd,passed);
	if (passed) then
		htp.p(htf.line);
		select name,path,owner,n_folder,creation_time,logo
		   into m_name,m_path,m_owner,
			m_n_folder,m_creation_time,
			m_logo from mailbox;
		htp.formOpen(MAILS.cgi_bin||'MAILS1.modify_mailbox_do');	
	htp.ulistOpen;
	htp.item;
		htp.p('Mailbox Name:<input name="mname" size=20 value="'||m_name||'">');
	htp.item;				
 		htp.p('Top-level UNIX Path: '||htf.bold(m_path));
	htp.item;
		htp.p('Owner of this mailbox: <input name="mowner" size=20 value="'||m_owner||'">');
    	htp.item;
		htp.p('Current Total Number of Folders: '||htf.bold(m_n_folder));
    	htp.item;
		htp.p('Created at: '||htf.bold(to_char(m_creation_time,'DY, mm/dd/yy hh24:mi')));
    	htp.item;
		htp.p('Mailbox Logo (URL): <input name="mlogo" size=20');
		htp.p(' value="'||m_logo||'">');	
	HTP.ulistClose;
	  htp.p(htf.para||'To submit your updates, press this button:'||htf.formDo('Submit Update'));

	htp.p(htf.formClose); 

	end if;
		
	wow.sig;	
	end;

  procedure modify_mailbox_do(mname char,mowner varchar2,mlogo varchar2) is

	begin
		update mailbox
			set name=mname, owner=mowner,logo=mlogo;
		commit;
	htp.p('The updates of your mailbox has been committed. The new values are: <br>');
	MAILS0.showmailbox;

	end;

  procedure clearvisitors(userid in char,passwd in char) is
        passed boolean := FALSE;
        n number(7) := 0;
        begin

        chkpassword(userid,passwd,passed);
        if (passed) then

           htp.formOpen(MAILS.cgi_bin||'MAILS1.clear_action');
           select count(*) into n from visitor;
           htp.p('Currently there are total <b>'||n||'</b> visitors entries in t
he database.<br>');
           htp.p('How many oldest entries you want to remove from the list ?'||'
 (<='||n||'):');
           htp.p('<input name="clear" size=6 value="'||floor(n/2)||'">');
           htp.p(htf.para||'To submit your choice, press this button:'||htf.formDo('Submit'));
        end if;
        wow.sig;
        end;

  procedure clear_action(clear in number) is

        begin

           delete from visitor where rownum <= clear;
           commit;
           HTP.P('Total '||clear||' entries have been removed from the visitors
list.');
           htp.p('Here is what currently in the database:');
                 stats.stats;

        end;

  procedure index_date is

	cursor cdate is select id,msg_date,subject,sender,bytes 
		from header where rownum <= 5 order by msg_date desc;	
	lower_id header.id%TYPE := 0;
	fid header.id%TYPE;
	i integer;
	j integer;
	k integer;
	junk date;
   	total number := 0;
   	n integer := 1;
   	cursor cfolder is select id,name,n_msg from folder order by name;
	--TYPE ftype is TABLE OF int INDEX BY BINARY_INTEGER;
	--fid_tab ftype;
	begin

	MAILS.button;
	htp.htitle('Query By Date');
	htp.p(htf.line);
	htp.p('Your 5 most recent mails are:');
	htp.p('<ul>');
	open cdate;
		loop
			fetch cdate into h_id,h_msg_date,h_subject,h_sender,h_bytes;
                	exit when cdate%NOTFOUND;
			h_subject := substr(h_subject,1,40);
			MAILS.header_list(h_id,h_bytes,
				h_sender,h_subject,h_msg_date,'~2');
		end loop;
	close cdate;
	htp.p('</ul>');
	htp.p(htf.line);

	htp.p('<h2>You can query by following options:</h2>');

	sysdate_est := new_time(sysdate,'EST','EST');
	htp.formOpen(MAILS.cgi_bin||'MAILS1.by_now');
	htp.p('<ol><li>Mails for <select name="op" size="1">');
	htp.p('<option value="1" selected>Today '||
		to_char(sysdate_est,'"("Dy,dd-mm-yy")"'));	
	htp.p('<option value="2">Yesterday '||
		to_char((sysdate_est-1),'"("Dy,dd-mm-yy")"'));
	htp.p('<option value="3">This week '||
		to_char(sysdate_est+1-(to_char(sysdate_est,'D')),'"("Dy,dd-mm-yy":"')||
		  to_char(sysdate_est,'Dy,dd-mm-yy")"'));		
	htp.p('<option value="4">Last week '||
		to_char(sysdate_est-6-(to_char(sysdate_est,'D')),'"("Dy,dd-mm-yy":"')||
		  to_char(sysdate_est-(to_char(sysdate_est,'D')),'Dy,dd-mm-yy")"'));	
	htp.p('<option value="5">This month '||
	  	to_char(sysdate_est,'"("Month,yyyy")"'));		
 	htp.p('<option value="6">Last month '||
		to_char(add_months(sysdate_est,-1),'"("Month,yyyy")"'));	
	htp.p('<option value="7">This hour '||
		to_char(sysdate_est,'"("hham Dy,dd-mm-yy")"'));	
	htp.p('<option value="8">Last hour');
	htp.p(htf.formSelectClose);
	htp.p('<br>In folder');
	MAILS.list_folder(5);
	htp.p(htf.formSelectClose);
	MAILS.submit;
--	htp.p(htf.formDo('Submit'));
	htp.p(htf.formClose);

	htp.p(htf.line);
	htp.formOpen(MAILS.cgi_bin||'MAILS1.by_today');	
	htp.p('<p><li>Mails from <input name="no" value=2 size=2>');
	htp.p('<select name="op" size="1">');
	htp.p('<option value="1" selected>days');
	htp.p('<option value="2">weeks');
	htp.p('<option value="3">months');
	htp.p('<option value="4">hours');
	htp.p(htf.formSelectClose);
	htp.p('ago till now (<blink>'||htf.bold(to_char(sysdate_est,'hham Dy, dd-mm-yy'))||
	' EST</blink>)<br>In folder');
	MAILS.list_folder(5);
	MAILS.submit;
	htp.p(htf.formClose);

	htp.p(htf.line);
	htp.p('<p><li>Any specific date: <br>');
 	htp.formOpen(MAILS.cgi_bin||'MAILS1.by_a_date');
	htp.p('<select name="month"><option value="0" selected>all months');
	junk := to_date('01-01-95','dd-mm-yy');
	for i in 1 .. 12 loop
		htp.p('<option value="'||i||'">'||to_char(add_months(junk,i-1),'Month'));
	end loop;
	htp.p(htf.formSelectClose);
	htp.p('/ <select name="day"><option value="0" selected>all days');
	for i in 1 .. 31 loop
		htp.p('<option value="'||i||'">'||i);
	end loop;
	htp.p(htf.formSelectClose);

	select 1900+to_number(to_char(min(msg_date),'yy'),'99') into i from header;
	j := 1900 + to_number(to_char(sysdate_est,'yy'),'99');
	htp.p('/ <select name="year">');
	for k in REVERSE i .. j loop
		htp.p('<option value="'||k||'">'||k);
	end loop;
	htp.p(htf.formSelectClose);

	htp.p('<br>In folder');
	MAILS.list_folder(5);
--	htp.p(htf.formDo('Submit'));
	MAILS.submit;
	htp.p(htf.formClose);
	htp.p('</ol>');

	wow.sig;
	end;

    procedure by_now(op integer,fid number,hit number) is

	begin

	if (op = 1) then
		by_date(-1,0,-1,-1,fid,hit);
	elsif (op = 2) then
		by_date(-1,1,-1,-1,fid,hit);
	elsif (op = 3) then
		by_date(-1,-1,0,-1,fid,hit);
	elsif (op = 4) then
		by_date(-1,-1,1,-1,fid,hit);
	elsif (op = 5) then
		by_date(-1,-1,-1,0,fid,hit);
	elsif (op = 6) then
		by_date(-1,-1,-1,1,fid,hit);
	elsif (op = 7) then
		by_date(0,-1,-1,-1,fid,hit);
	elsif (op = 8) then
		by_date(1,-1,-1,-1,fid,hit);
	end if;

	end;

    procedure by_today(no integer,op integer,fid number,hit number) is

	begin

	if (op = 1) then
		by_date(-1,no,-1,-1,fid,hit);
	elsif (op = 2) then
		by_date(-1,-1,no,-1,fid,hit);
	elsif (op = 3) then
		by_date(-1,-1,-1,no,fid,hit);
	elsif (op = 4) then
		by_date(no,-1,-1,-1,fid,hit);
	end if;

	end;

    procedure by_date(hour integer,day integer,week integer,month integer,fid number,hit number) is

	cursor chour(n integer) is select id,msg_date,subject,sender,bytes 
		from header where to_char(msg_date,'yymmdd')*24+(to_char(msg_date,'hh24')) = 
		(to_char(new_time(sysdate,'EST','EST'),'yymmdd')*24+
		(to_char(new_time(sysdate,'EST','EST'),'hh24'))-n) 
		order by msg_date desc;	
	cursor cday(n integer) is select id,msg_date,subject,sender,bytes 
		from header where to_char(msg_date,'ddmmyy') = 
		to_char((new_time(sysdate,'EST','EST')-n),'ddmmyy') order by msg_date desc;	
	cursor cmonth(n integer) is select id,msg_date,subject,sender,bytes 
		from header where to_char(msg_date,'yymm') = 
		to_char(add_months(new_time(sysdate,'EST','EST'),-n),'yymm') order by msg_date desc;	
	cursor cweek(n integer) is select id,msg_date,subject,sender,bytes 
		from header where to_char(msg_date,'yyww') = 
		(to_char(new_time(sysdate,'EST','EST'),'yyww')-n) order by msg_date desc;	
	lower_id header.id%TYPE := 0;
	f_id header.id%TYPE;
	f_name varchar2(100);
	total header.id%TYPE;
	limit header.id%TYPE;
	begin

--	sysdate_est := new_time(sysdate,'EST','EST');
	MAILS.button;
	htp.htitle('Query By Date');
	htp.p(htf.line);

	if (hit = 0) then
		limit := MAILS.maxmsg;
	else
		limit := hit;
	end if;
	if (fid = 0) then
		f_name := 'in all the folders';
		---	select sum(n_msg) into limit from folder;
	else
		select name into f_name from folder where id = fid;
		f_name := 'in folder '||f_name;
	end if;
	if (day != -1) then
		open cday(day);
		fetch cday into h_id,h_msg_date,h_subject,h_sender,h_bytes;
		if cday%NOTFOUND then
				htp.p('Oops, you don''t have mail for the day (<b>'||
				to_char((new_time(sysdate,'EST','EST')-day),'Day, Month dd, yyyy"</b>) "')
				||f_name||'.');
				wow.sig;
				return;
		end if;
		htp.p('Your mails for the day (<blink><b>'||
		to_char((new_time(sysdate,'EST','EST')-day),'Day, Month dd, yyyy"</b></blink>) "')
		||f_name||' are:<br>');
	elsif (week != -1) then
		open cweek(week);
		fetch cweek into h_id,h_msg_date,h_subject,h_sender,h_bytes;
		if cweek%NOTFOUND then
				htp.p('Oops, you don''t have mail for the week '||f_name||'.');
				wow.sig;
				return;
		end if;
		htp.p('Your mails for the week '||f_name||' are:<br>');
	elsif (month != -1) then
		open cmonth(month);
		fetch cmonth into h_id,h_msg_date,h_subject,h_sender,h_bytes;
		if cmonth%NOTFOUND then
				htp.p('Oops, you don''t have mail for the month (<b>'||
				to_char(add_months(new_time(sysdate,'EST','EST'),-month),'Month yyyy"</b>) "')||f_name||'.');
				wow.sig;
				return;
		end if;
		htp.p('Your mails for the month (<blink><b>'||
				to_char(add_months(new_time(sysdate,'EST','EST'),-month),'Month yyyy"</b></blink>) "')
				||f_name||' are:<br>');
	elsif (hour != -1) then
		open chour(hour);
		fetch chour into h_id,h_msg_date,h_subject,h_sender,h_bytes;
		if chour%NOTFOUND then
				htp.p('Oops, you don''t have mail for the hour'||f_name||'.');
				wow.sig;
				return;
		end if;
		htp.p('Your mails for the hour '||f_name||' are:');
	end if;			
			total := 0;
			htp.p('<ul>');
		  loop
			f_id := floor(h_id/MAILS.maxmsg) + 1;
			if ((fid = 0) or (f_id = fid)) then				   
				--lower_id := (f_id - 1)*MAILS.maxmsg;
				MAILS.header_list(h_id,h_bytes,h_sender,h_subject,h_msg_date,'~2');
				total := total + 1;
			end if;
			if (total >= limit) then exit; end if;

			if (day != -1) then
				fetch cday into h_id,h_msg_date,h_subject,h_sender,h_bytes;
		 		exit when cday%NOTFOUND;
			elsif (week != -1) then
				fetch cweek into h_id,h_msg_date,h_subject,h_sender,h_bytes;
		 		exit when cweek%NOTFOUND;
			elsif (month != -1) then
				fetch cmonth into h_id,h_msg_date,h_subject,h_sender,h_bytes;
		 		exit when cmonth%NOTFOUND;
			elsif (hour != -1) then
				fetch chour into h_id,h_msg_date,h_subject,h_sender,h_bytes;
		 		exit when chour%NOTFOUND;
			end if;
		  end loop;
		if (day != -1) then
		  close cday;
		elsif (week != -1) then
		  close cweek;
		elsif (week != -1) then
		 close cmonth;
		elsif (hour != -1) then
		 close chour;
		end if;
		htp.p('</ul>');
		  --htp.p(htf.formSelectClose);
		  htp.p('<br>Total <b>'||total||'</b> mails found.');
		  --htp.p(htf.para||htf.formDo('Show Mail Body'));
		  --htp.p(htf.formClose);

	wow.sig;

        end;


  procedure by_a_date(month integer,day integer,year integer, fid in number,hit number) is
	cursor cdate(date1 date, date2 date) is select id,msg_date,subject,sender,bytes 
		from header where msg_date between date1 and date2
		order by msg_date desc;	
	cursor cdate1(date1 date, date2 date,fid number) is select id,msg_date,subject,sender,bytes 
		from header where (fid = floor(id/MAILS.maxmsg)+1) and 
		(msg_date between date1 and date2)
		order by msg_date desc;	
	lower_id header.id%TYPE := 0;
	f_id header.id%TYPE;
	f_name varchar2(100);
	upper varchar2(12);
	lower varchar2(12);
	upper_tmp varchar2(12);
	lower_tmp varchar2(12);
	upper_date date;
	lower_date date;
	tag boolean := false;
	total header.id%TYPE := 0;
	i integer;
	limit header.id%TYPE;
	begin

	if (hit = 0) then limit := MAILS.maxmsg; 
	else limit := hit; end if;
	i := 12;
	if (month = 0) then
		if (day = 0) then    
			upper := lpad(year,4,'0')||'1231';
			lower := lpad(year,4,'0')||'0101';
		else
			i := 1;
			upper := lpad(year,4,'0')||'01'||lpad(day,2,'0');
			lower := upper;
		end if;
	else
		if (day = 0) then
			upper := lpad(year,4,'0')||lpad(month,2,'0')||'31';
			lower := lpad(year,4,'0')||lpad(month,2,'0')||'01';	
		else
			upper := lpad(year,4,'0')||lpad(month,2,'0')||lpad(day,2,'0');
			lower := upper;
		end if;
	end if;
	MAILS.button;						
	htp.htitle('Query By Date');
	loop
		upper_date := to_date(upper||'2359','yyyymmddhh24mi');
		lower_date := to_date(lower||'0001','yyyymmddhh24mi');
		htp.p(htf.line);
		if (fid = 0) then
			f_name := 'in <b>all the folders</b>';
			open cdate(lower_date,upper_date);
			fetch cdate into h_id,h_msg_date,h_subject,h_sender,h_bytes;
			lower_id := floor(h_id/MAILS.maxmsg)*MAILS.maxmsg;
		else
			select name into f_name from folder where id = fid;
			f_name := 'in folder <b>'||f_name||'</b>';
			open cdate1(lower_date,upper_date,fid);
			fetch cdate1 into h_id,h_msg_date,h_subject,h_sender,h_bytes;
			lower_id := (fid-1)*MAILS.maxmsg;
		end if;

             	if (((fid=0) and cdate%NOTFOUND) or ((fid != 0) and cdate1%NOTFOUND)) then
			htp.p('Oops, you don''t have mails between <b>'||
			to_char(lower_date,'hh:miam, Mon dd, yyyy')||'</b> and <b>'||
			to_char(upper_date,'hh:miam, Mon dd, yyyy')||'</b> '||f_name||'.');
	     	else
			htp.p('Your mails between <b>'||
					to_char(lower_date,'hh:miam, Mon dd, yyyy')||'</b> and <b>'||
					to_char(upper_date,'hh:miam, Mon dd, yyyy')||'</b> '||f_name||' are:');
			htp.p('<ul>');
			total := 0;
			loop
			MAILS.header_list(h_id,h_bytes,h_sender,h_subject,h_msg_date,'~2');
				total := total + 1;
				if (total >= limit) then exit; end if;
				if (fid = 0) then
					fetch cdate into h_id,h_msg_date,h_subject,h_sender,h_bytes;
                			exit when cdate%NOTFOUND;
					lower_id := floor(h_id/MAILS.maxmsg)*MAILS.maxmsg;
				else
					fetch cdate1 into h_id,h_msg_date,h_subject,h_sender,h_bytes;
                			exit when cdate1%NOTFOUND;
				end if;
			end loop;
			--htp.p(htf.formSelectClose);
			htp.p('</ul>');
			htp.p('<br>Total mails found: '||htf.bold(total)||' ');
			--htp.p(htf.para||htf.formDo('Show Mail Body'));
			--htp.p(htf.formClose);
	  	end if;
		if (fid=0) then close cdate;
		else close cdate1;
		end if;

		exit when (i = 12);
		i := i + 1;
		upper := lpad(year,4,'0')||lpad(i,2,'0')||lpad(day,2,'0');
		lower := upper;
	end loop;

	wow.sig;
        end;

--- i !=  query people; i=0 by sender
procedure index_sender_main(i int) is
--   cursor csender is select userid,name,email from people 
--		order by lower(email);
   cursor cdomain is select distinct lower(substr(email,instr(email,'.',-1)))
	from people where (instr(email,'.',-1) !=0) and (not (email like '% %'));
   sdomain varchar2(100);
   total header.id%TYPE;
 begin
	MAILS.button;
	if (i=0) then htp.htitle('Query By Sender');
	else htp.htitle('Query People');
	end if;
	htp.p(htf.line);
	select count(*) into total from people;
	htp.p('Currently there are total <b>'||total||
	'</b> senders in the database.');
	htp.p(htf.line);
	htp.p('<ol><li><h2>Search sender</h2>');
	htp.formOpen(MAILS.cgi_bin||'MAILS1.by_domain');
        htp.p('<ul><li>by domain name <select name="domain" size="5">');
	htp.p('<option value="all" selected>all');
	open cdomain;
	loop 
		fetch cdomain into sdomain;
		if cdomain%NOTFOUND then exit; end if;
		htp.p('<option value="'||sdomain||'">'||sdomain||' ');
	end loop;
	htp.p(htf.formSelectClose);
	close cdomain;
	htp.p(', ordered by <select name="sort">');
  	htp.p('<option value="1">Email<option value="2">Name<option value="3">Uid');
	htp.p(htf.formSelectClose);
	htp.p(htf.formDo('Submit'));
	htp.p('<INPUT TYPE="hidden" NAME="i" VALUE="'||i||'">');
	htp.p(htf.formClose);
	htp.formOpen(MAILS.cgi_bin||'MAILS1.by_alphabet');
        htp.p('<li>by index in alphabetic order <select name="aindex" size="5">');
	htp.p('<option value="all" selected>all');
	htp.p('<option value="a">a<option value="b">b<option value="c">c<option value="d">d');
	htp.p('<option value="e">e<option value="f">f<option value="g">g<option value="h">h');
	htp.p('<option value="i">i<option value="j">j<option value="k">k<option value="l">l');
	htp.p('<option value="m">m<option value="n">n<option value="o">o<option value="p">p');
	htp.p('<option value="q">q<option value="r">r<option value="s">s<option value="t">t');
	htp.p('<option value="u">u<option value="v">v<option value="w">w<option value="x">x');
	htp.p('<option value="y">y<option value="z">z');
	htp.p(htf.formSelectClose);
	htp.p(' of <select name="sort">');
  	htp.p('<option value="1">Email<option value="2">Name<option value="3">Uid');
	htp.p(htf.formSelectClose);
	htp.p(htf.formDo('Submit'));
	htp.p('<INPUT TYPE="hidden" NAME="i" VALUE="'||i||'">');
	htp.p(htf.formClose);
	htp.p('</ul>');
	htp.p('<li><h2> Enter a keyword</h2>');
	htp.formOpen(MAILS.cgi_bin||'MAILS1.by_senderkey');	
	htp.p('<input name="sender" size="20" value="">');
	htp.p(' ordered by <select name="sort">');
  	htp.p('<option value="1">Email<option value="2">Name<option value="3">Uid');
	htp.p(htf.formSelectClose);
	htp.p(htf.formDo('Submit'));
	htp.p('<INPUT TYPE="hidden" NAME="i" VALUE="'||i||'">');
	htp.p(htf.formClose);
	htp.p('a keyword can be any part of an email address or a person''s first/last name');
	htp.p('</ul>');	
	wow.sig;
	end;

procedure by_domain(domain varchar2,sort int,i int) is
	cursor csender1(do varchar2) is select userid,name,email from people
		where lower(substr(email,instr(email,'.',-1))) = do
		order by lower(email);
	cursor csender2(do varchar2) is select userid,name,email from people 
		where lower(substr(email,instr(email,'.',-1))) = do
		order by lower(name);
  	cursor csender3(do varchar2) is select userid,name,email from people 
	where lower(substr(email,instr(email,'.',-1))) = do
		order by lower(userid);
  	total header.id%TYPE;
	s_email people.email%TYPE;
	s_userid people.userid%TYPE;
	s_name people.email%TYPE;

	begin

	MAILS.button;
	if (domain = 'all') then
		index_allsender(sort,i);
	else
		if (i=0) then htp.htitle('Query By Sender');
		else htp.htitle('Query People');
		end if;
		htp.p(htf.line);
		select count(*) into total from people 
			where lower(substr(email,instr(email,'.',-1)))=domain;
		htp.p('Currently there are total <b>'||total||
			'</b> senders in the database with domain name ended with '||htf.bold(domain));
		htp.p(htf.line);	
		if (total = 0) then
			wow.sig;
			return;
		end if;

		htp.p('<h2>Choose one from the sender list</h2>');
		if (i=0) then htp.formOpen(MAILS.cgi_bin||'MAILS1.by_sender');
		else htp.formOpen(MAILS.cgi_bin||'MAILS1.by_people');
		end if;
		if (total > 15) then
			htp.p('<select name="uid" size="15">');
		else 
			htp.p('<select name="uid" size="'||total||'">');
		end if;
		if (i=0) then
			htp.p('<option value="*'||domain||'">all *'||domain);
		end if;
		if (sort=1) then
			open csender1(domain);
		elsif (sort=2) then
			open csender2(domain);
		else
			open csender3(domain);
		end if;
		
		loop			
	   		if (sort=1) then
				fetch csender1 into s_userid,s_name,s_email;
				exit when csender1%NOTFOUND;
			elsif (sort=2) then
				fetch csender2 into s_userid,s_name,s_email;
				exit when csender2%NOTFOUND;			
			else
				fetch csender3 into s_userid,s_name,s_email;
				exit when csender3%NOTFOUND;			
			end if;

			--if (instr(s_email,' ') !=0) then
			--	s_email := substr(s_email,1,instr(s_email,' ')-1);
			--end if;
	   		if (s_name IS NULL) then
				htp.p('<option value="'||s_email||'">'||
					s_email);
	   		else
				htp.p('<option value="'||s_email||'">'||
				s_email||' ('||substr(s_name,1,30)||')');
	   		end if;
		end loop;
		if (sort=1) then
			close csender1;
		elsif (sort=2) then
			close csender2;
		else
			close csender3;
		end if;
		htp.p(htf.formSelectClose);
		if (i=0) then
			htp.p('<br>In folder: ');
			MAILS.list_folder(5);
		end if;
		htp.p(htf.para||htf.formDo('Submit Your Choice'));
		htp.p(htf.formClose);
		wow.sig;
	end if;

	end;

procedure sender_group(domain varchar2,fid number) is
	cursor csender1(do varchar2,lo number,hi number) is select distinct userid,name,email from header,people
		where (id between lo and hi) and (sender=email) and
			(lower(substr(email,instr(email,'.',-1))) = do)
		order by lower(email);
  	total header.id%TYPE;
	s_email people.email%TYPE;
	s_userid people.userid%TYPE;
	s_name people.email%TYPE;
	f_name folder.name%TYPE;
	lo header.id%TYPE;
	hi header.id%TYPE;
begin
		select name into f_name from folder where id=fid;
		htp.htitle('Senders in '||f_name);
		htp.p(htf.line);
		lo := MAILS.maxmsg*(fid-1)+1;
		hi := MAILS.maxmsg*fid;
		select count(distinct email) into total from header,people 
			where (id between lo and hi) and (sender=email) and
			 (lower(substr(email,instr(email,'.',-1)))=domain);
		htp.p('Currently there are total <b>'||total||
			'</b> senders in the <i>'||f_name||'</i> with domain name ended with '||htf.bold(domain));
		htp.p(htf.line);	
                if (total = 0) then
                        wow.sig;
                        return;
                end if;

		htp.p('<h2>Choose one from the sender list</h2>');
		htp.formOpen(MAILS.cgi_bin||'MAILS1.by_sender');
		if (total > 15) then
			htp.p('<select name="uid" size="15">');
		else 
			htp.p('<select name="uid" size="'||total||'">');
		end if;
		open csender1(domain,lo,hi);
		
		loop			
				fetch csender1 into s_userid,s_name,s_email;
				exit when csender1%NOTFOUND;

			--if (instr(s_email,' ') !=0) then
			--	s_email := substr(s_email,1,instr(s_email,' ')-1);
			--end if;
	   		if (s_name IS NULL) then
				htp.p('<option value="'||s_email||'">'||
					s_email);
	   		else
				htp.p('<option value="'||s_email||'">'||
				s_email||' ('||substr(s_name,1,30)||')');
	   		end if;
		end loop;
		close csender1;
		htp.p(htf.formSelectClose);
		htp.p('<input type="hidden" name="fid" value="'||fid||'">');
		htp.p(htf.para||htf.formDo('Submit Your Choice'));
		htp.p(htf.formClose);
		wow.sig;
	end;


procedure by_alphabet(aindex char,sort int,i int) is

	cursor csender1(do varchar2) is select userid,name,email from people where lower(email) like do||'%'
		order by lower(email);
	cursor csender2(do varchar2) is select userid,name,email from people where lower(name) like do||'%'
		order by lower(name);
  	cursor csender3(do varchar2) is select userid,name,email from people where lower(userid) like do||'%'
		order by lower(userid);
  	total header.id%TYPE;
	s_email people.email%TYPE;
	s_userid people.userid%TYPE;
	s_name people.name%TYPE;
	str varchar2(14);
	begin

	MAILS.button;
	if (aindex = 'all') then
		index_allsender(sort,i);
	else
		if (i=0) then htp.htitle('Query By Sender');
		else htp.htitle('Query People');
		end if;
		htp.p(htf.line);
		if (sort=1) then
			select count(*) into total from people 
			   where lower(email) like aindex||'%';
			str := 'email address';
			open csender1(aindex);
		elsif (sort=2) then
		   	select count(*) into total from people 
			   where lower(name) like aindex||'%';
			str := 'name';
			open csender2(aindex);
		else
			select count(*) into total from people 
			   where lower(userid) like aindex||'%';
			str := 'user id';
			open csender3(aindex);
		end if;

		htp.p('Currently there are total <b>'||total||
		  '</b> senders in the database with '||htf.bold(str)||' started with '||htf.bold(aindex));
		htp.p(htf.line);	

		htp.p('<h2>Choose one from the sender list</h2>');
		if (i=0) then htp.formOpen(MAILS.cgi_bin||'MAILS1.by_sender');
		else htp.formOpen(MAILS.cgi_bin||'MAILS1.by_people');
		end if;
		if (total > 15) then
			htp.p('<select name="uid" size="15">');
		else 
			htp.p('<select name="uid" size="'||total||'">');
		end if;
		
		loop			
	   		if (sort=1) then
				fetch csender1 into s_userid,s_name,s_email;
				exit when csender1%NOTFOUND;
			elsif (sort=2) then
				fetch csender2 into s_userid,s_name,s_email;
				exit when csender2%NOTFOUND;			
			else
				fetch csender3 into s_userid,s_name,s_email;
				exit when csender3%NOTFOUND;			
			end if;
			--if (instr(s_email,' ') !=0) then
			--	s_email := substr(s_email,1,instr(s_email,' ')-1);
			--end if;
	   		if (s_name IS NULL) then
				htp.p('<option value="'||s_email||'">'||
					s_email);
	   		else
				htp.p('<option value="'||s_email||'">'||
				s_email||' ('||substr(s_name,1,30)||')');
	   		end if;
		end loop;
		if (sort=1) then
			close csender1;
		elsif (sort=2) then
			close csender2;
		else
			close csender3;
		end if;
		htp.p(htf.formSelectClose);
		if (i=0) then
			htp.p('<br>In folder: ');
			MAILS.list_folder(5);
		end if;
		htp.p(htf.para||htf.formDo('Submit Your Choice'));
		htp.p(htf.formClose);
		wow.sig;		
	end if;

	end;

procedure by_senderkey(sender varchar2,sort int,i int) is

	cursor csender1(do varchar2) is select distinct userid,name,email from people 
		where (lower(email) like '%'||do||'%') or (lower(name) like '%'||do||'%')
			or (lower(userid) like '%'||do||'%')
		order by lower(email);
	cursor csender2(do varchar2) is select distinct userid,name,email from people 
		where (lower(email) like '%'||do||'%') or (lower(name) like '%'||do||'%')
			or (lower(userid) like '%'||do||'%')
		order by lower(name);
	cursor csender3(do varchar2) is select distinct userid,name,email from people 
		where (lower(email) like '%'||do||'%') or (lower(name) like '%'||do||'%')
			or (lower(userid) like '%'||do||'%')
		order by lower(userid);

  	total header.id%TYPE;
	s_email people.email%TYPE;
	s_userid people.userid%TYPE;
	s_name people.name%TYPE;
	str varchar2(14);
	begin
		MAILS.button;
		if (i=0) then htp.htitle('Query By Sender');
		else htp.htitle('Query People');
		end if;
		htp.p(htf.line);
		if (sort=1) then
			open csender1(sender);
		elsif (sort=2) then
			open csender2(sender);
		else
			open csender3(sender);
		end if;
		
		select distinct count(*) into total from people
		where (lower(email) like '%'||sender||'%') or (lower(name) like '%'||sender||'%')
			or (lower(userid) like '%'||sender||'%');
		htp.p('Currently there are total <b>'||total||
		  '</b> senders in the database (keyword: '||htf.bold(sender)||')');
		htp.p(htf.line);	
		if (total = 0) then
			wow.sig;
			return;
		end if;
		htp.p('<h2>Choose one from the sender list</h2>');
		if (i=0) then htp.formOpen(MAILS.cgi_bin||'MAILS1.by_sender');
		else htp.formOpen(MAILS.cgi_bin||'MAILS1.by_people');
		end if;
		if (total > 15) then
			htp.p('<select name="uid" size="15">');
		else 
			htp.p('<select name="uid" size="'||total||'">');
		end if;
		
		loop			
	   		if (sort=1) then
				fetch csender1 into s_userid,s_name,s_email;
				exit when csender1%NOTFOUND;
			elsif (sort=2) then
				fetch csender2 into s_userid,s_name,s_email;
				exit when csender2%NOTFOUND;			
			else
				fetch csender3 into s_userid,s_name,s_email;
				exit when csender3%NOTFOUND;			
			end if;
			--if (instr(s_email,' ') !=0) then
			--	s_email := substr(s_email,1,instr(s_email,' ')-1);
			--end if;
	   		if (s_name IS NULL) then
				htp.p('<option value="'||s_email||'">'||
					s_email);
	   		else
				htp.p('<option value="'||s_email||'">'||
				s_email||' ('||substr(s_name,1,30)||')');
	   		end if;
		end loop;
		if (sort=1) then
			close csender1;
		elsif (sort=2) then
			close csender2;
		else
			close csender3;
		end if;
		htp.p(htf.formSelectClose);
		if (i=0) then
			htp.p('<br>In folder: ');
			MAILS.list_folder(5);
		end if;
		htp.p(htf.para||htf.formDo('Submit Your Choice'));
		htp.p(htf.formClose);
		wow.sig;		
	end;

procedure index_allsender(sort int,i int) is
   cursor csender1 is select userid,name,email from people 
		order by lower(email);
   cursor csender2 is select userid,name,email from people 
		order by lower(name);
   cursor csender3 is select userid,name,email from people 
		order by lower(userid);
   total header.id%TYPE;
	s_email people.email%TYPE;
	s_userid people.userid%TYPE;
	s_name people.name%TYPE;
  begin
	if (i=0) then htp.htitle('Query By Sender');
	else htp.htitle('Query People');
	end if;
	htp.p(htf.line);
	select count(*) into total from people;
	htp.p('Currently there are total <b>'||total||
	'</b> senders in the database.');
	htp.p(htf.line);

	htp.p('<h2>Choose one from the list of all senders</h2>');
	if (i=0) then htp.formOpen(MAILS.cgi_bin||'MAILS1.by_sender');
	else htp.formOpen(MAILS.cgi_bin||'MAILS1.by_people');
	end if;
	htp.p('<select name="uid" size="15">');
		if (sort=1) then
			open csender1;
		elsif (sort=2) then
			open csender2;
		else
			open csender3;
		end if;
		loop			
	   		if (sort=1) then
				fetch csender1 into s_userid,s_name,s_email;
				exit when csender1%NOTFOUND;
			elsif (sort=2) then
				fetch csender2 into s_userid,s_name,s_email;
				exit when csender2%NOTFOUND;			
			else
				fetch csender3 into s_userid,s_name,s_email;
				exit when csender3%NOTFOUND;			
			end if;
			--if (instr(s_email,' ') !=0) then
			--	s_email := substr(s_email,1,instr(s_email,' ')-1);
			--end if;
	   		if (s_name IS NULL) then
				htp.p('<option value="'||s_email||'">'||
					s_email);
	   		else
				htp.p('<option value="'||s_email||'">'||
					s_email||' ('||substr(s_name,1,30)||')');
	   		end if;
		end loop;
		if (sort=1) then
			close csender1;
		elsif (sort=2) then
			close csender2;
		else
			close csender3;
		end if;
	htp.p(htf.formSelectClose);
	if (i=0) then
		htp.p('<br>In folder: ');
		MAILS.list_folder(5);
	end if;
	htp.p(htf.para||htf.formDo('Submit Your Choice'));
	htp.p(htf.formClose);
	wow.sig;
 end;

 procedure by_sender(uid varchar2,fid in number) is
	cursor csender(uidin varchar2,lowerid number,upperid number) is 
		select id,msg_date,subject,sender,bytes 
		from header where (sender=uidin) and 
		(id between lowerid and upperid) order by msg_date desc;
	upper_id header.id%TYPE := 0;
	lower_id header.id%TYPE := 0;
	f_id header.id%TYPE;	
	f_name varchar2(200);
	total header.id%TYPE;
	domain varchar2(20);
 begin

	if (instr(uid,'*',1,1) = 1) then
		domain := substr(uid,2);
		if (fid = 0) then
			by_domain(domain,1,0);
		else
			sender_group(domain,fid);	
		end if;
		return;
	end if;
	MAILS.button;
	if (fid = 0) then
		select max(id) into upper_id from header;
		lower_id := 1;
	else
		upper_id := fid*MAILS.maxmsg;
		lower_id := upper_id - MAILS.maxmsg + 1;
	end if;
	if (fid = 0) then
		f_name := 'all folders';
	else
	 	select name into f_name from folder where id=fid;
	end if;
	open csender(uid,lower_id,upper_id);
	fetch csender into h_id,h_msg_date,h_subject,h_sender,h_bytes;
        if (csender%NOTFOUND) then
		close csender;
		htp.p('<p>No mail is found in folder('||f_name||') from sender ('||
			htf.url(MAILS.cgi_bin||'MAILS1.by_people?uid='||uid,uid)||')');
		wow.sig;	
		return;
	end if;		

	htp.p(htf.line);	
	htp.p('Mails are found in folder('||f_name||') from sender ('||
			htf.url(MAILS.cgi_bin||'MAILS1.by_people?uid='||uid,uid)||')');

	total := 1;
	htp.p('<ul>');
		loop
			--f_id := floor(h_id/MAILS.maxmsg) + 1;
			--lower_id := (f_id - 1)*MAILS.maxmsg;
			MAILS.header_list(h_id,h_bytes,h_sender,h_subject,h_msg_date,'~4');
			fetch csender into h_id,h_msg_date,h_subject,h_sender,h_bytes;
                	exit when csender%NOTFOUND;
		    	total := total + 1;
		end loop;
	htp.p('</ul>');
	htp.p('<p>Total '||htf.bold(total)||' mails are found.');
	close csender;
	wow.sig;
 end;

 procedure by_people(uid varchar2) is

 	p_userid people.userid%TYPE;
 	p_name people.name%TYPE;
	p_email people.email%TYPE;
	p_msg_received header.id%TYPE;
	p_html people.html%TYPE;
	myid url.id%TYPE;
	myhtml url.html%TYPE;
	n integer;
 begin

	select userid,name,email,msg_received,html
		into p_userid,p_name,p_email,p_msg_received,p_html		
		from people where email=uid;
	MAILS.button;
  	if (p_name IS NULL) then
		htp.htitle('Information about '||p_userid);
	else
		htp.htitle('Information about '||p_name);
	end if;
	htp.p(htf.line);

	htp.ulistOpen;
        htp.item;
		htp.p('Name: '||htf.bold(p_name));
    	htp.item;
		htp.p('User Id: '||htf.bold(p_userid));
   	htp.item;
		htp.p('Email Address: '||htf.bold(p_email));
   	htp.item;
		select id,msg_date,subject,sender,bytes into
			h_id,h_msg_date,h_subject,h_sender,h_bytes from header 
			where id=p_msg_received;
			htp.p('Most Recent Mail Received: ');
			htp.p('<ul>');
			MAILS.header_list(h_id,h_bytes,h_sender,h_subject,h_msg_date,'~4');
			htp.p('</ul>');
    	htp.item;
		htp.p(htf.url(MAILS.cgi_bin||'MAILS1.by_sender?uid='||
			uid||'&fid=0',htf.bold('All Mails Received')));

	if (p_html IS NOT NULL) then
    		htp.item;
			htp.p('Related HTML Page: ');
			htp.p('<ul>');
			n := instr(p_html,',');
			while (n != 0) loop
				myid := substr(p_html,1,n-1);
				p_html := substr(p_html,n+1);
				select html into myhtml from url where id=myid;
				htp.p('<li>'||htf.url(myhtml,myhtml));
				n := instr(p_html,',');	
			end loop;
			htp.p('</ul>');	
	end if;

	HTP.ulistClose;

	wow.sig;
   end;	   

end MAILS1;
/
show errors;
/
