drop package MAILS2;
/
create or replace package MAILS2 is

  mailbox_name constant varchar2(50) := MAILS.mailbox_name;
  mailbox_path constant varchar2(50) := MAILS.mailbox_path;
  mailbox_logo constant varchar2(50) := MAILS.mailbox_logo;
  inbox_path constant varchar2(50) := MAILS.inbox_path;
  inbox_logo constant varchar2(50) := MAILS.inbox_logo;
  owner_uid constant varchar2(10) := MAILS.owner_uid;
  cgi_bin1 constant varchar2(30) := MAILS.cgi_bin1;
  cgi_bin constant varchar2(30) := MAILS.cgi_bin;
  owner_name constant varchar2(20) := MAILS.owner_name;
  username constant varchar2(10) := owner_uid;
  password constant varchar2(20) := owner_uid;
  maxmsg constant number(8) := MAILS.maxmsg;
  my_url  constant varchar2(50) := MAILS.my_url;
  sysdate_est date;

  procedure listheader(fid number,op integer,hit number);
  procedure lthread(fid number,hit number,lo number,high number);
  procedure hlist_author(id number,subject in out varchar2,h_date date,h_bytes number);
  procedure keyword(typein varchar2, fid number);

  end;
/
show errors;
/
create or replace package body MAILS2 is
total_visitors number(7);
h_id header.id%TYPE;
h_msg_date header.msg_date%TYPE;
h_subject header.subject%TYPE;
h_sender header.sender%TYPE;
h_bytes header.bytes%TYPE;
h_name people.email%TYPE;
h_email people.email%TYPE;

 procedure listheader(fid number,op integer,hit number) is
	f_id number(7);	
	f_name varchar2(150);
	f_path varchar2(150);
	f_n_msg number(8);
	f_logo varchar2(150);
	total header.id%TYPE;
--    	cursor cname1(lower in number,upper in number) is 
--		SELECT id,msg_date,subject,sender,bytes 
--		from header where (id between lower and upper) 
--		order by id desc;
    	cursor cname2(lower in number,upper in number) is 
		SELECT id,msg_date,subject,sender,bytes 
		from header where (id between lower and upper) 
		order by msg_date desc;
	cursor cname3(lowerid in number,upperid in number) is
		SELECT id,msg_date,subject,sender,bytes from header where 
		(id between lowerid and upperid) order by replace(LOWER(subject),'re: ') asc,msg_date desc;
	cursor cname4(lower in number,upper in number) is
		SELECT id,msg_date,subject,sender,name,email,bytes from header,people where 
		(id between lower and upper) and sender=email order by name asc,msg_date desc;
	upper_id header.id%TYPE := 0;
	lower_id header.id%TYPE := 0;
	n integer;
	limit header.id%TYPE;
	max_date date;
	min_date date;
	tmp_sender header.sender%TYPE;
	tmp_subject header.subject%TYPE;
	cursor cpeople(csender varchar2) is
		select name,email from people where email=csender;
	high header.id%TYPE;
	lo header.id%TYPE;
   begin

	SELECT name,n_msg into f_name,f_n_msg from folder where id = fid;
	if (hit = 0 or hit >= f_n_msg) then limit := f_n_msg;
	else limit := hit;
	end if;

	select max_msgid into high from folder where id = fid;
	high := (fid-1)*maxmsg + high;
	lo := high - limit + 1;
	
	if (op = 1) then
		lthread(fid,hit,lo,high);
		return;
	else
		MAILS.button;
		upper_id := fid*maxmsg;
		lower_id := upper_id - maxmsg + 1;
		select max(msg_date),min(msg_date) into max_date,min_date from header where  
		id between lower_id and upper_id;	
	      if (op = 2) then
		htp.p('<title>'||f_name||' by date</title>');
		htp.p('<a name="start"><h1>'||f_name||' by date</h1></a>');
		htp.p('<ul><li><b>Messages sorted by:</b> ');
		htp.p(htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo||'&high='||high,'[ thread ]')||
			htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=3&hit='||limit,'[ subject ]'));
		htp.p(htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=4&hit='||limit,'[ author ]'));
		htp.formOpen(cgi_bin||'MAILS2.keyword');
		htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
			'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
		htp.p(htf.formClose);

		htp.p('</ul><p>');
		htp.p(htf.bold('Starting:')||' <i>'||to_char(min_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Ending:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Messages: ')||
			htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=2&hit='||f_n_msg,htf.bold(f_n_msg))
			||' ('||limit||' listed)');
		open cname2(lower_id,upper_id);
		fetch cname2 into h_id,h_msg_date,h_subject,h_sender,h_bytes;
		if (cname2%FOUND) then
			total := 1;
			htp.p('<p><ul>');
			loop
				MAILS.header_list(h_id,h_bytes,h_sender,h_subject,h_msg_date,'~1');	
				--hlthread_date(h_id,h_sender,h_subject);				
				if (total = limit) then exit; end if;
				fetch cname2 into h_id,h_msg_date,h_subject,h_sender,h_bytes;
	                	exit when cname2%NOTFOUND;
				total := total + 1;
			end loop;
			htp.p('</ul>');
		end if;
		close cname2;
		htp.p('<p>');
		htp.p(htf.bold('Last message date:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Archived on:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Messages: ')||
			htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=2&hit='||f_n_msg,htf.bold(f_n_msg))
			||' ('||limit||' listed)');
		htp.p('<ul><li><b>Messages sorted by:</b> ');
				htp.p(htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo||'&high='||high,'[ thread ]')||
		htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=3&hit='||limit,'[ subject ]'));
		htp.p(htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=4&hit='||limit,'[ author ]'));
		htp.formOpen(cgi_bin||'MAILS2.keyword');
		htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
			'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
		htp.p(htf.formClose);

		htp.p('</ul><p>');
	elsif (op = 3) then
		htp.p('<title>'||f_name||' by subject</title>');
		htp.p('<a name="start"><h1>'||f_name||' by subject</h1></a>');
		htp.p('<ul><li><b>Messages sorted by:</b> ');

		htp.p(htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
			'&lo='||lo||'&high='||high,'[ thread ]')||
			htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=2&hit='||limit,'[ date ]'));
		htp.p(htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=4&hit='||limit,'[ author ]'));
		htp.formOpen(cgi_bin||'MAILS2.keyword');
		htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
			'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
		htp.p(htf.formClose);

		htp.p('</ul><p>');
		htp.p(htf.bold('Starting:')||' <i>'||to_char(min_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Ending:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Messages: ')||
			htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=3&hit='||f_n_msg,htf.bold(f_n_msg))
			||' ('||limit||' listed)');
		open cname3(lower_id,upper_id);
		fetch cname3 into h_id,h_msg_date,h_subject,h_sender,h_bytes;
		if (cname3%FOUND) then
			total := 1;
			htp.p('<p><ul>');
			loop	
				if (replace(h_subject,' ') IS NULL) then
					h_subject := '(no subject)';
					tmp_subject := h_subject;					
				else
					tmp_subject := replace(lower(h_subject),'re: ');
					h_subject := replace(h_subject,'&','&amp');
					h_subject := replace(h_subject,'<','&lt');
					h_subject := replace(h_subject,'>','&gt');
					h_subject := replace(h_subject,'"','&quot');
					h_subject := replace(h_subject,'Re: ');
					h_subject := replace(h_subject,'RE: ');
					h_subject := replace(h_subject,'re: ');	
				end if;
				htp.p('<li>'||htf.bold(h_subject));
				htp.p('<ul>');
				loop
					open cpeople(h_sender);
					fetch cpeople into h_name,h_email;
					if (cpeople%NOTFOUND) then 
						h_name := '(no name)';
					else
						if (h_name IS NULL) then
							h_name := h_email;
						end if;
					end if;
					close cpeople;
					--hlist_subject(h_id,h_name,h_msg_date,h_bytes);
					htp.p('<li>'||htf.url_right(cgi_bin1||'showbody?bid='||
						h_id||'&word=~1',h_name)||'<i> '||
						to_char(new_time(h_msg_date,'EST','EST'),'Dy, DD Mon YYYY "-" hh24:mi:ss')||
						' EST ('||to_char(h_bytes/1024.,'FM99D9')||'K)</i>');
					total := total + 1;				
					if (total = limit) then exit; end if;
					fetch cname3 into h_id,h_msg_date,h_subject,h_sender,h_bytes;
	                		exit when (cname3%NOTFOUND);
					if (replace(h_subject,' ') IS NULL) then
						h_subject := '(no subject)';
					end if;
					exit when (replace(lower(h_subject),'re: ') != tmp_subject);
				end loop;
				htp.p('</ul>');
				if (total = limit) then exit; end if;
				exit when cname3%NOTFOUND;
			end loop;
			htp.p('</ul>');
		end if;
		close cname3;		

		htp.p('<p>');
		htp.p(htf.bold('Last message date:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Archived on:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Messages: ')||
			htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=3&hit='||f_n_msg,htf.bold(f_n_msg))
			||' ('||limit||' listed)');
		htp.p('<ul><li><b>Messages sorted by:</b> ');
		htp.p(htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo||'&high='||high,'[ thread ]')||
		htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=2&hit='||limit,'[ date ]'));
		htp.p(htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=4&hit='||limit,'[ author ]'));
		htp.formOpen(cgi_bin||'MAILS2.keyword');
		htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
			'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
		htp.p(htf.formClose);

		htp.p('</ul><p>');
	elsif (op = 4) then
		htp.p('<title>'||f_name||' by author</title>');
		htp.p('<a name="start"><h1>'||f_name||' by author</h1></a>');
		htp.p('<ul><li><b>Messages sorted by:</b> ');
		htp.p(htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo||'&high='||high,'[ thread ]')||
		htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=2&hit='||limit,'[ date ]'));
		htp.p(htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=3&hit='||limit,'[ subject ]'));
		htp.formOpen(cgi_bin||'MAILS2.keyword');
		htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
			'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
		htp.p(htf.formClose);

		htp.p('</ul><p>');
		htp.p(htf.bold('Starting:')||' <i>'||to_char(min_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Ending:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Messages: ')||
			htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=4&hit='||f_n_msg,htf.bold(f_n_msg))
			||' ('||limit||' listed)');

		open cname4(lower_id,upper_id);
		fetch cname4 into h_id,h_msg_date,h_subject,h_sender,h_name,h_email,h_bytes;
		if (cname4%FOUND) then
			total := 1;
			htp.p('<p><ul>');
			loop	
				tmp_sender := h_sender;
				if (h_name IS NULL) then
					htp.p('<li>'||htf.bold(h_email));
				else
					htp.p('<li>'||htf.bold(h_name));
				end if;

				htp.p('<ul>');
				loop
					hlist_author(h_id,h_subject,h_msg_date,h_bytes);
					total := total + 1;				
					if (total = limit) then exit; end if;
					fetch cname4 into h_id,h_msg_date,h_subject,h_sender,h_name,h_email,h_bytes;
	                		exit when (cname4%NOTFOUND or (h_sender != tmp_sender));
				end loop;
				htp.p('</ul>');
				if (total = limit) then exit; end if;
				exit when cname4%NOTFOUND;
			end loop;
			htp.p('</ul>');
		end if;
		close cname4;		

		htp.p('<p>');
		htp.p(htf.bold('Last message date:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Archived on:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
		htp.p(htf.bold('Messages: ')||
			htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=4&hit='||f_n_msg,htf.bold(f_n_msg))
			||' ('||limit||' listed)');
		htp.p('<ul><li><b>Messages sorted by:</b> ');
		htp.p(htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
			'&lo='||lo||'&high='||high,'[ thread ]')||
		htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=2&hit='||limit,'[ date ]'));
		htp.p(htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=3&hit='||limit,'[ subject ]'));
		htp.formOpen(cgi_bin||'MAILS2.keyword');
		htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
			'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
		htp.p(htf.formClose);

		htp.p('</ul><p>');		
	end if; 
    end if;

	wow.sig;
end;	 

procedure lthread(fid number,hit number,lo number,high number) is
	f_id number(7);	
	f_name varchar2(150);
	f_n_msg number(8);
    	cursor cname(lower in number,upper in number) is 
		SELECT id,msg_date,subject,sender,bytes 
		from header where (id between lower and upper) 
		order by id desc;
	n header.id%TYPE;
	limit header.id%TYPE;
	max_id header.id%TYPE;
	min_id header.id%TYPE;
	hi_id_next header.id%TYPE;
	lo_id_next header.id%TYPE;
	hi_id_prev header.id%TYPE;
	lo_id_prev header.id%TYPE;
	max_date date;
	min_date date;
	base  header.id%TYPE;
begin

	MAILS.button;
	SELECT name,n_msg,max_msgid,min_msgid into f_name,f_n_msg,max_id,min_id 
		from folder where id = fid;
	base := (fid-1)*maxmsg;
	max_id := base + max_id;
	min_id := base + min_id;

	--if (high > max_id) then high := max_id; end if;
	--if (lo < min_id) then lo := min_id; end if;

	if (hit = 0 or hit >= f_n_msg) then limit := f_n_msg;
	else limit := hit;
	end if;
		
	htp.p('<title>'||f_name||' by thread</title>');
	htp.p('<a name="start"><h1>'||f_name||' by thread</h1></a>');
	htp.p('<ul><li><b>Messages sorted by:</b> ');
	htp.p(htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=2&hit='||limit,'[ date ]')||
	htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=3&hit='||limit,'[ subject ]')||
	htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=4&hit='||limit,'[ author ]'));
	htp.formOpen(cgi_bin||'MAILS2.keyword');
	htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
		'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
	htp.p(htf.formClose);

	htp.p('</ul><p>');
	select max(msg_date),min(msg_date) into max_date,min_date from header where  
		id between min_id and max_id;
	htp.p(htf.bold('Starting:')||' <i>'||to_char(min_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i> ');
	htp.p(htf.bold('Ending:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
	htp.p(htf.bold('Messages: ')||f_n_msg||' ('||
		htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||min_id||'&high='||max_id,(max_id-base)||'-'||(min_id-base))||')');

	if (high < max_id) then
		lo_id_prev := high + 1;
		hi_id_prev := lo_id_prev + limit - 1;
		if (hi_id_prev > max_id) then hi_id_prev := max_id; end if;
		if (lo_id_prev < min_id) then lo_id_prev := min_id; end if;
		htp.p(htf.bold(' Previous: ')||htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo_id_prev||'&high='||hi_id_prev,(hi_id_prev-base)||'-'||(lo_id_prev-base)));
	end if;
	htp.p(htf.bold(' Current: ')||(high-base)||'-'||(lo-base));
	if (lo > min_id) then
		hi_id_next := lo - 1;
		lo_id_next := hi_id_next - limit + 1;
		if (hi_id_next > max_id) then hi_id_next := max_id; end if;
		if (lo_id_next < min_id) then lo_id_next := min_id; end if;
		htp.p(htf.bold(' Next: ')||htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo_id_next||'&high='||hi_id_next,(hi_id_next-base)||'-'||(lo_id_next-base)));
	end if;	
	htp.p(htf.bold(' Threads/page: '));
	if (limit=20) then
		htp.p('20 |');
	else
		htp.p(htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||20||
		'&lo='||(high-19)||'&high='||high,'20')||' |');
	end if;
	if (limit=50) then
		htp.p('50 |');
	else
		htp.p(htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||50||
		'&lo='||(high-49)||'&high='||high,'50')||' |');
	end if;
	if (limit=100) then
		htp.p('100 |');
	else
		htp.p(htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||100||
		'&lo='||(high-99)||'&high='||high,'100')||' |');
	end if;
	if (limit=f_n_msg) then
		htp.p('all');
	else
		htp.p(htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||f_n_msg||
		'&lo='||min_id||'&high='||high,'all'));
	end if;
	
	if (high < max_id) then
		n := (hi_id_prev - lo_id_prev + 1);
		if (n >= limit) then n := limit; end if;
		htp.p('<p><i>...<= '||htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo_id_prev||'&high='||hi_id_prev,'previous '||n||' threads')||
		' ('||(hi_id_prev-base)||'-'||(lo_id_prev-base)||')</i>');
		htp.p(' <i>'||htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||(max_id-limit+1)||'&high='||max_id,(max_id-base))||'<=...</i>');
	end if;
	open cname(lo,high);
	fetch cname into h_id,h_msg_date,h_subject,h_sender,h_bytes;
	if (cname%FOUND) then
		htp.p('<p><ul>');
		loop
			MAILS.header_list(h_id,h_bytes,h_sender,h_subject,h_msg_date,'~1');	
			fetch cname into h_id,h_msg_date,h_subject,h_sender,h_bytes;
	               	exit when cname%NOTFOUND;
		end loop;
		htp.p('</ul>');
	end if;
	close cname;
	if (lo > min_id) then
		n := (hi_id_next - lo_id_next + 1);
		if (n >= limit) then n := limit; end if;
		htp.p('<i>=>... '||htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo_id_next||'&high='||hi_id_next,'next '||n||' threads')||
		' ('||(hi_id_next-base)||'-'||(lo_id_next-base)||')</i>');
		htp.p(' <i>...=>'||htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||min_id||'&high='||(min_id+limit-1),(min_id-base))||'</i>');
	end if;

	htp.p('<p>');
	htp.p(htf.bold('Last message date:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i> ');
	htp.p(htf.bold('Archived on:')||' <i>'||to_char(max_date,'Dy DD Mon YYYY "-" hh24:mi:ss')||' EST</i><br>');
	htp.p(htf.bold('Messages: ')||f_n_msg||' ('||
		htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||min_id||'&high='||max_id,(max_id-base)||'-'||(min_id-base))||')');
	if (high < max_id) then
		htp.p(htf.bold(' Previous: ')||htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo_id_prev||'&high='||hi_id_prev,(hi_id_prev-base)||'-'||(lo_id_prev-base)));
	end if;
	htp.p(htf.bold(' Current: ')||(high-base)||'-'||(lo-base));
	if (lo > min_id) then
		htp.p(htf.bold(' Next: ')||htf.url(cgi_bin||'MAILS2.lthread?fid='||fid||'&hit='||limit||
		'&lo='||lo_id_next||'&high='||hi_id_next,(hi_id_next-base)||'-'||(lo_id_next-base)));
	end if;	

	htp.p('<ul><li><b>Messages sorted by:</b> ');
	htp.p(htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=2&hit='||limit,'[ date ]')||
		htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=3&hit='||limit,'[ subject ]')||
		htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||'&op=4&hit='||limit,'[ author ]'));
	htp.formOpen(cgi_bin||'MAILS2.keyword');
	htp.p('<li><b>Search by keywords:</b> <input name="typein" size="30" value="">'||
		'<input type="hidden" name="fid" value="'||fid||'">'||htf.formDo);
	htp.p(htf.formClose);
	htp.p('</ul><p>');
	wow.sig;
end;	 


procedure hlist_author(id number,subject in out varchar2,h_date date,h_bytes number) is
	begin
		if (subject IS NOT NULL) then
			subject := replace(subject,'&','&amp');
			subject := replace(subject,'<','&lt');
			subject := replace(subject,'>','&gt');
			subject := replace(subject,'"','&quot');
		else
			subject := '(no subject)';
		end if;
		htp.p('<li>'||htf.url_right(cgi_bin1||'showbody?bid='||id||'&word=~1',
			htf.bold(subject))||'<i> '||
			to_char(new_time(h_date,'EST','EST'),'Dy, DD Mon YYYY "-" hh24:mi:ss')||
			' EST ('||to_char(h_bytes/1024.,'FM99D9')||'K)</i>');

	end;

procedure keyword(typein varchar2, fid number) is
	TYPE wordstype IS TABLE
		OF varchar2(20) INDEX BY BINARY_INTEGER;
	word_tab wordstype;
    	cursor cbody(wordin varchar2,lowerid number,upperid number) is SELECT id
		from body where (id between lowerid and upperid) and 
		(lower(msg_body1) like wordin or 
		 lower(msg_body2) like wordin or
		 lower(msg_body3) like wordin or
		 lower(msg_body4) like wordin or
		 lower(msg_body5) like wordin or
		 lower(msg_body6) like wordin or
		 lower(msg_body7) like wordin or
		 lower(msg_body8) like wordin or
		 lower(msg_body9) like wordin or
		 lower(msg_body10) like wordin )
		order by id desc;

	upper_id header.id%TYPE := 0;
	lower_id header.id%TYPE := 0;
	f_id header.id%TYPE;
	typeinword varchar2(40);
	wordshow varchar2(200);
	word_junk varchar2(100);
	total header.id%TYPE := 0;
	words varchar2(200);
	i integer;
	k integer;
	ii BINARY_INTEGER;
	w_count BINARY_INTEGER;
	last_word boolean := false;
	tmp varchar2(200);
	body_all long;
	body_rec body%ROWTYPE;
	begin

	MAILS.button;
	tmp := replace(typein,' ','');
	if (tmp IS NULL) then
		htp.p('<p>You must choose a word to start the search. Try again.');	
		wow.sig;
		return;
	else
		words := typein;
	end if;

     	i := 1;
     	last_word := false;
    	w_count := 0;
	    tmp := NULL;
     	while (1 = 1) loop
		k := instr(words,' ',i);
		if (k = i) then 
			i := i + 1;
		else
			if (k = 0) then
				last_word := true;
				typeinword := words;	
			else
				typeinword := substr(words,1,k);
				words := substr(words,k+1);
				i := 1;					
			end if;
	
			typeinword := replace(typeinword,' ',''); 
			if (typeinword IS NULL) then
				last_word := true; 
			else
				w_count := w_count + 1;
				word_tab(w_count) := typeinword;					
				if (tmp IS NULL) then
					tmp := typeinword;
				else
					tmp := tmp||'+'||typeinword;
				end if;    
			end if;
			if (last_word) then exit; end if;
		end if;
	end loop;
	last_word := false;

	upper_id := fid*maxmsg;
	lower_id := upper_id - maxmsg + 1;
	
	typeinword := word_tab(1);
	if (w_count = 1) then last_word := true; end if;
		
	typeinword := lower(typeinword);
	wordshow := typeinword;
	typeinword := '%'||typeinword||'%';

	htp.p(htf.line);
	open cbody(typeinword,lower_id,upper_id);
	fetch cbody into h_id;
	if (cbody%NOTFOUND) then
		close cbody;
		htp.p('<p>The key word '||htf.bold(wordshow)
			||' is not found in any mail<br>');
		wow.sig;
	        return;
	end if;	
	total := 0;
	if (not last_word) then wordshow := tmp; end if;
	htp.p('<p>The key word '||htf.bold(wordshow)
		||' is found in the following mails:');

	htp.p('<ul>');
	loop

		if (not last_word) then
			select id,BODY_TYPE,CHARS,WORDS,LINES,msg_body1,msg_body2,
			msg_body3,msg_body4,msg_body5,msg_body6,
			msg_body7,msg_body8,msg_body9,msg_body10,msg_body11 into body_rec
			from body where id=h_id;
			ii := 2;
			body_all := body_rec.msg_body1||body_rec.msg_body2||
				body_rec.msg_body3||body_rec.msg_body4||body_rec.msg_body5||
				body_rec.msg_body6||body_rec.msg_body7||body_rec.msg_body8||
				body_rec.msg_body9||body_rec.msg_body10;
			while (ii <= w_count) loop
				k := instr(lower(body_all),lower(word_tab(ii)));
				if (k = 0) then exit; end if;
				ii := ii + 1;
			end loop;
			if (ii <= w_count) then goto no_if2; end if;
		end if;

		select id,msg_date,subject,sender,bytes into 
		h_id,h_msg_date,h_subject,h_sender,h_bytes
		from header where id = h_id;	      
		if (not last_word) then
			MAILS.header_list(h_id,h_bytes,h_sender,h_subject,h_msg_date,tmp);
		else
			MAILS.header_list(h_id,h_bytes,h_sender,h_subject,h_msg_date,wordshow);
		end if;
		    	total := total + 1;
<<no_if2>>
			fetch cbody into h_id;
                	exit when cbody%NOTFOUND;
	end loop;
	close cbody;
		
	htp.p('</ul>');
	htp.p('<p>Total '||htf.bold(total)||' mails found.');
		
	wow.sig;
        end;

end MAILS2;
/
show errors;
/
