drop package MAILS4;
/
create or replace package MAILS4 is

  mailbox_name constant varchar2(50) := MAILS.mailbox_name;
  mailbox_path constant varchar2(50) := MAILS.mailbox_path;
  mailbox_logo constant varchar2(50) := MAILS. mailbox_logo;
  inbox_path constant varchar2(50) := MAILS.inbox_path;
  inbox_logo constant varchar2(50) := MAILS.inbox_logo;
  owner_uid constant varchar2(10) := MAILS.owner_uid;
  cgi_bin1 constant varchar2(30) := MAILS.cgi_bin1;
  cgi_bin constant varchar2(30) := MAILS.cgi_bin;
  owner_name constant varchar2(20) := MAILS.owner_name;
  username constant varchar2(10) := owner_uid;
  password constant varchar2(20) := owner_uid;
  maxmsg constant number(8) := MAILS.maxmsg;
  my_url  constant varchar2(50) := MAILS.my_url;

  sysdate_est date;
  
  procedure urlist(uhid in varchar2, uhtml in varchar2);
  procedure urlistall;
  procedure by_domain(ucode in varchar2);
  procedure by_alphabet (aindex in varchar2);
  procedure by_protocol(protocol in varchar2);

  procedure index_url;
  procedure find_url(find_day in number);
  procedure insert_url(bid in number, urls in varchar2, urlcount in out number);
  procedure by_senderkey(sendkey varchar2);
  procedure showurl(upper_id in number, lower_id in number);
  procedure list_folder(m integer);
  procedure folderinfo (fid in number);
  procedure allurl(curr integer);
  function check_domain(urls varchar2) return boolean;
  procedure dourl(curr integer,dom varchar2);
  procedure count_domain;

  end;
/
show errors;
/
create or replace package body MAILS4 is

total header.id%TYPE;
procedure urlist(uhid in varchar2, uhtml in varchar2) is 
 	s_id       header.id%TYPE;
	s_msg_date header.msg_date%TYPE;
	s_subject  header.subject%TYPE;
	s_sender   header.sender%TYPE;
	s_bytes    header.bytes%TYPE;
	s_html     url.html%TYPE;
	s_head_id  url.head_id%TYPE;
	tmp     url.head_id%TYPE;
	m       header.id%TYPE;
	bid     header.id%TYPE;
	total           header.id%TYPE;
	i	header.id%TYPE;
	h	header.id%TYPE;
	cursor curl(cid number) is select id,msg_date,subject,sender,bytes 
		from header where id=cid;
begin
	total:=0;
	i:=1;
	m:=instr(uhid,',',1,i);
	h:=1;
	--htp.url(uhtml,uhtml);
	--htp.p('<ul>');	
	while(m!=0) loop
		tmp:=substr(uhid, h, m-h);
		bid:=to_number(tmp);
		 open curl(bid);
		 fetch curl into s_id, s_msg_date,s_subject,s_sender,s_bytes;
                 if (curl%FOUND) then
                    if (total=0) then
                          htp.url(uhtml,uhtml);
                          htp.p('<ul>');
                    end if;
	            MAILS.header_list(s_id,s_bytes,s_sender,s_subject,s_msg_date,'~4');
		    total:=total+1;
		end if;
		close curl;
		i:=i+1;
		h:=m+1;
		m:=instr(uhid,',',1,i);
	end loop;
	if (total != 0) then htp.p('</ul>'); end if;
end;

procedure urlistall is 
	cursor curl is select html, head_id from url;
 	s_id       header.id%TYPE;
	s_msg_date header.msg_date%TYPE;
	s_subject  header.subject%TYPE;
	s_sender   header.sender%TYPE;
	s_bytes    header.bytes%TYPE;
	uhtml     url.html%TYPE;
	uhid  url.head_id%TYPE;
	tmp     url.head_id%TYPE;
	m       header.id%TYPE;
	bid     header.id%TYPE;
	i	header.id%TYPE;
	h	header.id%TYPE;
	urlstring  long;
begin
	htp.htitle('Query URL in Newsgroup');
	htp.p(htf.line);
	select urls into total from mailbox;

	htp.p('Currently there are total <b>'||total||'</b> URLs, sorted by hostname');
	htp.p(htf.line);	
	if (total = 0) then
		wow.sig;
		return;
	end if;

	open curl;
	loop 
		fetch curl into uhtml, uhid;
		exit when curl%NOTFOUND;
		i:=1;
		m:=instr(uhid,',',1,i);
		h:=1;
		htp.url(uhtml,uhtml);
		htp.p('<ul>');	
		while(m!=0) loop
			tmp:=substr(uhid, h, m-h);
			bid:=to_number(tmp);

			select id,msg_date,subject,sender,bytes into s_id, s_msg_date, 
					s_subject,s_sender,s_bytes from header where id=bid; 

			MAILS.header_list(s_id,s_bytes,s_sender,s_subject,s_msg_date,'~4');
			i:=i+1;
			h:=m+1;
			m:=instr(uhid,',',1,i);
		end loop;
		htp.p('</ul>');
	end loop;
	close curl;
	wow.sig;	
end;

procedure by_domain(ucode in varchar2) is
	cursor chtml(bdomain varchar2) is select distinct html, head_id from url
		where ((instr(html,'/',1,3) = 0) and
		(lower(substr(html,instr(html,'.',-1)+1,4)) like bdomain||'%')) or
		((instr(html,'/',1,3) != 0) and
		(lower(substr(html,instr(substr(html,1,instr(html,'/',1,3)-1),'.',-1)+1,4)) like bdomain||'%'))
		order by 1 asc;
	cursor chtml1 is select distinct html, head_id from url
		where (ascii(upper(substr(html,(instr(html,'.',-1)+1),1)))
		not between 65 and 90)
		order by 1 asc;
 	s_id       header.id%TYPE;
	s_msg_date header.msg_date%TYPE;
	s_subject  header.subject%TYPE;
	s_sender   header.sender%TYPE;
	s_bytes    header.bytes%TYPE;
	s_html     url.html%TYPE;
	s_head_id  url.head_id%TYPE;
	tmp     url.head_id%TYPE;
	m       header.id%TYPE;
	bid     header.id%TYPE;
	i	header.id%TYPE;
	h	header.id%TYPE;	
	begin


	if (ucode = 'all') then
		allurl(65);
		return;
	else
		if (ucode != 'other') then
			select urls into total from domain where code=upper(ucode);
			if (total > 100) then
				dourl(65,ucode);
				return;
			end if;
		end if;

		MAILS.button;
		htp.htitle('Query URL By Domain Name');
		htp.p(htf.line);
		total := 0;

		if (ucode = 'other') then
			open chtml1;
			loop 		
				fetch chtml1 into s_html, s_head_id;
				exit when chtml1%NOTFOUND;
				urlist(s_head_id, s_html);
				total := total + 1;
			end loop;
			close chtml1;
		else
			open chtml(ucode);
			loop 		
				fetch chtml into s_html, s_head_id;
				exit when chtml%NOTFOUND;
				urlist(s_head_id, s_html);
				total := total + 1;
			end loop;
			close chtml;
		end if;
		htp.p(htf.line);
		htp.p('Total '||htf.bold(total)||
			' URLs found in the database');
		if ( ucode != 'other') then
			select name into s_html from domain where code=upper(ucode);
			htp.p(' with domain name ended with .'||htf.bold(ucode)||' ('||s_html||').');	
		end if;	
	end if;

	wow.sig;

	end;

procedure dourl(curr integer,dom varchar2) is 
	i integer;
	total header.id%TYPE;
--	cursor curl(al varchar2,domm varchar2) is select html, head_id from url where 
--		(lower(html) like '%://'||al||'%') and 
--		(lower(substr(html,instr(html,'.',-1)+1,4)) like domm||'%')
--		order by html;

	cursor curl(al varchar2,domm varchar2) is select distinct html, head_id from url
		where (lower(html) like '%://'||al||'%') and 
		((instr(html,'/',1,3) = 0) and
		(lower(substr(html,instr(html,'.',-1)+1,4)) like domm||'%')) or
		((instr(html,'/',1,3) != 0) and
		(lower(substr(html,instr(substr(html,1,instr(html,'/',1,3)-1),'.',-1)+1,4)) like domm||'%'))
		order by 1 asc;
	curr1 integer;
begin
	MAILS.button;
        htp.htitle('Query URL By Hostname and Domain Name');
	htp.p(htf.line);
	if (curr > 0) then
	for i in curr .. 90 loop
		select count(*) into total from url where 
			ascii(upper(substr(html, instr(html,'://')+3)))=i and
				((instr(html,'/',1,3) = 0) and
				(lower(substr(html,instr(html,'.',-1)+1,4)) like dom||'%')) or
				((instr(html,'/',1,3) != 0) and
				(lower(substr(html,instr(substr(html,1,instr(html,'/',1,3)-1),'.',-1)+1,4)) 
				like dom||'%'));		

			--(lower(substr(html,instr(html,'.',-1)+1,4)) like dom||'%');
		if (total > 0) then
			htp.p('Total '||htf.bold(total)||' urls found with hostname started with '||
					htf.bold(lower(chr(i)))||' with domain name '||htf.bold(dom));
			htp.p(htf.line);
			if ((i-1) >= 65) then
				htp.p('<i>Previous <-- hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.dourl?curr='||(1-i)||'&dom='||dom,
				htf.bold(lower(chr(i-1))||' - a'))||'</i> | ');
			end if;
			if ((i+1) <= 90) then
				htp.p('<i>Next --> hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.dourl?curr='||(i+1)||'&dom='||dom,
				htf.bold(lower(chr(i+1))||' - z'))||'</i>');
			end if;
			htp.p('<p>');
			for url in curl(lower(chr(i)),dom) loop
				urlist(url.head_id, url.html);
			end loop;
			if ((i+1) <= 90) then
				htp.p('<i>Next --> hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.dourl?curr='||(i+1)||'&dom='||dom,
				htf.bold(lower(chr(i+1))||' - z'))||'</i> | ');
			end if;
			if ((i-1) >= 65) then
				htp.p('<i>Previous <-- hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.dourl?curr='||(1-i)||'&dom='||dom,
				htf.bold(lower(chr(i-1))||' - a'))||'</i>');
			end if;
			htp.p('<p>');
			exit;
		end if;
	end loop;
	else
	curr1 := (-curr);
	for i in REVERSE 65 .. curr1 loop
		select count(*) into total from url where 
			ascii(upper(substr(html, instr(html,'://')+3)))=i and
			((instr(html,'/',1,3) = 0) and
				(lower(substr(html,instr(html,'.',-1)+1,4)) like dom||'%')) or
				((instr(html,'/',1,3) != 0) and
				(lower(substr(html,instr(substr(html,1,instr(html,'/',1,3)-1),'.',-1)+1,4)) 
				like dom||'%'));	
			--(lower(substr(html,instr(html,'.',-1)+1,4)) like dom||'%');
		if (total > 0) then
			htp.p('Total '||htf.bold(total)||' urls found with hostname started with '||
					htf.bold(lower(chr(i)))||' with domain name '||htf.bold(dom));
			htp.p(htf.line);
			if ((i-1) >= 65) then
				htp.p('<i>Previous <-- hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.dourl?curr='||(1-i)||'&dom='||dom,
				htf.bold(lower(chr(i-1))||' - a'))||'</i> | ');
			end if;
			if ((i+1) <= 90) then
				htp.p('<i>Next --> hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.dourl?curr='||(i+1)||'&dom='||dom,
				htf.bold(lower(chr(i+1))||' - z'))||'</i>');
			end if;	
			htp.p('<p>');		
			for url in curl(lower(chr(i)),dom) loop
				urlist(url.head_id, url.html);
			end loop;
			if ((i+1) <= 90) then
				htp.p('<i>Next --> hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.dourl?curr='||(i+1)||'&dom='||dom,
				htf.bold(lower(chr(i+1))||' - z'))||'</i> | ');
			end if;
			if ((i-1) >= 65) then
				htp.p('<i>Previous <-- hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.dourl?curr='||(1-i)||'&dom='||dom,
				htf.bold(lower(chr(i-1))||' - a'))||'</i>');
			end if;
			htp.p('<p>');
			exit;
		end if;
	end loop;	
	end if;

	wow.sig;	
end;


procedure by_senderkey(sendkey varchar2) is 
	cursor csenderkey(do varchar2) is select distinct html,head_id from url
		where (lower(html) like '%'||do||'%');
  	total header.id%TYPE;
	s_html url.html%TYPE;
	s_hid  url.head_id%TYPE;
	str varchar2(14);
	begin
		MAILS.button;
		htp.htitle('Query URL in Newsgroup');

		htp.p(htf.line);
		total := 0;
		open csenderkey(sendkey);		
		loop			
			fetch csenderkey into s_html,s_hid;
			exit when csenderkey%NOTFOUND;
			urlist(s_hid, s_html);
			total := total + 1;
		end loop;
		close csenderkey;
		htp.p(htf.line);
		htp.p('Total <b>'||total||
			'</b> urls found in the database with keyword '||htf.bold(sendkey)||'.');
		wow.sig;		
	end;


procedure by_alphabet (aindex in varchar2) is 
	cursor curl1(do varchar2) is select html, head_id from url where 
		lower(html) like '%://'||do||'%' order by html;
	cursor curlother is select html, head_id from url where 
		(ascii(upper(substr(html, instr(html,'://')+3))) < 65) or 
		(ascii(upper(substr(html, instr(html,'://')+3))) > 90);  -- <'A" and >'Z'
	s_html    url.html%TYPE;
	s_head_id url.head_id%TYPE;
	begin
		
		if (aindex = 'all') then 
	 		allurl(65);
			return;
		else
			MAILS.button;
			htp.htitle('Query URL in Newsgroup');
			htp.p(htf.line);

			if (aindex = 'others') then
				open curlother;
			else 
		     		open curl1(aindex);
			end if;
		end if;
		
		total := 0;
		loop			

			if (aindex = 'others') then 
				fetch curlother into s_html,s_head_id;
				exit when curlother%NOTFOUND;
			else
				fetch curl1 into s_html,s_head_id;
				exit when curl1%NOTFOUND;
			end if;
			urlist(s_head_id, s_html);
			total := total + 1;
		end loop;
		if (aindex = 'others') then 
			close curlother;
		else
			close curl1;
		end if;
		
		htp.p(htf.para||htf.formDo('Submit Your Choice'));
		htp.p(htf.formClose);
		htp.p(htf.line);	
		htp.p('Total <b>'||total||
		  '</b> URLs found in the database with '||htf.bold('hostname')||' started with '||htf.bold(aindex));

		wow.sig;		
	end;

procedure allurl(curr integer) is 
	i integer;
	total header.id%TYPE;
	cursor curl(do varchar2) is select html, head_id from url where 
		lower(html) like '%://'||do||'%' order by html;
	curr1 integer;
begin
	MAILS.button;
        htp.htitle('Query URL By Hostname');
	htp.p(htf.line);
	if (curr > 0) then
	for i in curr .. 90 loop
		select count(*) into total from url where 
			ascii(upper(substr(html, instr(html,'://')+3)))=i;
		if (total > 0) then
			htp.p('Total '||htf.bold(total)||' urls found with hostname started with '||
					htf.bold(lower(chr(i))));
			htp.p(htf.line);
			if ((i-1) >= 65) then
				htp.p('<i>Previous <-- hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.allurl?curr='||(1-i),
				htf.bold(lower(chr(i-1))||' - a'))||'</i> | ');
			end if;
			if ((i+1) <= 90) then
				htp.p('<i>Next --> hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.allurl?curr='||(i+1),
				htf.bold(lower(chr(i+1))||' - z'))||'</i>');
			end if;
			htp.p('<p>');
			for url in curl(lower(chr(i))) loop
				urlist(url.head_id, url.html);
			end loop;
			if ((i+1) <= 90) then
				htp.p('<i>Next --> hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.allurl?curr='||(i+1),
				htf.bold(lower(chr(i+1))||' - z'))||'</i> | ');
			end if;
			if ((i-1) >= 65) then
				htp.p('<i>Previous <-- hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.allurl?curr='||(1-i),
				htf.bold(lower(chr(i-1))||' - a'))||'</i>');
			end if;
			htp.p('<p>');
			exit;
		end if;
	end loop;
	else
	curr1 := (-curr);
	for i in REVERSE 65 .. curr1 loop
		select count(*) into total from url where 
			ascii(upper(substr(html, instr(html,'://')+3)))=i;
		if (total > 0) then
			htp.p('Total '||htf.bold(total)||' urls found with hostname started with '||
					htf.bold(lower(chr(i))));
			htp.p(htf.line);
			if ((i-1) >= 65) then
				htp.p('<i>Previous <-- hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.allurl?curr='||(1-i),
				htf.bold(lower(chr(i-1))||' - a'))||'</i>');
			end if;
			if ((i+1) <= 90) then
				htp.p(' | <i>Next --> hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.allurl?curr='||(i+1),
				htf.bold(lower(chr(i+1))||' - z'))||'</i><p>');
			end if;			
			for url in curl(lower(chr(i))) loop
				urlist(url.head_id, url.html);
			end loop;
			if ((i+1) <= 90) then
				htp.p('<i>Next --> hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.allurl?curr='||(i+1),
				htf.bold(lower(chr(i+1))||' - z'))||'</i>');
			end if;
			if ((i-1) >= 65) then
				htp.p(' | <i>Previous <-- hostname started with '||
				htf.url(MAILS.cgi_bin||'MAILS4.allurl?curr='||(1-i),
				htf.bold(lower(chr(i-1))||' - a'))||'</i><p>');
			end if;

			exit;
		end if;
	end loop;	
	end if;

	wow.sig;	
end;

procedure by_protocol(protocol in varchar2) is 
  cursor cprotocol(sprotocol varchar2) is select html, head_id from url where html like sprotocol||'://%' order by html;
  cursor cprotocolall is select html, head_id from url order by html;
  s_html    url.html%TYPE;
  s_head_id url.head_id%TYPE;
  str varchar2(14);
  bhtml      url.html%TYPE;
  bhead_id   url.head_id%TYPE;
  tmp        url.head_id%TYPE;
  bid        body.id%TYPE;
  m          header.id%TYPE;
  i          header.id%TYPE;
  h          header.id%TYPE;
begin

  if (protocol = 'all' ) then	
 	allurl(65);
	return;
  else 
         open cprotocol(protocol);
  end if;
  MAILS.button;
  htp.htitle('Query URL in Newsgroup');
  htp.p(htf.line);
  total := 0;		
  loop			
	if (protocol = 'all') then 
		fetch cprotocolall into s_html,s_head_id;
		exit when cprotocolall%NOTFOUND;
	else
		fetch cprotocol into s_html,s_head_id;
		exit when cprotocol%NOTFOUND;
	end if;
		urlist(s_head_id, s_html);
	total := total + 1;

  end loop;
  if (protocol = 'all') then 
	close cprotocolall;
  else
	close cprotocol;
  end if;

  htp.p(htf.line);
  htp.p('Total <b>'||total||'</b> URLs found in the database with protocol '||htf.bold(protocol));

  wow.sig;		
end;


procedure index_url is
--   cursor cprotocol is select distinct lower(substr(html, 1,instr(html,'://')-1)) 
--	from url where instr(html,'://') != 0;
   sprotocol url.html%TYPE;
   cursor cmachine is select distinct lower(substr(html, instr(html,'://')+3, instr(html,'.')-instr(html,'://')-3))
	 from url where instr(html,'.')-instr(html,'://')-3 > 0;
   smachine   url.html%TYPE;

   sdomain url.html%TYPE;
   tmp     varchar2(2000);
   total_folder number := 0;
   i number;
   l number;
   k number;
   j number;
   cursor cdomain is select lower(code),name,urls
	from domain order by 3 desc,1 asc;
   ucode domain.code%TYPE;
   uname domain.name%TYPE;
 begin
	MAILS.button;
        htp.htitle('Query URL in Newsgroup');
	htp.p(htf.line);
	select urls into total from mailbox;
	htp.p('Currently there are total <b>'||total||
	'</b> URLs in the database.');
	htp.p(htf.line);

-- By Newsgroup

	htp.p('<ol><li><h2>Search by Newsgroups</h2>');
	htp.formOpen(MAILS.cgi_bin||'MAILS4.folderinfo');
	list_folder(10);
	htp.p(htf.formDo('Submit'));
	htp.p(htf.formClose);

	htp.p('<li><h2>Search URL</h2><ul>');
--By keyword
	htp.formOpen(MAILS.cgi_bin||'MAILS4.by_senderkey');
        htp.p('<li>By Keyword: <input name="sendkey" size="20" value="">');
	htp.p(htf.formDo('Submit'));
	htp.p(htf.formClose);
	htp.p('(a keyword can be any part of an URL)');

-- By alphabet
        htp.p('<p><li>By Host Name Index in Alphabetic Order<p><p>');
	htp.formOpen(MAILS.cgi_bin||'MAILS4.by_alphabet');
	htp.p('<input TYPE=submit value="all" name="aindex">');
	htp.p('<input TYPE=submit value="a" name="aindex"><input TYPE=submit value="b" name="aindex"><input TYPE=submit value="c" name="aindex">');
        htp.p('<input TYPE=submit value="d" name="aindex"><input TYPE=submit value="e" name="aindex"><input TYPE=submit value="f" name="aindex">');
	htp.p('<input TYPE=submit value="g" name="aindex"><input TYPE=submit value="h" name="aindex"><input TYPE=submit value="i" name="aindex">');
	htp.p('<input TYPE=submit value="j" name="aindex"><input TYPE=submit value="k" name="aindex"><input TYPE=submit value="l" name="aindex">');
	htp.p('<input TYPE=submit value="m" name="aindex"><p><input TYPE=submit value="n" name="aindex"><input TYPE=submit value="o"name="aindex">');
	htp.p('<input TYPE=submit value="p" name="aindex"><input TYPE=submit value="q" name="aindex"><input TYPE=submit value="r"name="aindex">');
	htp.p('<input TYPE=submit value="s" name="aindex"><input TYPE=submit value="t" name="aindex"><input TYPE=submit value="u"name="aindex">');
	htp.p('<input TYPE=submit value="v" name="aindex"><input TYPE=submit value="w" name="aindex"><input TYPE=submit value="x" name="aindex">');
	htp.p('<input TYPE=submit value="y" name="aindex"><input TYPE=submit value="z" name="aindex"><input TYPE=submit value="others" name="aindex">');
        htp.p(htf.formClose);
--By domain
	htp.formOpen(MAILS.cgi_bin||'MAILS4.by_domain');
        htp.p('<li>By Domain Name <br><select name="ucode" size="6">');
	htp.p('<option value="all" selected>all ('||total||')');
	open cdomain;
	loop 
		fetch cdomain into ucode,uname,k;
		exit when cdomain%NOTFOUND;
		htp.p('<option value="'||ucode||'">'||'.'||ucode||' ('||uname||', '||k||')');
	end loop;
	select sum(urls) into k from domain;
	htp.p('<option value="other">others (unknown, '||(total-k)||')');	
	htp.p(htf.formSelectClose);
	close cdomain;
	htp.p(htf.formDo('Submit'));
	htp.p(htf.formClose);

--   By protocol 

        htp.formOpen(MAILS.cgi_bin||'MAILS4.by_protocol'); 
        htp.p('<li>By Protocol Name');
        htp.p('<INPUT TYPE=submit value="all" name="protocol">');
        htp.p('<INPUT TYPE=submit value="ftp" name="protocol">');
        htp.p('<INPUT TYPE=submit value="wais" name="protocol">');
        htp.p('<INPUT TYPE=submit value="gopher" name="protocol">');
        htp.p(htf.formSelectClose);
        htp.p(htf.formClose);
        htp.p('</ul>');

	htp.p('</ol>');	

	wow.sig;
	end;

function check_domain(urls varchar2) return boolean is
	cursor cdomain(ucode varchar2) is select code from domain where upper(ucode) like code||'%';
	ucode domain.code%TYPE;
	n integer;
begin
	
		n := instr(urls,'.',-1);
		if (n != 0) then
			ucode := substr(urls,n+1,4);
			open cdomain(ucode);
			fetch cdomain into ucode;
			if (cdomain%FOUND) then
				close cdomain;
				return FALSE;
			else
				close cdomain;
				return TRUE;
			end if;
		elsif (ascii(substr(urls,(instr(urls,'.',-1)+1),1)) between 48 and 57) then
			return FALSE;
		end if;
		return TRUE;
end;


procedure insert_url (bid in number, urls in varchar2, urlcount in out number) is
	in_head_id  number;
	in_html     number;
	cursor new_url(urladd varchar2) is select id, head_id from url where html=urladd;
	cursor people_url(ssender varchar2) is select html from people where email=ssender;
	cursor csender (sid number) is select sender from header where id=sid;
	new_url_rec new_url%ROWTYPE;
	url_id      new_url_rec.id%TYPE;
 	urlhead_id  new_url_rec.head_id%TYPE;
	add_head_id new_url_rec.head_id%TYPE;
	add_url_id  people.html%TYPE;
	pid         people.userid%TYPE;
	phtml       people.html%TYPE;
	hsender     header.sender%TYPE;
	ucode 	    domain.code%TYPE;
	cursor cdomain(ucode varchar2) is select code from domain where 
		upper(ucode) like code||'%' order by code desc;
	n integer;
	begin

	    if (check_domain(urls)) then
		return;
	    end if;
	    /* for updating URLs info */
	    open new_url(urls);
		fetch new_url into url_id,urlhead_id; -- count how many row on table url 
		add_head_id := bid||',';
		if (new_url%FOUND) then
	  	        in_head_id := instr(urlhead_id,add_head_id);
			if (in_head_id = 0) then
				if ((length(urlhead_id) + 10) < 2000) then
			    		update url set head_id = concat(head_id, add_head_id) where id = url_id;
				end if;
			end if;
		else
			urlcount := urlcount + 1;
			insert into url values(urlcount, urls, add_head_id);
			n := instr(urls,'/',1,3);
			if (n != 0) then
				ucode := substr(urls,instr(substr(urls,1,n-1),'.',-1)+1,4);
			else
				ucode := substr(urls,instr(urls,'.',-1)+1,4);
			end if;
			open cdomain(ucode);
			fetch cdomain into ucode;
			if (cdomain%FOUND) then
				update domain set urls=urls+1 where code=ucode;
			end if;
			close cdomain;
			commit;
		end if;
		htp.p('url '||urls||' inserted '||urlcount);
            close new_url; 
	    commit;
            
	    /* for updating people's info */
	    open csender(bid);
	    fetch csender into hsender;
	    if (csender%FOUND) then 	
		    open people_url(hsender);
			fetch  people_url into phtml; 
			add_url_id:=urlcount||',';
			if (people_url%FOUND) then
	  	        	in_html:=instr(phtml, add_url_id);
				if ((phtml is NULL) or (in_html = 0)) then
					if ((phtml is NULL) or (length(phtml) < 55)) then
			   			update people set html = html||add_url_id where email = hsender;
						commit;
						htp.p('people '||hsender||' updated.');
					end if;
				end if;
			end if;
        	    close people_url;
		    commit;
	    end if;
	    close csender;
	end;

   procedure find_url(find_day in number) is
	l number(1);
	n header.id%TYPE;
	i header.id%TYPE;
	j header.id%TYPE;
	k header.id%TYPE;
	body_all long;
	tmp long;
	urls varchar2(254);
	n1 header.id%TYPE;
	m header.id%TYPE;	
	bid     body.id%TYPE;
	counts header.id%TYPE;
	search_str varchar2(10);

	cursor cbody(days number) is
		select header.id,msg_body1,msg_body2,
			msg_body3,msg_body4,msg_body5,msg_body6,
			msg_body7,msg_body8,msg_body9,msg_body10
			from header,body where (header.id = body.id) and
			(msg_date > sysdate-days); -- for one day

	cursor cbody1 is select id,msg_body1,msg_body2,
			msg_body3,msg_body4,msg_body5,msg_body6,
			msg_body7,msg_body8,msg_body9,msg_body10
			from body;  -- for whole file
	body_rec cbody%ROWTYPE;

begin
	select count(*) into counts from url; -- get the total number of row in url 
	
	if (find_day != 0) then 
		open cbody(find_day);  -- for one day;
	else
		open cbody1;           -- for whole file
	end if;

	loop

		if (find_day !=0) then
			fetch cbody into body_rec;
			if (cbody%NOTFOUND) then	
 				exit;
			end if;
		else  
			fetch cbody1 into body_rec;
			if (cbody1%NOTFOUND) then	
				exit;
			end if;
		end if;

		bid :=body_rec.id;
		body_all := body_rec.msg_body1||body_rec.msg_body2||
			body_rec.msg_body3||body_rec.msg_body4||body_rec.msg_body5||
			body_rec.msg_body6||body_rec.msg_body7||body_rec.msg_body8||
			body_rec.msg_body9||body_rec.msg_body10;

--		for l in 1..6 loop 
		for l in 1..4 loop 
	  	   if (l = 1) then search_str:='http://';
		   elsif (l = 2) then search_str:='ftp://';
	    	   elsif (l = 3) then search_str:='wais://';
  		   elsif (l = 4) then search_str:='gopher://'; 
--		   elsif (l = 5) then search_str:='doc://';
--		   elsif (l = 6) then search_str:='telnet://'; 
		   end if;
			
	           i := 1;
		   m := instr(body_all,search_str,i,1);
		   while ( m != 0) loop		
			tmp := substr(body_all,m);
			k := instr(tmp,' ');

			n1 := instr(tmp,'>');	
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,')');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,',');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,'|');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,';');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,'''');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,'"');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,chr(10));
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,'#');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;

			if (k != 0) then 
				urls := substr(tmp,1,k-1);
				n1 := instr(substr(urls,-1,1),'.');
				if ((n1 != 0) and (n1 < k)) then urls:=substr(tmp,1,k-2); end if;
				if (length(urls) >= 10) then
					insert_url(bid,urls,counts); -- for insert url
				end if;
				i := m + k;
			else
				i := m + length(search_str);
			end if;
			m := instr(body_all,search_str,i,1);
	  	   end loop;  -- for while
		end loop; -- for l
	
	end loop;

	if (find_day != 0) then 
	      close cbody;
      	else
	      close cbody1;
      	end if;	
	update mailbox set urls = (select count(*) from url);
	commit;
    end;

procedure showurl(upper_id in number, lower_id in number) is
cursor matchurl is select html, head_id from url; 
s_id       header.id%TYPE;
s_msg_date header.msg_date%TYPE;
s_subject  header.subject%TYPE;
s_sender   header.sender%TYPE;
s_bytes    header.bytes%TYPE;
uhtml      url.html%TYPE;
uhid       url.head_id%TYPE;
tmp        url.head_id%TYPE;
m          header.id%TYPE;
bid        header.id%TYPE;
total      header.id%TYPE;
i	   header.id%TYPE;
h	   header.id%TYPE;
tot	   header.id%TYPE := 0;
cursor curl(cid number) is select id,msg_date,subject,sender,bytes from header where id=cid;
begin
	open matchurl;
	loop
		fetch matchurl into uhtml, uhid;
		exit when matchurl%NOTFOUND;	
		total:=0;
		i:=1;
		m:=instr(uhid,',',1,i);
		h:=1;	
		while(m!=0) loop
			tmp:=substr(uhid, h, m-h);
			bid:=to_number(tmp);
			if (bid between lower_id and upper_id) then 
				open curl(bid);
				fetch curl into s_id, s_msg_date,s_subject,s_sender,s_bytes;
				if (curl%FOUND) then
					if (total=0) then 
						htp.url(uhtml,uhtml);
						htp.p('<ul>');
					end if;
					MAILS.header_list(s_id,s_bytes,s_sender,s_subject,s_msg_date,'~4');
					total:=total+1;
				end if;
				close curl;
			end if;
			i:=i+1;
			h:=m+1;
			m:=instr(uhid,',',1,i);
		end loop;
		if (total != 0) then 
			htp.p('</ul>'); 
			tot := tot + 1;
			end if;
	end loop;
	close matchurl;
	htp.p('Total URLs found : '||htf.bold(tot));

end;

procedure list_folder(m integer) is
   total number := 0;
   n integer := 1;
   cursor cfolder is select id,name,n_msg from folder order by name;
 begin

	select sum(n_msg),count(*) into total,n from folder;
	if (n > m) then n := m; end if;
	htp.p('<select name="fid" size="'||n||'">');
	--htp.p('<option value="0" selected> All folders');
	for folder in cfolder loop
	   htp.p('<option value="'||folder.id||'">'||folder.name);
	end loop;
	htp.p(htf.formSelectClose);
 end;

 procedure folderinfo(fid in number) is
	f_id number(7);
	f_name varchar2(150);
	f_path varchar2(150);
	f_n_msg number(8);
	f_creation_time date;
	f_logo varchar2(150);
    	cursor cname1 is SELECT id,name,path,n_msg,creation_time,logo from folder order by name;
	total number(5) := 0;
	flag boolean := false;
	mid header.id%TYPE := 0;
	upper_id header.id%TYPE := 0;
	lower_id header.id%TYPE := 0;
	mdate date;

	cursor matchurl is select id, html, head_id from url;
   begin
	MAILS.button;
	htp.htitle('URL Information in Folder');
	if (fid = 0) then
		open cname1;
	end if;

        loop
		if (fid = 0) then
               		fetch cname1 into f_id,f_name,f_path,f_n_msg,f_creation_time,f_logo;
                	exit when cname1%NOTFOUND;
		else			
                	SELECT name,path,n_msg,creation_time,logo 
				into f_name,f_path,f_n_msg,f_creation_time,f_logo	
				from folder where id = fid;
			f_id := fid;
  		end if;

	htp.p(htf.line);
	htp.p('Folder Name: '||htf.bold(f_name)||'<p>');
	total := total + 1;
	upper_id := MAILS.maxmsg*fid;
	lower_id := upper_id - MAILS.maxmsg + 1;
	showurl(upper_id, lower_id);
	if (fid != 0) then exit; end if;

       end loop;

        if (fid = 0) then
		close cname1;
		htp.p('Total <blink><b>'||total||'</b></blink> Folders !<p>');
	end if;

	wow.sig;
   end;

procedure count_domain is
	cursor curl is select html from url;
	ucode 	    domain.code%TYPE;
	cursor cdomain(ucode varchar2) is select code from domain where 
		upper(ucode) like code||'%' order by code desc;
	n integer;
	urls url.html%TYPE;
	begin
		update domain set urls=0;
		commit;
		open curl;
		loop
			fetch curl into urls;
			exit when curl%NOTFOUND;
			n := instr(urls,'/',1,3);
			if (n != 0) then
				ucode := substr(urls,instr(substr(urls,1,n-1),'.',-1)+1,4);
			else
				ucode := substr(urls,instr(urls,'.',-1)+1,4);
			end if;
			open cdomain(ucode);
			fetch cdomain into ucode;
			if (cdomain%FOUND) then
				update domain set urls=urls+1 where code=ucode;
			end if;
			close cdomain;
			commit;
		end loop;
	end;

end MAILS4;
/
show errors;
/
