drop package mails6;
/
create or replace package mails6 is

  mailbox_name constant varchar2(50) := MAILS0.mailbox_name;
  mailbox_path constant varchar2(50) := MAILS0.mailbox_path;
  mailbox_logo constant varchar2(50) := MAILS0.mailbox_logo;
  inbox_path constant varchar2(50) := MAILS0.inbox_path;
  inbox_logo constant varchar2(50) := MAILS0.inbox_logo;
  owner_uid constant varchar2(10) := MAILS0.owner_uid;
  cgi_bin1 constant varchar2(30) := MAILS0.cgi_bin1;
  cgi_bin constant varchar2(30) := MAILS0.cgi_bin;
  owner_name constant varchar2(20) := MAILS0.owner_name;
  username constant varchar2(10) := MAILS0.username;
  password constant varchar2(20) := MAILS0.password;
  maxmsg constant number(8) := MAILS0.maxmsg;
  my_url  constant varchar2(50) := MAILS0.my_url;
  root_url constant varchar2(50) :=  MAILS0.root_url;
  help_html constant varchar2(50) := '/'||owner_uid||'/help_kids.html';

procedure home(fid number);
procedure by_date(this_month integer,fid number);
procedure by_date(this_month integer,fid number,op integer);
procedure entry;
procedure by_a_date(this varchar2,fid number);
procedure by_a_date(this varchar2,op varchar2,fid number);
procedure header_list(id rowid,bytes number,
		sender varchar2,subject in out varchar2,msg_date date);
procedure header_list1(id rowid,bytes number,
		sender varchar2,subject in out varchar2,msg_date date);

function url_right (curl  in varchar2, cname   in varchar2) return varchar2;
function td(data varchar2) return varchar2;
procedure showbody(rid in rowid);
procedure showbody(rid in rowid,word varchar2);
procedure index_home;
procedure search_index(fid number,month integer);
procedure keyword(typein varchar2,fid number,month integer);
procedure parse_typein(typein varchar2);

  end;
/
show errors;
/
create or replace package body mails6 is
h_id header.id%TYPE;
h_name people.email%TYPE;
h_email people.email%TYPE;
h_rid rowid;
h_msg_date header.msg_date%TYPE;
h_msgid header.msg_id%TYPE;
h_msg_id header.msg_id%TYPE;
h_subject header.subject%TYPE;
h_sender header.sender%TYPE;
h_bytes header.bytes%TYPE;
urowid rowid;
summary integer := 0;
TYPE wordstype IS TABLE	OF varchar2(50) INDEX BY BINARY_INTEGER;
word_tab wordstype;
w_count BINARY_INTEGER;

fname folder.name%TYPE := 'All';
left constant varchar2(60) := '<img src="/images/left.gif" border=0 width=18 height=20>';
right constant varchar2(60) := '<img src="/images/right.gif" border=0 width=18 height=20>';
highlight varchar2(200) := NULL;
lo header.id%TYPE := 0;
hi header.id%TYPE := 500*maxmsg;

procedure home(fid number) is
i varchar2(6);
j integer;
begin
	htp.title('Daily USENET Newsgroups Articles');
	i := to_char(sysdate,'ddmmyy');
	j := to_char(sysdate,'mm');
	htp.p('<frameset rows="50%,50%">');
	htp.p('<frameset cols="33%,67%">');
	htp.p('<frame src="'||cgi_bin||'mails6.by_date?this_month='||j||'&fid='||fid||'" name="left">');
	htp.p('<frame src="'||cgi_bin||'mails6.by_a_date?this='||i||'&fid='||fid||'" name="right">');
	htp.p('</frameset>');
	htp.p('<frame src="'||help_html||'" name="right2">');
	htp.p('</frameset>');
	htp.p('<noframes> If your web browser does not support <b>Frame</b>,<br>');
	htp.p('use this '||htf.url(cgi_bin||'mails6.by_date?this_month='||j||'&fid='||fid,'link')||' </noframes>'); 
end;

procedure entry is
begin
	htp.p('<body bgcolor="#EEEEEE">');
	htp.p('<p><center>Message text will be displayed here.</center>');
end;

procedure by_date(this_month integer,fid number,op integer) is
begin
	summary := op;
	by_date(this_month,fid);
end;

/* full verison */
procedure by_date(this_month integer,fid number) is
month varchar2(9);
year varchar2(2);
day varchar2(6);
offset integer;
i integer;
counter integer;
last integer;
now date;
j integer;
to_month integer;
today integer := to_char(sysdate,'dd');
anchor varchar2(40);

total1 number(8);
total number(10) := 0;

cursor cdate(date1 date, date2 date, loo number,hii number) is select 
	to_char(msg_date,'dd'),count(*) from header 
	where (id between loo and hii) and (msg_date between date1 and date2)
		group by to_char(msg_date,'dd') order by 1;

TYPE counttabtype is table of folder.n_msg%TYPE index by binary_integer;
count_index counttabtype;

begin

	htp.p('<header>');
	htp.title('Daily USENET articles in this month');
	htp.p('</header><body>');

	to_month := to_char(sysdate,'mm');

	now := to_date('01 '||this_month||' '||to_char(sysdate,'yy'),'dd mm yy');
	month := to_char(now,'Month');
	year := to_char(now,'YY');

	if (fid != 0) then
		lo := maxmsg*(fid - 1)+1;
		hi := lo + maxmsg - 1;
	end if;


	for i in 1..31 loop
		count_index(i) := 0;
	end loop;

	open cdate(to_date('01'||this_month,'ddmm'),to_date('01'||(this_month+1),'ddmm'),lo,hi);
	loop
		fetch cdate into j,total1;
		exit when cdate%NOTFOUND;
		count_index(j) := total1;
		total := total + total1;
	end loop;
	close cdate;


--	i := (summary+1) mod 2;
	htp.p('<center><table border=0 cellpadding=0 cellspacing=0 width=100%>'); -- header
	htp.p('<tr>');
	if (this_month != 1) then
		htp.p('<td align=left>'||htf.url(cgi_bin||'mails6.by_date?this_month='||(this_month-1)||
		'&fid='||fid||'&op='||summary,left)||'</td>');
	else
		htp.p('<td align=left>'||left||'</td>');
	end if;
	if (summary = 0) then
		htp.p('<td align=center><b>'||htf.url(cgi_bin||'mails6.by_date?this_month='||this_month||
		'&fid='||fid||'&op=1',month||' '||year)||'</b></td>');
	else
		htp.p('<td align=center><b>'||htf.url(cgi_bin||'mails6.by_date?this_month='||this_month||
		'&fid='||fid||'&op=0',month||' '||year)||'<font size="-1"> <tt>('||total
		||')</tt></font></b></td>');
	end if;

	if (this_month < to_month) then
		htp.p('<td align=right>'||htf.url(cgi_bin||'mails6.by_date?this_month='||(this_month+1)||
		'&fid='||fid||'&op='||summary,right)||'</td>');
	else
		htp.p('<td align=right>'||right||'</td>');
	end if;
	htp.p('</tr>');
		
	-- the actual table starts here 
	htp.p('<tr align=center><td colspan=3><table border=1 cellspacing=0 cellpadding=0 width=100%>');
	htp.p('<tr align=center><td><font color="#ff000">Sun</font></td><td>Mon</td><td>Tue</td><td>Wed</td><td>Tue</td><td>Fri</td><td>Sat</td></tr>');
	offset := to_char(to_date('01 '||month,'DD MONTH'),'D');

	htp.p('<tr align=center>');
	for i in 1..(offset-1) loop
		htp.p('<td> </td>');
	end loop;
	last := to_char(last_day(now),'DD');
	counter := offset;


	for i in 1..last loop
		anchor := i;
		if (counter = 1) then
			anchor := '<font color="#ff000">'||anchor||'</font>';
		end if;

		if ((this_month < to_month) or ((this_month = to_month) and (i <= today))) then
			day := to_char(i,'FM09')||to_char(this_month,'FM09')||year;
			
			if ((this_month = to_month) and (i = today)) then
				anchor := '<blink>'||i||'</blink>';
			end if;

			if (count_index(i) = 0) then
				htp.p('<td>'||anchor||'</td>');
			else
				if (summary = 0) then
					htp.p('<td>'||htf.url_right(cgi_bin||'mails6.by_a_date?this='||day
						||'&fid='||fid,anchor)||'</td>');
				else
					htp.p('<td>'||htf.url_right(cgi_bin||'mails6.by_a_date?this='||day
						||'&fid='||fid,anchor)||
					 	'<font size="-1"><tt>('||count_index(i)||
						')</tt></font></td>');
				end if;
			end if;
		else
			htp.p('<td>'||anchor||'</td>');
		end if;
		if (mod(counter,7) = 0) then
			if (i = last) then
				htp.p('</tr>');
			else
				htp.p('</tr><tr align=center>');
			end if;
			counter := 0;
		end if;
		counter := counter + 1;	
	end loop;		
	if (counter != 1) then
		for i in counter..7 loop
			htp.p('<td> </td>');
		end loop;
		htp.p('</tr>');
	end if;
	htp.p('</table></td></tr>'); -- the actual table ends here

	htp.p('<tr align=center><td colspan=3>');
	day := to_char(today,'FM09')||to_char(to_month,'FM09')||year;
	htp.p('<font size="-1"><center>'||to_char(sysdate,'Day')||', '||htf.url_right(cgi_bin||'mails6.by_a_date?this='||
	day||'&fid='||fid,
		to_char(sysdate,'Month DD'))||'</center>');
	htp.p('</td></tr></table></center></font>');

	htp.p('<hr><font size="-1">');
	for i in 1..to_month loop
	    if (i != this_month) then
		htp.p(htf.url(cgi_bin||'mails6.by_date?this_month='||i||
		'&fid='||fid,to_char(to_date(i,'mm'),'Mon'))||' | ');
            else
		htp.p(to_char(to_date(i,'mm'),'Mon')||' | ');
	    end if;
	end loop;
	htp.p('</font>');
	search_index(fid,this_month);
end;

/* this is in the format 'ddmmyy' full version */
procedure by_a_date(this varchar2,fid number) is

cursor cdate(date1 date, date2 date, loo number,hii number) is select rowid,id,msg_date,subject,sender,bytes,msg_id 
		from header where (id between loo and hii) and (msg_date between date1 and date2)
		order by msg_date desc;

this_date date;
next_date date;
cmsgid header.msg_id%TYPE := '$$$junk$$$$';
total number(8) := 0;
begin
	htp.title('What people are talking on USENET in this month');
	htp.p('<body bgcolor="#EEEEEE">');
	this_date := to_date(this,'ddmmyy');
	next_date := this_date + 1;

	if (fid != 0) then
		lo := maxmsg*(fid - 1)+1;
		hi := lo + maxmsg - 1;
		select name into fname from folder where id=fid;
	end if;

	htp.p('<table border cellpadding=3 cellspacing=1 width=100% height=12%>');
	htp.p('<caption align=top><b>'||fname||' articles on '||to_char(this_date,'Day, Month DD')||'</b></cpation>');
	htp.p('<tr align=center>');
	htp.p('<th>'||htf.url(cgi_bin||'mails6.by_a_date?this='||this
		||'&op=1'||'&fid='||fid,'Subject')||'</th>');
	htp.p('<th>'||htf.url(cgi_bin||'mails6.by_a_date?this='||this
		||'&op=2'||'&fid='||fid,'Sender')||'</th>');
	htp.p('<th>Time</th>');

	open cdate(this_date,next_date,lo,hi);
	loop
		fetch cdate into h_rid,h_id,h_msg_date,h_subject,h_sender,h_bytes,h_msgid;
		exit when cdate%NOTFOUND;
		if (h_msgid != cmsgid) then
			header_list(h_rid,h_bytes,h_sender,h_subject,h_msg_date);
			cmsgid := h_msgid;
			total := total + 1;
		end if;
	end loop;
	htp.p('</table>');
	htp.p('<br>Total: '||total);
	close cdate;
	wow.sig;

end;

/* this is in the format 'ddmmyy' full version */
procedure by_a_date(this varchar2,op varchar2,fid number) is
cursor cdate1(date1 date, date2 date,loo number,hii number) is 
	select rowid,id,msg_date,replace(subject,'Re: '),sender,bytes,msg_id 
	from header where (id between loo and hii) and (msg_date between date1 and date2) 
	order by replace(lower(subject),'re: '),msg_date desc;

cursor cdate2(date1 date, date2 date,loo number,hii number) is 
	select rowid,id,msg_date,subject,sender,bytes,msg_id 
		from header where  (id between loo and hii) and (msg_date between date1 and date2)
		order by sender asc,msg_date desc;

this_date date;
next_date date;
--tname topic.name%TYPE;
g_subject header.subject%TYPE := '#';
cmsgid header.msg_id%TYPE := '$$$junk$$$$';
total number(8) := 0;
begin
	if (op = '0') then 
		by_a_date(this,fid);
		return;
	end if;

	htp.title('What people are talking on USENET this month');
	htp.p('<body bgcolor="#EEEEEE">');
	this_date := to_date(this,'ddmmyy');
	next_date := this_date + 1;

	if (fid != 0) then
		lo := maxmsg*(fid - 1)+1;
		hi := lo + maxmsg - 1;
		select name into fname from folder where id=fid;
	end if;

	htp.p('<table border cellpadding=3 cellspacing=1 width=100% height=12%>');
	htp.p('<caption align=top><b>'||fname||' articles on '||to_char(this_date,'Day, Month DD')||'</b></cpation>');
	htp.p('<tr align=center>');

	if (op = '1') then
		htp.p('<th>Subject</th>');
	else
		htp.p('<th>'||htf.url(cgi_bin||'mails6.by_a_date?this='||this
		||'&op=1'||'&fid='||fid,'Subject')||'</th>');
	end if;
	if (op = '2') then
		htp.p('<th>Sender</th>');
	else
		htp.p('<th>'||htf.url(cgi_bin||'mails6.by_a_date?this='||this
		||'&op=2'||'&fid='||fid,'Sender')||'</th>');
	end if;	
	htp.p('<th>'||htf.url(cgi_bin||'mails6.by_a_date?this='||this
		||'&op=0'||'&fid='||fid,'Time')||'</th>');

	if (op ='1') then
		-- order by subject
		open cdate1(this_date,next_date,lo,hi);
		loop
			fetch cdate1 into h_rid,h_id,h_msg_date,h_subject,h_sender,h_bytes,h_msgid;
			exit when cdate1%NOTFOUND;
			if (h_msgid != cmsgid) then
				if (h_subject = g_subject) then
					h_subject := '#';
				else
					g_subject := h_subject;
				end if;
				header_list1(h_rid,h_bytes,h_sender,h_subject,h_msg_date);
				cmsgid := h_msgid;
				total := total + 1;
			end if;
		end loop;
		close cdate1;
	elsif (op = '2') then
		-- order by sender
		open cdate2(this_date,next_date,lo,hi);
		loop
			fetch cdate2 into h_rid,h_id,h_msg_date,h_subject,h_sender,h_bytes,h_msgid;
			exit when cdate2%NOTFOUND;
			if (h_msgid != cmsgid) then
				header_list(h_rid,h_bytes,h_sender,h_subject,h_msg_date);
				cmsgid := h_msgid;
				total := total + 1;
			end if;
		end loop;
		close cdate2;
	end if;
	htp.p('</table>');
	htp.p('<br>Total: '||total);
	wow.sig;

end;

procedure header_list(id rowid,bytes number,
		sender varchar2,subject in out varchar2,msg_date date) is
h_name people.email%TYPE := NULL;
h_email people.email%TYPE;
cursor csender(sender varchar2) is SELECT name,email from people where email=sender;
begin
		subject := replace(subject,'&','&amp');
		subject := replace(subject,'<','&lt');
		subject := replace(subject,'>','&gt');
		subject := replace(subject,'"','&quot');	
		if (replace(subject,' ') IS NULL) then
			subject := '(no subject)';
		end if;
		if (sender IS NOT NULL) then
			open csender(sender);
			fetch csender into h_name,h_email;
			if (csender%NOTFOUND or (h_name IS NULL)) then
				h_name := h_email;
			end if;
			close csender;
		end if;
		htp.p('<tr align=left><td width="50%" nowrap>');
		if (highlight IS NULL) then
			htp.p(url_right(cgi_bin||'mails6.showbody?rid='||id,substr(subject,1,40))||'</td>');
			htp.p(td(substr(h_name,1,15))||td(to_char(msg_date,'hh24:mi'))||'</tr>');
		else
			htp.p(url_right(cgi_bin||'mails6.showbody?rid='||id||
				'&word='||highlight,substr(subject,1,40))||'</td>');
			htp.p(td(substr(h_name,1,15))||td(to_char(msg_date,'hh24:mi MM/DD'))||'</tr>');
		end if;
		
end;

procedure header_list1(id rowid,bytes number,
		sender varchar2,subject in out varchar2,msg_date date) is
h_name people.email%TYPE := NULL;
h_email people.email%TYPE;
cursor csender(sender varchar2) is SELECT name,email from people where email=sender;
begin
		subject := replace(subject,'&','&amp');
		subject := replace(subject,'<','&lt');
		subject := replace(subject,'>','&gt');
		subject := replace(subject,'"','&quot');	
		if (replace(subject,' ') IS NULL) then
			subject := '(no subject)';
		elsif (subject = '#') then
			subject := '<br>';
		end if;
		open csender(sender);
		fetch csender into h_name,h_email;
		if (csender%NOTFOUND or (h_name IS NULL)) then
			h_name := h_email;
		end if;
		close csender;

		htp.p('<tr align=left><td nowrap>'||substr(subject,1,40)||'</td>');
		htp.p('<td nowrap>'||url_right(cgi_bin||
			'mails6.showbody?rid='||id,substr(h_name,1,15))||'</td>');
		htp.p(td(to_char(msg_date,'hh24:mi'))||'</tr>');	
end;

function url_right (curl  in varchar2, cname   in varchar2) return varchar2 is
begin return('<a href="' || curl || '" TARGET="right2">' || cname || '</a>'); end;

function td(data varchar2) return varchar2 is
begin return('<td>'||data||'</td>'); end;

procedure showbody(rid in rowid, word in varchar2) is
begin
	highlight := word;
	showbody(rid);
end;

procedure showbody(rid in rowid) is
	bid header.id%TYPE;
	fid header.id%TYPE;
	fpath folder.path%TYPE;
	gname folder.name%TYPE;
	n header.id%TYPE;
	i header.id%TYPE;
	j header.id%TYPE;
	k header.id%TYPE;
	body_all long;
	tmp long;
	h_cc header.cc%TYPE;
	h_receiver header.receiver%TYPE;
	h_replied_id header.replied_id%TYPE;
	url varchar2(254);
	n1 header.id%TYPE;
	m header.id%TYPE;	
	cursor reply(low_id number,high_id number,repid varchar2) is
		select rowid from header where (id between low_id and high_id) 
		and (msg_id = repid);
	cursor cbody(rid number) is
		select id,BODY_TYPE,CHARS,WORDS,LINES,msg_body1,msg_body2,
			msg_body3,msg_body4,msg_body5,msg_body6,
			msg_body7,msg_body8,msg_body9,msg_body10,msg_body11
			from body where id=rid;		
	cursor creply(low_id number,high_id number,repid varchar2) is
		select rowid,sender from header where (id between low_id and high_id) 
		and (replied_id = repid) order by msg_date asc;
	cursor cname(csender varchar2) is SELECT name from people where email=csender;
	body_rec body%ROWTYPE;
	min_id header.id%TYPE;
	replied_rid rowid;
	hword varchar2(200);
	word varchar2(200);

	begin

 	SELECT id,msg_date,subject,sender,receiver,cc,msg_id,replied_id into 
		bid,h_msg_date,h_subject,h_sender,h_receiver,h_cc,h_msg_id,h_replied_id
		from header where rowid = rid;
	SELECT name,email into h_name,h_email from people where email=h_sender;

	htp.p('<title>article body</title>');
	htp.p('<body bgcolor="#FFFFFF" background="/images/notebook.gif"><BLOCKQUOTE>');
	fid := floor(bid/maxmsg) + 1;
	select name,path into gname,fpath from folder where id = fid;

	open cbody(bid);
	fetch cbody into body_rec;
	if (cbody%FOUND) then
		body_all := body_rec.msg_body1||body_rec.msg_body2||
				body_rec.msg_body3||body_rec.msg_body4||body_rec.msg_body5||
				body_rec.msg_body6||body_rec.msg_body7||body_rec.msg_body8||
				body_rec.msg_body9||body_rec.msg_body10;
	else
		body_all := NULL;
	end if;
	close cbody;

	body_all := replace(body_all,'&','&amp');
	body_all := replace(body_all,'<','&lt');
	body_all := replace(body_all,'>','&gt');
	body_all := replace(body_all,'"','&quot'); 
	body_all := replace(body_all,'&ltbr&gt','');	
	body_all := replace(body_all,'\$','$'); --- left by the perl parser
	i := 1;
	m := instr(body_all,'http://',i,1);
	while ( m != 0) loop		
			tmp := substr(body_all,m);
			k := instr(tmp,' ');
			--- for both &gt and &quot
			n1 := instr(tmp,'&');	
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,')');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,',');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,'|');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,';');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,'''');
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			n1 := instr(tmp,chr(10));
			if ((k = 0) or ((n1 != 0) and (n1 < k)) ) then k := n1; end if;
			if (k != 0) then
				url := substr(tmp,1,k-1);
				body_all := substr(body_all,1,m-1)||htf.url(url,url)||substr(tmp,k);
				i := m + 2*length(url)+11;
			else
				i := m + 5;
			end if;
			m := instr(body_all,'http://',i,1);
	end loop;


	h_receiver := substr(h_receiver,1,150);
  	h_receiver := replace(h_receiver,'<','&lt');
        h_receiver := replace(h_receiver,'>','&gt');
        h_receiver := replace(h_receiver,'\$','$');

	if (h_cc IS NOT NULL) then
		h_cc := substr(h_cc,1,150);
		h_cc := replace(h_cc,'<','&lt');
        	h_cc := replace(h_cc,'>','&gt');
        	h_cc := replace(h_cc,'\$','$');
	end if;
	
	h_subject := substr(h_subject,1,150);
	h_subject := replace(h_subject,'\$','$');
	h_subject := replace(h_subject,'&','&amp');
	h_subject := replace(h_subject,'<','&lt');
	h_subject := replace(h_subject,'>','&gt');
	h_subject := replace(h_subject,'"','&quot');	

	htp.p('<center><font size="+2">');
	m := (fid-1)*maxmsg + 1;
	n := m + maxmsg - 1;
	if (h_replied_id IS NULL) then
		htp.p(h_subject);
	else
		h_replied_id := replace(h_replied_id,chr(10));
		open reply(m,n,h_replied_id);
		fetch reply into replied_rid;	
		if (reply%NOTFOUND) then
			htp.p(h_subject);
		else
			htp.p(htf.url(cgi_bin||'MAILS6.showbody?rid='||replied_rid,
			h_subject));
		end if;
		close reply;
	end if;
	htp.p('</font></center>');

	if (h_name IS NULL) then
		h_name := h_email;
	end if;
	htp.p('<table border=0>');
	htp.p('<tr><td align="right">From:</td>');
	htp.p('<td>'||htf.url(cgi_bin||'MAILS5.by_people?uid='||
		h_email,h_email)||' ('||h_name||')</td></tr>'); 
	htp.p('<tr><td align="right">To:</td>');
	htp.p('<td>'||htf.url(cgi_bin||'MAILS5.folderinfo?fid='||fid,h_receiver)||'</td></tr>');
--	htp.p('<td>'||h_receiver||'</td></tr>');
	if (h_cc IS NOT NULL) then 
		htp.p('<tr><td align="right">Cc:</td>');
		htp.p('<td>'||h_cc||'</td></tr>'); 
	end if;
	htp.p('<tr><td align="right">Date:</td>');
	htp.p('<td>'||to_char(h_msg_date,'Mon dd yyyy hh24:mi')||'</td></tr>');

	open creply(m,n,h_msg_id);
	fetch creply into urowid,h_sender;
	if (creply%FOUND) then
		htp.p('<tr><td align="right">Replied-by:</td><td>');
		loop
			open cname(h_sender);
			fetch cname into h_name;
			if (cname%NOTFOUND) then
				h_name := h_sender;
			end if;
			close cname;
			if (creply%ROWCOUNT > 1) then
				htp.p(', ');
			end if;
			htp.p(htf.url(cgi_bin||'MAILS6.showbody?rid='||urowid,h_name));
			fetch creply into urowid,h_name;
			exit when creply%NOTFOUND;
		end loop;
		close creply;
		htp.p('</td></tr>');
	end if;		

	htp.p('</table>'||htf.line||'<pre>');

	-- highlight keywords
 	if (highlight IS NOT NULL) then
		loop
			k := instr(highlight,' ');
			exit when k=0;
			word := substr(highlight,1,k-1);
			highlight := substr(highlight,k+1);
			hword := '<font color="#ff000">'||word||'</font>';
			body_all := replace(body_all,word,hword);
			body_all := replace(body_all,upper(word),hword);
			body_all := replace(body_all,INITCAP(word),hword);
		end loop;
		hword := '<font color="#ff000">'||highlight||'</font>';
		body_all := replace(body_all,highlight,hword);
		body_all := replace(body_all,upper(highlight),hword);
		body_all := replace(body_all,INITCAP(highlight),hword);
	end if;

	htp.bp(body_all);

	body_all := body_rec.msg_body11;
	if (body_all IS NOT NULL) then
		htp.bp(body_all);
	end if;

	htp.p('</pre><center>');	
	htp.p(htf.line);

		h_subject := 'Re: '||h_subject;
		htp.p('<a href="mailto:'||h_email||'?subject='||h_subject||'">');
		htp.p('<IMG BORDER=0 SRC="/images/reply.gif"></A>');
		htp.p('<a href="mailto:'||h_receiver||'?subject='||h_subject||'">');
                htp.p('<IMG BORDER=0 SRC="/images/preply.gif"></A>');
                if (h_cc IS NOT NULL) then
            		htp.p('<a href="mailto:'||h_receiver||','||h_email||','||
               		 h_cc||'?subject='||h_subject||'">');
            	else
                	htp.p('<a href="mailto:'||h_receiver||','||h_email||
			'?subject='||h_subject||'">');
            	end if;
            	htp.p('<IMG BORDER=0 SRC="/images/mpreply.gif"> </A>');
		htp.p('<a href="mailto:">');
		htp.p('<IMG BORDER=0 SRC="/images/post.gif"></a>');

	htp.p('<HR WIDTH="50%" ALIGN="CENTER">');

	htp.p('</center></BLOCKQUOTE>');
	wow.sig;

  exception
	when NO_DATA_FOUND then
		htp.p(htf.line);
		wow.sig;	
end;

procedure index_home is
cursor list is select id,name,n_msg from folder order by name;
fid folder.id%TYPE;
tname  folder.name%TYPE;
total number(8);

begin

	htp.p('<header>');
	htp.title('Daily USENET Newsgroups Articles');
	htp.p('</header><body>');

	htp.p('<center><table border=1 cellpadding=3 cellspacing=1 width=80%>'); -- header
	htp.p('<caption align=top><font size="+1"><b>Daily USENET Newsgroups Articles</b></font></caption>');
	htp.p('<tr><th>Newsgroup</th><th>Messages</th>');
	open list;
	loop
		fetch list into fid,tname,total;
		exit when list%NOTFOUND;
		htp.p('<tr align=left>'||td(htf.url(cgi_bin||'mails6.home?fid='||fid,tname))||td(total));
	end loop;
	close list;
	select sum(n_msg) into total from folder;
	tname := 'All';
	htp.p('<tr valign=top align=left>'||td(htf.url(cgi_bin||'mails6.home?fid=0',tname))||td(total));
	htp.p('</table></body></html>');

	hypermail.copyright;
end;

procedure search_index(fid number,month integer) is
begin
	htp.p('<form action="'||cgi_bin||'mails6.keyword'||'" TARGET="right" METHOD="POST">');
	htp.p('<input type="hidden" name="month" value="'||month||'">');
	htp.p('<input type="hidden" name="fid" value="'||fid||'">');
        htp.p('<font size="-1"><b>Search in '||
		to_char(to_date(to_char(month,'FM09')||to_char(sysdate,'YY'),'mmyy'),'Month')||'</b></font>');
	htp.p('<br><input name="typein" value="" size=18><font size="-1"><input type="submit" value="Go!"></font>');
	htp.p(htf.formClose);
	htp.p('<hr>');
	htp.p(url_right(help_html,'Help')||' | '||htf.url_top(root_url,'Home'));
end;


procedure keyword(typein varchar2,fid number,month integer) is
cursor cbody(wordin varchar2,lo number,hi number,date1 date, date2 date) is 
	SELECT h.rowid,h.msg_date,h.subject,h.sender,h.bytes,h.msg_id,b.rowid
	from header h, body b where 
	(h.id between lo and hi) and (h.msg_date between date1 and date2) and
	(h.id=b.id) and
	(lower(msg_body1) like wordin or 
	 lower(msg_body2) like wordin or
	lower(msg_body3) like wordin or
	lower(msg_body4) like wordin or
	lower(msg_body5) like wordin or
	lower(msg_body6) like wordin or
	lower(msg_body7) like wordin or
	lower(msg_body8) like wordin or
	lower(msg_body9) like wordin or
	lower(msg_body10) like wordin )
	order by h.msg_date desc; 

k integer;
ii BINARY_INTEGER;
body_all long;
body_rec body%ROWTYPE;
n number(6) := 0;
lo header.id%TYPE := 1;
hi header.id%TYPE := 500*maxmsg;
f_name folder.name%TYPE := url_right(cgi_bin||'MAILS5.showmailbox','All folders');
browid rowid;
found boolean := true;
prev header.msg_id%TYPE := ' ';
total folder.n_msg%TYPE;
date1 date;
date2 date;
begin
	htp.title('Keyword Search Results');
	htp.p('<body bgcolor="#EEEEEE">');
	parse_typein(typein);
	if (w_count = 0) then
		htp.p('<p><center>You must choose a word to start the keyword search. Try again.</center>');	
		return;
	end if;
	date1 := to_date('01'||month,'ddmm');
	date2 := to_date('01'||(month+1),'ddmm');
	if (fid != 0) then
		lo := (fid-1)*maxmsg + 1;
		hi := lo + maxmsg - 1;
		SELECT name into f_name from folder where id = fid;
		f_name := url_right(cgi_bin||'MAILS5.folderinfo?fid='||fid,f_name);
	end if;
	select count(*) into total from header where (id between lo and hi) and
		(msg_date between date1 and date2);

	htp.p('<center><table border=1 cellpadding=0 cellspacing=0 width=100%>');
	htp.p('<caption><font size="+1">Keyword (<i>'||htf.bold(highlight)||'</i>) Search in ');
	htp.p(f_name||', '||to_char(to_date(month,'mm'),'Month YY')||'</font></caption>');
	htp.p('<tr align=center><th>Subject</th><th>Sender</th><th>Date</th></tr>');	
	open cbody('%'||word_tab(1)||'%',lo,hi,date1,date2);
	if (w_count != 1) then
		loop
			fetch cbody into urowid,h_msg_date,h_subject,h_sender,h_bytes,h_msg_id,browid;
			exit when cbody%NOTFOUND;
			if (h_msg_id != prev) then
				prev := h_msg_id;
				select * into body_rec from body where rowid=browid;
				body_all := body_rec.msg_body1||body_rec.msg_body2||
				body_rec.msg_body3||body_rec.msg_body4||body_rec.msg_body5||
				body_rec.msg_body6||body_rec.msg_body7||body_rec.msg_body8||
				body_rec.msg_body9||body_rec.msg_body10;
				found := true;
				for ii in 2..w_count loop
					k := instr(lower(body_all),word_tab(ii));
					if (k = 0) then 
						found := false;
						exit; 
					end if;
				end loop;
				if (found) then 
					n := n + 1;
					header_list(urowid,h_bytes,h_sender,h_subject,h_msg_date);	
				end if;
			end if;
		end loop;
	else
		loop
			fetch cbody into urowid,h_msg_date,h_subject,h_sender,h_bytes,h_msg_id,browid;
			exit when cbody%NOTFOUND;
			if (h_msg_id != prev) then
				prev := h_msg_id;
				n := n + 1;
				header_list(urowid,h_bytes,h_sender,h_subject,h_msg_date);	
			end if;
		end loop;
	end if;
	htp.p('<tr align=center><td>Found: <b>'||n||'</b></td><td>Keyword: <i>'||htf.bold(highlight)||
		'</i></td><td>Searched: <b>'||total||'</b></td></tr>');
	close cbody;
	htp.p('</table>');	
end;

procedure parse_typein(typein varchar2) is
words varchar2(300);
i integer;
begin
	w_count := 0;
	words := typein;
	loop
		while ((words IS NOT NULL) and (substr(words,1,1) = ' ')) loop
			words := substr(words,2);
		end loop;
		if (words IS NULL) then
			exit;
		end if;

		w_count := w_count + 1;
		i := instr(words,' ');
		if (i = 0) then
			word_tab(w_count) := lower(words);
			if (highlight IS NULL) then
				highlight := word_tab(w_count);
			else
				highlight := highlight||'+'||word_tab(w_count);
			end if;
			exit;
		else
			word_tab(w_count) := lower(substr(words,1,i-1));
			if (highlight IS NULL) then
				highlight := word_tab(w_count);
			else
				highlight := highlight||'+'||word_tab(w_count);
			end if;
			words := substr(words,i+1);
		end if;
	end loop;
end;



end mails6;
/
show errors;
/
