
drop table mailbox;	
create table mailbox (
 	name char(100),
 	path varchar2(200),
 	owner varchar2(100),
 	n_folder number(5),
 	creation_time date,
 	logo char(200),
	visitors number(8),
	urls number(8)
);

drop table folder;
create table folder (
        id number(8) constraint pk_fid primary key,
        name varchar2(200),
        path varchar2(200) constraint unq_path UNIQUE,
        max_msgid number(9),
	min_msgid number(9),
        n_msg number(8),
        creation_time date,
	description varchar2(2000),
        logo varchar2(200)
);

drop table header;
create table header (
       	 	id number(9) constraint pk_hid primary key,
       	 	msg_date date constraint nn_date not null,
      	 	subject varchar2(400),
      	  	sender varchar2(100) constraint nn_sender not null,
        	receiver varchar2(2000),
		msg_id varchar2(200) constraint nn_msgid not null,
        	bytes number(8),
        	cc varchar2(1000) default null,
        	type varchar2(8) default null,
        	body_type varchar2(20) default null,
        	replied_id varchar2(200) default null
) 
storage (initial 5M next 1M minextents 1 maxextents 100 pctincrease 5);

REM index to be enabled after data loaded
REM create index i_header_date on header(msg_date);
REM create index i_header_sender on header(sender);

drop table body;
create table body (
        	id number(9) constraint pk_bid primary key,
        	body_type varchar2(20),
        	chars number(8),
        	words number(8),
        	lines number(8),
        	msg_body1 varchar2(2000),
        	msg_body2 varchar2(2000),
        	msg_body3 varchar2(2000),
        	msg_body4 varchar2(2000),
        	msg_body5 varchar2(2000),
        	msg_body6 varchar2(2000),
    		msg_body7 varchar2(2000),
		msg_body8 varchar2(2000),
	    	msg_body9 varchar2(2000),
     		msg_body10 varchar2(2000),
		msg_body11 long
)
storage (initial 40M next 2M minextents 1 maxextents 100 pctincrease 5);

drop table people;
create table people (
	email varchar2(100) constraint pk_email primary key,
	name varchar2(50),
	userid varchar2(50),
	msg_received number(9),
	html varchar2(100),
	creation_time date
	);

drop table subject;
create table subject (
        word varchar2(30) constraint pk_word primary key,
        msg_id number(9),
        count number(8),
        creation_time date
        );

drop table visitor;
CREATE TABLE visitor (
       	 	visit_time date,
        	REMOTE_HOST varchar2(70),
        	REMOTE_ADDR varchar2(20),
        	REMOTE_USER varchar2(100)
);

drop table url;
create table url (
        id number(8) constraint pk_urlid primary key,
        html    varchar2(150) constraint pk_html unique,
        head_id varchar2(2000)
);

drop table domain;
create table domain (
        code varchar2(4) constraint pk_code primary key,
        name varchar2(50),
	urls number(8) default 0
);

