
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned long magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* Object support */
struct sqltvn
{
  unsigned char *tvnvsn; 
  unsigned short tvnvsnl; 
  unsigned char *tvnnm;
  unsigned short tvnnml; 
  unsigned char *tvnsnm;
  unsigned short tvnsnml;
};
typedef struct sqltvn sqltvn;

struct sqladts
{
  unsigned int adtvsn; 
  unsigned short adtmode; 
  unsigned short adtnum;  
  sqltvn adttvn[1];       
};
typedef struct sqladts sqladts;

static struct sqladts sqladt = {
  1,0,0,
};

/* Binding to PL/SQL Records */
struct sqltdss
{
  unsigned int tdsvsn; 
  unsigned short tdsnum; 
  unsigned char *tdsval[1]; 
};
typedef struct sqltdss sqltdss;
static struct sqltdss sqltds =
{
  1,
  0,
};

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[7];
};
static struct sqlcxp sqlfpn =
{
    6,
    "ser.pc"
};


static unsigned long sqlctx = 4827;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   occurs;
            short *cud;
   unsigned char  *sqlest;
            char  *stmt;
   sqladts *sqladtp;
   sqltdss *sqltdsp;
            void  **sqphsv;
   unsigned int   *sqphsl;
            int   *sqphss;
            void  **sqpind;
            int   *sqpins;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned short  *sqpadto;
   unsigned short  *sqptdso;
            void  *sqhstv[8];
   unsigned int   sqhstl[8];
            int   sqhsts[8];
            void  *sqindv[8];
            int   sqinds[8];
   unsigned int   sqharm[8];
   unsigned int   *sqharc[8];
   unsigned short  sqadto[8];
   unsigned short  sqtdso[8];
} sqlstm = {10,8};

/* SQLLIB Prototypes */
extern sqlcxt (/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlcx2t(/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlbuft(/*_ void **, char * _*/);
extern sqlgs2t(/*_ void **, char * _*/);
extern sqlorat(/*_ void **, unsigned long *, void * _*/);

/* Forms Interface */
static int IAPSUCC = 0;
static int IAPFAIL = 1403;
static int IAPFTL  = 535;
extern void sqliem(/*_ char *, int * _*/);

typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* CUD (Compilation Unit Data) Array */
static short sqlcud0[] =
{10,4112,0,27,0,
5,0,0,1,36,0,1,113,0,0,0,0,0,1,0,
20,0,0,2,41,0,4,124,0,0,1,0,0,1,0,2,9,0,0,
39,0,0,3,58,0,4,126,0,0,1,0,0,1,0,2,3,0,0,
58,0,0,4,74,0,4,134,0,0,2,1,0,1,0,2,3,0,0,1,3,0,0,
81,0,0,5,0,0,29,143,0,0,0,0,0,1,0,
96,0,0,6,36,0,1,145,0,0,0,0,0,1,0,
111,0,0,7,117,0,4,159,0,0,7,0,0,1,0,2,9,0,0,2,3,0,0,2,9,0,0,2,9,0,0,2,9,0,0,2,
3,0,0,2,3,0,0,
154,0,0,8,133,0,4,165,0,0,8,1,0,1,0,2,9,0,0,2,3,0,0,2,9,0,0,2,9,0,0,2,9,0,0,2,
3,0,0,2,3,0,0,1,3,0,0,
201,0,0,9,63,0,5,172,0,0,1,1,0,1,0,1,9,0,0,
220,0,0,10,0,0,29,229,0,0,0,0,0,1,0,
235,0,0,11,47,0,5,265,0,0,0,0,0,1,0,
250,0,0,12,0,0,29,266,0,0,0,0,0,1,0,
265,0,0,13,36,0,1,331,0,0,0,0,0,1,0,
280,0,0,14,65,0,5,336,0,0,2,2,0,1,0,1,3,0,0,1,9,0,0,
303,0,0,15,65,0,5,343,0,0,2,2,0,1,0,1,3,0,0,1,9,0,0,
326,0,0,16,65,0,5,350,0,0,2,2,0,1,0,1,3,0,0,1,9,0,0,
349,0,0,17,0,0,29,356,0,0,0,0,0,1,0,
364,0,0,18,0,0,27,435,0,0,4,4,0,1,0,1,9,0,0,1,10,0,0,1,10,0,0,1,10,0,0,
395,0,0,19,36,0,1,437,0,0,0,0,0,1,0,
410,0,0,20,43,0,5,438,0,0,0,0,0,1,0,
425,0,0,21,0,0,29,439,0,0,0,0,0,1,0,
440,0,0,22,36,0,1,488,0,0,0,0,0,1,0,
455,0,0,23,62,0,5,494,0,0,2,2,0,1,0,1,9,0,0,1,9,0,0,
478,0,0,24,62,0,5,503,0,0,2,2,0,1,0,1,9,0,0,1,9,0,0,
501,0,0,25,62,0,5,511,0,0,2,2,0,1,0,1,9,0,0,1,9,0,0,
524,0,0,26,0,0,30,526,0,0,0,0,0,1,0,
};


#ifdef RCSID
static char *RCSid='costamcostam';
#endif
#define TXRAPP
#define OK 0
#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <ctype.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/mode.h>
#include <sys/msg.h>
#include <sys/sem.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <unistd.h>
#include <sys/stat.h>

#define URL 2
#define NEXT 3
/*char filename[] = "/oracle/usr/grid/load/tmp2/urls.tmp";
char logfile[] = "/oracle/usr/grid/load/tmp2/load.log";
char command[] = "ctxload.sh >> /oracle/usr/grid/load/tmp2/aixterm.log";
*/

char filename[80],logfile[80],command[80];
char USR_PWD[80];

char chr_dep[5];

/* EXEC SQL INCLUDE sqlca;
 */ 
/*
 * $Header: sqlca.h,v 1.3 1994/12/12 19:27:27 jbasu Exp $ sqlca.h 
 */

/* Copyright (c) 1985,1986, 1998 by Oracle Corporation. */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  **************************************************************
  ***                                                        ***
  *** This file is SOSD.  Porters must change the data types ***
  *** appropriately on their platform.  See notes/pcport.doc ***
  *** for more information.                                  ***
  ***                                                        ***
  **************************************************************

  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    lvbcheng   07/31/98 -  long to int
    jbasu      12/12/94 -  Bug 217878: note this is an SOSD file
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
         /* b4  */ int     sqlabc;
         /* b4  */ int     sqlcode;
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
         /* b4  */ int     sqlerrd[6];
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */


/* key used for IPC initialization  */
static long key=989690581l;
static int URL_QUEUE_SIZE=5000;

struct url_str
{
  long  fid;
  long  hid;
  int   depth;
  char  prot[10];
  char  host[60];
  char  path[512];
};

  struct messagebuf
  {
    long msgid;
    long fid;
    long hid_flag;
    long depth;
/*    long host_offset;
    long path_offset;
    char msg[255];*/
	char prot[10];
	char host[60];
	char path[512];
};

/*union semun {
            int val;
            struct semid_ds *buf;
            ushort *array;
          	} arg;*/

int shmid;  /* shared memory identifier */
int msgid, msgida;  /* message queue identifier */
int semid;  /* semaphore identifier     */

void ser_handler();

/*# This procedure sends passed in argument number of url to gathering program
# It also marks these urls as send ( flag 1)
*/

send_addrs(int number)
{
  struct messagebuf  mb={0,0,0,0,"","",""};
  int urlnum, i, j;
  struct msqid_ds arg;

  /* EXEC SQL BEGIN DECLARE SECTION; */ 

/*	VARCHAR hostname[120][255];
	VARCHAR pathname[120][255];
	VARCHAR protname[120][255];
	VARCHAR url_rowid[120][255];
	long h_id[120];
	int depth[120];
	long f_id[120];*/
	/* VARCHAR hostname[60]; */ 
struct { unsigned short len; unsigned char arr[60]; } hostname;

	/* VARCHAR pathname[512]; */ 
struct { unsigned short len; unsigned char arr[512]; } pathname;

	/* VARCHAR protname[10]; */ 
struct { unsigned short len; unsigned char arr[10]; } protname;

	/* VARCHAR url_rowid[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } url_rowid;

	long h_id;
	int depth;
	long f_id;
	int total;
	/* VARCHAR link_dep[5]; */ 
struct { unsigned short len; unsigned char arr[5]; } link_dep;

	int url_dep;
  /* EXEC SQL END DECLARE SECTION; */ 


  /* EXEC SQL LOCK TABLE search_urls IN SHARE MODE; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 0;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.stmt = "lock TABLE search_urls IN SHARE MODE";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )5;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


 /* EXEC SQL DECLARE initurl CURSOR FOR 
           SELECT rowid, host_id, prot, host, path, depth, fid 
 		   FROM search_urls 
		   WHERE flag='0'
		   AND ((depth < url_dep) OR (host = 'www.erc.msstate.edu')
			OR (host = 'www-users.informatik.rwth-aachen.de'));*/
		  
/*		   ORDER BY PRIORITY DESC;*/
  /*printf("send_addr\n");*/
  while(1) {
	/* EXEC SQL SELECT depth INTO :link_dep FROM robot_config; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 1;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select depth into :b0  from robot_config ";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )20;
 sqlstm.selerr = (unsigned short)0;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&link_dep;
 sqlstm.sqhstl[0] = (unsigned int  )7;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	if (link_dep.len == 0) 
		/* EXEC SQL SELECT count(*) INTO :total FROM search_urls
			 WHERE flag='0'; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 1;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.stmt = "select count(*)  into :b0  from search_urls where flag='0'";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )39;
  sqlstm.selerr = (unsigned short)0;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlstm.sqhstv[0] = (         void  *)&total;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)0;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	else {
		url_dep = 0;
/*		for (i=0; i<link_dep.len; i++)
			url_dep = (url_dep * 10) + atoi(link_dep.arr[i]);
*/
		url_dep = atoi((char *)link_dep.arr);
		/* EXEC SQL SELECT count(*) INTO :total FROM search_urls
			 WHERE flag='0'
			 AND (depth < :url_dep); */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 2;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.stmt = "select count(*)  into :b0  from search_urls where (flag='0'\
 and depth<:b1)";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )58;
  sqlstm.selerr = (unsigned short)0;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlstm.sqhstv[0] = (         void  *)&total;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)0;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqhstv[1] = (         void  *)&url_dep;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqhsts[1] = (         int  )0;
  sqlstm.sqindv[1] = (         void  *)0;
  sqlstm.sqinds[1] = (         int  )0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqadto[1] = (unsigned short )0;
  sqlstm.sqtdso[1] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	}
/*			   OR host='www.erc.msstate.edu'
			   OR host='www-users.informatik.rwth-aachen.de');*/
	if ( total > number )  
		total=number;
        if ( total==0 ) {
           /* EXEC SQL COMMIT; */ 

{
           struct sqlexd sqlstm;

           sqlstm.sqlvsn = 10;
           sqlstm.arrsiz = 2;
           sqlstm.sqladtp = &sqladt;
           sqlstm.sqltdsp = &sqltds;
           sqlstm.iters = (unsigned int  )1;
           sqlstm.offset = (unsigned int  )81;
           sqlstm.cud = sqlcud0;
           sqlstm.sqlest = (unsigned char  *)&sqlca;
           sqlstm.sqlety = (unsigned short)256;
           sqlstm.occurs = (unsigned int  )0;
           sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	   sleep(20);
	   /* EXEC SQL LOCK TABLE search_urls IN SHARE MODE; */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 10;
    sqlstm.arrsiz = 2;
    sqlstm.sqladtp = &sqladt;
    sqlstm.sqltdsp = &sqltds;
    sqlstm.stmt = "lock TABLE search_urls IN SHARE MODE";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )96;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)256;
    sqlstm.occurs = (unsigned int  )0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


           continue;
        }
/*    EXEC SQL WHENEVER NOTFOUND GOTO notfound;*/
/*    EXEC SQL OPEN initurl;*/
/*	for (i=0; i<total; i++) 
*/
	{
/*    EXEC SQL WHENEVER NOTFOUND GOTO notfound;*/
/*	  EXEC SQL FETCH initurl*/
/*		INTO :url_rowid[i], :h_id[i], :protname[i], :hostname[i], 
		:pathname[i], :depth[i], :f_id[i];
		printf("host = %s h_id = %d\n", (char *)hostname[i].arr,h_id[i]);*/
	if (link_dep.len ==0 )
	   /* EXEC SQL SELECT rowid, host_id, prot, host, path, depth, fid 
 		INTO :url_rowid, :h_id, :protname, :hostname, 
			:pathname, :depth, :f_id
		FROM search_urls 
		WHERE flag='0'; */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 10;
    sqlstm.arrsiz = 7;
    sqlstm.sqladtp = &sqladt;
    sqlstm.sqltdsp = &sqltds;
    sqlstm.stmt = "select rowid ,host_id ,prot ,host ,path ,depth ,fid into \
:b0,:b1,:b2,:b3,:b4,:b5,:b6  from search_urls where flag='0'";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )111;
    sqlstm.selerr = (unsigned short)0;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)256;
    sqlstm.occurs = (unsigned int  )0;
    sqlstm.sqhstv[0] = (         void  *)&url_rowid;
    sqlstm.sqhstl[0] = (unsigned int  )257;
    sqlstm.sqhsts[0] = (         int  )0;
    sqlstm.sqindv[0] = (         void  *)0;
    sqlstm.sqinds[0] = (         int  )0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqadto[0] = (unsigned short )0;
    sqlstm.sqtdso[0] = (unsigned short )0;
    sqlstm.sqhstv[1] = (         void  *)&h_id;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqhsts[1] = (         int  )0;
    sqlstm.sqindv[1] = (         void  *)0;
    sqlstm.sqinds[1] = (         int  )0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqadto[1] = (unsigned short )0;
    sqlstm.sqtdso[1] = (unsigned short )0;
    sqlstm.sqhstv[2] = (         void  *)&protname;
    sqlstm.sqhstl[2] = (unsigned int  )12;
    sqlstm.sqhsts[2] = (         int  )0;
    sqlstm.sqindv[2] = (         void  *)0;
    sqlstm.sqinds[2] = (         int  )0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqadto[2] = (unsigned short )0;
    sqlstm.sqtdso[2] = (unsigned short )0;
    sqlstm.sqhstv[3] = (         void  *)&hostname;
    sqlstm.sqhstl[3] = (unsigned int  )62;
    sqlstm.sqhsts[3] = (         int  )0;
    sqlstm.sqindv[3] = (         void  *)0;
    sqlstm.sqinds[3] = (         int  )0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqadto[3] = (unsigned short )0;
    sqlstm.sqtdso[3] = (unsigned short )0;
    sqlstm.sqhstv[4] = (         void  *)&pathname;
    sqlstm.sqhstl[4] = (unsigned int  )514;
    sqlstm.sqhsts[4] = (         int  )0;
    sqlstm.sqindv[4] = (         void  *)0;
    sqlstm.sqinds[4] = (         int  )0;
    sqlstm.sqharm[4] = (unsigned int  )0;
    sqlstm.sqadto[4] = (unsigned short )0;
    sqlstm.sqtdso[4] = (unsigned short )0;
    sqlstm.sqhstv[5] = (         void  *)&depth;
    sqlstm.sqhstl[5] = (unsigned int  )4;
    sqlstm.sqhsts[5] = (         int  )0;
    sqlstm.sqindv[5] = (         void  *)0;
    sqlstm.sqinds[5] = (         int  )0;
    sqlstm.sqharm[5] = (unsigned int  )0;
    sqlstm.sqadto[5] = (unsigned short )0;
    sqlstm.sqtdso[5] = (unsigned short )0;
    sqlstm.sqhstv[6] = (         void  *)&f_id;
    sqlstm.sqhstl[6] = (unsigned int  )4;
    sqlstm.sqhsts[6] = (         int  )0;
    sqlstm.sqindv[6] = (         void  *)0;
    sqlstm.sqinds[6] = (         int  )0;
    sqlstm.sqharm[6] = (unsigned int  )0;
    sqlstm.sqadto[6] = (unsigned short )0;
    sqlstm.sqtdso[6] = (unsigned short )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqphss = sqlstm.sqhsts;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqpins = sqlstm.sqinds;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlstm.sqpadto = sqlstm.sqadto;
    sqlstm.sqptdso = sqlstm.sqtdso;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	else	
	   /* EXEC SQL SELECT rowid, host_id, prot, host, path, depth, fid 
 		INTO :url_rowid, :h_id, :protname, :hostname, 
			:pathname, :depth, :f_id
		FROM search_urls 
		WHERE flag='0'
		AND (depth < :url_dep); */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 10;
    sqlstm.arrsiz = 8;
    sqlstm.sqladtp = &sqladt;
    sqlstm.sqltdsp = &sqltds;
    sqlstm.stmt = "select rowid ,host_id ,prot ,host ,path ,depth ,fid into \
:b0,:b1,:b2,:b3,:b4,:b5,:b6  from search_urls where (flag='0' and depth<:b7)";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )154;
    sqlstm.selerr = (unsigned short)0;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)256;
    sqlstm.occurs = (unsigned int  )0;
    sqlstm.sqhstv[0] = (         void  *)&url_rowid;
    sqlstm.sqhstl[0] = (unsigned int  )257;
    sqlstm.sqhsts[0] = (         int  )0;
    sqlstm.sqindv[0] = (         void  *)0;
    sqlstm.sqinds[0] = (         int  )0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqadto[0] = (unsigned short )0;
    sqlstm.sqtdso[0] = (unsigned short )0;
    sqlstm.sqhstv[1] = (         void  *)&h_id;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqhsts[1] = (         int  )0;
    sqlstm.sqindv[1] = (         void  *)0;
    sqlstm.sqinds[1] = (         int  )0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqadto[1] = (unsigned short )0;
    sqlstm.sqtdso[1] = (unsigned short )0;
    sqlstm.sqhstv[2] = (         void  *)&protname;
    sqlstm.sqhstl[2] = (unsigned int  )12;
    sqlstm.sqhsts[2] = (         int  )0;
    sqlstm.sqindv[2] = (         void  *)0;
    sqlstm.sqinds[2] = (         int  )0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqadto[2] = (unsigned short )0;
    sqlstm.sqtdso[2] = (unsigned short )0;
    sqlstm.sqhstv[3] = (         void  *)&hostname;
    sqlstm.sqhstl[3] = (unsigned int  )62;
    sqlstm.sqhsts[3] = (         int  )0;
    sqlstm.sqindv[3] = (         void  *)0;
    sqlstm.sqinds[3] = (         int  )0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqadto[3] = (unsigned short )0;
    sqlstm.sqtdso[3] = (unsigned short )0;
    sqlstm.sqhstv[4] = (         void  *)&pathname;
    sqlstm.sqhstl[4] = (unsigned int  )514;
    sqlstm.sqhsts[4] = (         int  )0;
    sqlstm.sqindv[4] = (         void  *)0;
    sqlstm.sqinds[4] = (         int  )0;
    sqlstm.sqharm[4] = (unsigned int  )0;
    sqlstm.sqadto[4] = (unsigned short )0;
    sqlstm.sqtdso[4] = (unsigned short )0;
    sqlstm.sqhstv[5] = (         void  *)&depth;
    sqlstm.sqhstl[5] = (unsigned int  )4;
    sqlstm.sqhsts[5] = (         int  )0;
    sqlstm.sqindv[5] = (         void  *)0;
    sqlstm.sqinds[5] = (         int  )0;
    sqlstm.sqharm[5] = (unsigned int  )0;
    sqlstm.sqadto[5] = (unsigned short )0;
    sqlstm.sqtdso[5] = (unsigned short )0;
    sqlstm.sqhstv[6] = (         void  *)&f_id;
    sqlstm.sqhstl[6] = (unsigned int  )4;
    sqlstm.sqhsts[6] = (         int  )0;
    sqlstm.sqindv[6] = (         void  *)0;
    sqlstm.sqinds[6] = (         int  )0;
    sqlstm.sqharm[6] = (unsigned int  )0;
    sqlstm.sqadto[6] = (unsigned short )0;
    sqlstm.sqtdso[6] = (unsigned short )0;
    sqlstm.sqhstv[7] = (         void  *)&url_dep;
    sqlstm.sqhstl[7] = (unsigned int  )4;
    sqlstm.sqhsts[7] = (         int  )0;
    sqlstm.sqindv[7] = (         void  *)0;
    sqlstm.sqinds[7] = (         int  )0;
    sqlstm.sqharm[7] = (unsigned int  )0;
    sqlstm.sqadto[7] = (unsigned short )0;
    sqlstm.sqtdso[7] = (unsigned short )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqphss = sqlstm.sqhsts;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqpins = sqlstm.sqinds;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlstm.sqpadto = sqlstm.sqadto;
    sqlstm.sqptdso = sqlstm.sqtdso;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}



		/* EXEC SQL UPDATE search_urls SET flag='1' WHERE
			rowid = :url_rowid AND flag='0'; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 8;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.stmt = "update search_urls  set flag='1' where (rowid=:b0 and flag=\
'0')";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )201;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlstm.sqhstv[0] = (         void  *)&url_rowid;
  sqlstm.sqhstl[0] = (unsigned int  )257;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)0;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}



      mb.hid_flag = h_id;
      mb.fid = f_id;
      mb.depth = depth;
      mb.msgid = URL;
/*      mb.host_offset = protname.len + 1;
      mb.path_offset = mb.host_offset + hostname.len + 1;
      sprintf(mb.msg, "%s\0%s\0%s",protname.arr,hostname.arr,pathname.arr);
*/
	for (j=0;j<protname.len;j++) mb.prot[j]=protname.arr[j];
	mb.prot[j] = '\0';
	for (j=0;j<hostname.len;j++) mb.host[j]=hostname.arr[j];
	mb.host[j] = '\0';
	for (j=0;j<pathname.len;j++) mb.path[j]=pathname.arr[j];
	mb.path[j] = '\0';
/*printf("prot = %s host = %s path = %s\n",mb.prot,mb.host,mb.path);*/
      msgsnd(msgid, &mb, sizeof(mb), 0);

	
/*	if ( url_rowid[i]==0) break;*/
	}
	
/*	EXEC SQL CLOSE initurl;*/
	if (i!=0) break;

	{
	  msgctl(msgid, IPC_STAT, &arg);
	  if (arg.msg_qnum != 0) break;
	  sleep(10);
 	}
  /* notfound:
	printf("fail i= %d\n", i);
 	EXEC SQL CLOSE initurl;
    EXEC SQL WHENEVER NOTFOUND CONTINUE;*/
 }

	urlnum=i;
	/*printf("urlnum=%d\n",i);*/
/*	for (i=0; i<urlnum; i++) 
	{
	  EXEC SQL UPDATE search_urls SET flag='1' 
			   WHERE rowid='url_rowid[i]' AND flag='0';

      mb.hid_flag = h_id[i];
	  mb.fid = f_id[i];
	  mb.depth = depth[i];
	  mb.msgid = URL;
	  mb.host_offset = protname[i].len + 1;
	  mb.path_offset = mb.host_offset + hostname[i].len + 1;
	  sprintf(mb.msg, "%s%s%s",(char *)protname[i].arr,(char *)hostname[i].arr,(char *)pathname[i].arr);
	  msgsnd(msgid, &mb, sizeof(mb), 0);

	}
*/
	/*printf("ffffffffffffffffffff\n");*/
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 8;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )220;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	
}

/* # This procedure loads data into TR database. It continues execution
immediatelly,
# but it waits berore running next load for termination of a previous one.
# If rtload is interrupted database is reloaded
# after wait it also checks if it has connection with oracle. If Delete
command cannot
# be executed it logson and tries to repeat oracle operation.
*/

load_to_TR()
{
	struct sembuf sba={0,-1,0},sbb={0,1,0};
	char commd[80],commd1[80],commd2[80];
	struct stat info2,loginfo;
        int ret;

/*	if(child_pid != 0) {
	  status=0;
	  wait;
      if ((status & 255) != 0) {
		status=0;
		status=system(command);
		print" Return code:tatus\n";
	    }
	  }
	}*/

	sleep(5);
	stat (filename,&info2);
   if (info2.st_size >= 50000) {
	semop(semid, &sba, 0);
     /*   EXEC SQL DELETE FROM search_urls WHERE flag='3';*/
	/* EXEC SQL UPDATE search_urls SET flag='3' WHERE flag='2'; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 8;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "update search_urls  set flag='3' where flag='2'";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )235;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 8;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )250;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	sprintf(commd,"mv %s %s.rtd",filename,filename);
	ret=system(commd); 
	semop(semid, &sbb, 0);  
        if (! ret) {
	   stat(logfile, &loginfo);
	   if (loginfo.st_size != 0) {
                sprintf(commd1, "cp %s.old %s.err",filename,filename);
                sprintf(commd2, "cp %s %s.err",logfile,logfile);
                system(commd1);
                system(commd2);
           }

	   system(command);
           sprintf(commd,"mv %s.rtd %s.old",filename,filename);
           system(commd);
	  /* stat(logfile, &loginfo);
	   if (loginfo.st_size != 0) {
		sprintf(commd1, "mv %s.old %.err",filename,filename);
		system(commd1);
	   }*/
        }
    }	
}


/*# this is main server of urls procedure. It receives maessages from gathering
# programs and if number of messages in message queue drops below certain
# number it starts sending urls
# It also check and if size of file to which data is loaded exceeds 1 MB it runs
# rtload application to load it to TR
*/

server()
{
	struct msqid_ds arg;
	struct stat info;
    struct messagebuf  mb={0,0,0,0,"","",""};
	struct url_str url;

  /* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* VARCHAR pathname[512]; */ 
struct { unsigned short len; unsigned char arr[512]; } pathname;

	long id;
  /* EXEC SQL END DECLARE SECTION; */ 


	signal(SIGINT, &ser_handler);
	signal(SIGTERM, &ser_handler);
	/*printf("1234567\n");*/
	while(1) {
		msgrcv(msgid, &mb, sizeof(mb), NEXT, 0);
	/*	msgrcv(msgid, &mb, 255, NEXT, 0);*/
		printf("message received Okay.\n");
		url.fid = mb.fid;
		url.hid = mb.hid_flag;
		url.depth = mb.depth;
/*		strcpy(url.prot, mb.msg);
		strcpy(url.host, mb.msg+mb.host_offset);
		strcpy(url.path, mb.msg+mb.path_offset);
*/
		strcpy(url.prot, mb.prot);
		strcpy(url.host, mb.host);
		strcpy(url.path, mb.path);
		
		if (strcmp(url.prot,"") != 0)
		{
			/* EXEC SQL LOCK TABLE search_urls IN SHARE MODE; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 8;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.stmt = "lock TABLE search_urls IN SHARE MODE";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )265;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


		if (url.fid == 0)
			{
			id = url.hid;
			pathname.len = sprintf((char *)pathname.arr, "%s", url.path);
			/* EXEC SQL UPDATE search_urls SET flag='2' WHERE host_id=:id AND path = :pathname; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 8;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.stmt = "update search_urls  set flag='2' where (host_id=:b0 and pa\
th=:b1)";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )280;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlstm.sqhstv[0] = (         void  *)&id;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqhsts[0] = (         int  )0;
   sqlstm.sqindv[0] = (         void  *)0;
   sqlstm.sqinds[0] = (         int  )0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqadto[0] = (unsigned short )0;
   sqlstm.sqtdso[0] = (unsigned short )0;
   sqlstm.sqhstv[1] = (         void  *)&pathname;
   sqlstm.sqhstl[1] = (unsigned int  )514;
   sqlstm.sqhsts[1] = (         int  )0;
   sqlstm.sqindv[1] = (         void  *)0;
   sqlstm.sqinds[1] = (         int  )0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqadto[1] = (unsigned short )0;
   sqlstm.sqtdso[1] = (unsigned short )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqphss = sqlstm.sqhsts;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqpins = sqlstm.sqinds;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlstm.sqpadto = sqlstm.sqadto;
   sqlstm.sqptdso = sqlstm.sqtdso;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


			printf("IN*OK: %s://%s%s\n",url.prot,url.host,url.path);
			}
		else
		  if (url.fid == 2) {
			 id = url.hid;
			pathname.len = sprintf((char *)pathname.arr, "%s", url.path);
			/* EXEC SQL UPDATE search_urls SET flag='9' WHERE host_id=:id AND path = :pathname; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 8;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.stmt = "update search_urls  set flag='9' where (host_id=:b0 and pa\
th=:b1)";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )303;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlstm.sqhstv[0] = (         void  *)&id;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqhsts[0] = (         int  )0;
   sqlstm.sqindv[0] = (         void  *)0;
   sqlstm.sqinds[0] = (         int  )0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqadto[0] = (unsigned short )0;
   sqlstm.sqtdso[0] = (unsigned short )0;
   sqlstm.sqhstv[1] = (         void  *)&pathname;
   sqlstm.sqhstl[1] = (unsigned int  )514;
   sqlstm.sqhsts[1] = (         int  )0;
   sqlstm.sqindv[1] = (         void  *)0;
   sqlstm.sqinds[1] = (         int  )0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqadto[1] = (unsigned short )0;
   sqlstm.sqtdso[1] = (unsigned short )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqphss = sqlstm.sqhsts;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqpins = sqlstm.sqinds;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlstm.sqpadto = sqlstm.sqadto;
   sqlstm.sqptdso = sqlstm.sqtdso;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


			printf("IN*REDIRECT: %s://%s%s\n",url.prot,url.host,url.path);
		  }
		  else
			{
			id = url.hid;
            pathname.len = sprintf((char *)pathname.arr, "%s", url.path);
            /* EXEC SQL UPDATE search_urls SET flag='4' WHERE host_id=:id AND
path = :pathname; */ 

{
            struct sqlexd sqlstm;

            sqlstm.sqlvsn = 10;
            sqlstm.arrsiz = 8;
            sqlstm.sqladtp = &sqladt;
            sqlstm.sqltdsp = &sqltds;
            sqlstm.stmt = "update search_urls  set flag='4' where (host_id=:\
b0 and path=:b1)";
            sqlstm.iters = (unsigned int  )1;
            sqlstm.offset = (unsigned int  )326;
            sqlstm.cud = sqlcud0;
            sqlstm.sqlest = (unsigned char  *)&sqlca;
            sqlstm.sqlety = (unsigned short)256;
            sqlstm.occurs = (unsigned int  )0;
            sqlstm.sqhstv[0] = (         void  *)&id;
            sqlstm.sqhstl[0] = (unsigned int  )4;
            sqlstm.sqhsts[0] = (         int  )0;
            sqlstm.sqindv[0] = (         void  *)0;
            sqlstm.sqinds[0] = (         int  )0;
            sqlstm.sqharm[0] = (unsigned int  )0;
            sqlstm.sqadto[0] = (unsigned short )0;
            sqlstm.sqtdso[0] = (unsigned short )0;
            sqlstm.sqhstv[1] = (         void  *)&pathname;
            sqlstm.sqhstl[1] = (unsigned int  )514;
            sqlstm.sqhsts[1] = (         int  )0;
            sqlstm.sqindv[1] = (         void  *)0;
            sqlstm.sqinds[1] = (         int  )0;
            sqlstm.sqharm[1] = (unsigned int  )0;
            sqlstm.sqadto[1] = (unsigned short )0;
            sqlstm.sqtdso[1] = (unsigned short )0;
            sqlstm.sqphsv = sqlstm.sqhstv;
            sqlstm.sqphsl = sqlstm.sqhstl;
            sqlstm.sqphss = sqlstm.sqhsts;
            sqlstm.sqpind = sqlstm.sqindv;
            sqlstm.sqpins = sqlstm.sqinds;
            sqlstm.sqparm = sqlstm.sqharm;
            sqlstm.sqparc = sqlstm.sqharc;
            sqlstm.sqpadto = sqlstm.sqadto;
            sqlstm.sqptdso = sqlstm.sqtdso;
            sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


			printf("IN*ER: %s://%s%s\n",url.prot,url.host,url.path);
			}
		}

		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 8;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )349;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


		msgctl(msgid, IPC_STAT, &arg);
		/*printf("222222222222222222222\n");*/

		if (arg.msg_qnum < 60) send_addrs(60-arg.msg_qnum);
        	if ((filename,F_OK) >=0) {	
	   	   stat(filename, &info);
	   	   /*if (info.st_size > 1000000) load_to_TR();*/
	   	   if (info.st_size > 50000) load_to_TR();
        	}
	}
}


main()
{
int i;
int ret;
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    /* VARCHAR user_pwd[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } user_pwd;

  /* EXEC SQL END DECLARE SECTION; */ 



union semun {
            int val;
            struct semid_ds *buf;
            ushort *array;
            } arg;


/* 
  initialization of semaphores and messages
  this module actually does not use msgida but it still opens this message queue
  for use by other modules.
  I just prefered to have all queues opened here
*/
	get_config_value("rtd_file",filename);
	filename[strlen(filename)-1] = '\0';
	get_config_value("log_file",logfile);
	logfile[strlen(logfile)-1] = '\0';
	get_config_value("command",command);
	command[strlen(command)-1] = '\0';
	get_config_value("userid/passwd",USR_PWD);
	USR_PWD[strlen(USR_PWD)-1] = '\0';
	printf("%s\n%s\n%s\n%s",filename,logfile,command,USR_PWD);
/*	exit(1);*/

	semid = semget(key,2, IPC_CREAT | S_IRUSR | S_IWUSR);
			/* create the semophore */
    if (semid < 0) {
		printf("can't open semaphore\n");
		exit(1);
	}
	/*printf("000000000000000000000\n");*/
	
	arg.val = 1;
    if ((ret=semctl(semid, 0, SETVAL, arg, 00200)) < 0) {
		printf("can't set semaphore. ret = %d\n",ret);
		exit(1);
	}
	printf("000000000000000000000\n");
	arg.val = URL_QUEUE_SIZE;
	if (semctl(semid, 1, SETVAL, arg, 00200) < 0) {
		printf("can't set semaphore2\n");
		exit(1);
	}

	msgid = msgget(key, IPC_CREAT | S_IRUSR | S_IWUSR);
	if (msgid < 0) {
		printf("can't open message queue\n");
		exit(1);
	}
	msgida = msgget(key+1, IPC_CREAT | S_IRUSR | S_IWUSR);
	if (msgida < 0) {
        printf("can't open message queue\n");
        exit(1);
	}

  user_pwd.len=sprintf((char *)user_pwd.arr,"%s",USR_PWD);
  /* EXEC SQL CONNECT :user_pwd; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 8;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )10;
  sqlstm.offset = (unsigned int  )364;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlstm.sqhstv[0] = (         void  *)&user_pwd;
  sqlstm.sqhstl[0] = (unsigned int  )257;
  sqlstm.sqhsts[0] = (         int  )257;
  sqlstm.sqindv[0] = (         void  *)0;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


printf("111111111111111111\n");
	/* EXEC SQL LOCK TABLE search_urls IN SHARE MODE; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 8;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "lock TABLE search_urls IN SHARE MODE";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )395;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	/* EXEC SQL UPDATE search_urls SET FLAG=0 WHERE FLAG=1; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 8;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "update search_urls  set FLAG=0 where FLAG=1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )410;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 8;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )425;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	printf("wwwww000000000000000000000\n");
	server();
}

/*
# this procedure handles interrupts
# it receives all messages that are in queue
# and marks records in urls tables accordingly to returned status
# Then it closes down all message queues and semaphores
# waits for loading process to finish and logsoff from oracle
*/

void ser_handler()
{
  struct messagebuf  mb={0,0,0,0,"","",""};
    struct url_str url;

union semun {
            int val;
            struct semid_ds *buf;
            ushort *array;
                } arg;



  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    /* VARCHAR pathname[512]; */ 
struct { unsigned short len; unsigned char arr[512]; } pathname;

	/* VARCHAR hostname[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } hostname;

  /* EXEC SQL END DECLARE SECTION; */ 



	printf("shutting down\n");
    signal(SIGINT, &ser_handler);
	signal(SIGTERM, &ser_handler);

	while (msgrcv(msgid, &mb, sizeof(mb), NEXT, IPC_NOWAIT))
	{
        url.fid = mb.fid;
        url.hid = mb.hid_flag;
        url.depth = mb.depth;
		strcpy(url.prot, mb.prot);
		strcpy(url.host, mb.host);
		strcpy(url.path, mb.path);
		printf("dead loop prot=%s	\n", url.prot);
		printf("host=%s    path=%s\n",url.host,url.path);

		if (strcmp(mb.host, "")!=0)
		{
			/* EXEC SQL LOCK TABLE search_urls IN SHARE MODE; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 8;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.stmt = "lock TABLE search_urls IN SHARE MODE";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )440;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


			if (url.fid == 0)
			{
			printf("FLAG CHANGED TO 2!\n");
            hostname.len = sprintf((char *)hostname.arr, "%s", url.host);
            pathname.len = sprintf((char *)pathname.arr, "%s", url.path);
			/* EXEC SQL UPDATE search_urls SET flag='2' WHERE 
				host = :hostname AND path = :pathname; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 8;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.stmt = "update search_urls  set flag='2' where (host=:b0 and path=\
:b1)";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )455;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlstm.sqhstv[0] = (         void  *)&hostname;
   sqlstm.sqhstl[0] = (unsigned int  )257;
   sqlstm.sqhsts[0] = (         int  )0;
   sqlstm.sqindv[0] = (         void  *)0;
   sqlstm.sqinds[0] = (         int  )0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqadto[0] = (unsigned short )0;
   sqlstm.sqtdso[0] = (unsigned short )0;
   sqlstm.sqhstv[1] = (         void  *)&pathname;
   sqlstm.sqhstl[1] = (unsigned int  )514;
   sqlstm.sqhsts[1] = (         int  )0;
   sqlstm.sqindv[1] = (         void  *)0;
   sqlstm.sqinds[1] = (         int  )0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqadto[1] = (unsigned short )0;
   sqlstm.sqtdso[1] = (unsigned short )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqphss = sqlstm.sqhsts;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqpins = sqlstm.sqinds;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlstm.sqpadto = sqlstm.sqadto;
   sqlstm.sqptdso = sqlstm.sqtdso;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


			}
			else
			if (url.fid == 2)
			{
			printf("FLAG CHANGED TO 9!\n");
            hostname.len = sprintf((char *)hostname.arr, "%s", url.host);
            pathname.len = sprintf((char *)pathname.arr, "%s", url.path);
			/* EXEC SQL UPDATE search_urls SET flag='9' WHERE 
				host = :hostname AND path = :pathname; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 8;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.stmt = "update search_urls  set flag='9' where (host=:b0 and path=\
:b1)";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )478;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlstm.sqhstv[0] = (         void  *)&hostname;
   sqlstm.sqhstl[0] = (unsigned int  )257;
   sqlstm.sqhsts[0] = (         int  )0;
   sqlstm.sqindv[0] = (         void  *)0;
   sqlstm.sqinds[0] = (         int  )0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqadto[0] = (unsigned short )0;
   sqlstm.sqtdso[0] = (unsigned short )0;
   sqlstm.sqhstv[1] = (         void  *)&pathname;
   sqlstm.sqhstl[1] = (unsigned int  )514;
   sqlstm.sqhsts[1] = (         int  )0;
   sqlstm.sqindv[1] = (         void  *)0;
   sqlstm.sqinds[1] = (         int  )0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqadto[1] = (unsigned short )0;
   sqlstm.sqtdso[1] = (unsigned short )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqphss = sqlstm.sqhsts;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqpins = sqlstm.sqinds;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlstm.sqpadto = sqlstm.sqadto;
   sqlstm.sqptdso = sqlstm.sqtdso;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


			}
			else
			{
			printf("FLAG CHANGED TO 4!\n");
            hostname.len = sprintf((char *)hostname.arr, "%s", url.host);
            pathname.len = sprintf((char *)pathname.arr, "%s", url.path);
			/* EXEC SQL UPDATE search_urls SET flag='4' WHERE
                host = :hostname AND path = :pathname; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 8;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.stmt = "update search_urls  set flag='4' where (host=:b0 and path=\
:b1)";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )501;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlstm.sqhstv[0] = (         void  *)&hostname;
   sqlstm.sqhstl[0] = (unsigned int  )257;
   sqlstm.sqhsts[0] = (         int  )0;
   sqlstm.sqindv[0] = (         void  *)0;
   sqlstm.sqinds[0] = (         int  )0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqadto[0] = (unsigned short )0;
   sqlstm.sqtdso[0] = (unsigned short )0;
   sqlstm.sqhstv[1] = (         void  *)&pathname;
   sqlstm.sqhstl[1] = (unsigned int  )514;
   sqlstm.sqhsts[1] = (         int  )0;
   sqlstm.sqindv[1] = (         void  *)0;
   sqlstm.sqinds[1] = (         int  )0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqadto[1] = (unsigned short )0;
   sqlstm.sqtdso[1] = (unsigned short )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqphss = sqlstm.sqhsts;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqpins = sqlstm.sqinds;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlstm.sqpadto = sqlstm.sqadto;
   sqlstm.sqptdso = sqlstm.sqtdso;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


			}
		}
		else break;

	}
	arg.val = 0;
	semctl(semid, 0, IPC_RMID, arg);
	printf("semaphore closed\n");
	msgctl(msgid, IPC_RMID, 0);
	msgctl(msgida, IPC_RMID, 0);
	printf("message queues closed\n");
/*	wait();*/
	printf("children terminated\n");
	/* EXEC SQL COMMIT WORK RELEASE; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 8;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )524;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	exit(0);
}









