drop package cwosurvey;
/
create or replace package cwosurvey is
procedure go_survey(typein varchar2, op number);
procedure show_doc(dep number,seed number);
procedure doc_domain(dom varchar2,seed number);
procedure links_num(dep number,seed number);
procedure domain_level(dom varchar2,dep number,seed number);

function cwo_url(curl in varchar2, cname in varchar2) return varchar2;

root_url varchar2(200) := cwosearch.root_url;
root_url1 varchar2(200) := cwosearch.root_url1;
server_name varchar2(200) := cwosearch.server_name;

end;
/
show errors;
/
create or replace package body cwosurvey is
url_hits integer := 30;

function cwo_url(curl   in varchar2, cname   in varchar2) return varchar2 is
begin return('<a href="' || curl || '">' || cname || '</a>'); end;


procedure go_survey(typein varchar2, op number) is

begin
  htp.p('<head><title>CWO survey</title></head>');
  htp.p('<body bgcolor="#ffffff">');
  if (op = 0) then
	show_doc(to_number(typein),1);
  elsif (op = 1) then
	doc_domain(typein,1);
  elsif (op = 2) then
	links_num(to_number(typein),1);
  else
	htp.p('<frameset cols=100%,*>
		<frame src="'||server_name||'survey2.html">
		</frameset></html>');
	return;
  end if;
end;

procedure show_doc(dep number,seed number) is

cursor doccur(d number) is
	select host,path from search_urls 
	where (depth = d)
	and (prot ='http')
	order by host asc,path asc;
res_host search_urls.host%TYPE;
res_path search_urls.path%TYPE;
num integer := 0;
next number(8);   
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;
total number(8) :=0;
iseed integer;
n integer;
i integer;

begin
   htp.p('<head><title> All URLS with Level '||dep||' </title></head>');
   htp.p('<body background="'||server_name||'bluestone.jpg">');
   htp.p('<center><font size=+5>All URLS with Level '||dep||'</font>');
   select count(*) into total from search_urls 
	where (depth = dep) 
	and (prot='http');
   if (total = 0 ) then
	htp.p('No url with level ='||dep);
	return;
   end if;
   next := seed + url_hits;
   if (next <= total) then
	if ((next+url_hits)<=total) then
		next_str := (next+url_hits-1);
	else
		next_str := total;
	end if;
	next_str := next||'-'||next_str;
	curr_str := (next-1);
   else
	curr_str := total;
   end if;
   prev := seed - url_hits;
   if (prev >= 1) then
        prev_str := prev||'-'||(seed-1);
   elsif (seed > 1) then
        prev := 1;
        prev_str := '1-'||url_hits;
   end if;
	
   htp.p('<center><table border=0><tr>');
   htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
   htp.p('<td>Current: '||seed||'-'||curr_str||' ');
   if (next_str IS NOT NULL) then
	htp.p(' <b>|</b> <td align=right>');
	htp.p(cwo_url(root_url||'/cwosurvey.show_doc?dep='||
		dep||'&seed='||next,'Next '||next_str));
	
   end if;
   if (prev_str IS NOT NULL) then
	htp.p(' <b>|</b><td align=right>');
	htp.p(cwo_url(root_url||'/cwosurvey.show_doc?dep='||
		dep||'&seed='||prev,'Prev '||prev_str));
   end if;
   htp.p('</table></center><dl>');

   htp.p('<center><table border=1 cellpadding=1 cellspacing=1 width=50%>');
   htp.p('<tr><th>URL</th></tr>');

   open doccur(dep);   
   loop
   	fetch doccur into res_host,res_path;
   	exit when doccur%NOTFOUND;
	num := num + 1;
	if (num >= seed) then
	    htp.p('<tr><th align=left><a href="http://'||res_host||
		res_path||'">http://'||res_host||res_path||'</a></th></tr>');
	end if;
	if (num >= (seed + url_hits)) then
		exit;
	end if;
   end loop;
   close doccur;
   htp.p('</table>');
   htp.p('<img src="'||server_name||'wavy.gif"><br>');	
   htp.p('<table>');
   if (prev_str IS NOT NULL) then
		htp.p('['||cwo_url(root_url||'/cwosurvey.show_doc?dep='
			||dep||'&seed='||prev, 'Prev')||']');
   end if;
   htp.p(' p.');
   n := ceil(total/url_hits);
   if (n > 20) then n := 20; end if;
   for i in 1..n loop
	iseed := (i-1)*url_hits + 1;
	if (iseed = seed) then
		htp.p(' '||i);
	else
		htp.p(' '||cwo_url(root_url||
		'/cwosurvey.show_doc?dep='||dep||'&seed='||
			iseed,i));
	end if;
   end loop;
   if (seed < ((n-1)*url_hits+1)) then
	htp.p('['||cwo_url(root_url||'/cwosurvey.show_doc?
		dep='||dep||'&seed='||next,'Next')||']');
   end if;
   htp.p('</center>');
   htp.p('</TABLE>');
end;

procedure doc_domain(dom varchar2, seed number) is

cursor domcur(dh varchar2,dhport varchar2) is 
	select host,path,depth from search_urls
	where ((host like dh) or (host like dhport))
	and (prot='http')
	order by depth asc,host asc, path asc;

res_host search_urls.host%TYPE;
res_path search_urls.path%TYPE;
res_dep search_urls.depth%TYPE;
num integer := 0;
next number(8);   
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;
total number(8) :=0;
iseed integer;
n integer;
i integer;
host_domain varchar2(200) := NULL;

begin
   htp.p('<head><title> All URLS with Domain '||dom||' </title></head>');
   htp.p('<body background="'||server_name||'bluestone.jpg">');
   htp.p('<center><font size=+4>All URLS with Domain '||dom||'</font>');
   host_domain := '%.'||dom;
   select count(*) into total from search_urls 
	where ((host like host_domain) or (host like host_domain||':%'))
	and (prot = 'http');
   if (total = 0 ) then
	htp.p('No url with domain: '||dom);
	return;
   end if;
   next := seed + url_hits;
   if (next <= total) then
	if ((next+url_hits)<=total) then
		next_str := (next+url_hits-1);
	else
		next_str := total;
	end if;
	next_str := next||'-'||next_str;
	curr_str := (next-1);
   else
	curr_str := total;
   end if;
   prev := seed - url_hits;
   if (prev >= 1) then
        prev_str := prev||'-'||(seed-1);
   elsif (seed > 1) then
        prev := 1;
        prev_str := '1-'||url_hits;
   end if;
	
   htp.p('<center><table border=0><tr>');
   htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
   htp.p('<td>Current: '||seed||'-'||curr_str||' ');
   if (next_str IS NOT NULL) then
	htp.p(' <b>|</b> <td align=right>');
	htp.p(cwo_url(root_url||'/cwosurvey.doc_domain?dom='||
		dom||'&seed='||next,'Next '||next_str));
	
   end if;
   if (prev_str IS NOT NULL) then
	htp.p(' <b>|</b><td align=right>');
	htp.p(cwo_url(root_url||'/cwosurvey.doc_domain?dom='||
		dom||'&seed='||prev,'Prev '||prev_str));
   end if;
   htp.p('</table></center><dl>');

   htp.p('<center><table border=1 cellpadding=1 cellspacing=1 width=50%>');
   htp.p('<tr><th>URL</th><th>Level</th></tr>');

   open domcur(host_domain,host_domain||':%');   
   loop
   	fetch domcur into res_host,res_path,res_dep;
   	exit when domcur%NOTFOUND;
	num := num + 1;
	if (num >= seed) then
	    htp.p('<tr><th align=left><a href="http://'||res_host||
		res_path||'">http://'||res_host||res_path||'</a></th>');
	    htp.p('<th>'||res_dep||'</th></tr>');
	end if;
	if (num >= (seed + url_hits)) then
		exit;
	end if;
   end loop;
   close domcur;
   htp.p('</table>');
   htp.p('<img src="'||server_name||'wavy.gif"><br>');	
   htp.p('<table>');
   if (prev_str IS NOT NULL) then
		htp.p('['||cwo_url(root_url||'/cwosurvey.doc_domain?dom='
			||dom||'&seed='||prev, 'Prev')||']');
   end if;
   htp.p(' p.');
   n := ceil(total/url_hits);
   if (n > 20) then n := 20; end if;
   for i in 1..n loop
	iseed := (i-1)*url_hits + 1;
	if (iseed = seed) then
		htp.p(' '||i);
	else
		htp.p(' '||cwo_url(root_url||
		'/cwosurvey.doc_domain?dom='||dom||'&seed='||
			iseed,i));
	end if;
   end loop;
   if (seed < ((n-1)*url_hits+1)) then
	htp.p('['||cwo_url(root_url||'/cwosurvey.doc_domain?
		dom='||dom||'&seed='||next,'Next')||']');
   end if;
   htp.p('</center>');
   htp.p('</TABLE>');
end;

procedure links_num(dep number, seed number) is

cursor linkcur(d number) is
	select b.host,b.path, a.no_html from search a, search_urls b
	where (a.host1 = b.host) 
	and (a.path = b.path)
	and (b.depth = d)
	order by a.no_html desc, b.host asc, b.path asc;

res_host search_urls.host%TYPE;
res_path search_urls.path%TYPE;
res_link search.no_html%TYPE;
num integer := 0;
next number(8);   
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;
total number(8) :=0;
iseed integer;
n integer;
i integer;

begin
   htp.p('<head><title> The links number of URLs with Level '||dep||' </title></head>');
   htp.p('<body background="'||server_name||'bluestone.jpg">');
   htp.p('<center><font size=+5>The link number of URLs with Level '||dep||'</font>');
   select count(*) into total from search a, search_urls b
	where (b.depth = dep)
	and (a.host1 = b.host)
	and (a.path = b.path);
   if (total = 0 ) then
	htp.p('No url with level ='||dep);
	return;
   end if;
   next := seed + url_hits;
   if (next <= total) then
	if ((next+url_hits)<=total) then
		next_str := (next+url_hits-1);
	else
		next_str := total;
	end if;
	next_str := next||'-'||next_str;
	curr_str := (next-1);
   else
	curr_str := total;
   end if;
   prev := seed - url_hits;
   if (prev >= 1) then
        prev_str := prev||'-'||(seed-1);
   elsif (seed > 1) then
        prev := 1;
        prev_str := '1-'||url_hits;
   end if;
	
   htp.p('<center><table border=0><tr>');
   htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
   htp.p('<td>Current: '||seed||'-'||curr_str||' ');
   if (next_str IS NOT NULL) then
	htp.p(' <b>|</b> <td align=right>');
	htp.p(cwo_url(root_url||'/cwosurvey.links_num?dep='||
		dep||'&seed='||next,'Next '||next_str));
	
   end if;
   if (prev_str IS NOT NULL) then
	htp.p(' <b>|</b><td align=right>');
	htp.p(cwo_url(root_url||'/cwosurvey.links_num?dep='||
		dep||'&seed='||prev,'Prev '||prev_str));
   end if;
   htp.p('</table></center><dl>');

   htp.p('<center><table border=1 cellpadding=1 cellspacing=1 width=50%>');
   htp.p('<tr><th>URL</th><th>Link Number</th></tr>');

   open linkcur(dep);   
   loop
   	fetch linkcur into res_host,res_path,res_link;
   	exit when linkcur%NOTFOUND;
	num := num + 1;
	if (num >= seed) then
	    htp.p('<tr><th align=left><a href="http://'||res_host||
		res_path||'">http://'||res_host||res_path||'</a></th>');
	    htp.p('<th>'||res_link||'</th></tr>');
	end if;
	if (num >= (seed + url_hits)) then
		exit;
	end if;
   end loop;
   close linkcur;
   htp.p('</table>');
   htp.p('<img src="'||server_name||'wavy.gif"><br>');	
   htp.p('<table>');
   if (prev_str IS NOT NULL) then
		htp.p('['||cwo_url(root_url||'/cwosurvey.link_num?dep='
			||dep||'&seed='||prev, 'Prev')||']');
   end if;
   htp.p(' p.');
   n := ceil(total/url_hits);
   if (n > 20) then n := 20; end if;
   for i in 1..n loop
	iseed := (i-1)*url_hits + 1;
	if (iseed = seed) then
		htp.p(' '||i);
	else
		htp.p(' '||cwo_url(root_url||
		'/cwosurvey.link_num?dep='||dep||'&seed='||
			iseed,i));
	end if;
   end loop;
   if (seed < ((n-1)*url_hits+1)) then
	htp.p('['||cwo_url(root_url||'/cwosurvey.link_num?
		dep='||dep||'&seed='||next,'Next')||']');
   end if;
   htp.p('</center>');
   htp.p('</TABLE>');
end;
	
procedure domain_level(dom varchar2,dep number,seed number) is

cursor dlcur(dm varchar2, dhport varchar2, dp number) is
	select host,path,depth from search_urls
	where (depth = dp)
	and (prot= 'http')
	and ((host like dm) or (host like dhport))
	order by depth asc, host asc, path asc;

res_host search_urls.host%TYPE;
res_path search_urls.path%TYPE;
res_dep search_urls.depth%TYPE;
num integer := 0;
next number(8);   
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;
total number(8) :=0;
iseed integer;
n integer;
i integer;
host_domain varchar2(200) := NULL;

begin
   htp.p('<head><title> All URLS with Domain '||dom||' and Level '||dep||' </title></head>');
   htp.p('<body background="'||server_name||'bluestone.jpg">');
   htp.p('<center><font size=+4>All URLS with Domain '||dom||' and Level '||dep||' </font>');
   host_domain := '%.'||dom;
   select count(*) into total from search_urls 
	where (depth=dep)
	and ((host like host_domain) or (host like host_domain||':%'))
	and (prot = 'http');
   if (total = 0 ) then
	htp.p('<p>No url with domain: '||dom||' and level: '||dep);
	return;
   end if;
   next := seed + url_hits;
   if (next <= total) then
	if ((next+url_hits)<=total) then
		next_str := (next+url_hits-1);
	else
		next_str := total;
	end if;
	next_str := next||'-'||next_str;
	curr_str := (next-1);
   else
	curr_str := total;
   end if;
   prev := seed - url_hits;
   if (prev >= 1) then
        prev_str := prev||'-'||(seed-1);
   elsif (seed > 1) then
        prev := 1;
        prev_str := '1-'||url_hits;
   end if;
	
   htp.p('<center><table border=0><tr>');
   htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
   htp.p('<td>Current: '||seed||'-'||curr_str||' ');
   if (next_str IS NOT NULL) then
	htp.p(' <b>|</b> <td align=right>');
	htp.p(cwo_url(root_url||'/cwosurvey.domain_level?dom='||
		dom||'&dep='||dep||'&seed='||next,'Next '||next_str));
	
   end if;
   if (prev_str IS NOT NULL) then
	htp.p(' <b>|</b><td align=right>');
	htp.p(cwo_url(root_url||'/cwosurvey.domain_level?dom='||
		dom||'&dep='||dep||'&seed='||prev,'Prev '||prev_str));
   end if;
   htp.p('</table></center><dl>');

   htp.p('<center><table border=1 cellpadding=1 cellspacing=1 width=50%>');
   htp.p('<tr><th>URL</th><th>Level</th></tr>');

   open dlcur(host_domain,host_domain||':%',dep);   
   loop
   	fetch dlcur into res_host,res_path,res_dep;
   	exit when dlcur%NOTFOUND;
	num := num + 1;
	if (num >= seed) then
	    htp.p('<tr><th align=left><a href="http://'||res_host||
		res_path||'">http://'||res_host||res_path||'</a></th>');
	    htp.p('<th>'||res_dep||'</th></tr>');
	end if;
	if (num >= (seed + url_hits)) then
		exit;
	end if;
   end loop;
   close dlcur;
   htp.p('</table>');
   htp.p('<img src="'||server_name||'wavy.gif"><br>');	
   htp.p('<table>');
   if (prev_str IS NOT NULL) then
		htp.p('['||cwo_url(root_url||'/cwosurvey.domain_level?dom='
			||dom||'&dep='||dep||'&seed='||prev, 'Prev')||']');
   end if;
   htp.p(' p.');
   n := ceil(total/url_hits);
   if (n > 20) then n := 20; end if;
   for i in 1..n loop
	iseed := (i-1)*url_hits + 1;
	if (iseed = seed) then
		htp.p(' '||i);
	else
		htp.p(' '||cwo_url(root_url||
		'/cwosurvey.domain_level?dom='||dom||'&dep='||dep||'&seed='||
			iseed,i));
	end if;
   end loop;
   if (seed < ((n-1)*url_hits+1)) then
	htp.p('['||cwo_url(root_url||'/cwosurvey.domain_level?
		dom='||dom||'&dep='||dep||'&seed='||next,'Next')||']');
   end if;
   htp.p('</center>');
   htp.p('</TABLE>');
end;

end cwosurvey;
/
show errors;
/

	



