truncate table search_urls;
drop table search_urls;
create table search_urls (
        host_id         number(6),      -- id of http server
        prot            varchar2(10),
        host            varchar2(60),
        path            varchar2(250),
	oldpath		varchar2(250),
        flag            char(1),    --0..4,R,U
        priority        number(2),      -- determines priority of loading
        depth           number(2),      -- depth from root
        fid             number(8)    
);                          
                          

drop index i_search_urls;
create unique index i_search_urls on search_urls(host,path);


truncate table search_urls_temp;
drop table search_urls_temp;
create table search_urls_temp (
        host_id         number(6),      -- id of http server
        prot            varchar2(10),
        host            varchar2(60),
        path            varchar2(250),
	oldpath		varchar2(250),
        flag            char(1),
        priority        number(2),      -- determines priority of loading
        depth           number(2),      -- depth from root
        fid             number(8)
);

drop index i_search_urls_temp;
create unique index i_search_urls_temp on search_urls_temp(host,path);

truncate table search_disallow;
drop table search_disallow;
create table search_disallow (
        host_id         number(6),      -- id of http server
        path            varchar2(250)   -- disallowed path
);
drop index i_search_disallow;
create index i_search_disallow on search_disallow(host_id);

truncate table search_hosts;
drop table search_hosts;
create table search_hosts (
        host_id         number(6),      -- id of http server
        host            varchar2(60) constraint pk_host primary key,    -- unique hostname:port
        time            number(12),     -- time of last reading of robot.txt
        flag            number(1)
);

truncate table search_info;
drop table search_info;
create table search_info (
        name            varchar2(32),   -- name of stored SQE
        info            varchar2(2000)  -- information returned by TextRetrival
);


drop table search;
create table search(
 FID                                      NUMBER(8) constraint pk_fid primary key,
 STATUS                                   NUMBER(1),
 HOST_ID                                  NUMBER(6),
 PROT                                     VARCHAR2(10),
 HOST1                                    VARCHAR2(60),
 PATH                                     VARCHAR2(255),
 TIME                                     DATE,
 LTIME                                    DATE,
 NO_REFS                                  NUMBER(5),
 NO_HTML                                  NUMBER(5),
 NO_IMGS                                  NUMBER(5),
 S_FORM                                   NUMBER(1),
 FSIZE                                    NUMBER(8),
 TITLE                                    VARCHAR2(255),
 SUBJECT                                  VARCHAR2(255),
 TEXT					  LONG
);

drop index i_search;
create unique index i_search on search(host1,path);

drop index docindex;
create index docindex on search(text) indextype is ctxsys.context;

drop view doc_hit;
create view doc_hit as
select a.fid, a.title, a.host1, a.path, a.time, a.subject,
         a.fsize, a.text, b.depth
        from search a, search_urls b
        where  (a.host_id = b.host_id and a.path=b.path);
