include env_precomp.mk

.SUFFIXES: .pc .c .o

LDSTRING=
PRODUCT_LIBHOME=
MAKEFILE=proc.mk
PROCPLSFLAGS= sqlcheck=semantics userid=$(USERID) dbms=v6_char 
PROCPPFLAGS= code=cpp include=/usr/include include=/opt/SUNWspro/SC3.0.1/include/CC
USERID=search/search
INCLUDE=$(I_SYM). $(PRECOMPPUBLIC)

PROCFLAGS = sqlcheck=semantics userid=$(USERID)


CPPSAMPLES=

# Rule to compile any program (specify EXE= and OBJS= on command line)

build: $(OBJS)
	$(CC) -o $(EXE) $(OBJS) -L$(LIBHOME) $(PROLDLIBS)

cppbuild:
	$(PROC) $(PROCPPFLAGS) iname=$(EXE)
	CC -c $(INCLUDE) $(EXE).c
	CC -o $(EXE) $(OBJS) -L$(LIBHOME) $(PROLDLIBS)

all: gth_ins gth_web gth_rob ser;
cppsamples: $(CPPSAMPLES)

gth_rob: gth_rob.o 
	$(MAKE) -f $(MAKEFILE) build OBJS=$@.o EXE=$@

ser: ser.o 
	$(MAKE) -f $(MAKEFILE) build OBJS=$@.o EXE=$@

gth_ins: gth_ins.o 
	$(MAKE) -f $(MAKEFILE) build OBJS=$@.o EXE=$@

gth_web : gth_web.o buffer.o
	$(CC) -o gth_web gth_web.o buffer.o -lsocket -lnsl

$(CPPSAMPLES):
	$(MAKE) -f $(MAKEFILE) cppbuild OBJS=$@.o EXE=$@


.pc.c:
	$(PROC) $(PROCFLAGS)  iname=$*.pc

.pc.o:
	$(PROC) $(PROCFLAGS)  iname=$*.pc
	$(CC) $(CFLAGS) -c $*.c

.c.o:
	$(CC) $(CFLAGS) -c $*.c

gth_rob.o : gth_rob.pc
	$(PROC) mode=ansi varchar=yes dbms=v6_char sqlcheck=semantics \
		ireclen=132 oreclen=132 select_error=no userid=$(USERID) iname=$*.pc
	$(CC) $(CFLAGS) $(PRECOMPPUBLIC) -c $*.c

gth_ins.o : gth_ins.pc
	$(PROC) mode=ansi varchar=yes dbms=v6_char sqlcheck=semantics \
		ireclen=132 oreclen=132 select_error=no userid=$(USERID) iname=$*.pc
	$(CC) $(CFLAGS) $(PRECOMPPUBLIC) -c $*.c

ser.o : ser.pc
	$(PROC) mode=ansi varchar=yes dbms=v6_char sqlcheck=semantics \
		ireclen=132 oreclen=132 select_error=no userid=$(USERID) iname=$*.pc
	$(CC) $(CFLAGS) $(PRECOMPPUBLIC) -c $*.c

buffer.o: buffer.c
	$(CC) $(CFLAGS) -c buffer.c

gth_web.o : gth_web.c
	$(CC) $(CFLAGS) -I/opt/SUNWspro/SC3.0.1/include/CC -c gth_web.c

