// Purpose: Test to use XML SQL Utility to generate XML file
//         It uses JDBC to fetch data from DB table
// Class: DbtoXML
// Author: Yuping Zhu
// Date: 07-16-1999


import java.sql.*;
import java.math.*;
import oracle.xml.sql.query.*;
import oracle.jdbc.*;
import oracle.jdbc.driver.*;
//import org.w3c.dom.Document;
import org.w3c.dom.*;
import org.w3c.dom.Node;

public class DbtoXmlDoc {

 public static void main(String args[]) throws SQLException
 {
   DriverManager.registerDriver
        (new oracle.jdbc.driver.OracleDriver());

   Connection conn = (Connection)
    DriverManager.getConnection("jdbc:oracle:oci8:scott/tiger@");

   Statement stmt = conn.createStatement();
   ResultSet rset = stmt.executeQuery("select * from emp");

   OracleXMLQuery qry =  new OracleXMLQuery(conn,rset);

   // set the row and result tags..!
   qry.setRowTag("EMP_ROW");
   qry.setRowsetTag("EMP_RESULT");

   // Force lower case tag names..
   qry.useLowerCaseTagNames();

   // set the maximum number of rows to be retrieved = 10

   /*   qry.setMaxRows(10);
 
   qry.keepCursorState(true); 
    String xmlString = qry.getXMLString();
    System.out.println(" OUPUT IS "+xmlString); 
   */
 
   // generate a DOM Document
   Document doc = qry.getXMLDOM();
        
   // Print document elements
   System.out.print("The elements are: ");
   printElements(doc);

   // Print document element attributes
   System.out.println("The attributes of each element are: ");
   printElementAttributes(doc);
 
   qry.close();
   conn.close();
 }

    static void printElements(Document doc) throws DOMException
   {
      NodeList nl = doc.getElementsByTagName("*");
      Node n;
        
      System.out.println(nl.getLength());

      for (int i=0; i<nl.getLength(); i++)
      {
         n = nl.item(i);
         System.out.println(n.getNodeName() + " ");
      }

      System.out.println();
   }


    static void printElementAttributes(Document doc)
   {
      NodeList nl = doc.getElementsByTagName("*");
      Element e;
      Node n;
      NamedNodeMap nnm;

      String attrname;
      String attrval;
      int i, len;

      len = nl.getLength();

      for (int j=0; j < len; j++)
      {
         e = (Element)nl.item(j);
         System.out.println(e.getTagName() + ":");
         nnm = e.getAttributes();

         if (nnm != null)
         {
            for (i=0; i<nnm.getLength(); i++)
            {
               n = nnm.item(i);
               attrname = n.getNodeName();
               attrval = n.getNodeValue();
               System.out.print(" " + attrname + " = " + attrval);
            }
         }
         System.out.println();
      }
   }

} 
