/* Transfer formatted document to HTML using ctx_doc.filter
** Class: DocView
** Author: Yuping Zhu
** Date: 08-05-1999
*/

package ioe;

import java.io.*;

// import the JDBC package
import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;

//import Servlet package
import javax.servlet.*;
import javax.servlet.http.*;

public class DocView extends HttpServlet {
     public void doGet(HttpServletRequest req, HttpServletResponse res)
           throws ServletException, IOException
     {
     // set output content type
     res.setContentType("text/html");
     
     PrintWriter out = res.getWriter();

     // get query string values
     String id = req.getParameter("id");
     String docFormat = req.getParameter("fmt");

     try {
	 // load JDBC driver
	 DriverManager.registerDriver( new oracle.jdbc.driver.OracleDriver());
	 // Create connection to DB
	 Connection conn = DriverManager.getConnection("jdbc:oracle:thin:@mira.npac.syr.edu:1521:mira", "ioexml","xml");
     
	 // Create a statement to get query_id from sequence idseq
	 Statement stmt = conn.createStatement();
	 
	 // get query_id
	 ResultSet rset = stmt.executeQuery("select idseq.nextval from dual");
     	 
	 String q_id = "0";
	 if (rset.next())
	     q_id = rset.getString(1);
	 
       	 stmt.close();

	 // Create Callable statement
	 CallableStatement cs = conn.prepareCall
	     ("begin ctxsys.ctx_doc.filter(?,?,?,?); end;");
         
         // setup parameters for callable statement
         cs.setString(1,"docindex");
         cs.setString(2,id);
         cs.setString(3,"filtertab");
         cs.setString(4,q_id);
	 cs.executeUpdate();

	 out.println("<font color=red size=+4>Document is transfered from " +docFormat + "</font>");

         // Create statement to get document in HTML format
         Statement stmt1 = conn.createStatement();

         ResultSet rset1 = stmt1.executeQuery("select document from filtertab where query_id = " + q_id);
         
         CLOB html_doc = null;
         int num_char = 0;
         if (rset1.next())
              html_doc = ((OracleResultSet)rset1).getCLOB(1);
         Reader doc_stream = html_doc.getCharacterStream();
         char[] doc_buffer = new char[10];
         while ((num_char = doc_stream.read(doc_buffer)) != -1)
              out.print(doc_buffer);
       	 out.println("</HTML>");
         stmt1.close();
         conn.close();
     }
     catch (SQLException e) {
       out.println(e.getMessage());
     }
     }
}
     
