/* Insert formatted document into DB table with BLOB column
** Class: LoadFileToDB
** Author: Yuping Zhu
** Date: 09-17-1999
*/

package ioe;

import java.io.*;

// import the packages for JDBC
import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;

// import the packages for servlet
import javax.servlet.*;
import javax.servlet.http.*;


public class LoadFileToDB extends HttpServlet {

  public static String myServletPath = null;

  public void doGet(HttpServletRequest req, HttpServletResponse res)
           throws ServletException, IOException 
  {
  // Create a ServletOutputStream to write the output
    ServletOutputStream l_out = res.getOutputStream();
  try {
    // set the content type of the response
    res.setContentType("text/html");
    
    String filepath = req.getParameter("fname");
    
    // Load the Oracle JDBC driver: 
    Class.forName ("oracle.jdbc.driver.OracleDriver");

    // Connect to the database: 
    Connection conn =
	DriverManager.getConnection ("jdbc:oracle:thin:@mira.npac.syr.edu:1521:mira", "ioexml", "xml");
   
    // Create a Statement: 
    Statement stmt = conn.createStatement ();

    stmt.execute("insert into docs values ('Doc-009','test','Yuping','text',empty_blob())");
        	
    ResultSet rset = stmt.executeQuery("select * from docs where id='Doc-009'");
    BLOB blob=null;
    if (rset.next())
          blob = ((OracleResultSet)rset).getBLOB(5);

    File binaryFile = new File(filepath);
    FileInputStream instream = new FileInputStream(binaryFile);
    OutputStream outstream = blob.getBinaryOutputStream();

    int chunk = blob.getChunkSize();
    byte[] buffer = new byte[chunk];
    int length = -1;

    while ((length = instream.read(buffer)) != -1)
          outstream.write(buffer, 0, length);
    instream.close();
    outstream.close();
    System.out.println("File:" + filepath + " Has been inserted into DB");
  }
  catch (SQLException e) {
	l_out.println(e.getMessage());
  }
  catch (ClassNotFoundException e) {
	l_out.println("Can not load the JDBC Driver!");
  }
}

}



