# Entering rdbms.mk

# Entering /osp/d6/s/buildtools/mkfile/prefix.mk

# Entering /osp/d6/s/buildtools/mkfile/defs.mk

SHELL=/bin/sh

AS_EXT=s
LIB_EXT=a
OBJ_EXT=o
PLB_EXT=plb
SO_EXT=so
LOCK_EXT=lk
SQL_EXT=sql
SYM_EXT=sym

LIB_PREFIX=lib
LDLIBFLAG=-l
LDPATHFLAG=-L
PATHSEP= :

AR=ar
AS=as
AWK=awk
CAT=cat
CC=/usr/local/bin/gcc
CD=cd
CHMOD=chmod
CP=cp
CPP=cpp
DATE=date
ECHO=echo
ECHON=echo -n
EXEC=exec
FIND=find
FOLLOW=-follow
NOLEAF=-noleaf
GREP=grep
KILL=kill
SLEEP=sleep
LD=ld
LMAKE=make
LN=ln
LNS=ln -s
MKDIR=mkdir
MKDIRP=mkdir -p
MV=mv
NM=nm
PERL=perl
RM=rm
RMF=rm -f
RMRF=rm -rf
SED=sed
SORT=sort
TOUCH=touch
XARGS=xargs
LS=ls

BINHOME=$(ORACLE_HOME)/bin/
LIBHOME=$(ORACLE_HOME)/lib/

PRODHOME=$(ORACLE_HOME)/$(PRODUCT)/
PRODLIBHOME=$(PRODHOME)lib/
PRODSOHOME=$(PRODLIBHOME)

ECHODO=$(BINHOME)echodo
GENSYSLIB=$(BINHOME)gensyslib
GENCLNTSH=$(BINHOME)genclntsh
GENAGTSH=$(BINHOME)genagtsh
GENNAFLG=$(BINHOME)gennaflg
GENAUTAB=$(BINHOME)genautab

ARCHIVE_OBJ=$(AR) r $@ $*.$(OBJ_EXT)
ARCREATE=$(AR) cr$(ARLOCAL)
ARDELETE=$(AR) d$(ARLOCAL)
AREXTRACT=$(AR) x 
ARPRINT=$(AR) t
ARREPLACE=$(AR) r 
DOAR=$(ARCREATE) $@ $? $(RANLIB)
MAKE=$(LMAKE)
QUIET=>/dev/null 2>&1
QUIETE=2>/dev/null
SILENT=@
CTSMAKEFLAGS=$(SILENT:@=--no-print-directory -s)

CFLAGS=$(GFLAG) $(OPTIMIZE) $(CDEBUG) $(CCFLAGS) $(QACCFLAGS) $(PFLAGS)\
	$(SHARED_CFLAG) $(USRFLAGS)
PFLAGS=$(INCLUDE) $(SPFLAGS) $(LPFLAGS)

LDCCOM=$(PURECMDS) $(CC) $(GFLAG) $(CCFLAGS) $(EXOSFLAGS) $(LDFLAGS)
LDFLAGS=-o $@ $(LDPATHFLAG)$(PRODLIBHOME) $(LDPATHFLAG)$(LIBHOME)
LDLIBS=$(EXPDLIBS) $(EXOSLIBS) $(SYSLIBS) $(EXSYSLIBS) $(MATHLIB) $(USRLIBS)
MATHLIB=-lm
PURECMDS=$(PURELINK) $(PURIFY) $(PURECOV) $(QUANTIFY)

SYSLIBLIST=$(LIBHOME)sysliblist
SYSLIBS=`$(CAT) $(SYSLIBLIST)`

TTLIBD=$(NETLIBD) $(LIBRDBMS_CLT) $(LIBMM) $(CORELIBD) $(LIBEPC) $(LIBCLNTSH)
STATICTTLIBS=$(NAUTAB) $(NAETAB) $(NAEDHS) \
       $(NETLIBS) $(LLIBRDBMS_CLT) $(LLIBMM) $(CORELIBS)\
       $(NETLIBS) $(LLIBRDBMS_CLT) $(LIBPLS_CLT) \
       $(LLIBEPC) $(CORELIBS) $(LLIBRDBMS_CLT) $(CORELIBS) $(LDLIBS)
TTLIBS=$(LLIBCLNTSH) $(STATICTTLIBS)
DEVTTLIBS=$(TTLIBS)

STLIBS=$(SGL_ON) $(CONFIG) $(LLIBSERVER) $(LLIBSKGXP) $(LLIBPLSF) $(LLIBSLAX) \
       $(LIBGENERIC) $(LLIBCLIENT) $(LLIBMM) $(LLIBKNLOPT) $(LLIBPLSB)\
       $(LLIBSERVER) $(LLIBEXTP) $(NAUTAB) $(NAETAB) $(NAEDHS) \
       $(NETLIBS) $(LLIBCLIENT) \
       $(LLIBPLSF) $(LLIBICX) $(LLIBOWSUTL) \
       $(LLIBJAVAVMORJOX) \
       $(NETLIBS) $(LLIBEPC) $(SDOLIBS) $(LLIBCORE) $(LLIBVSN) $(LLIBCOMMON)\
       $(LIBGENERIC) $(LLIBKNLOPT) $(NMLIBS) $(CARTLIBS) $(CORELIBS) $(LDLIBS)

# Exiting /osp/d6/s/buildtools/mkfile/defs.mk
# Entering /osp/d6/s/buildtools/mkfile/platform.mk

FAMILY=unix
PLATFORM=solaris

MOTIFHOME=/usr/dt/
OPENWINHOME=/usr/openwin/
GUILIBHOME=$(OPENWINHOME)lib/

DIRSEP=/

#CLUSTERDIR=/opt/SUNWcluster
CLUSTERDIR=

GMAKE=make -r
LMAKE=/usr/ccs/bin/make
FIND=/usr/local/bin/find # gnu find!
PS=ps -feda

ARCHIVE=@`if echo ${LIB} | grep lib > /dev/null 2>&1;then $(ARCREATE) $(LIB) $? $(RANLIB); else echo ""; fi`

GROUP=/etc/group

LINK=ld -dy $(COMPOBJS)

LLIBTHREAD=

MOTIFLIBS=-L$(MOTIFHOME)lib -lXm -lgen -L$(GUILIBHOME) -R$(GUILIBHOME)\
	-lXt -lX11 -lw -lm
XLIBS=-L$(GUILIBHOME) -R$(GUILIBHOME) $(GUILIBHHOME)libXaw.so.4 -lXt -lXmu\
	-lXext -lX11 -lm

#EXOSFLAGS=-L$(CLUSTERDIR)/lib -R$(CLUSTERDIR)/lib
EXOSFLAGS=

CCVER=SC4.2
COMPOBJ=$(ORACLE_HOME)/lib/$(CCVER)
COMPOBJS=$(COMPOBJ)/crti.o $(COMPOBJ)/crt1.o $(COMPOBJ)/crtn.o

#EXSYSLIBS= -R $(CLUSTERDIR)/lib:$(ORACLE_HOME)/lib \
EXSYSLIBS= -R $(ORACLE_HOME)/lib \
	$(LD_LIBRARY_PATH):$(CLUSTERDIR)/lib:/usr/ccs/lib:/usr/lib \
#	-Y P,$(LD_LIBRARY_PATH):$(CLUSTERDIR)/lib:/usr/ccs/lib:/usr/lib \
	-Qy -lc -laio $(LLIBPOSIX4) $(LLIBKSTAT)
DEVTTLIBS=$(NETLIBS) $(LLIBRDBMS_CLT) $(NETLIBS) $(LLIBRDBMS_CLT)\
	$(LIBPLS_CLT) $(LLIBEPC) $(CORELIBS) $(EXPDLIBS) $(EXOSLIBS)\
	$(SYSLIBS) $(MATHLIB)

#OPTIMIZE2=-xO2
OPTIMIZE2=
OPTIMIZE4=-xO4
OPTIMIZE=$(OPTIMIZE2)

ROFLAGS=-c -xMerge
SPFLAGS=-DSLMXMX_ENABLE -DSLTS_ENABLE -D_SVID_GETTOD

AR=/usr/ccs/bin/ar
AS=/usr/ccs/bin/as
CPP=$(CC) -E $(ANSI)
CHMOD=/bin/chmod
CHGRP=/bin/chgrp
CHOWN=/bin/chown

#ASFLAGS=-P -K PIC
ASFLAGS=-P 
ASPFLAGS=-P $(PFLAGS)
NOKPIC_ASFLAGS=-P
ASRO=$(AS) $(ASROFLAGS) $(MAKERO) $<
ASROFLAGS=$(ASFLAGS)
CXC=-Xc
#CXA=-Xa
CXA=
ANSI=$(CXC)


MR=-mr
#NOKPIC_CCFLAGS= -Xa $(PROFILE) -xstrconst -xF $(XS) $(MR) \
NOKPIC_CCFLAGS=  $(PROFILE) -xstrconst -xF $(XS) $(MR) \
        -xarch=v8 -xcache=16/32/1:1024/64/1 -xchip=ultra -D_REENTRANT
CCFLAGS= $(NOKPIC_CCFLAGS) -K PIC
FASTCCFLAGS= $(NOKPIC_CCFLAGS)

SHARED_LDFLAG=-G -L$(ORACLE_HOME)/lib -R$(ORACLE_HOME)/lib -o
SHARED_CFLAG=

# Exiting /osp/d6/s/buildtools/mkfile/platform.mk
# Entering /osp/d6/s/buildtools/mkfile/rules.mk
 
# Exiting /osp/d6/s/buildtools/mkfile/rules.mk
# Exiting /osp/d6/s/buildtools/mkfile/prefix.mk
# Entering /osp/d6/s/oracore/exports.mk

COREHOME    = $(ORACLE_HOME)/oracore/
ORACOREHOME = $(COREHOME)



CORE_LIB_VER = 8
CORE_LIB_NAME = core
LIBCORE  = $(LIBHOME)$(LIB_PREFIX)$(CORE_LIB_NAME)$(CORE_LIB_VER).$(LIB_EXT)
LLIBCORE = $(LDLIBFLAG)$(CORE_LIB_NAME)$(CORE_LIB_VER)

LIBCORE_ARC_LIB		= $(LIBHOME)$(CORE_LIB).$(LIB_EXT)

LIBCORE_SHARE_LIB	= $(LIBHOME)$(CORE_LIB).$(SO_EXT)


S0MAIN   = $(LIBHOME)s0main.$(OBJ_EXT)
S1MAIN_C = $(COREHOME)src/corehl/lpm/sosd/main/s1main.c
SCOREPT  = $(LIBHOME)scorept.$(OBJ_EXT)
SSCOREED = $(LIBHOME)sscoreed.$(OBJ_EXT)



COREPUBLIC=$(COREHOME)include $(COREHOME)public/

ORACOREPUBH=$(I_SYM)$(COREHOME)include $(I_SYM)$(COREHOME)public


CORELIBD = $(LIBNLSRTL) $(LIBCV6) $(LIBCORE) $(LIBNLSRTL) $(LIBCORE) \
             $(LIBNLSRTL) 
CORELIBS = $(LLIBNLSRTL) $(LLIBCV6) $(LLIBCORE) $(LLIBNLSRTL) $(LLIBCORE) \
             $(LLIBNLSRTL) 




# Entering /osp/d6/s/oracore/s_exports.mk
 
# Exiting /osp/d6/s/oracore/s_exports.mk
# Exiting /osp/d6/s/oracore/exports.mk
# Entering /osp/d6/s/nlsrtl/exports.mk

NLSRTLHOME= $(ORACLE_HOME)/nlsrtl/


ORA_NLS = $(ORACLE_HOME)/ocommon/nls/admin/data/
ORA_NLS33 = $(ORACLE_HOME)/ocommon/nls/admin/data/

LIBNLSRTLNAME = nls8
LIBNLSRTL= $(LIBHOME)$(LIB_PREFIX)$(LIBNLSRTLNAME).$(LIB_EXT)
LLIBNLSRTL= $(LDLIBFLAG)$(LIBNLSRTLNAME)$(LIB_SUFFIX)

NLSRTLPUBH = $(I_SYM)$(NLSRTLHOME)include

# Entering /osp/d6/s/nlsrtl/s_exports.mk


# Exiting /osp/d6/s/nlsrtl/s_exports.mk
# Exiting /osp/d6/s/nlsrtl/exports.mk
# Entering /osp/d6/s/network/exports.mk
# Entering /osp/d6/s/network/s_exports.mk



# Exiting /osp/d6/s/network/s_exports.mk

# Entering /osp/d6/s/network/libnames.mk

# Entering /osp/d6/s/buildtools/mkfile/prefix.mk

# Entering /osp/d6/s/buildtools/mkfile/defs.mk

SHELL=/bin/sh

AS_EXT=s
LIB_EXT=a
OBJ_EXT=o
PLB_EXT=plb
SO_EXT=so
LOCK_EXT=lk
SQL_EXT=sql
SYM_EXT=sym

LIB_PREFIX=lib
LDLIBFLAG=-l
LDPATHFLAG=-L
PATHSEP= :

AR=ar
AS=as
AWK=awk
CAT=cat
CC=/usr/local/bin/gcc
CD=cd
CHMOD=chmod
CP=cp
CPP=cpp
DATE=date
ECHO=echo
ECHON=echo -n
EXEC=exec
FIND=find
FOLLOW=-follow
NOLEAF=-noleaf
GREP=grep
KILL=kill
SLEEP=sleep
LD=ld
LMAKE=make
LN=ln
LNS=ln -s
MKDIR=mkdir
MKDIRP=mkdir -p
MV=mv
NM=nm
PERL=perl
RM=rm
RMF=rm -f
RMRF=rm -rf
SED=sed
SORT=sort
TOUCH=touch
XARGS=xargs
LS=ls

BINHOME=$(ORACLE_HOME)/bin/
LIBHOME=$(ORACLE_HOME)/lib/

PRODHOME=$(ORACLE_HOME)/$(PRODUCT)/
PRODLIBHOME=$(PRODHOME)lib/
PRODSOHOME=$(PRODLIBHOME)

ECHODO=$(BINHOME)echodo
GENSYSLIB=$(BINHOME)gensyslib
GENCLNTSH=$(BINHOME)genclntsh
GENAGTSH=$(BINHOME)genagtsh
GENNAFLG=$(BINHOME)gennaflg
GENAUTAB=$(BINHOME)genautab

ARCHIVE_OBJ=$(AR) r $@ $*.$(OBJ_EXT)
ARCREATE=$(AR) cr$(ARLOCAL)
ARDELETE=$(AR) d$(ARLOCAL)
AREXTRACT=$(AR) x 
ARPRINT=$(AR) t
ARREPLACE=$(AR) r 
DOAR=$(ARCREATE) $@ $? $(RANLIB)
MAKE=$(LMAKE)
QUIET=>/dev/null 2>&1
QUIETE=2>/dev/null
SILENT=@
CTSMAKEFLAGS=$(SILENT:@=--no-print-directory -s)

CFLAGS=$(GFLAG) $(OPTIMIZE) $(CDEBUG) $(CCFLAGS) $(QACCFLAGS) $(PFLAGS)\
	$(SHARED_CFLAG) $(USRFLAGS)
PFLAGS=$(INCLUDE) $(SPFLAGS) $(LPFLAGS)

LDCCOM=$(PURECMDS) $(CC) $(GFLAG) $(CCFLAGS) $(EXOSFLAGS) $(LDFLAGS)
LDFLAGS=-o $@ $(LDPATHFLAG)$(PRODLIBHOME) $(LDPATHFLAG)$(LIBHOME)
LDLIBS=$(EXPDLIBS) $(EXOSLIBS) $(SYSLIBS) $(EXSYSLIBS) $(MATHLIB) $(USRLIBS)
MATHLIB=-lm
PURECMDS=$(PURELINK) $(PURIFY) $(PURECOV) $(QUANTIFY)

SYSLIBLIST=$(LIBHOME)sysliblist
SYSLIBS=`$(CAT) $(SYSLIBLIST)`

TTLIBD=$(NETLIBD) $(LIBRDBMS_CLT) $(LIBMM) $(CORELIBD) $(LIBEPC) $(LIBCLNTSH)
STATICTTLIBS=$(NAUTAB) $(NAETAB) $(NAEDHS) \
       $(NETLIBS) $(LLIBRDBMS_CLT) $(LLIBMM) $(CORELIBS)\
       $(NETLIBS) $(LLIBRDBMS_CLT) $(LIBPLS_CLT) \
       $(LLIBEPC) $(CORELIBS) $(LLIBRDBMS_CLT) $(CORELIBS) $(LDLIBS)
TTLIBS=$(LLIBCLNTSH) $(STATICTTLIBS)
DEVTTLIBS=$(TTLIBS)

STLIBS=$(SGL_ON) $(CONFIG) $(LLIBSERVER) $(LLIBSKGXP) $(LLIBPLSF) $(LLIBSLAX) \
       $(LIBGENERIC) $(LLIBCLIENT) $(LLIBMM) $(LLIBKNLOPT) $(LLIBPLSB)\
       $(LLIBSERVER) $(LLIBEXTP) $(NAUTAB) $(NAETAB) $(NAEDHS) \
       $(NETLIBS) $(LLIBCLIENT) \
       $(LLIBPLSF) $(LLIBICX) $(LLIBOWSUTL) \
       $(LLIBJAVAVMORJOX) \
       $(NETLIBS) $(LLIBEPC) $(SDOLIBS) $(LLIBCORE) $(LLIBVSN) $(LLIBCOMMON)\
       $(LIBGENERIC) $(LLIBKNLOPT) $(NMLIBS) $(CARTLIBS) $(CORELIBS) $(LDLIBS)

# Exiting /osp/d6/s/buildtools/mkfile/defs.mk
# Entering /osp/d6/s/buildtools/mkfile/platform.mk

FAMILY=unix
PLATFORM=solaris

MOTIFHOME=/usr/dt/
OPENWINHOME=/usr/openwin/
GUILIBHOME=$(OPENWINHOME)lib/

DIRSEP=/

#CLUSTERDIR=/opt/SUNWcluster
CLUSTERDIR=

GMAKE=make -r
LMAKE=/usr/ccs/bin/make
FIND=/usr/local/bin/find # gnu find!
PS=ps -feda

ARCHIVE=@`if echo ${LIB} | grep lib > /dev/null 2>&1;then $(ARCREATE) $(LIB) $? $(RANLIB); else echo ""; fi`

GROUP=/etc/group

LINK=ld -dy $(COMPOBJS)

LLIBTHREAD=

MOTIFLIBS=-L$(MOTIFHOME)lib -lXm -lgen -L$(GUILIBHOME) -R$(GUILIBHOME)\
	-lXt -lX11 -lw -lm
XLIBS=-L$(GUILIBHOME) -R$(GUILIBHOME) $(GUILIBHHOME)libXaw.so.4 -lXt -lXmu\
	-lXext -lX11 -lm

#EXOSFLAGS=-L$(CLUSTERDIR)/lib -R$(CLUSTERDIR)/lib
EXOSFLAGS=

CCVER=SC4.2
COMPOBJ=$(ORACLE_HOME)/lib/$(CCVER)
COMPOBJS=$(COMPOBJ)/crti.o $(COMPOBJ)/crt1.o $(COMPOBJ)/crtn.o

#EXSYSLIBS= -R $(CLUSTERDIR)/lib:$(ORACLE_HOME)/lib \
EXSYSLIBS= -R $(ORACLE_HOME)/lib \
	$(LD_LIBRARY_PATH):/usr/ccs/lib:/usr/lib 
#	-Y P,$(LD_LIBRARY_PATH):$(CLUSTERDIR)/lib:/usr/ccs/lib:/usr/lib \
	-Qy -lc -laio $(LLIBPOSIX4) $(LLIBKSTAT)
DEVTTLIBS=$(NETLIBS) $(LLIBRDBMS_CLT) $(NETLIBS) $(LLIBRDBMS_CLT)\
	$(LIBPLS_CLT) $(LLIBEPC) $(CORELIBS) $(EXPDLIBS) $(EXOSLIBS)\
	$(SYSLIBS) $(MATHLIB)

#OPTIMIZE2=-xO2
OPTIMIZE2=
OPTIMIZE4=-xO4
OPTIMIZE=$(OPTIMIZE2)

ROFLAGS=-c -xMerge
SPFLAGS=-DSLMXMX_ENABLE -DSLTS_ENABLE -D_SVID_GETTOD

AR=/usr/ccs/bin/ar
AS=/usr/ccs/bin/as
CPP=$(CC) -E $(ANSI)
CHMOD=/bin/chmod
CHGRP=/bin/chgrp
CHOWN=/bin/chown

#ASFLAGS=-P -K PIC
ASFLAGS=-P 
ASPFLAGS=-P $(PFLAGS)
NOKPIC_ASFLAGS=-P
ASRO=$(AS) $(ASROFLAGS) $(MAKERO) $<
ASROFLAGS=$(ASFLAGS)
CXC=-Xc
#CXA=-Xa
CXA=
ANSI=$(CXC)


MR=-mr
#NOKPIC_CCFLAGS= -Xa $(PROFILE) -xstrconst -xF $(XS) $(MR) \
NOKPIC_CCFLAGS= $(PROFILE) -xstrconst -xF $(XS) $(MR) \
        -xarch=v8 -xcache=16/32/1:1024/64/1 -xchip=ultra -D_REENTRANT
CCFLAGS= $(NOKPIC_CCFLAGS) -K PIC
FASTCCFLAGS= $(NOKPIC_CCFLAGS)

SHARED_LDFLAG=-G -L$(ORACLE_HOME)/lib -R$(ORACLE_HOME)/lib -o
SHARED_CFLAG=

# Exiting /osp/d6/s/buildtools/mkfile/platform.mk
# Entering /osp/d6/s/buildtools/mkfile/rules.mk
 
# Exiting /osp/d6/s/buildtools/mkfile/rules.mk
# Exiting /osp/d6/s/buildtools/mkfile/prefix.mk

VER         =8
BASENAME    =n
NETWORKHOME = $(ORACLE_HOME)/network/
NETWORKLIB  = $(NETWORKHOME)lib/

COMMONNAME=${BASENAME}${VER}
NLNAME=${BASENAME}l${VER}
TCPNAME=${BASENAME}tcp${VER}
DECNETNAME=${BASENAME}dec${VER}
LU62NAME=${BASENAME}lu62${VER}
MBNAME=${BASENAME}mb${VER}
DCENAME=${BASENAME}dce${VER}
BEQNAME=${BASENAME}beq${VER}
IPCNAME=${BASENAME}ipc${VER}
SPXNAME=${BASENAME}spx${VER}
TLINAME=${BASENAME}tli${VER}
TLITNAME=${BASENAME}tlit${VER}
TLISNAME=${BASENAME}tlis${VER}
TLIDNAME=${BASENAME}tlid${VER}
USNAME=${BASENAME}us${VER}
SHMNAME=${BASENAME}shm${VER}
TCPSNAME=${BASENAME}tcps${VER}
LSNRNAME=${BASENAME}lsnr${VER}
LSNRCNAME=${BASENAME}lsnrc${VER}
K5NAME=${BASENAME}k5${VER}
RADNAME=${BASENAME}rad${VER}
IDXNAME=${BASENAME}idx${VER}
GSSNAME=${BASENAME}gss${VER}
SIDNAME=${BASENAME}sid${VER}
OSSNAME=${BASENAME}oss${VER}
NTSNAME=${BASENAME}nts${VER}
NSSNAME=${BASENAME}nss${VER}
CRYPTNAME=${BASENAME}crypt${VER}
ONNAME=${BASENAME}on${VER}
ONDNAME=${BASENAME}ond${VER}
ONCNAME=${BASENAME}onc${VER}
ONCJNAME=${BASENAME}oncj${VER}
RONAME=${BASENAME}ro${VER}
ROCNAME=${BASENAME}roc${VER}
ROXNAME=${BASENAME}rox${VER}
ROTNAME=${BASENAME}rot${VER}
CMNAME=${BASENAME}cm${VER}
NHOSTNAME=${BASENAME}host${VER}
TNSNAME=${BASENAME}tns${VER}
ORACLENAME=${BASENAME}oname${VER}
NISNAME=${BASENAME}nis${VER}
CDSNAME=${BASENAME}cds${VER}
NDSNAME=${BASENAME}nds${VER}
LDAPNAME=${BASENAME}ldap${VER}
LDAPJNAME=${BASENAME}ldapj${VER}
SSLBNAME=${BASENAME}sslb${VER}
NUJNINAME=${BASENAME}jni${VER}

NMPNAME=${BASENAME}nmp${VER}

TANAME=${BASENAME}ta${VER}
TALNAME=${BASENAME}tal${VER}
TNSAPINAME=tnsapi${VER}

RSASTDNAME=rsastd
BCERTNAME=bcert
LDAPCLNTNAME=ldapclnt${VER}
DCESYSNAME=dce




SNLPTDUM         =  $(NETWORKLIB)snlptdum.$(OBJ_EXT) 

LIBNETWORK	 =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBTHINNCR       =  $(NETWORKLIB)$(LIB_PREFIX)$(ROTNAME).$(LIB_EXT)

LIBONCJ          =  $(NETWORKLIB)$(LIB_PREFIX)$(ONCJNAME).$(SO_EXT)
LIBNUJNI         =  $(NETWORKLIB)$(LIB_PREFIX)$(NUJNINAME).$(SO_EXT)

LIBNCR           =  $(NETWORKLIB)$(LIB_PREFIX)$(RONAME).$(LIB_EXT)
LIBNFP           =  $(NETWORKLIB)$(LIB_PREFIX)$(CMNAME).$(LIB_EXT)
LIBNI            =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNNCC          =  $(NETWORKLIB)$(LIB_PREFIX)$(ONCNAME).$(LIB_EXT)
LIBNND           =  $(NETWORKLIB)$(LIB_PREFIX)$(ONDNAME).$(LIB_EXT)
LIBNNO           =  $(NETWORKLIB)$(LIB_PREFIX)$(ONNAME).$(LIB_EXT)
LIBNSGL          =  $(NETWORKLIB)$(LIB_PREFIX)$(LSNRNAME).$(LIB_EXT)
LIBNSGLC         =  $(NETWORKLIB)$(LIB_PREFIX)$(LSNRCNAME).$(LIB_EXT)
LIBRSASTD        =  $(NETWORKLIB)$(LIB_PREFIX)$(RSASTDNAME).$(LIB_EXT)

LLIBNCR           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(RONAME)$(ILIB_SUFFIX)
LLIBNFP           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(CMNAME)$(ILIB_SUFFIX)
LLIBNI            =  $(LDLIBFLAG)$(ILIB_PREFIX)$(COMMONNAME)$(ILIB_SUFFIX)
LLIBNNCC          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(ONCNAME)$(ILIB_SUFFIX)
LLIBNND           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(ONDNAME)$(ILIB_SUFFIX)
LLIBNNO           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(ONNAME)$(ILIB_SUFFIX)
LLIBNSGL          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(LSNRNAME)$(ILIB_SUFFIX)
LLIBNSGLC         =  $(LDLIBFLAG)$(ILIB_PREFIX)$(LSNRCNAME)$(ILIB_SUFFIX)
LLIBRSASTD        =  $(LDLIBFLAG)$(ILIB_PREFIX)$(RSASTDNAME)$(ILIB_SUFFIX)

LIBNAUK5         =  $(NETWORKLIB)$(LIB_PREFIX)$(K5NAME).$(LIB_EXT)
LIBNAUS          =  $(NETWORKLIB)$(LIB_PREFIX)$(SIDNAME).$(LIB_EXT)
LIBNAUR          =  $(NETWORKLIB)$(LIB_PREFIX)$(RADNAME).$(LIB_EXT)
LIBNAUI          =  $(NETWORKLIB)$(LIB_PREFIX)$(IDXNAME).$(LIB_EXT)
LIBNAUG          =  $(NETWORKLIB)$(LIB_PREFIX)$(GSSNAME).$(LIB_EXT)
LIBNAUZ          =  $(NETWORKLIB)$(LIB_PREFIX)$(OSSNAME).$(LIB_EXT)
LIBNAUNTS        =  $(NETWORKLIB)$(LIB_PREFIX)$(NTSNAME).$(LIB_EXT)

LLIBNAUK5         =  $(LDLIBFLAG)$(ILIB_PREFIX)$(K5NAME)$(ILIB_SUFFIX)
LLIBNAUS          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(SIDNAME)$(ILIB_SUFFIX)
LLIBNAUR          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(RADNAME)$(ILIB_SUFFIX)
LLIBNAUI          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(IDXNAME)$(ILIB_SUFFIX)
LLIBNAUG          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(GSSNAME)$(ILIB_SUFFIX)
LLIBNAUZ          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(OSSNAME)$(ILIB_SUFFIX)
LLIBNAUNTS        =  $(LDLIBFLAG)$(ILIB_PREFIX)$(NTSNAME)$(ILIB_SUFFIX)



LIBNTT           =  $(NETWORKLIB)$(LIB_PREFIX)$(TCPNAME).$(LIB_EXT)
LIBNTZ           =  $(NETWORKLIB)$(LIB_PREFIX)$(TCPSNAME).$(LIB_EXT)
LIBNTS           =  $(NETWORKLIB)$(LIB_PREFIX)$(SPXNAME).$(LIB_EXT)
LIBNTD           =  $(NETWORKLIB)$(LIB_PREFIX)$(DECNETNAME).$(LIB_EXT)
LIBNTOD          =  $(NETWORKLIB)$(LIB_PREFIX)$(DCENAME).$(LIB_EXT)
LIBNTLU62        =  $(NETWORKLIB)$(LIB_PREFIX)$(LU62NAME).$(LIB_EXT)
LIBNTTLI	 =  $(NETWORKLIB)$(LIB_PREFIX)$(TLINAME).$(LIB_EXT)
LIBNTUS          =  $(NETWORKLIB)$(LIB_PREFIX)$(USNAME).$(LIB_EXT)
LIBNTSHM         =  $(NETWORKLIB)$(LIB_PREFIX)$(SHMNAME).$(LIB_EXT)
LIBNTP           =  $(NETWORKLIB)$(LIB_PREFIX)$(BEQNAME).$(LIB_EXT)
LIBNTNP          =  $(NETWORKLIB)$(LIB_PREFIX)$(NMPNAME).$(LIB_EXT)

LLIBNTT           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(TCPNAME)$(ILIB_SUFFIX)
LLIBNTZ           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(TCPSNAME)$(ILIB_SUFFIX)
LLIBNTS           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(SPXNAME)$(ILIB_SUFFIX)
LLIBNTD           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(DECNETNAME)$(ILIB_SUFFIX)
LLIBNTOD          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(DCENAME)$(ILIB_SUFFIX)
LLIBNTLU62        =  $(LDLIBFLAG)$(ILIB_PREFIX)$(LU62NAME)$(ILIB_SUFFIX)
LLIBNTTLI	 =  $(LDLIBFLAG)$(ILIB_PREFIX)$(TLINAME)$(ILIB_SUFFIX)
LLIBNTUS          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(USNAME)$(ILIB_SUFFIX)
LLIBNTSHM        = $(NETWORKLIB)$(LIB_PREFIX)$(SHMNAME)$(ILIB_SUFFIX)
LLIBNTP           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(BEQNAME)$(ILIB_SUFFIX)
LLIBNTNP          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(NMPNAME)$(ILIB_SUFFIX)

LIBNL1           =  $(NETWORKLIB)$(LIB_PREFIX)$(NLNAME).$(LIB_EXT)
LIBNL2           =  $(NETWORKLIB)$(LIB_PREFIX)$(NLNAME).$(LIB_EXT)

LLIBNL           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(NLNAME)$(ILIB_SUFFIX)


LIBSNS           =  $(NETWORKLIB)$(LIB_PREFIX)$(CRYPTNAME).$(LIB_EXT)
LIBNUAPI         =  $(NETWORKLIB)$(LIB_PREFIX)$(TANAME).$(LIB_EXT)
LIBNULOCAL       =  $(NETWORKLIB)$(LIB_PREFIX)$(TALNAME).$(LIB_EXT)
LIBBCERT	 =  $(NETWORKLIB)$(LIB_PREFIX)$(BCERTNAME).$(LIB_EXT) 

LLIBSNS           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(CRYPTNAME)$(ILIB_SUFFIX)
LLIBNUAPI         =  $(LDLIBFLAG)$(ILIB_PREFIX)$(TANAME)$(ILIB_SUFFIX)
LLIBNULOCAL       =  $(LDLIBFLAG)$(ILIB_PREFIX)$(TALNAME)$(ILIB_SUFFIX)
LLIBBCERT	  =  $(LDLIBFLAG)$(ILIB_PREFIX)$(BCERTNAME)$(ILIB_SUFFIX)


LLIBTNSAPI       = $(LDLIBFLAG)$(ILIB_PREFIX)$(TNSAPINAME)$(ILIB_SUFFIX)
LLIBNNCC         =  $(NETWORKLIB)$(LIB_PREFIX)$(ONCNAME).$(LIB_EXT)
LLIBNUAPI	 = $(LDLIBFLAG)$(ILIB_PREFIX)$(TANAME)$(ILIB_SUFFIX)
LLIBNULOCAL	 = $(LDLIBFLAG)$(ILIB_PREFIX)$(TALNAME)$(ILIB_SUFFIX)
LLIBRSASTD       = $(LDLIBFLAG)$(ILIB_PREFIX)$(RSASTDNAME)$(ILIB_SUFFIX)
LLIBBCERT        = $(LDLIBFLAG)$(ILIB_PREFIX)$(BCERTNAME)$(ILIB_SUFFIX)
LLIBSSL          = #$(LDLIBFLAG)$(ILIB_PREFIX)sslref-bsafe$(ILIB_SUFFIX)
LLIBSSLB         = $(LDLIBFLAG)$(ILIB_PREFIX)$(SSLBNAME)$(ILIB_SUFFIX)

LIBNA            =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNAE           =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNAU           =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNLNV          =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNMP           =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNNCI          =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNNFG          =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNNG           =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNPL           =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNR            =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNS            =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNT            =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNTR           =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNZ            =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNMS0          =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBSSLREF 	 =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)

LIBTNSAPI        =  $(NETWORKLIB)$(LIB_PREFIX)$(TNSAPINAME).$(LIB_EXT)

LIBSSLB          =  $(NETWORKLIB)$(LIB_PREFIX)$(SSLBNAME).$(LIB_EXT)

LDAPSYSLIBD = $(LIBHOME)$(LIB_PREFIX)$(LDAPCLNTNAME).$(LIB_EXT)
LDAPSYSLIBS = $(LDLIBFLAG)$(ILIB_PREFIX)$(LDAPCLNTNAME)$(ILIB_SUFFIX)
# Exiting /osp/d6/s/network/libnames.mk

# Entering /osp/d6/s/buildtools/mkfile/prefix.mk

# Entering /osp/d6/s/buildtools/mkfile/defs.mk

SHELL=/bin/sh

AS_EXT=s
LIB_EXT=a
OBJ_EXT=o
PLB_EXT=plb
SO_EXT=so
LOCK_EXT=lk
SQL_EXT=sql
SYM_EXT=sym

LIB_PREFIX=lib
LDLIBFLAG=-l
LDPATHFLAG=-L
PATHSEP= :

AR=ar
AS=as
AWK=awk
CAT=cat
CC=/usr/local/bin/gcc
CD=cd
CHMOD=chmod
CP=cp
CPP=cpp
DATE=date
ECHO=echo
ECHON=echo -n
EXEC=exec
FIND=find
FOLLOW=-follow
NOLEAF=-noleaf
GREP=grep
KILL=kill
SLEEP=sleep
LD=ld
LMAKE=make
LN=ln
LNS=ln -s
MKDIR=mkdir
MKDIRP=mkdir -p
MV=mv
NM=nm
PERL=perl
RM=rm
RMF=rm -f
RMRF=rm -rf
SED=sed
SORT=sort
TOUCH=touch
XARGS=xargs
LS=ls

BINHOME=$(ORACLE_HOME)/bin/
LIBHOME=$(ORACLE_HOME)/lib/

PRODHOME=$(ORACLE_HOME)/$(PRODUCT)/
PRODLIBHOME=$(PRODHOME)lib/
PRODSOHOME=$(PRODLIBHOME)

ECHODO=$(BINHOME)echodo
GENSYSLIB=$(BINHOME)gensyslib
GENCLNTSH=$(BINHOME)genclntsh
GENAGTSH=$(BINHOME)genagtsh
GENNAFLG=$(BINHOME)gennaflg
GENAUTAB=$(BINHOME)genautab

ARCHIVE_OBJ=$(AR) r $@ $*.$(OBJ_EXT)
ARCREATE=$(AR) cr$(ARLOCAL)
ARDELETE=$(AR) d$(ARLOCAL)
AREXTRACT=$(AR) x 
ARPRINT=$(AR) t
ARREPLACE=$(AR) r 
DOAR=$(ARCREATE) $@ $? $(RANLIB)
MAKE=$(LMAKE)
QUIET=>/dev/null 2>&1
QUIETE=2>/dev/null
SILENT=@
CTSMAKEFLAGS=$(SILENT:@=--no-print-directory -s)

CFLAGS=$(GFLAG) $(OPTIMIZE) $(CDEBUG) $(CCFLAGS) $(QACCFLAGS) $(PFLAGS)\
	$(SHARED_CFLAG) $(USRFLAGS)
PFLAGS=$(INCLUDE) $(SPFLAGS) $(LPFLAGS)

LDCCOM=$(PURECMDS) $(CC) $(GFLAG) $(CCFLAGS) $(EXOSFLAGS) $(LDFLAGS)
LDFLAGS=-o $@ $(LDPATHFLAG)$(PRODLIBHOME) $(LDPATHFLAG)$(LIBHOME)
LDLIBS=$(EXPDLIBS) $(EXOSLIBS) $(SYSLIBS) $(EXSYSLIBS) $(MATHLIB) $(USRLIBS)
MATHLIB=-lm
PURECMDS=$(PURELINK) $(PURIFY) $(PURECOV) $(QUANTIFY)

SYSLIBLIST=$(LIBHOME)sysliblist
SYSLIBS=`$(CAT) $(SYSLIBLIST)`

TTLIBD=$(NETLIBD) $(LIBRDBMS_CLT) $(LIBMM) $(CORELIBD) $(LIBEPC) $(LIBCLNTSH)
STATICTTLIBS=$(NAUTAB) $(NAETAB) $(NAEDHS) \
       $(NETLIBS) $(LLIBRDBMS_CLT) $(LLIBMM) $(CORELIBS)\
       $(NETLIBS) $(LLIBRDBMS_CLT) $(LIBPLS_CLT) \
       $(LLIBEPC) $(CORELIBS) $(LLIBRDBMS_CLT) $(CORELIBS) $(LDLIBS)
TTLIBS=$(LLIBCLNTSH) $(STATICTTLIBS)
DEVTTLIBS=$(TTLIBS)

STLIBS=$(SGL_ON) $(CONFIG) $(LLIBSERVER) $(LLIBSKGXP) $(LLIBPLSF) $(LLIBSLAX) \
       $(LIBGENERIC) $(LLIBCLIENT) $(LLIBMM) $(LLIBKNLOPT) $(LLIBPLSB)\
       $(LLIBSERVER) $(LLIBEXTP) $(NAUTAB) $(NAETAB) $(NAEDHS) \
       $(NETLIBS) $(LLIBCLIENT) \
       $(LLIBPLSF) $(LLIBICX) $(LLIBOWSUTL) \
       $(LLIBJAVAVMORJOX) \
       $(NETLIBS) $(LLIBEPC) $(SDOLIBS) $(LLIBCORE) $(LLIBVSN) $(LLIBCOMMON)\
       $(LIBGENERIC) $(LLIBKNLOPT) $(NMLIBS) $(CARTLIBS) $(CORELIBS) $(LDLIBS)

# Exiting /osp/d6/s/buildtools/mkfile/defs.mk
# Entering /osp/d6/s/buildtools/mkfile/platform.mk

FAMILY=unix
PLATFORM=solaris

MOTIFHOME=/usr/dt/
OPENWINHOME=/usr/openwin/
GUILIBHOME=$(OPENWINHOME)lib/

DIRSEP=/

#CLUSTERDIR=/opt/SUNWcluster


GMAKE=make -r
LMAKE=/usr/ccs/bin/make
FIND=/usr/local/bin/find # gnu find!
PS=ps -feda

ARCHIVE=@`if echo ${LIB} | grep lib > /dev/null 2>&1;then $(ARCREATE) $(LIB) $? $(RANLIB); else echo ""; fi`

GROUP=/etc/group

LINK=ld -dy $(COMPOBJS)

LLIBTHREAD=

MOTIFLIBS=-L$(MOTIFHOME)lib -lXm -lgen -L$(GUILIBHOME) -R$(GUILIBHOME)\
	-lXt -lX11 -lw -lm
XLIBS=-L$(GUILIBHOME) -R$(GUILIBHOME) $(GUILIBHHOME)libXaw.so.4 -lXt -lXmu\
	-lXext -lX11 -lm

#EXOSFLAGS=-L$(CLUSTERDIR)/lib -R$(CLUSTERDIR)/lib
EXOSFLAGS=

CCVER=SC4.2
COMPOBJ=$(ORACLE_HOME)/lib/$(CCVER)
COMPOBJS=$(COMPOBJ)/crti.o $(COMPOBJ)/crt1.o $(COMPOBJ)/crtn.o

#EXSYSLIBS= -R $(CLUSTERDIR)/lib:$(ORACLE_HOME)/lib \
EXSYSLIBS= -R $(ORACLE_HOME)/lib \
	$(LD_LIBRARY_PATH):/usr/ccs/lib:/usr/lib \
#	-Y P,$(LD_LIBRARY_PATH):$(CLUSTERDIR)/lib:/usr/ccs/lib:/usr/lib \
	-Qy -lc -laio $(LLIBPOSIX4) $(LLIBKSTAT)
DEVTTLIBS=$(NETLIBS) $(LLIBRDBMS_CLT) $(NETLIBS) $(LLIBRDBMS_CLT)\
	$(LIBPLS_CLT) $(LLIBEPC) $(CORELIBS) $(EXPDLIBS) $(EXOSLIBS)\
	$(SYSLIBS) $(MATHLIB)

#OPTIMIZE2=-xO2
OPTIMIZE2=
OPTIMIZE4=-xO4
OPTIMIZE=$(OPTIMIZE2)

ROFLAGS=-c -xMerge
SPFLAGS=-DSLMXMX_ENABLE -DSLTS_ENABLE -D_SVID_GETTOD

AR=/usr/ccs/bin/ar
AS=/usr/ccs/bin/as
CPP=$(CC) -E $(ANSI)
CHMOD=/bin/chmod
CHGRP=/bin/chgrp
CHOWN=/bin/chown

ASFLAGS=-P -K PIC
ASPFLAGS=-P $(PFLAGS)
NOKPIC_ASFLAGS=-P
ASRO=$(AS) $(ASROFLAGS) $(MAKERO) $<
ASROFLAGS=$(ASFLAGS)
CXC=-Xc
#CXA=-Xa
CXA=
ANSI=$(CXC)


MR=-mr
#NOKPIC_CCFLAGS= -Xa $(PROFILE) -xstrconst -xF $(XS) $(MR) \
NOKPIC_CCFLAGS=  $(PROFILE) -xstrconst -xF $(XS) $(MR) \
        -xarch=v8 -xcache=16/32/1:1024/64/1 -xchip=ultra -D_REENTRANT
CCFLAGS= $(NOKPIC_CCFLAGS) -K PIC
FASTCCFLAGS= $(NOKPIC_CCFLAGS)

SHARED_LDFLAG=-G -L$(ORACLE_HOME)/lib -R$(ORACLE_HOME)/lib -o
SHARED_CFLAG=

# Exiting /osp/d6/s/buildtools/mkfile/platform.mk
# Entering /osp/d6/s/buildtools/mkfile/rules.mk
 
# Exiting /osp/d6/s/buildtools/mkfile/rules.mk
# Exiting /osp/d6/s/buildtools/mkfile/prefix.mk

# Entering /osp/d6/s/network/adapters.mk

# Entering /osp/d6/s/buildtools/mkfile/prefix.mk

# Entering /osp/d6/s/buildtools/mkfile/defs.mk

SHELL=/bin/sh

AS_EXT=s
LIB_EXT=a
OBJ_EXT=o
PLB_EXT=plb
SO_EXT=so
LOCK_EXT=lk
SQL_EXT=sql
SYM_EXT=sym

LIB_PREFIX=lib
LDLIBFLAG=-l
LDPATHFLAG=-L
PATHSEP= :

AR=ar
AS=as
AWK=awk
CAT=cat
CC=/usr/local/bin/gcc
CD=cd
CHMOD=chmod
CP=cp
CPP=cpp
DATE=date
ECHO=echo
ECHON=echo -n
EXEC=exec
FIND=find
FOLLOW=-follow
NOLEAF=-noleaf
GREP=grep
KILL=kill
SLEEP=sleep
LD=ld
LMAKE=make
LN=ln
LNS=ln -s
MKDIR=mkdir
MKDIRP=mkdir -p
MV=mv
NM=nm
PERL=perl
RM=rm
RMF=rm -f
RMRF=rm -rf
SED=sed
SORT=sort
TOUCH=touch
XARGS=xargs
LS=ls

BINHOME=$(ORACLE_HOME)/bin/
LIBHOME=$(ORACLE_HOME)/lib/

PRODHOME=$(ORACLE_HOME)/$(PRODUCT)/
PRODLIBHOME=$(PRODHOME)lib/
PRODSOHOME=$(PRODLIBHOME)

ECHODO=$(BINHOME)echodo
GENSYSLIB=$(BINHOME)gensyslib
GENCLNTSH=$(BINHOME)genclntsh
GENAGTSH=$(BINHOME)genagtsh
GENNAFLG=$(BINHOME)gennaflg
GENAUTAB=$(BINHOME)genautab

ARCHIVE_OBJ=$(AR) r $@ $*.$(OBJ_EXT)
ARCREATE=$(AR) cr$(ARLOCAL)
ARDELETE=$(AR) d$(ARLOCAL)
AREXTRACT=$(AR) x 
ARPRINT=$(AR) t
ARREPLACE=$(AR) r 
DOAR=$(ARCREATE) $@ $? $(RANLIB)
MAKE=$(LMAKE)
QUIET=>/dev/null 2>&1
QUIETE=2>/dev/null
SILENT=@
CTSMAKEFLAGS=$(SILENT:@=--no-print-directory -s)

CFLAGS=$(GFLAG) $(OPTIMIZE) $(CDEBUG) $(CCFLAGS) $(QACCFLAGS) $(PFLAGS)\
	$(SHARED_CFLAG) $(USRFLAGS)
PFLAGS=$(INCLUDE) $(SPFLAGS) $(LPFLAGS)

LDCCOM=$(PURECMDS) $(CC) $(GFLAG) $(CCFLAGS) $(EXOSFLAGS) $(LDFLAGS)
LDFLAGS=-o $@ $(LDPATHFLAG)$(PRODLIBHOME) $(LDPATHFLAG)$(LIBHOME)
LDLIBS=$(EXPDLIBS) $(EXOSLIBS) $(SYSLIBS) $(EXSYSLIBS) $(MATHLIB) $(USRLIBS)
MATHLIB=-lm
PURECMDS=$(PURELINK) $(PURIFY) $(PURECOV) $(QUANTIFY)

SYSLIBLIST=$(LIBHOME)sysliblist
SYSLIBS=`$(CAT) $(SYSLIBLIST)`

TTLIBD=$(NETLIBD) $(LIBRDBMS_CLT) $(LIBMM) $(CORELIBD) $(LIBEPC) $(LIBCLNTSH)
STATICTTLIBS=$(NAUTAB) $(NAETAB) $(NAEDHS) \
       $(NETLIBS) $(LLIBRDBMS_CLT) $(LLIBMM) $(CORELIBS)\
       $(NETLIBS) $(LLIBRDBMS_CLT) $(LIBPLS_CLT) \
       $(LLIBEPC) $(CORELIBS) $(LLIBRDBMS_CLT) $(CORELIBS) $(LDLIBS)
TTLIBS=$(LLIBCLNTSH) $(STATICTTLIBS)
DEVTTLIBS=$(TTLIBS)

STLIBS=$(SGL_ON) $(CONFIG) $(LLIBSERVER) $(LLIBSKGXP) $(LLIBPLSF) $(LLIBSLAX) \
       $(LIBGENERIC) $(LLIBCLIENT) $(LLIBMM) $(LLIBKNLOPT) $(LLIBPLSB)\
       $(LLIBSERVER) $(LLIBEXTP) $(NAUTAB) $(NAETAB) $(NAEDHS) \
       $(NETLIBS) $(LLIBCLIENT) \
       $(LLIBPLSF) $(LLIBICX) $(LLIBOWSUTL) \
       $(LLIBJAVAVMORJOX) \
       $(NETLIBS) $(LLIBEPC) $(SDOLIBS) $(LLIBCORE) $(LLIBVSN) $(LLIBCOMMON)\
       $(LIBGENERIC) $(LLIBKNLOPT) $(NMLIBS) $(CARTLIBS) $(CORELIBS) $(LDLIBS)

# Exiting /osp/d6/s/buildtools/mkfile/defs.mk
# Entering /osp/d6/s/buildtools/mkfile/platform.mk

FAMILY=unix
PLATFORM=solaris

MOTIFHOME=/usr/dt/
OPENWINHOME=/usr/openwin/
GUILIBHOME=$(OPENWINHOME)lib/

DIRSEP=/

CLUSTERDIR=/opt/SUNWcluster


GMAKE=make -r
LMAKE=/usr/ccs/bin/make
FIND=/usr/local/bin/find # gnu find!
PS=ps -feda

ARCHIVE=@`if echo ${LIB} | grep lib > /dev/null 2>&1;then $(ARCREATE) $(LIB) $? $(RANLIB); else echo ""; fi`

GROUP=/etc/group

LINK=ld -dy $(COMPOBJS)

LLIBTHREAD=

MOTIFLIBS=-L$(MOTIFHOME)lib -lXm -lgen -L$(GUILIBHOME) -R$(GUILIBHOME)\
	-lXt -lX11 -lw -lm
XLIBS=-L$(GUILIBHOME) -R$(GUILIBHOME) $(GUILIBHHOME)libXaw.so.4 -lXt -lXmu\
	-lXext -lX11 -lm

#EXOSFLAGS=-L$(CLUSTERDIR)/lib -R$(CLUSTERDIR)/lib
EXOSFLAGS=

CCVER=SC4.2
COMPOBJ=$(ORACLE_HOME)/lib/$(CCVER)
COMPOBJS=$(COMPOBJ)/crti.o $(COMPOBJ)/crt1.o $(COMPOBJ)/crtn.o

#EXSYSLIBS= -R $(CLUSTERDIR)/lib:$(ORACLE_HOME)/lib \
EXSYSLIBS= -R $(ORACLE_HOME)/lib \
	$(LD_LIBRARY_PATH):/usr/ccs/lib:/usr/lib \
#	-Y P,$(LD_LIBRARY_PATH):$(CLUSTERDIR)/lib:/usr/ccs/lib:/usr/lib \
	-Qy -lc -laio $(LLIBPOSIX4) $(LLIBKSTAT)
DEVTTLIBS=$(NETLIBS) $(LLIBRDBMS_CLT) $(NETLIBS) $(LLIBRDBMS_CLT)\
	$(LIBPLS_CLT) $(LLIBEPC) $(CORELIBS) $(EXPDLIBS) $(EXOSLIBS)\
	$(SYSLIBS) $(MATHLIB)

#OPTIMIZE2=-xO2
OPTIMIZE2=
OPTIMIZE4=-xO4
OPTIMIZE=$(OPTIMIZE2)

ROFLAGS=-c -xMerge
SPFLAGS=-DSLMXMX_ENABLE -DSLTS_ENABLE -D_SVID_GETTOD

AR=/usr/ccs/bin/ar
AS=/usr/ccs/bin/as
CPP=$(CC) -E $(ANSI)
CHMOD=/bin/chmod
CHGRP=/bin/chgrp
CHOWN=/bin/chown

ASFLAGS=-P -K PIC
ASPFLAGS=-P $(PFLAGS)
NOKPIC_ASFLAGS=-P
ASRO=$(AS) $(ASROFLAGS) $(MAKERO) $<
ASROFLAGS=$(ASFLAGS)
CXC=-Xc
#CXA=-Xa
CXA=
ANSI=$(CXC)


MR=-mr
#NOKPIC_CCFLAGS= -Xa $(PROFILE) -xstrconst -xF $(XS) $(MR) \
NOKPIC_CCFLAGS= $(PROFILE) -xstrconst -xF $(XS) $(MR) \
        -xarch=v8 -xcache=16/32/1:1024/64/1 -xchip=ultra -D_REENTRANT
CCFLAGS= $(NOKPIC_CCFLAGS) -K PIC
FASTCCFLAGS= $(NOKPIC_CCFLAGS)

SHARED_LDFLAG=-G -L$(ORACLE_HOME)/lib -R$(ORACLE_HOME)/lib -o
SHARED_CFLAG=

# Exiting /osp/d6/s/buildtools/mkfile/platform.mk
# Entering /osp/d6/s/buildtools/mkfile/rules.mk
 
# Exiting /osp/d6/s/buildtools/mkfile/rules.mk
# Exiting /osp/d6/s/buildtools/mkfile/prefix.mk

# Entering /osp/d6/s/network/libnames.mk

# Entering /osp/d6/s/buildtools/mkfile/prefix.mk

# Entering /osp/d6/s/buildtools/mkfile/defs.mk

SHELL=/bin/sh

AS_EXT=s
LIB_EXT=a
OBJ_EXT=o
PLB_EXT=plb
SO_EXT=so
LOCK_EXT=lk
SQL_EXT=sql
SYM_EXT=sym

LIB_PREFIX=lib
LDLIBFLAG=-l
LDPATHFLAG=-L
PATHSEP= :

AR=ar
AS=as
AWK=awk
CAT=cat
CC=/usr/local/bin/gcc
CD=cd
CHMOD=chmod
CP=cp
CPP=cpp
DATE=date
ECHO=echo
ECHON=echo -n
EXEC=exec
FIND=find
FOLLOW=-follow
NOLEAF=-noleaf
GREP=grep
KILL=kill
SLEEP=sleep
LD=ld
LMAKE=make
LN=ln
LNS=ln -s
MKDIR=mkdir
MKDIRP=mkdir -p
MV=mv
NM=nm
PERL=perl
RM=rm
RMF=rm -f
RMRF=rm -rf
SED=sed
SORT=sort
TOUCH=touch
XARGS=xargs
LS=ls

BINHOME=$(ORACLE_HOME)/bin/
LIBHOME=$(ORACLE_HOME)/lib/

PRODHOME=$(ORACLE_HOME)/$(PRODUCT)/
PRODLIBHOME=$(PRODHOME)lib/
PRODSOHOME=$(PRODLIBHOME)

ECHODO=$(BINHOME)echodo
GENSYSLIB=$(BINHOME)gensyslib
GENCLNTSH=$(BINHOME)genclntsh
GENAGTSH=$(BINHOME)genagtsh
GENNAFLG=$(BINHOME)gennaflg
GENAUTAB=$(BINHOME)genautab

ARCHIVE_OBJ=$(AR) r $@ $*.$(OBJ_EXT)
ARCREATE=$(AR) cr$(ARLOCAL)
ARDELETE=$(AR) d$(ARLOCAL)
AREXTRACT=$(AR) x 
ARPRINT=$(AR) t
ARREPLACE=$(AR) r 
DOAR=$(ARCREATE) $@ $? $(RANLIB)
MAKE=$(LMAKE)
QUIET=>/dev/null 2>&1
QUIETE=2>/dev/null
SILENT=@
CTSMAKEFLAGS=$(SILENT:@=--no-print-directory -s)

CFLAGS=$(GFLAG) $(OPTIMIZE) $(CDEBUG) $(CCFLAGS) $(QACCFLAGS) $(PFLAGS)\
	$(SHARED_CFLAG) $(USRFLAGS)
PFLAGS=$(INCLUDE) $(SPFLAGS) $(LPFLAGS)

LDCCOM=$(PURECMDS) $(CC) $(GFLAG) $(CCFLAGS) $(EXOSFLAGS) $(LDFLAGS)
LDFLAGS=-o $@ $(LDPATHFLAG)$(PRODLIBHOME) $(LDPATHFLAG)$(LIBHOME)
LDLIBS=$(EXPDLIBS) $(EXOSLIBS) $(SYSLIBS) $(EXSYSLIBS) $(MATHLIB) $(USRLIBS)
MATHLIB=-lm
PURECMDS=$(PURELINK) $(PURIFY) $(PURECOV) $(QUANTIFY)

SYSLIBLIST=$(LIBHOME)sysliblist
SYSLIBS=`$(CAT) $(SYSLIBLIST)`

TTLIBD=$(NETLIBD) $(LIBRDBMS_CLT) $(LIBMM) $(CORELIBD) $(LIBEPC) $(LIBCLNTSH)
STATICTTLIBS=$(NAUTAB) $(NAETAB) $(NAEDHS) \
       $(NETLIBS) $(LLIBRDBMS_CLT) $(LLIBMM) $(CORELIBS)\
       $(NETLIBS) $(LLIBRDBMS_CLT) $(LIBPLS_CLT) \
       $(LLIBEPC) $(CORELIBS) $(LLIBRDBMS_CLT) $(CORELIBS) $(LDLIBS)
TTLIBS=$(LLIBCLNTSH) $(STATICTTLIBS)
DEVTTLIBS=$(TTLIBS)

STLIBS=$(SGL_ON) $(CONFIG) $(LLIBSERVER) $(LLIBSKGXP) $(LLIBPLSF) $(LLIBSLAX) \
       $(LIBGENERIC) $(LLIBCLIENT) $(LLIBMM) $(LLIBKNLOPT) $(LLIBPLSB)\
       $(LLIBSERVER) $(LLIBEXTP) $(NAUTAB) $(NAETAB) $(NAEDHS) \
       $(NETLIBS) $(LLIBCLIENT) \
       $(LLIBPLSF) $(LLIBICX) $(LLIBOWSUTL) \
       $(LLIBJAVAVMORJOX) \
       $(NETLIBS) $(LLIBEPC) $(SDOLIBS) $(LLIBCORE) $(LLIBVSN) $(LLIBCOMMON)\
       $(LIBGENERIC) $(LLIBKNLOPT) $(NMLIBS) $(CARTLIBS) $(CORELIBS) $(LDLIBS)

# Exiting /osp/d6/s/buildtools/mkfile/defs.mk
# Entering /osp/d6/s/buildtools/mkfile/platform.mk

FAMILY=unix
PLATFORM=solaris

MOTIFHOME=/usr/dt/
OPENWINHOME=/usr/openwin/
GUILIBHOME=$(OPENWINHOME)lib/

DIRSEP=/

CLUSTERDIR=/opt/SUNWcluster


GMAKE=make -r
LMAKE=/usr/ccs/bin/make
FIND=/usr/local/bin/find # gnu find!
PS=ps -feda

ARCHIVE=@`if echo ${LIB} | grep lib > /dev/null 2>&1;then $(ARCREATE) $(LIB) $? $(RANLIB); else echo ""; fi`

GROUP=/etc/group

LINK=ld -dy $(COMPOBJS)

LLIBTHREAD=

MOTIFLIBS=-L$(MOTIFHOME)lib -lXm -lgen -L$(GUILIBHOME) -R$(GUILIBHOME)\
	-lXt -lX11 -lw -lm
XLIBS=-L$(GUILIBHOME) -R$(GUILIBHOME) $(GUILIBHHOME)libXaw.so.4 -lXt -lXmu\
	-lXext -lX11 -lm

#EXOSFLAGS=-L$(CLUSTERDIR)/lib -R$(CLUSTERDIR)/lib
EXOSFLAGS=

CCVER=SC4.2
COMPOBJ=$(ORACLE_HOME)/lib/$(CCVER)
COMPOBJS=$(COMPOBJ)/crti.o $(COMPOBJ)/crt1.o $(COMPOBJ)/crtn.o

#EXSYSLIBS= -R $(CLUSTERDIR)/lib:$(ORACLE_HOME)/lib \
EXSYSLIBS= -R $(ORACLE_HOME)/lib \
	$(LD_LIBRARY_PATH):/usr/ccs/lib:/usr/lib \
#	-Y P,$(LD_LIBRARY_PATH):$(CLUSTERDIR)/lib:/usr/ccs/lib:/usr/lib \
	-Qy -lc -laio $(LLIBPOSIX4) $(LLIBKSTAT)
DEVTTLIBS=$(NETLIBS) $(LLIBRDBMS_CLT) $(NETLIBS) $(LLIBRDBMS_CLT)\
	$(LIBPLS_CLT) $(LLIBEPC) $(CORELIBS) $(EXPDLIBS) $(EXOSLIBS)\
	$(SYSLIBS) $(MATHLIB)

#OPTIMIZE2=-xO2
OPTIMIZE2=
OPTIMIZE4=-xO4
OPTIMIZE=$(OPTIMIZE2)

ROFLAGS=-c -xMerge
SPFLAGS=-DSLMXMX_ENABLE -DSLTS_ENABLE -D_SVID_GETTOD

AR=/usr/ccs/bin/ar
AS=/usr/ccs/bin/as
CPP=$(CC) -E $(ANSI)
CHMOD=/bin/chmod
CHGRP=/bin/chgrp
CHOWN=/bin/chown

ASFLAGS=-P -K PIC
ASPFLAGS=-P $(PFLAGS)
NOKPIC_ASFLAGS=-P
ASRO=$(AS) $(ASROFLAGS) $(MAKERO) $<
ASROFLAGS=$(ASFLAGS)
CXC=-Xc
#CXA=-Xa
CXA=
ANSI=$(CXC)


MR=-mr
#NOKPIC_CCFLAGS= -Xa $(PROFILE) -xstrconst -xF $(XS) $(MR) \
NOKPIC_CCFLAGS= $(PROFILE) -xstrconst -xF $(XS) $(MR) \
        -xarch=v8 -xcache=16/32/1:1024/64/1 -xchip=ultra -D_REENTRANT
#CCFLAGS= $(NOKPIC_CCFLAGS) -K PIC
CCFLAGS= $(NOKPIC_CCFLAGS)
FASTCCFLAGS= $(NOKPIC_CCFLAGS)

SHARED_LDFLAG=-G -L$(ORACLE_HOME)/lib -R$(ORACLE_HOME)/lib -o
SHARED_CFLAG=

# Exiting /osp/d6/s/buildtools/mkfile/platform.mk
# Entering /osp/d6/s/buildtools/mkfile/rules.mk
 
# Exiting /osp/d6/s/buildtools/mkfile/rules.mk
# Exiting /osp/d6/s/buildtools/mkfile/prefix.mk

VER         =8
BASENAME    =n
NETWORKHOME = $(ORACLE_HOME)/network/
NETWORKLIB  = $(NETWORKHOME)lib/

COMMONNAME=${BASENAME}${VER}
NLNAME=${BASENAME}l${VER}
TCPNAME=${BASENAME}tcp${VER}
DECNETNAME=${BASENAME}dec${VER}
LU62NAME=${BASENAME}lu62${VER}
MBNAME=${BASENAME}mb${VER}
DCENAME=${BASENAME}dce${VER}
BEQNAME=${BASENAME}beq${VER}
IPCNAME=${BASENAME}ipc${VER}
SPXNAME=${BASENAME}spx${VER}
TLINAME=${BASENAME}tli${VER}
TLITNAME=${BASENAME}tlit${VER}
TLISNAME=${BASENAME}tlis${VER}
TLIDNAME=${BASENAME}tlid${VER}
USNAME=${BASENAME}us${VER}
SHMNAME=${BASENAME}shm${VER}
TCPSNAME=${BASENAME}tcps${VER}
LSNRNAME=${BASENAME}lsnr${VER}
LSNRCNAME=${BASENAME}lsnrc${VER}
K5NAME=${BASENAME}k5${VER}
RADNAME=${BASENAME}rad${VER}
IDXNAME=${BASENAME}idx${VER}
GSSNAME=${BASENAME}gss${VER}
SIDNAME=${BASENAME}sid${VER}
OSSNAME=${BASENAME}oss${VER}
NTSNAME=${BASENAME}nts${VER}
NSSNAME=${BASENAME}nss${VER}
CRYPTNAME=${BASENAME}crypt${VER}
ONNAME=${BASENAME}on${VER}
ONDNAME=${BASENAME}ond${VER}
ONCNAME=${BASENAME}onc${VER}
ONCJNAME=${BASENAME}oncj${VER}
RONAME=${BASENAME}ro${VER}
ROCNAME=${BASENAME}roc${VER}
ROXNAME=${BASENAME}rox${VER}
ROTNAME=${BASENAME}rot${VER}
CMNAME=${BASENAME}cm${VER}
NHOSTNAME=${BASENAME}host${VER}
TNSNAME=${BASENAME}tns${VER}
ORACLENAME=${BASENAME}oname${VER}
NISNAME=${BASENAME}nis${VER}
CDSNAME=${BASENAME}cds${VER}
NDSNAME=${BASENAME}nds${VER}
LDAPNAME=${BASENAME}ldap${VER}
LDAPJNAME=${BASENAME}ldapj${VER}
SSLBNAME=${BASENAME}sslb${VER}
NUJNINAME=${BASENAME}jni${VER}

NMPNAME=${BASENAME}nmp${VER}

TANAME=${BASENAME}ta${VER}
TALNAME=${BASENAME}tal${VER}
TNSAPINAME=tnsapi${VER}

RSASTDNAME=rsastd
BCERTNAME=bcert
LDAPCLNTNAME=ldapclnt${VER}
DCESYSNAME=dce




SNLPTDUM         =  $(NETWORKLIB)snlptdum.$(OBJ_EXT) 

LIBNETWORK	 =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBTHINNCR       =  $(NETWORKLIB)$(LIB_PREFIX)$(ROTNAME).$(LIB_EXT)

LIBONCJ          =  $(NETWORKLIB)$(LIB_PREFIX)$(ONCJNAME).$(SO_EXT)
LIBNUJNI         =  $(NETWORKLIB)$(LIB_PREFIX)$(NUJNINAME).$(SO_EXT)

LIBNCR           =  $(NETWORKLIB)$(LIB_PREFIX)$(RONAME).$(LIB_EXT)
LIBNFP           =  $(NETWORKLIB)$(LIB_PREFIX)$(CMNAME).$(LIB_EXT)
LIBNI            =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNNCC          =  $(NETWORKLIB)$(LIB_PREFIX)$(ONCNAME).$(LIB_EXT)
LIBNND           =  $(NETWORKLIB)$(LIB_PREFIX)$(ONDNAME).$(LIB_EXT)
LIBNNO           =  $(NETWORKLIB)$(LIB_PREFIX)$(ONNAME).$(LIB_EXT)
LIBNSGL          =  $(NETWORKLIB)$(LIB_PREFIX)$(LSNRNAME).$(LIB_EXT)
LIBNSGLC         =  $(NETWORKLIB)$(LIB_PREFIX)$(LSNRCNAME).$(LIB_EXT)
LIBRSASTD        =  $(NETWORKLIB)$(LIB_PREFIX)$(RSASTDNAME).$(LIB_EXT)

LLIBNCR           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(RONAME)$(ILIB_SUFFIX)
LLIBNFP           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(CMNAME)$(ILIB_SUFFIX)
LLIBNI            =  $(LDLIBFLAG)$(ILIB_PREFIX)$(COMMONNAME)$(ILIB_SUFFIX)
LLIBNNCC          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(ONCNAME)$(ILIB_SUFFIX)
LLIBNND           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(ONDNAME)$(ILIB_SUFFIX)
LLIBNNO           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(ONNAME)$(ILIB_SUFFIX)
LLIBNSGL          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(LSNRNAME)$(ILIB_SUFFIX)
LLIBNSGLC         =  $(LDLIBFLAG)$(ILIB_PREFIX)$(LSNRCNAME)$(ILIB_SUFFIX)
LLIBRSASTD        =  $(LDLIBFLAG)$(ILIB_PREFIX)$(RSASTDNAME)$(ILIB_SUFFIX)

LIBNAUK5         =  $(NETWORKLIB)$(LIB_PREFIX)$(K5NAME).$(LIB_EXT)
LIBNAUS          =  $(NETWORKLIB)$(LIB_PREFIX)$(SIDNAME).$(LIB_EXT)
LIBNAUR          =  $(NETWORKLIB)$(LIB_PREFIX)$(RADNAME).$(LIB_EXT)
LIBNAUI          =  $(NETWORKLIB)$(LIB_PREFIX)$(IDXNAME).$(LIB_EXT)
LIBNAUG          =  $(NETWORKLIB)$(LIB_PREFIX)$(GSSNAME).$(LIB_EXT)
LIBNAUZ          =  $(NETWORKLIB)$(LIB_PREFIX)$(OSSNAME).$(LIB_EXT)
LIBNAUNTS        =  $(NETWORKLIB)$(LIB_PREFIX)$(NTSNAME).$(LIB_EXT)

LLIBNAUK5         =  $(LDLIBFLAG)$(ILIB_PREFIX)$(K5NAME)$(ILIB_SUFFIX)
LLIBNAUS          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(SIDNAME)$(ILIB_SUFFIX)
LLIBNAUR          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(RADNAME)$(ILIB_SUFFIX)
LLIBNAUI          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(IDXNAME)$(ILIB_SUFFIX)
LLIBNAUG          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(GSSNAME)$(ILIB_SUFFIX)
LLIBNAUZ          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(OSSNAME)$(ILIB_SUFFIX)
LLIBNAUNTS        =  $(LDLIBFLAG)$(ILIB_PREFIX)$(NTSNAME)$(ILIB_SUFFIX)



LIBNTT           =  $(NETWORKLIB)$(LIB_PREFIX)$(TCPNAME).$(LIB_EXT)
LIBNTZ           =  $(NETWORKLIB)$(LIB_PREFIX)$(TCPSNAME).$(LIB_EXT)
LIBNTS           =  $(NETWORKLIB)$(LIB_PREFIX)$(SPXNAME).$(LIB_EXT)
LIBNTD           =  $(NETWORKLIB)$(LIB_PREFIX)$(DECNETNAME).$(LIB_EXT)
LIBNTOD          =  $(NETWORKLIB)$(LIB_PREFIX)$(DCENAME).$(LIB_EXT)
LIBNTLU62        =  $(NETWORKLIB)$(LIB_PREFIX)$(LU62NAME).$(LIB_EXT)
LIBNTTLI	 =  $(NETWORKLIB)$(LIB_PREFIX)$(TLINAME).$(LIB_EXT)
LIBNTUS          =  $(NETWORKLIB)$(LIB_PREFIX)$(USNAME).$(LIB_EXT)
LIBNTSHM         =  $(NETWORKLIB)$(LIB_PREFIX)$(SHMNAME).$(LIB_EXT)
LIBNTP           =  $(NETWORKLIB)$(LIB_PREFIX)$(BEQNAME).$(LIB_EXT)
LIBNTNP          =  $(NETWORKLIB)$(LIB_PREFIX)$(NMPNAME).$(LIB_EXT)

LLIBNTT           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(TCPNAME)$(ILIB_SUFFIX)
LLIBNTZ           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(TCPSNAME)$(ILIB_SUFFIX)
LLIBNTS           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(SPXNAME)$(ILIB_SUFFIX)
LLIBNTD           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(DECNETNAME)$(ILIB_SUFFIX)
LLIBNTOD          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(DCENAME)$(ILIB_SUFFIX)
LLIBNTLU62        =  $(LDLIBFLAG)$(ILIB_PREFIX)$(LU62NAME)$(ILIB_SUFFIX)
LLIBNTTLI	 =  $(LDLIBFLAG)$(ILIB_PREFIX)$(TLINAME)$(ILIB_SUFFIX)
LLIBNTUS          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(USNAME)$(ILIB_SUFFIX)
LLIBNTSHM        = $(NETWORKLIB)$(LIB_PREFIX)$(SHMNAME)$(ILIB_SUFFIX)
LLIBNTP           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(BEQNAME)$(ILIB_SUFFIX)
LLIBNTNP          =  $(LDLIBFLAG)$(ILIB_PREFIX)$(NMPNAME)$(ILIB_SUFFIX)

LIBNL1           =  $(NETWORKLIB)$(LIB_PREFIX)$(NLNAME).$(LIB_EXT)
LIBNL2           =  $(NETWORKLIB)$(LIB_PREFIX)$(NLNAME).$(LIB_EXT)

LLIBNL           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(NLNAME)$(ILIB_SUFFIX)


LIBSNS           =  $(NETWORKLIB)$(LIB_PREFIX)$(CRYPTNAME).$(LIB_EXT)
LIBNUAPI         =  $(NETWORKLIB)$(LIB_PREFIX)$(TANAME).$(LIB_EXT)
LIBNULOCAL       =  $(NETWORKLIB)$(LIB_PREFIX)$(TALNAME).$(LIB_EXT)
LIBBCERT	 =  $(NETWORKLIB)$(LIB_PREFIX)$(BCERTNAME).$(LIB_EXT) 

LLIBSNS           =  $(LDLIBFLAG)$(ILIB_PREFIX)$(CRYPTNAME)$(ILIB_SUFFIX)
LLIBNUAPI         =  $(LDLIBFLAG)$(ILIB_PREFIX)$(TANAME)$(ILIB_SUFFIX)
LLIBNULOCAL       =  $(LDLIBFLAG)$(ILIB_PREFIX)$(TALNAME)$(ILIB_SUFFIX)
LLIBBCERT	  =  $(LDLIBFLAG)$(ILIB_PREFIX)$(BCERTNAME)$(ILIB_SUFFIX)


LLIBTNSAPI       = $(LDLIBFLAG)$(ILIB_PREFIX)$(TNSAPINAME)$(ILIB_SUFFIX)
LLIBNNCC         =  $(NETWORKLIB)$(LIB_PREFIX)$(ONCNAME).$(LIB_EXT)
LLIBNUAPI	 = $(LDLIBFLAG)$(ILIB_PREFIX)$(TANAME)$(ILIB_SUFFIX)
LLIBNULOCAL	 = $(LDLIBFLAG)$(ILIB_PREFIX)$(TALNAME)$(ILIB_SUFFIX)
LLIBRSASTD       = $(LDLIBFLAG)$(ILIB_PREFIX)$(RSASTDNAME)$(ILIB_SUFFIX)
LLIBBCERT        = $(LDLIBFLAG)$(ILIB_PREFIX)$(BCERTNAME)$(ILIB_SUFFIX)
LLIBSSL          = #$(LDLIBFLAG)$(ILIB_PREFIX)sslref-bsafe$(ILIB_SUFFIX)
LLIBSSLB         = $(LDLIBFLAG)$(ILIB_PREFIX)$(SSLBNAME)$(ILIB_SUFFIX)

LIBNA            =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNAE           =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNAU           =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNLNV          =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNMP           =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNNCI          =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNNFG          =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNNG           =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNPL           =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNR            =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNS            =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNT            =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNTR           =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNZ            =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBNMS0          =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LIBSSLREF 	 =  $(NETWORKLIB)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)

LIBTNSAPI        =  $(NETWORKLIB)$(LIB_PREFIX)$(TNSAPINAME).$(LIB_EXT)

LIBSSLB          =  $(NETWORKLIB)$(LIB_PREFIX)$(SSLBNAME).$(LIB_EXT)

LDAPSYSLIBD = $(LIBHOME)$(LIB_PREFIX)$(LDAPCLNTNAME).$(LIB_EXT)
LDAPSYSLIBS = $(LDLIBFLAG)$(ILIB_PREFIX)$(LDAPCLNTNAME)$(ILIB_SUFFIX)
# Exiting /osp/d6/s/network/libnames.mk

# Entering /osp/d6/s/network/s_adapters.mk

# Exiting /osp/d6/s/network/s_adapters.mk

# Exiting /osp/d6/s/network/adapters.mk


LIBNL        = $(NETWORKLIB)$(LIB_PREFIX)$(NLNAME).$(LIB_EXT)
LLIBNL       = $(LDLIBFLAG)$(ILIB_PREFIX)$(NLNAME)$(ILIB_SUFFIX)

LIBNTTCP     = $(LIBHOME)$(LIB_PREFIX)$(TCPNAME).$(LIB_EXT)
LLIBNTTCP    = $(LDLIBFLAG)$(ILIB_PREFIX)$(TCPNAME)$(ILIB_SUFFIX)

LIBNTOD      = $(LIBHOME)$(LIB_PREFIX)$(DCENAME).$(LIB_EXT)
LLIBNTOD     = $(LDLIBFLAG)$(ILIB_PREFIX)$(DCENAME)$(ILIB_SUFFIX)

LIBNTLU62    = $(LIBHOME)$(LIB_PREFIX)$(LU62NAME).$(LIB_EXT)
LLIBNTLU62   = $(LDLIBFLAG)$(ILIB_PREFIX)$(LU62NAME)$(ILIB_SUFFIX)

LIBNTS       = $(LIBHOME)$(LIB_PREFIX)$(SPXNAME).$(LIB_EXT)
LLIBNTS      = $(LDLIBFLAG)$(ILIB_PREFIX)$(SPXNAME)$(ILIB_SUFFIX)

LIBNETWORK   = $(LIBHOME)$(LIB_PREFIX)$(COMMONNAME).$(LIB_EXT)
LLIBNETWORK  = $(LDLIBFLAG)$(ILIB_PREFIX)$(COMMONNAME)$(ILIB_SUFFIX)

LIBSQLNET  = $(LDFLAGSLIST) $(ANOLIBD) $(PROTOCOLLIBD) $(NATIVELIBD) $(NATIVESYSLIBD) $(LIBNETWORK) $(LIBNL)
LLIBSQLNET = $(LDFLAGSLIST) $(ANOLIBS) $(PROTOCOLLIBS) $(NATIVELIBS) $(NATIVESYSLIBS) $(LLIBNETWORK) $(LLIBNL)

LIBRPC       = $(LIBHOME)$(LIB_PREFIX)$(RONAME).$(LIB_EXT)
LLIBRPC      = $(LDLIBFLAG)$(ILIB_PREFIX)$(RONAME)$(ILIB_SUFFIX)

LIBTNSAPI    = $(NETWORKLIB)$(LIB_PREFIX)$(TNSAPINAME).$(LIB_EXT)
LLIBTNSAPI   = $(LDLIBFLAG)$(ILIB_PREFIX)$(TNSAPINAME)$(ILIB_SUFFIX)

TNSLSNR	     = $(BINHOME)tnslsnr$(EXE_SUFFIX)
LSNRCTL	     = $(BINHOME)lsnrctl$(EXE_SUFFIX)
NAMES	     = $(BINHOME)names$(EXE_SUFFIX)
NAMESCTL     = $(BINHOME)namesctl$(EXE_SUFFIX)

NIGTAB       = $(LIBHOME)nigtab.$(OBJ_EXT)
NIGCON       = $(LIBHOME)nigcon.$(OBJ_EXT) 
NTCONTAB     = $(LIBHOME)ntcontab.$(OBJ_EXT)
MTS_NCR	     = $(LIBHOME)ncrstab.$(OBJ_EXT)

OSNTABST     = $(NETWORKLIB)osntabst.$(OBJ_EXT)
NNFGT        = $(NETWORKLIB)nnfgt.$(OBJ_EXT)

NAETAB       = $(LIBHOME)naeet.$(OBJ_EXT) $(LIBHOME)naect.$(OBJ_EXT)
NAEDHS	     = $(LIBHOME)naedhs.$(OBJ_EXT)
NAUTAB	     = $(LIBHOME)nautab.$(OBJ_EXT)

NETLIBS      = $(LLIBSQLNET) $(LLIBRPC) $(LLIBSQLNET)
NETLIBD      = $(LIBSQLNET) $(LIBRPC)

LDFLAGSFILE=$(LIBHOME)ldflags
LDFLAGSLIST=`$(CAT) $(LDFLAGSFILE)`

# Exiting /osp/d6/s/network/exports.mk
# Entering /osp/d6/s/ldap/exports.mk

LDAP_VERSION=8

LIBGSLSSFNAME= gslssf$(LDAP_VERSION)
LLIBGSLSSF= $(LDLIBFLAG)$(LIBGSLSSFNAME)$(LIB_SUFFIX)
LIBGSLSSF= $(LIBHOME)$(LIB_PREFIX)$(LIBGSLSSFNAME).$(LIB_EXT)

LIBGSLSSBNAME= gslssb$(LDAP_VERSION)
LLIBGSLSSB= $(LDLIBFLAG)$(LIBGSLSSBNAME)$(LIB_SUFFIX)
LIBGSLSSB= $(LIBHOME)$(LIB_PREFIX)$(LIBGSLSSBNAME).$(LIB_EXT)

LIBGSLBER_SNAME= gslber_s$(LDAP_VERSION)
LLIBGSLBER_S= $(LDLIBFLAG)$(LIBGSLBER_SNAME)$(LIB_SUFFIX)
LIBGSLBER_S= $(LIBHOME)$(LIB_PREFIX)$(LIBGSLBER_SNAME).$(LIB_EXT)

LIBGSLAVLNAME= gslavl$(LDAP_VERSION)
LLIBGSLAVL= $(LDLIBFLAG)$(LIBGSLAVLNAME)$(LIB_SUFFIX)
LIBGSLAVL= $(LIBHOME)$(LIB_PREFIX)$(LIBGSLAVLNAME).$(LIB_EXT)

LIBGSLRNAME= gslr$(LDAP_VERSION)
LLIBGSLR= $(LDLIBFLAG)$(LIBGSLRNAME)$(LIB_SUFFIX)
LIBGSLR= $(LIBHOME)$(LIB_PREFIX)$(LIBGSLRNAME).$(LIB_EXT)

LIBGSLDBNAME= gsldb$(LDAP_VERSION)
LLIBGSLDB= $(LDLIBFLAG)$(LIBGSLDBNAME)$(LIB_SUFFIX)
LIBGSLDB= $(LIBHOME)$(LIB_PREFIX)$(LIBGSLDBNAME).$(LIB_EXT)

LIBGSLSGNAME= gslsg$(LDAP_VERSION)
LLIBGSLSG= $(LDLIBFLAG)$(LIBGSLSGNAME)$(LIB_SUFFIX)
LIBGSLSG= $(LIBHOME)$(LIB_PREFIX)$(LIBGSLSGNAME).$(LIB_EXT)

LIBSGSL_SNAME= sgsl_s$(LDAP_VERSION)
LLIBSGSL_S= $(LDLIBFLAG)$(LIBSGSL_SNAME)$(LIB_SUFFIX)
LIBSGSL_S= $(LIBHOME)$(LIB_PREFIX)$(LIBSGSL_SNAME).$(LIB_EXT)

LIBLDAPCLNTNAME= ldapclnt$(LDAP_VERSION)
LIBLDAPCLNT= $(LIBHOME)$(LIB_PREFIX)$(LIBLDAPCLNTNAME).$(LIB_EXT)

LDAPHOME=    $(ORACLE_HOME)/ldap/
LDAPBIN=     $(LDAPHOME)bin/
LDAPLIB=     $(LDAPHOME)lib/

LDAPPUBH=    $(I_SYM)$(LDAPHOME)public

LLIBLDAPCLNT= $(LDAPLIB)$(LIB_PREFIX)$(LIBLDAPCLNTNAME).$(LIB_EXT)

# Entering /osp/d6/s/ldap/s_exports.mk


# Exiting /osp/d6/s/ldap/s_exports.mk
# Exiting /osp/d6/s/ldap/exports.mk
# Entering /osp/d6/s/plsql/exports.mk

VERSION=8

WRAP=$(BINHOME)wrap

LIBPLSNAME=pls
LIBPLSN=$(LIBHOME)$(LIB_PREFIX)$(LIBPLSNAME)$(VERSION).$(LIB_EXT)
LLIBPLS=$(LDLIBFLAG)$(LIBPLSNAME)$(VERSION) 
LIBPLSNSHR=$(LIBHOME)/$(LIB_PREFIX)$(LIBPLSNAME).$(SO_EXT)
ILIBPLSN=$(LIBHOME)/$(LIB_PREFIX)$(LIBPLSNAME).$(ILIB_EXT)
LIBPLPNAME=plp
LIBPLPN=$(LIBHOME)$(LIB_PREFIX)$(LIBPLPNAME)$(VERSION).$(LIB_EXT)
LLIBPLP=$(LDLIBFLAG)$(LIBPLPNAME)$(VERSION)
LIBPLPNSHR=$(LIBHOME)/$(LIB_PREFIX)$(LIBPLPNAME).$(SO_EXT)
ILIBPLPN=$(LIBHOME)/$(LIB_PREFIX)$(LIBPLPNAME).$(ILIB_EXT)
LIBPLCNAME=plc
LIBPLCN=$(LIBHOME)$(LIB_PREFIX)$(LIBPLCNAME)$(VERSION).$(LIB_EXT)
LLIBPLC=$(LDLIBFLAG)$(LIBPLCNAME)$(VERSION)
LIBPLCSHR=$(LIBHOME)/$(LIB_PREFIX)$(LIBPLCNAME).$(SO_EXT)
ILIBPLCN=$(LIBHOME)/$(LIB_PREFIX)$(LIBPLCNAME).$(ILIB_EXT)

LIBEXTP=$(LIBHOME)$(LIB_PREFIX)$(LIBPLSNAME)$(VERSION).$(LIB_EXT)
LLIBEXTP=$(LDLIBFLAG)$(LIBPLSNAME)$(VERSION)

LIBPLSF=$(LIBHOME)$(LIB_PREFIX)$(LIBPLSNAME)$(VERSION).$(LIB_EXT) 
LLIBPLSF=$(LDLIBFLAG)$(LIBPLSNAME)$(VERSION) $(LDLIBFLAG)$(LIBPLPNAME)$(VERSION)

LIBPLSB=$(LIBHOME)$(LIBPLSNAME)$(VERSION)
LLIBPLSB=$(LDLIBFLAG)$(LIBPLSNAME)$(VERSION)

PLSQLLIBS=$(LIBPLSN) $(LIBPLPN)
LPLSQLLIBS=$(LLIBPLS)


LLIBPLSQL= $(LPLSQLLIBS) $(LLIBPLP)

LIBPSANAME=psa
LIBICD=$(LIBHOME)$(LIB_PREFIX)$(LIBPLPNAME)$(VERSION).$(LIB_EXT)
LLIBICD=$(LDLIBFLAG)$(LIBPLPNAME)$(VERSION)
LIBPSD=$(LIBHOME)$(LIB_PREFIX)$(LIBPLCNAME)$(VERSION).$(LIB_EXT)
LLIBPSD=$(LDLIBFLAG)$(LIBPLCNAME)$(VERSION)
LIBPSA=$(LIBHOME)$(LIB_PREFIX)$(LIBPSANAME)$(VERSION).$(LIB_EXT)
LLIBPSA=$(LDLIBFLAG)$(LIBPSANAME)$(VERSION)

# Entering /osp/d6/s/plsql/s_exports.mk
 
# Exiting /osp/d6/s/plsql/s_exports.mk
# Exiting /osp/d6/s/plsql/exports.mk
# Entering /osp/d6/s/otrace/exports.mk

LIBTRACENAME=trace8
LIBTRACE=$(LIBHOME)$(LIB_PREFIX)$(LIBTRACENAME).$(LIB_EXT)
LLIBTRACE=$(LDLIBFLAG)$(LIBTRACENAME)$(LIB_SUFFIX)
LIBEPC=$(LIBHOME)$(LIB_PREFIX)$(LIBTRACENAME).$(LIB_EXT)
LLIBEPC=$(LDLIBFLAG)$(LIBTRACENAME)$(LIB_SUFFIX)

LIBTRACEPTNAME=tracept8
LIBTRACEPT=$(LIBHOME)$(LIB_PREFIX)$(LIBTRACEPTNAME).$(LIB_EXT)
LLIBTRACEPT=$(LDLIBFLAG)$(LIBTRACEPTNAME)$(LIB_SUFFIX)
LIBEPCPT=$(LIBHOME)$(LIB_PREFIX)$(LIBTRACEPTNAME).$(LIB_EXT)
LLIBEPCPT=$(LDLIBFLAG)$(LIBTRACEPTNAME)$(LIB_SUFFIX)

LIBTRACEFENAME=tracefe8
LIBTRACEFE=$(LIBHOME)$(LIB_PREFIX)$(LIBTRACEFENAME).$(LIB_EXT)
LLIBTRACEFE=$(LDLIBFLAG)$(LIBTRACEFENAME)$(LIB_SUFFIX)
LIBEPCFE=$(LIBHOME)$(LIB_PREFIX)$(LIBTRACEFENAME).$(LIB_EXT)
LLIBEPCFE=$(LDLIBFLAG)$(LIBTRACEFENAME)$(LIB_SUFFIX)

# Entering /osp/d6/s/otrace/s_exports.mk

# Exiting /osp/d6/s/otrace/s_exports.mk
# Exiting /osp/d6/s/otrace/exports.mk
# Entering /osp/d6/s/icx/exports.mk

VERSION=8
LIBICXNAME=dbicx$(VERSION)
LIBICX= $(LIBHOME)$(LIB_PREFIX)$(LIBICXNAME).$(LIB_EXT)
LIBICXSHR= $(PRODSOHOME)$(LIB_PREFIX)$(LIBICXNAME).$(SO_EXT)
ILIBICX= $(LIBHOME)$(LIB_PREFIX)$(LIBICXNAME).$(ILIB_EXT)

LLIBICX= $(LDLIBFLAG)$(LIBICXNAME)

ICXPUBH= $(I_SYM). $(I_SYM)$(ICXHOME)/public 

# Entering /osp/d6/s/icx/s_exports.mk
 
# Exiting /osp/d6/s/icx/s_exports.mk
# Exiting /osp/d6/s/icx/exports.mk
# Entering /osp/d6/s/owsutl/exports.mk
 
# Entering /osp/d6/s/icx/exports.mk

VERSION=8
LIBICXNAME=dbicx$(VERSION)
LIBICX= $(LIBHOME)$(LIB_PREFIX)$(LIBICXNAME).$(LIB_EXT)
LIBICXSHR= $(PRODSOHOME)$(LIB_PREFIX)$(LIBICXNAME).$(SO_EXT)
ILIBICX= $(LIBHOME)$(LIB_PREFIX)$(LIBICXNAME).$(ILIB_EXT)

LLIBICX= $(LDLIBFLAG)$(LIBICXNAME)

ICXPUBH= $(I_SYM). $(I_SYM)$(ICXHOME)/public 

# Entering /osp/d6/s/icx/s_exports.mk
 
# Exiting /osp/d6/s/icx/s_exports.mk
# Exiting /osp/d6/s/icx/exports.mk

LIBOWSUTLNAME=$(LIBICXNAME)
LIBOWSUTL= $(LIBHOME)/$(LIB_PREFIX)$(LIBOWSUTLNAME).$(LIB_EXT)
LIBOWSUTLSHR= $(LIBHOME)/$(LIB_PREFIX)$(LIBOWSUTLNAME).$(SO_EXT)
ILIBOWSUTL= $(LIBHOME)/$(LIB_PREFIX)$(LIBOWSUTLNAME).$(ILIB_EXT)
 
LLIBOWSUTL= $(LDLIBFLAG)$(LIBOWSUTLNAME)

# Entering /osp/d6/s/owsutl/s_exports.mk
 
# Exiting /osp/d6/s/owsutl/s_exports.mk
# Exiting /osp/d6/s/owsutl/exports.mk
# Entering /osp/d6/s/ordts/exports.mk

LIBKIDTNAME = ordts8
LLIBKIDT = $(LDLIBFLAG)$(LIBKIDTNAME)$(LIB_SUFFIX)

# Entering /osp/d6/s/ordts/s_exports.mk


# Exiting /osp/d6/s/ordts/s_exports.mk
# Exiting /osp/d6/s/ordts/exports.mk
# Entering /osp/d6/s/spatial/exports.mk

LIBORDSDONAME=ordsdo8
LIBORDSDO=$(LIB_PREFIX)$(LIBORDSDONAME).$(LIB_EXT)
LLIBORDSDO=$(LDLIBFLAG)$(LIB_PREFIX)$(LIBORDSDONAME).$(LIB_EXT)

SDODIRM=md
SDOHOME=$(ORACLE_HOME)/$(SDODIRM)/
SDOLIB=$(SDOHOME)lib/
SDOADMIN=$(SDOHOME)admin/
SDOBIN=$(SDOHOME)bin/

# Entering /osp/d6/s/sdo/s_exports.mk
# Exiting /osp/d6/s/sdo/s_exports.mk
# Exiting /osp/d6/s/spatial/exports.mk
# Entering /osp/d6/s/ctx/exports.mk



LIBCTXS8NAME=ctxs8
LIBCTXS8 = $(CTXLIB)$(LIB_PREFIX)$(LIBCTXS8NAME).$(LIB_EXT)
LLIBCTXS8 = $(LDLIBFLAG)$(LIBCTXS8NAME)$(LIB_SUFFIX)

LIBCTXC8NAME=ctxc8
LIBCTXC8 = $(CTXLIB)$(LIB_PREFIX)$(LIBCTXC8NAME).$(LIB_EXT)
LLIBCTXC8 = $(LDLIBFLAG)$(LIBCTXC8NAME)$(LIB_SUFFIX)

LIBCTX8NAME=ctx8
LIBCTX8 = $(CTXLIB)$(LIB_PREFIX)$(LIBCTX8NAME).$(LIB_EXT)
LLIBCTX8 = $(LDLIBFLAG)$(LIBCTX8NAME)$(LIB_SUFFIX)
 
CTX_LINK = $(LLIBCTXC8) $(LLIBCTX8)

CTXHOME=$(ORACLE_HOME)/ctx/

CTXPUBH=$(I_SYM)$(CTXHOME)public

CTXLIB=$(CTXHOME)lib/

# Entering /osp/d6/s/ctx/s_exports.mk
# Exiting /osp/d6/s/ctx/s_exports.mk
# Exiting /osp/d6/s/ctx/exports.mk
# Entering /osp/d6/s/ordvir/exports.mk

LIBORDVIRTNAME=  ordvirt8
LOC_LIBORDVIRT=  $(LIB_PREFIX)$(LIBORDVIRTNAME).$(LIB_EXT)
LIBORDVIRT=      $(LIBHOME)$(LOC_LIBORDVIRT)
LLIBORDVIRT=     $(LDLIBFLAG)$(LIBORDVIRTNAME)$(LIB_SUFFIX)
ILIBORDVIRT=     $(LIBHOME)$(LIB_PREFIX)$(LIBORDVIRTNAME).$(ILIB_EXT)

LLIBKIDRT= $(LDLIBFLAG)$(LIBORDVIRTNAME)$(LIB_SUFFIX)
LIBKIDRT=  $(LIBHOME)$(LIB_PREFIX)$(LIBORDVIRTNAME).$(LIB_EXT)


LIBORDVIRNAME=    ordvir8
LOC_LIBORDVIR=    $(LIB_PREFIX)$(LIBORDVIRNAME).$(LIB_EXT)
LIBORDVIR=        $(LIBHOME)$(LOC_LIBORDVIR)
LOC_LIBORDVIRSHR= $(LIB_PREFIX)$(LIBORDVIRNAME).$(SO_EXT)
LIBORDVIRSHR=     $(LIBHOME)$(LOC_LIBORDVIRSHR)
ILIBORDVIR=       $(LIBHOME)$(LIB_PREFIX)$(LIBORDVIRNAME).$(ILIB_EXT)
LOC_ZIPORDVIR=  ordvir.$(ZIP_EXT)
ZIPORDVIR=      $(ORDVIRLIB)$(LOC_ZIPORDVIR)


LOC_LIBKIDRSHR= $(LIB_PREFIX)$(LIBORDVIRNAME).$(SO_EXT)
LIBKIDRSHR=     $(LIBORDVIRSHR)
LIBKIDR=        $(LIBORDVIR)


# Entering /osp/d6/s/ordvir/s_exports.mk

# Exiting /osp/d6/s/ordvir/s_exports.mk
# Exiting /osp/d6/s/ordvir/exports.mk
# Entering /osp/d6/s/javavm/exports.mk
LIBJAVAVM=$(LIBHOME)$(LIB_PREFIX)aurora.$(LIB_EXT)
LLIBJAVAVM=$(LDLIBFLAG)aurora

# Entering s_exports.mk


SKGXP_EXT=$(SO_EXT)



# Exiting s_exports.mk
# Exiting /osp/d6/s/javavm/exports.mk

# Entering /osp/d6/s/rdbms/exports.mk


RDBMS_VERSION = 8
LIBSERVERNAME=server$(RDBMS_VERSION)
LIBSERVER=$(LIBHOME)$(LIB_PREFIX)$(LIBSERVERNAME).$(LIB_EXT)
LLIBSERVER=$(LDLIBFLAG)$(LIBSERVERNAME)$(LIB_SUFFIX)

LIBCLIENTNAME=client$(RDBMS_VERSION)
LIBCLIENT=$(LIBHOME)$(LIB_PREFIX)$(LIBCLIENTNAME).$(LIB_EXT)
LLIBCLIENT=$(LDLIBFLAG)$(LIBCLIENTNAME)

LIBGENERICNAME=generic$(RDBMS_VERSION)
LIBGENERIC=$(LIBHOME)$(LIB_PREFIX)$(LIBGENERICNAME).$(LIB_EXT)
LLIBGENERIC=$(LDLIBFLAG)$(LIBGENERICNAME)

LIBDSBTSHNAME=dsbtsh$(RDBMS_VERSION)
LIBDSBTSH=$(RDBMSLIB)$(LIB_PREFIX)$(LIBDSBTSHNAME).$(SO_EXT)

LIBSKGXPNAME=skgxp$(RDBMS_VERSION)
LIBSKGXP=$(LIBHOME)$(LIB_PREFIX)$(LIBSKGXPNAME).$(SKGXP_EXT)
LLIBSKGXP=$(LDLIBFLAG)$(LIBSKGXPNAME)

LIBCOMMONNAME=common$(RDBMS_VERSION)
LIBCOMMON=$(LIBHOME)$(LIB_PREFIX)$(LIBCOMMONNAME).$(LIB_EXT)
LLIBCOMMON=$(LDLIBFLAG)$(LIBCOMMONNAME)

LIBVSNNAME=vsn$(RDBMS_VERSION)
LIBVSN=$(LIBHOME)$(LIB_PREFIX)$(LIBVSNNAME).$(LIB_EXT)
LLIBVSN=$(LDLIBFLAG)$(LIBVSNNAME)

LIBAGENTNAME=agent$(RDBMS_VERSION)
LIBAGENT=$(LIBHOME)$(LIB_PREFIX)$(LIBAGENTNAME).$(LIB_EXT)
LLIBAGENT=$(LDLIBFLAG)$(LIBAGENTNAME)

LIBDBTOOLSNAME=dbtools$(RDBMS_VERSION)
LIBDBTOOLS=$(RDBMSLIB)$(LIB_PREFIX)$(LIBDBTOOLSNAME).$(LIB_EXT)

DLMHOME=$(ORACLE_HOME)/odlm/

SKGXNS=$(RDBMSLIB)skgxns.$(OBJ_EXT)
SKGXND=$(RDBMSLIB)skgxnd.$(OBJ_EXT)
SKGXN=$(RDBMSLIB)skgxn.$(OBJ_EXT)

LIBDLMNAME=udlm
LIBDLM=$(SKGXN) $(LIBHOME)$(LIB_PREFIX)$(LIBDLMNAME).$(LIB_EXT)
LLIBDLM=$(SKGXN) $(LDLIBFLAG)$(LIBDLMNAME)

LIBNM=$(LIBDLM)
LLIBNM=$(LLIBDLM)
NMLIBLIST=$(RDBMSLIB)nmliblist
NMLIBS=`$(CAT) $(NMLIBLIST)`

LIBMMNAME=mm
LIBMM=$(LIBHOME)$(LIB_PREFIX)$(LIBMMNAME).$(LIB_EXT)
LLIBMM=$(LDLIBFLAG)$(LIBMMNAME)


LIBRDBMS_CLT=$(LIBCLIENT) $(LIBVSN) $(LIBCOMMON) $(LIBSKGXP) $(LIBGENERIC)
LLIBRDBMS_CLT=$(LLIBCLIENT) $(LLIBVSN) $(LLIBCOMMON) $(LLIBSKGXP) $(LLIBGENERIC)

LIBCLNTSHNAME=clntsh
LIBCLNTSH=$(LIBHOME)$(LIB_PREFIX)$(LIBCLNTSHNAME).$(SO_EXT)
LLIBCLNTSH=$(LDLIBFLAG)$(LIBCLNTSHNAME)

LIBAGTSHNAME=agtsh
LIBAGTSH=$(LIBHOME)$(LIB_PREFIX)$(LIBAGTSHNAME).$(SO_EXT)
LLIBAGTSH=$(LDLIBFLAG)$(LIBAGTSHNAME)

LIBKNLOPTNAME=knlopt
LIBKNLOPT=$(RDBMSLIB)$(LIB_PREFIX)$(LIBKNLOPTNAME).$(LIB_EXT)
LLIBKNLOPT=$(LDLIBFLAG)$(LIBKNLOPTNAME)

CONFIG = $(RDBMSLIB)config.$(OBJ_EXT)

HSALLMAI = $(RDBMSLIB)horm.$(OBJ_EXT)			# hs all modules main
HSSQLMAI = $(RDBMSLIB)horms.$(OBJ_EXT)			# hs SQL main
HSDEPMAI = $(RDBMSLIB)hormd.$(OBJ_EXT)			# hs DEP main
HSOTSMAI = $(RDBMSLIB)hormt.$(OBJ_EXT)			# hs OTS main
HSAGTSHC = $(RDBMSLIB)homts.$(OBJ_EXT)                  # multi-threaded agent 
                                                        # shutdown callback



LLIBORDSDO=$(LDLIBFLAG)$(LIBORDSDONAME)$(LIB_SUFFIX)
SDOLIBS = `if ${AR} tv ${ORACLE_HOME}/rdbms/lib/$(LIB_PREFIX)$(LIBKNLOPTNAME).$(LIB_EXT) | $(GREP) "kxmnsd.o" > /dev/null 2>&1 ; then echo " " ; else echo "${LLIBORDSDO}"; fi`

DEF_ON= $(RDBMSLIB)kpudfo.$(OBJ_EXT)
DEF_OFF= $(RDBMSLIB)kpundf.$(OBJ_EXT)
DEF_OPT= $(RDBMSLIB)defopt.$(OBJ_EXT)

LIBSLAXNAME=slax8
LIBSLAX=$(LIBHOME)$(LIB_PREFIX)$(LIBSLAXNAME).$(LIB_EXT)
LLIBSLAX=$(LDLIBFLAG)$(LIBSLAXNAME)

LIBSQLNAME=sql8
LIBSQL=$(LIBHOME)$(LIB_PREFIX)$(LIBSQLNAME).$(LIB_EXT)
LLIBSQL=$(LDLIBFLAG)$(LIBSQLNAME)


LIBSVRMGRLNAME=svrmgrl
LIBSLPMNAME=slpm
LIBSVRM= $(LIBHOME)smalmain.$(OBJ_EXT) $(LIBHOME)$(LIB_PREFIX)$(LIBSVRMGRLNAME).$(LIB_EXT) $(LIBHOME)$(LIB_PREFIX)$(LIBSLPMNAME).$(LIB_EXT)
LLIBSVRM= $(LIBHOME)smalmain.$(OBJ_EXT) $(LDLIBFLAG)$(LIBSVRMGRLNAME) $(LDLIBFLAG)$(LIBSLPMNAME)

RDBMSHOME=$(ORACLE_HOME)/rdbms/
RDBMSLIB=$(RDBMSHOME)lib/
RDBMSADMIN=$(RDBMSHOME)admin/

# Entering /osp/d6/s/rdbms/s_exports.mk


SKGXP_EXT=$(SO_EXT)



# Exiting /osp/d6/s/rdbms/s_exports.mk
# Exiting /osp/d6/s/rdbms/exports.mk


LIBDSBT=$(LOC_LIBDSBTSH)
LIBS=$(LIBDSBT)
SHLIBS=$(LIBDSBTSH)

CARTLIBS= $(LLIBKIDT) $(CTX_LINK) $(LLIBKIDRT)
CARTLIBD= $(LLIBKIDT) $(CTX_LINK) $(LLIBKIDRT)
HS_OCI_DRIVER=$(RDBMSLIB)hoaoci.$(OBJ_EXT)		# ORACLE/OCI driver
HS_DEP_DRIVER=$(RDBMSLIB)hoax.$(OBJ_EXT)                # DEP/XA driver
HS_OTS_DRIVER=$(RDBMSLIB)hoat.$(OBJ_EXT)                # HS OTS driver

HS_XASWITCH_ORA=$(RDBMSLIB)hsxaora.$(OBJ_EXT)           # XA switch for Oracle
 
HS_OCI_DRIVER_ON=$(RDBMSLIB)hokoci.$(OBJ_EXT)	# ORACLE/OCI driver for kernel
HS_OCI_DRIVER_OFF=$(RDBMSLIB)hoksoci.$(OBJ_EXT)	# ORACLE/OCI driver

HO_DRV_ON=$(HS_OCI_DRIVER_OFF)
HO_DRV_OFF=$(HS_OCI_DRIVER_OFF)
 

VER_ENT= vsnfprd.$(OBJ_EXT)
VER_STD= vsnfstd.$(OBJ_EXT)
VER_PO= vsnfpo.$(OBJ_EXT)
VSNNTP= vsnntp.$(OBJ_EXT)
VSNSTD= vsnstd.$(OBJ_EXT)
VSNPO= vsnpo.$(OBJ_EXT)

PLS_ON= kkxwtp.$(OBJ_EXT)
PLS_OFF= kkxntp.$(OBJ_EXT)

JOXOPT_FILE=$(RDBMSLIB)joxopt.txt
JOXOFF_OFILE= joxoff.$(OBJ_EXT)
JOX_OFILE=jox.$(OBJ_EXT)
JOXWTP_OFILE= joxwtp.$(OBJ_EXT)

JOX_BOM=$(RDBMSADMIN)jox.bom

JOXNAME=jox$(RDBMS_VERSION)
LIBJOXNAME=$(LIB_PREFIX)$(JOXNAME)
SHLIBJOX=$(JAVAVM_SHLIB_SOHOME)$(LIBJOXNAME).$(SO_EXT)

OPS_ON= kcsm.$(OBJ_EXT)
OPS_OFF= ksnkcs.$(OBJ_EXT)

DDB_ON= ktd.$(OBJ_EXT)
DDB_OFF= ksnktd.$(OBJ_EXT)

SDO_ON= kxmwsd.$(OBJ_EXT)
SDO_OFF= kxmnsd.$(OBJ_EXT)

CTX_ON= kciwcx.$(OBJ_EXT)
CTX_OFF= kcincx.$(OBJ_EXT)

HO_ON= $(RDBMSLIB)npiapho.$(OBJ_EXT) $(RDBMSLIB)homs.$(OBJ_EXT) $(HO_DRV_OFF)	
HO_ON_NPIAPH=npiapho.$(OBJ_EXT)
HO_ON_HOMS=homs.$(OBJ_EXT)
HO_OFF=$(RDBMSLIB)npiap.$(OBJ_EXT) $(RDBMSLIB)homsstub.$(OBJ_EXT) $(HO_DRV_OFF)
HO_OFF_NPIAP=npiap.$(OBJ_EXT)
HO_OFF_HOMSSTUB=homsstub.$(OBJ_EXT)

OBJ_ON= kokiobj.$(OBJ_EXT)
OBJ_OFF= koknobj.$(OBJ_EXT)

PART_ON= kkpoban.$(OBJ_EXT)
PART_OFF= ksnkkpo.$(OBJ_EXT)

LIL_ON= $(LIB_PREFIX)lil.$(LIB_EXT)
LIL_OFF= sllfls.$(OBJ_EXT)

XAS_ON=$(LIBSQL)
XAS_OFF=xaonsl.$(OBJ_EXT)
 
XAD_OFF=xaondy.$(OBJ_EXT)

SQLLIBS=              			 # By default no SQLLIB, no dummy stubs

KPT_ON=kprwts.$(OBJ_EXT)
KPT_OFF=kprnts.$(OBJ_EXT)

SGL_ON=$(OSNTABST) $(RDBMSLIB)ttcsoi.$(OBJ_EXT) $(RDBMSLIB)ttcoerr.$(OBJ_EXT)
SGL_OFF=$(NIGTAB)

ORAMAI = $(RDBMSLIB)opimai.$(OBJ_EXT)			# oracle server
SSORED = $(RDBMSLIB)ssoraed.$(OBJ_EXT)			# oracle prog. mgr. data
IMPMAI = $(RDBMSLIB)impdrv.$(OBJ_EXT)			# import
EXPMAI = $(RDBMSLIB)exudrv.$(OBJ_EXT)			# export
LDRMAI = $(RDBMSLIB)ulmai.$(OBJ_EXT)			# loader
MIGMAI = $(RDBMSLIB)kumain.$(OBJ_EXT)			# migrate
MXMMAI = $(RDBMSLIB)maxmem.$(OBJ_EXT)			# maxmem
DBGMAI = $(RDBMSLIB)dbfmig.$(OBJ_EXT)			# dbfmig
SYSRESVMAI = $(RDBMSLIB)sysresv.$(OBJ_EXT)		# sysresv
TSMMAI = $(RDBMSLIB)tstshm.$(OBJ_EXT)			# tstshm
TKPMAI = $(RDBMSLIB)s0kvpf.$(OBJ_EXT)			# tkprof
GOCMAI = $(RDBMSLIB)genoci.$(OBJ_EXT)			# genoci
ADLMAI = $(RDBMSLIB)addlcmp.$(OBJ_EXT)			# addlcmp
PWDMAI = $(RDBMSLIB)s0kuzr.$(OBJ_EXT)			# orapwd
DBFMAI = $(RDBMSLIB)dbfsize.$(OBJ_EXT)			# dbfsize
CURMAI = $(RDBMSLIB)cursize.$(OBJ_EXT)			# cursize
DBVMAI = $(RDBMSLIB)kudbv.$(OBJ_EXT)			# dbverify
SSDBED=$(RDBMSLIB)ssdbaed.$(OBJ_EXT)			# sqldba prog. mgr. data
TDSMAI = $(RDBMSLIB)kopc.$(OBJ_EXT)			# tdscomp
EXTPMAI = $(RDBMSLIB)hormc.$(OBJ_EXT)			# extproc main
AGTCLMAI = $(RDBMSLIB)hout.$(OBJ_EXT)                   # agtctl main
AGTCLSUR = $(RDBMSLIB)shou.$(OBJ_EXT)                   # agtctl startup routine
GMSMAI = $(RDBMSLIB)/kgxgd.$(OBJ_EXT)	$(RDBMSLIB)/kgxgm.$(OBJ_EXT)							# OGMS main
GMCTLM = $(RDBMSLIB)kgxgk.$(OBJ_EXT)			# ogmsctl main
SSORED = $(RDBMSLIB)ssoraed.$(OBJ_EXT)			# oracle prog. mgr. data
TTCSOI = $(RDBMSLIB)ttcsoi.$(OBJ_EXT)			# for osncoi, osnsoi.
ARCMAI = $(RDBMSLIB)archmon.$(OBJ_EXT)			# archmon
OSHMAI = $(RDBMSLIB)osh.$(OBJ_EXT)				# osh
GKSMAI = $(RDBMSLIB)genksms.$(OBJ_EXT)			# genksms
GKFMAI = $(RDBMSLIB)genkflat.$(OBJ_EXT)			# genkflat
SSKRMED = $(RDBMSLIB)sskrmed.$(OBJ_EXT)			# rman executable descriptor
SKRMPT = $(RDBMSLIB)skrmpt.$(OBJ_EXT)			# rman products table
SBBDPT = $(RDBMSLIB)sbbdpt.$(OBJ_EXT)           # bbed products table
SSBBDED = $(RDBMSLIB)ssbbded.$(OBJ_EXT)         # bbed executable descriptor
SKRSPT = $(RDBMSLIB)skrspt.$(OBJ_EXT)           # sbttest products table
SSKRSED = $(RDBMSLIB)sskrsed.$(OBJ_EXT)         # sbttest executable descriptor
KGPPMAI = $(RDBMSLIB)kgupc.$(OBJ_EXT)	                # kgpmon

ORACLE=$(RDBMSBIN)oracle$(EXE_SUFFIX)
IMP=$(RDBMSBIN)imp$(EXE_SUFFIX)
EXP=$(RDBMSBIN)exp$(EXE_SUFFIX)
SQLLDR=$(RDBMSBIN)sqlldr$(EXE_SUFFIX)
SQLLDR_LIL=$(RDBMSBIN)sqlldr_lil$(EXE_SUFFIX)
MIG=$(RDBMSBIN)mig$(EXE_SUFFIX)
DBVERIFY=$(RDBMSBIN)dbv$(EXE_SUFFIX)
TSTSHM=$(RDBMSBIN)tstshm$(EXE_SUFFIX)
MAXMEM=$(RDBMSBIN)maxmem$(EXE_SUFFIX)
DBFMIG=$(RDBMSBIN)dbfmig$(EXE_SUFFIX)
SYSRESVER=$(RDBMSBIN)sysresv$(EXE_SUFFIX)
ORAPWD=$(RDBMSBIN)orapwd$(EXE_SUFFIX)
TKPROF=$(RDBMSBIN)tkprof$(EXE_SUFFIX)
DBFSIZE=$(RDBMSBIN)dbfsize$(EXE_SUFFIX)
CURSIZE=$(RDBMSBIN)cursize$(EXE_SUFFIX)
RMAN=$(RDBMSBIN)rman$(EXE_SUFFIX)
GENOCI=$(RDBMSBIN)genoci$(EXE_SUFFIX)
ADDLCMP=$(RDBMSBIN)addlcmp$(EXE_SUFFIX)
GENKFLAT=$(RDBMSBIN)genkflat$(EXE_SUFFIX)
SVRMGRL=$(RDBMSBIN)svrmgrl$(EXE_SUFFIX)
TDSCOMP=$(RDBMSBIN)tdscomp$(EXE_SUFFIX)
EXTPROC=$(RDBMSBIN)extproc$(EXE_SUFFIX)
HSALLOCI=$(RDBMSBIN)hsalloci$(EXE_SUFFIX)
HSDEPXA=$(RDBMSBIN)hsdepxa$(EXE_SUFFIX)
HSOTS=$(RDBMSBIN)hsots$(EXE_SUFFIX)
AGTCTL=$(RDBMSBIN)agtctl$(EXE_SUFFIX)
OGMS=$(RDBMSBIN)ogms$(EXE_SUFFIX)
OGMSCTL=$(RDBMSBIN)ogmsctl$(EXE_SUFFIX)
ARCHMON=$(RDBMSBIN)archmon$(EXE_SUFFIX)
OSH=$(RDBMSBIN)osh$(EXE_SUFFIX)
RMAN=$(RDBMSBIN)rman$(EXE_SUFFIX)
BBED=$(RDBMSBIN)bbed$(EXE_SUFFIX)
SBTTEST=$(RDBMSBIN)sbttest$(EXE_SUFFIX)
KGPMON=$(RDBMSBIN)kgpmon$(EXE_SUFFIX)

ALL_OPTS= $(RDBMSLIB)$(VER_ENT) $(RDBMSLIB)$(PLS_ON) $(RDBMSLIB)$(OPS_ON) $(RDBMSLIB)$(DDB_ON) $(RDBMSLIB)$(SDO_ON) $(RDBMSLIB)$(CTX_ON) $(HO_ON) $(RDBMSLIB)$(OBJ_ON) $(RDBMSLIB)$(PART_ON) $(RDBMSLIB)$(LIL_OFF) $(RDBMSLIB)$(KPT_OFF)

NO_OPTS= $(RDBMSLIB)$(VER_ENT) $(RDBMSLIB)$(PLS_ON) $(RDBMSLIB)$(OPS_OFF) $(RDBMSLIB)$(DDB_OFF) $(RDBMSLIB)$(SDO_OFF) $(RDBMSLIB)$(CTX_OFF) $(HO_OFF) $(RDBMSLIB)$(OBJ_OFF) $(RDBMSLIB)$(PART_OFF) $(RDBMSLIB)$(LIL_OFF) $(RDBMSLIB)$(KPT_OFF)



SKGXPD_NAME=skgxpd
SKGXPD_SRC=skgxpd.c
SKGXPD_OBJ=$(RDBMSLIB)skgxpd.$(OBJ_EXT)
LIBSKGXPD_MEMBERS=$(LIBSKGXPD_STATIC)($(RDBMSLIB)skgxpd.$(OBJ_EXT))

SKGXPU_NAME=skgxpu
SKGXPU_SRC=skgxpu.c sskgxpu.c
SKGXPU_OBJ=$(RDBMSLIB)skgxpu.$(OBJ_EXT)	$(RDBMSLIB)sskgxpu.$(OBJ_EXT)
LIBSKGXPU_MEMBERS=$(LIBSKGXPU_STATIC)($(RDBMSLIB)skgxpu.$(OBJ_EXT))	\
		$(LIBSKGXPU_STATIC)($(RDBMSLIB)sskgxpu.$(OBJ_EXT))

SKGXPT_NAME=skgxpt
SKGXPT_SRC=skgxpt.c sskgxpt.c
SKGXPT_OBJ=$(RDBMSLIB)skgxpt.$(OBJ_EXT)	$(RDBMSLIB)sskgxpt.$(OBJ_EXT)
LIBSKGXPT_MEMBERS=$(LIBSKGXPT_STATIC)($(RDBMSLIB)skgxpt.$(OBJ_EXT))	\
		$(LIBSKGXPT_STATIC)($(RDBMSLIB)sskgxpt.$(OBJ_EXT))

# Entering /osp/d6/s/rdbms/s_rdbms.mk
RANLIBKNLOPT=
RANLIBORA=
OTHERST=
GENARGS=-n F
LDFLAGS_ORA=
LIBLISTRDBMS=
LLAIO=-laio
LLIBTHREAD=-lthread
LLIBPOSIX4=-lposix4
LLIBKSTAT=-lkstat


#LIBNM=$(CLUSTERDIR)/lib/libudlm.so
LIBNM=
#LIBCLUST=$(CLUSTERDIR)/lib/libcdb.so
LIBCLUST=
LLIBNM=$(SKGXN) -ludlm
LLIBCLUST=-lcdb
LIBOBKNAME=obk
LIBOBK=$(LIBHOME)$(LIB_PREFIX)$(LIBOBKNAME).$(SO_EXT)
LLIBOBK=$(LDLIBFLAG)$(LIBOBKNAME)

SYSLIBS +=`if [ -f /usr/lib/libsched.so ] ; then echo -lsched ; else true; fi` 

LIBSKGXPD_STATIC=$(RDBMSLIB)$(LIB_PREFIX)$(SKGXPD_NAME).$(LIB_EXT)
LIBSKGXPU_STATIC=$(RDBMSLIB)$(LIB_PREFIX)$(SKGXPU_NAME).$(LIB_EXT)
LIBSKGXPT_STATIC=$(RDBMSLIB)$(LIB_PREFIX)$(SKGXPT_NAME).$(LIB_EXT)

$(LIBSKGXPD_STATIC):	$(LIBSKGXPD_MEMBERS)
$(LIBSKGXPU_STATIC):	$(LIBSKGXPU_MEMBERS)
$(LIBSKGXPT_STATIC):	$(LIBSKGXPT_MEMBERS)


LIBSKGXPD=$(RDBMSLIB)$(LIB_PREFIX)$(SKGXPD_NAME).$(SO_EXT)
LIBSKGXPU=$(RDBMSLIB)$(LIB_PREFIX)$(SKGXPU_NAME).$(SO_EXT)
LIBSKGXPT=$(RDBMSLIB)$(LIB_PREFIX)$(SKGXPT_NAME).$(SO_EXT)

LIBSSKGXP_STATIC=$(LIBSKGXPD_STATIC) $(LIBSKGXPU_STATIC) $(LIBSKGXPT_STATIC)
LIBSSKGXP=       $(LIBSKGXPD)        $(LIBSKGXPU)        $(LIBSKGXPT)
EXTRALIBS += $(LIBSSKGXP_STATIC)
SHLIBS += $(LIBSSKGXP)

$(LIBSKGXPD):	$(LIBSKGXPD_STATIC)
$(LIBSKGXPU):	$(LIBSKGXPU_STATIC)
$(LIBSKGXPT):	$(LIBSKGXPT_STATIC)

POST_SKGXP_UPDATE=



SKGXP_DEFAULT=ipc_none
SKGXP_OPS_ON=ipc_udp

# Exiting /osp/d6/s/rdbms/s_rdbms.mk
# Exiting rdbms.mk
# Entering /osp/d6/s/buildtools/mkfile/libclntsh.mk
$(LIBCLNTSH):	${ORACLE_HOME}/lib/libclient8.a	${ORACLE_HOME}/lib/libsql8.a \
		${ORACLE_HOME}/lib/libntcp8.a	${ORACLE_HOME}/lib/libn8.a \
		${ORACLE_HOME}/lib/libnus8.a	${ORACLE_HOME}/lib/libntcps8.a \
		${ORACLE_HOME}/lib/libnoss8.a	${ORACLE_HOME}/lib/libnro8.a \
		${ORACLE_HOME}/lib/libnsslb8.a	${ORACLE_HOME}/lib/libcommon8.a\
		${ORACLE_HOME}/lib/libgeneric8.a ${ORACLE_HOME}/lib/libmm.a \
		${ORACLE_HOME}/lib/libnls8.a	${ORACLE_HOME}/lib/libcore8.a \
		${ORACLE_HOME}/lib/libtrace8.a\
		${ORACLE_HOME}/rdbms/lib/xaondy.o
	$(SILENT)$(ECHO) "Building client shared library libclntsh.so ..."
	$(SILENT)$(ECHO) "Call script $$ORACLE_HOME/bin/genclntsh ..."
	$(GENCLNTSH)
	$(SILENT)$(ECHO) "Built $$ORACLE_HOME/lib/libclntsh.so ... DONE"

# Exiting /osp/d6/s/buildtools/mkfile/libclntsh.mk
