/* Copyright (c) 1994 by M.Lonnroth, Oracle Corp.  All Rights Reserved */

/***
   NAME
     wowstub
   PURPOSE
     Invoke PL/SQL gateway procedure passing on HTML+ Forms parameters
   NOTES
     
   HISTORY
     mloennro - Dec 22, 1994: Created.
     $Log: wowstub.h,v $
 * Revision 1.1  1994/12/28  13:48:15  mloennro
 * Initial revision
 *
***/

/*#define DEBUG*/

#ifndef WOWSTUB
#define WOWSTUB

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "oci.h"

/* Default Oracle account - env WOW_UID overrides */
#define WOW_UID "test/test"
/* Array size for fetch */
#define ARRSZ 100
/* Max length of final PL/SQL string */
#define MAXPLSQL 8192
/* Max no of parameters */
#define MAX_ENTRIES 1000
/* Max len of one parameter value (only GET method) */
#define MAXGETVAL 1024
/* Max len of one parameter name (only GET method) */
#define MAXGETNAME 256
/* URL pointer to CGI documentation */
#define CGI_HELP_URL "<a href=\"/www/docs/cgi/overview.html\">CGI Overview</a>\n"

typedef struct {
     char *name;
     char *val;
} entry;


/* Request methods */
#define UNKNOWN 0
#define POST 1
#define GET 2

#ifdef __STDC__
char *makeword(char *line, char stop);
char *fmakeword(FILE *f, char stop, int *len);
char x2c(char *what);
void unescape_url(char *url);
void plustospace(char *str);
void wowFail(char *str);
void getword(char *, char *, char);
#else
char *makeword();
char *fmakeword();
char x2c();
void unescape_url();
void plustospace();
void wowFail();
void getword();
#endif
#endif /* WOWSTUB */
