drop table sccs_book;
create table sccs_book (
 ID                                VARCHAR2(200) CONSTRAINT fk_book
						REFERENCES bom(id),
 BOOK_TITLE                               VARCHAR2(100),
 PUB_DATE                                 DATE,
 ISBN_#                                   VARCHAR2(24),
 EDITION                                  VARCHAR2(24),
 SERIES                                   VARCHAR2(24),
 VOLUME_#                                 VARCHAR2(24),
 EDITOR                                   VARCHAR2(60),
 PUBLISHER                                VARCHAR2(110),
 PUBLISHER_ADDRESS1                       VARCHAR2(70),
 PUBLISHER_ADDRESS2                       VARCHAR2(70),
 PUBLISHER_PHONE                          VARCHAR2(24),
 PUBLISHER_FAX                            VARCHAR2(24),
 PUBLISHER_EMAIL                          VARCHAR2(50),
 BOOK_NOTE                                VARCHAR2(255)
);




drop table sccs_conf_proceedings;
create table sccs_conf_proceedings (
 ID                                VARCHAR2(200)
						CONSTRAINT fk_conf_proceedings
						REFERENCES bom(id),
 CONFERENCE_LOCATION                      VARCHAR2(70),
 CONFERENCE_NAME                          VARCHAR2(170),
 CONFERENCE_SPONSOR                       VARCHAR2(100),
 CONFERENCE_DATE                          DATE,
 ISBN_#                                   VARCHAR2(20),
 PUBLISHED_BY                             VARCHAR2(120),
 EDITION                                  VARCHAR2(10),
 CONFERENCE_SERIES                        VARCHAR2(40),
 CONFERENCE_VOLUME                        VARCHAR2(24),
 CONFERENCE_PAGES                         VARCHAR2(24),
 CONFERENCE_EDITOR                        VARCHAR2(70),
 CONFERENCE_PUBLISHER                     VARCHAR2(110),
 PUBLISHER_ADDRESS1                       VARCHAR2(70),
 PUBLISHER_ADDRESS2                       VARCHAR2(70),
 PUBLISHER_PHONE                          VARCHAR2(24),
 PUBLISHER_FAX                            VARCHAR2(24),
 PUBLISHER_EMAIL                          VARCHAR2(50),
 CONFERENCE_NOTE                          VARCHAR2(255)
);




drop table sccs_journal;
create table sccs_journal (
 ID                                VARCHAR2(200) CONSTRAINT fk_journal
						REFERENCES bom(id),
 JOURNAL_NAME                             VARCHAR2(120),
 SUBMITTED_DATE                           DATE,
 REVISED_DATE                             DATE,
 ACCEPTED_DATE                            DATE,
 PUB_DATE                                 DATE,
 ISBN_#                                   VARCHAR2(24),
 VOLUME_#                                 VARCHAR2(24),
 NUMBER_#                                 VARCHAR2(24),
 PAGE_NUMBERS                             VARCHAR2(24),
 PAGE_START                               NUMBER(6),
 PAGE_END                                 NUMBER(6),
 EDITOR                                   VARCHAR2(75),
 PUBLISHER                                VARCHAR2(110),
 PUBLISHER_ADDRESS1                       VARCHAR2(70),
 PUBLISHER_ADDRESS2                       VARCHAR2(70),
 PUBLISHER_PHONE                          VARCHAR2(24),
 PUBLISHER_FAX                            VARCHAR2(24),
 PUBLISHER_EMAIL                          VARCHAR2(50),
 JOURNAL_NOTE                             VARCHAR2(255)
);




drop table sccs_phd_thesis;
create table sccs_phd_thesis (
 ID                                VARCHAR2(200) CONSTRAINT fk_phd_thesis
						REFERENCES bom(id),
 PHD_DATE                                 DATE,
 SCHOOL                                   VARCHAR2(50),
 SCHOOL_ADDRESS                           VARCHAR2(70),
 PHD_NOTE                                 VARCHAR2(255)
);



drop table sccs_contract;
create table sccs_contract (
 ID                                VARCHAR2(200) CONSTRAINT fk_contract
						REFERENCES bom(id),
 DERIVED_FROM_V_ID                        VARCHAR2(10),
 PROJECT_TITLE                            VARCHAR2(50),
 PRINCIPAL_INVESTIGATOR                   VARCHAR2(40),
 CONTRACT_#                               VARCHAR2(30),
 ACCOUNT_#                                VARCHAR2(30),
 REPORT_#                                 VARCHAR2(15),
 CONTRACTOR                               VARCHAR2(50),
 REPORTING_PERIOD_FROM                    VARCHAR2(24),
 REPORTING_PERIOD_TO                      VARCHAR2(24),
 FUNDING_SOURCE                           VARCHAR2(70),
 COLLABORATING_ORGANIZATION               VARCHAR2(150),
 CONTRACT_NOTE                            VARCHAR2(150)
);



