rem
rem
Rem  Copyright (c) 1995 by Oracle Corporation
Rem    NAME
Rem      owa.sql - package of procedures called directly from OWA
Rem    DESCRIPTION
Rem      This file contains one package:
Rem         owa     - These procedures are interface procedures for
Rem                     the Oracle Web Agent.  These procedures should
Rem                     not be called by an end-user.
Rem
Rem    NOTES
Rem      The Oracle Web Agent is needed to use these facilities.
Rem      The package htpp is needed to use these facilities.
Rem
Rem    MODIFIED   (MM/DD/YY)
Rem     mbookman   07/09/95 -  Creation

REM Creating OWA package body...
create or replace package body OWA is

     /********************************************/
    /* Initialize the CGI environment variables */
   /********************************************/
   procedure init_cgi_env (num_params in number,
                           param_name in vc_arr,
                           param_val  in vc_arr) is
   begin
      for i in 1..num_params
      loop
         cgi_var_name(i) := param_name(i);
         cgi_var_val(i)  := param_val(i);
      end loop;
   end;
            
     /********************************************/
    /*  init_cgi_env_wow is for WOW             */
   /********************************************/
/*   procedure init_cgi_env_wow ( xAUTH_TYPE in varchar2,
                            xGATEWAY_INTERFACE in varchar2,
                            xHTTP_USER_AGENT in varchar2,
                            xREMOTE_HOST in varchar2,
                            xREMOTE_ADDR in varchar2,
                            xREMOTE_USER in varchar2,
                            xREMOTE_IDENT in varchar2,
                            xSERVER_PROTOCOL in varchar2,
                            xSERVER_SOFTWARE in varchar2,
                            xSERVER_NAME in varchar2,
                            xSERVER_PORT in varchar2
                          ) is */
procedure init_cgi_env_wow (xREMOTE_ADDR in varchar2) is
   begin
          remote_addr := xREMOTE_ADDR;
/*
          auth_type := xAUTH_TYPE;
          gateway_interface := xGATEWAY_INTERFACE;
          http_user_agent := xHTTP_USER_AGENT;
          remote_host := xREMOTE_HOST;
          remote_user := xREMOTE_USER;
          remote_ident := xREMOTE_IDENT;
          server_protocol := xSERVER_PROTOCOL;
          server_software := xSERVER_SOFTWARE;
          server_name := xSERVER_NAME;
           server_port := xSERVER_PORT;*/

   end;
            

     /*****************************************/
    /* Get the output from the user's PL/SQL */
   /*****************************************/
   procedure get_page (thepage     out htpp.htbuf_arr,
                       irows    in out integer ) is
   begin
      irows := least(irows,htpp.rows_in - htpp.rows_out);

      for i in 1..irows
      loop
         thepage(i) := htpp.htbuf(htpp.rows_out+i);
      end loop;

      htpp.rows_out := htpp.rows_out + irows;
   end;

     /**************************************************************/
    /* Procedure/function for accessing CGI environment variables */
   /**************************************************************/
   function get_cgi_env(param_name in varchar2) return varchar2 is
      i number := 1;
   begin
      loop
         if (owa.cgi_var_name(i) = upper(param_name))
           then return owa.cgi_var_val(i);
         end if;
 
         i := i+1;
      end loop;
 
   exception
 
      when NO_DATA_FOUND then return NULL;
   end;
 
 
     /**************************************************************/
    /* Procedure/function for printing CGI environment variables */
   /**************************************************************/
   procedure print_cgi_env is
      i number := 1;
   begin
--      htpp.p('test print_cgi_env');
--      loop
--         htpp.print(owa.cgi_var_name(i)||' = '||owa.cgi_var_val(i)||htff.nl);
--         htpp.p(owa.cgi_var_name(i)||' = '||owa.cgi_var_val(i));
--         i := i+1;
--      end loop;
--   exception
 
--      when NO_DATA_FOUND then NULL;

--         htpp.p(cgi_var_name(1)||' = '||cgi_var_val(1));
 htpp.p('remote_addr'||' = '||owa.remote_addr);
/*      htpp.p('auth_type'||' = '||owa.auth_type);
      htpp.br;
      htpp.p('gateway_interface'||' = '||owa.gateway_interface);
      htpp.br;
      htpp.p('http_user_agent'||' = '||owa.http_user_agent);
      htpp.br;
      htpp.p('remote_host'||' = '||owa.remote_host);
      htpp.br;
      htpp.p('remote_addr'||' = '||owa.remote_addr);
      htpp.br;
      htpp.p('remote_user'||' = '||owa.remote_user);
      htpp.br;
      htpp.p('remote_ident'||' = '||owa.remote_ident);
      htpp.br;
      htpp.p('server_protocol'||' = '||owa.server_protocol);
      htpp.br;
      htpp.p('server_software'||' = '||owa.server_software);
      htpp.br;
      htpp.p('server_name'||' = '||owa.server_name);
      htpp.br;
      htpp.p('server_port'||' = '||owa.server_port);
      htpp.br;
*/
   end;

  /* Jiangang's stuff */
  function get_value(name in varchar2, which in number) return varchar2 is
    value varchar2(100);
    a number;
    b number;
  begin
    if (which=1) then
      a := 0;
      b := instr(name, '&', 1, which);
      value := substr(name, a+1, b-a-1);
    elsif (which = get_length(name)) then
      a := instr(name, '&', 1, which-1);
      value := substr(name, a+1);
    else
      a := instr(name, '&', 1, which-1);
      b := instr(name, '&', 1, which);
      value := substr(name, a+1, b-a-1);
    end if;
    return value;    
  end;
 
  function get_length(name in varchar2) return number is
    length number :=1;
    para_counter number :=1;
  begin
    while (instr(name, '&', 1, para_counter) != 0) loop
      para_counter := para_counter +1;
      length := length +1;
    end loop;
    return length;
  end;

  function get_next(name in out varchar2) return number is
    next varchar2(100);
    a number;
  begin
    a := instr(name, '&', 1, 1);
    next := substr(name, 1, a-1);
    name := substr(name, a+1);
    return next;    
  end;

end;
/
show errors
