drop package sccs2;
/
create or replace package sccs2 is

function tr(name varchar2) return varchar2;
function th(name varchar2) return varchar2;
function td(name varchar2) return varchar2;

procedure add_conference(bomid varchar2,fid varchar2,pat integer);
procedure insert_conf_action(pat integer,fid varchar2,location varchar2,
	name varchar2,sponsor varchar2,mm1 char,dd1 char,yy1 char,
	isbn varchar2,pub varchar2,edit varchar2,series varchar2,
	volume varchar2,pages varchar2,editor varchar2,publisher varchar2,
	addr1 varchar2,addr2 varchar2,phone varchar2,fax varchar2,
	mail varchar2,note varchar2);
procedure add_journal(bomid varchar2,fid varchar2,pat integer);
procedure insert_jour_action(pat integer,fid varchar2,name varchar2,mm1 char,
	dd1 char,yy1 char,mm2 char,dd2 char,yy2 char,mm3 char,dd3 char,
	yy3 char,mm4 char,dd4 char,yy4 char,isbn varchar2,volume varchar2,
	number varchar2,page_num varchar2,start1 varchar2,end1 varchar2,
	ed_person varchar2,pub varchar2,addr1 varchar2,
	addr2 varchar2,phone varchar2,fax varchar2,mail varchar2,
	note varchar2);
procedure add_internal(bomid varchar2,fid varchar2,pat integer);
procedure insert_inter_action(pat integer,fid varchar2,org_id varchar2,
	title varchar2,investigator varchar2,contract varchar2,
	account varchar2,report varchar2,con_person varchar2,
	period_from varchar2,period_to varchar2,fund varchar2,orga varchar2,
	note varchar2);
procedure add_book(bomid varchar2,fid varchar2,pat integer);
procedure insert_book_action(pat integer,fid varchar2,title varchar2,mm1 char,
	dd1 char,yy1 char,isbn varchar2,edit varchar2,ser varchar2,
	volume varchar2,ed_person varchar2,pub varchar2,addr1 varchar2,
	addr2 varchar2,phone varchar2,fax varchar2,mail varchar2,
	note varchar2);
procedure add_phd(bomid varchar2,fid varchar2,pat integer);
procedure insert_phd_action(pat integer,fid varchar2,mm1 char,dd1 char,
	yy1 char,school_name varchar2,addr varchar2,note varchar2);

procedure show_info(docid varchar2, doctype varchar2);
procedure show_conf(docid varchar2);
procedure show_journal(docid varchar2);
procedure show_internal(docid varchar2);
procedure show_book(docid varchar2);
procedure show_phd_thesis(docid varchar2);

procedure modify_by_id(p varchar2,me varchar2,op integer,pat integer);
procedure modify_button(me varchar2, op integer, pat integer);

end;
/
show errors;

create or replace package body sccs2 is

cgi_bin constant varchar2(60) := sccs.cgi_bin;
username constant varchar2(10) := sccs.username;
password constant varchar2(10) := sccs.password;
client varchar2(30) := sccs.client;
time_out number(8,5) := sccs.time_out;
USER_II constant integer := sccs.USER_II;
USER_III constant integer := sccs.USER_III;
ROOT constant integer := sccs.ROOT;
help_page constant varchar2(100) := sccs.help_page;
h_caption varchar2(600);
total number(8);


function td(name varchar2) return varchar2 is
begin
	return ('<td>'||name||'</td>');
end;

function th(name varchar2) return varchar2 is
begin
	return ('<th>'||name||'</th>');
end;

function tr(name varchar2) return varchar2 is
begin
	return ('<tr>'||name||'</tr>');
end;


procedure show_info(docid varchar2,doctype varchar2) is
begin
	if (doctype = 2) or (doctype = 3) then
		show_conf(docid);
	elsif (doctype = 4) then
		show_journal(docid);
	elsif (doctype = 5) then
		show_internal(docid);
	elsif (doctype = 6) then
		show_book(docid);
	elsif (doctype = 7) then
		show_phd_thesis(docid);
	end if;
end;

procedure show_conf(docid varchar2) is
res sccs_conf_proceedings%ROWTYPE;
cursor info(oid varchar2) is select * from sccs_conf_proceedings
	where id=oid;
begin

htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
htp.p('<center>');
htp.p('<p><h2>The Additional Information For This Conference Paper</h2>');
htp.p('<p><font size=+3>');
htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/forest.gif">');
htp.p('<p></font>');
open info(docid);
fetch info into res;
if (info%NOTFOUND) then
	htp.p('<br> Not Found');
else
htp.p('<table border=2 align="center">');
htp.p('<tr><th>Data Item</th><th>The Data Value</th>');
htp.p('<tr><td>SCCS ID<td><b>SCCS-'||docid||'</b>');
if (res.conference_location IS NOT NULL) then
   htp.p('<tr><td><b>Conference Location</b><td>'||res.conference_location);
end if;
if (res.conference_name IS NOT NULL) then
   htp.p('<tr><td><b>Conference Name</b><td>'||res.conference_name);
end if;
if (res.conference_sponsor IS NOT NULL) then
   htp.p('<tr><td><b>Conference Sponsor</b><td>'||res.conference_sponsor);
end if;
if (res.conference_date IS NOT NULL) then
   htp.p('<tr><td><b>Conference Date (mm/dd/yy)</b><td>'||
	to_char(res.conference_date,'mm/dd/yy'));
end if;
if (res.isbn_# IS NOT NULL) then
   htp.p('<tr><td><b>ISBN Number</b><td>'||res.isbn_#);
end if;
if (res.published_by IS NOT NULL) then
   htp.p('<tr><td><b>Published By</b><td>'||res.published_by);
end if;
if (res.edition IS NOT NULL) then
   htp.p('<tr><td><b>Edition</b><td>'||res.edition);
end if;
if (res.conference_series IS NOT NULL) then
   htp.p('<tr><td><b>Conference Series</b><td>'||res.conference_series);
end if;
if (res.conference_volume IS NOT NULL) then
   htp.p('<tr><td><b>Conference Volume</b><td>'||res.conference_volume);
end if;
if (res.conference_pages IS NOT NULL) then
   htp.p('<tr><td><b>Conference pages</b><td>'||res.conference_pages);
end if;
if (res.conference_editor IS NOT NULL) then
   htp.p('<tr><td><b>Conference editor</b><td>'||res.conference_editor);
end if;
if (res.conference_publisher IS NOT NULL) then
   htp.p('<tr><td><b>Conference Publisher</b><td>'||res.conference_publisher);
end if;
if (res.publisher_address1 IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Address1</b><td>'||res.publisher_address1);
end if;
if (res.publisher_address2 IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Address2</b><td>'||res.publisher_address2);
end if;
if (res.publisher_phone IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Phone</b><td>'||res.publisher_phone);
end if;
if (res.publisher_fax IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Fax</b><td>'||res.publisher_fax);
end if;
if (res.publisher_email IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Email</b><td>'||res.publisher_email);
end if;
if (res.conference_note IS NOT NULL) then
   htp.p('<tr><td><b>Conference Note</b><td>'||res.conference_note);
end if;
htp.p('</table>');
htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/wavy.gif">');
end if;

htp.p('</center>');
close info;
end ;


procedure add_conference(bomid varchar2,fid varchar2, pat integer) is
res sccs_conf_proceedings%ROWTYPE;
cursor info(oid varchar2) is select * from sccs_conf_proceedings
	where id=oid;

begin

htp.p('<hr>');
	--htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
htp.p('<form action="'||cgi_bin||'sccs2.insert_conf_action" method="POST">');
htp.p('<center>');
htp.bp('<table border=2 align="center">
<caption><font size=+2>Additional Information For Conference Paper</font>
</caption><tr><th>Data Item</th><th>New Value to be inserted</th>
<tr><td>SCCS ID<td><b>SCCS '||fid||'</b><input type="hidden" name="fid" value='||fid||'>');

open info(bomid);
fetch info into res;

if (pat=1) and (not (bomid=fid)) then
	htp.p('   (From SCCS-'||bomid||')');
end if;
htp.p('<tr><td>Conference Location<td><input name="location" size="40" value="'||res.conference_location||'">');
htp.p('<tr><td>Conference Name<td><input name="name" size="40" value="'||res.conference_name||'">');
htp.p('<tr><td>Conference Sponsor<td><input name="sponsor" size="40" value="'||res.conference_sponsor||'">');
htp.p('<tr><td>Conference Date');
htp.p('<td><input name="mm1" size=2 value="'||to_char(res.conference_date,'mm')||'">
/<input name="dd1" size=2 value="'||to_char(res.conference_date,'dd')||'" >/
<input size=2 name="yy1" value="'||to_char(res.conference_date,'yy')||'"> (mm/dd/yy)');
htp.p('<tr><td>ISBN Number<td><input name="isbn" size="40" value="'||res.isbn_#||'">');
htp.p('<tr><td>Published By<td><input name="pub" size="40" value="'||res.published_by||'">');
htp.p('<tr><td>Edition<td><input name="edit" size="40" value="'||res.edition||'">');
htp.p('<tr><td>Conference Series<td><input name="series" size="40" value="'||res.conference_series||'">');
htp.p('<tr><td>Conference Volume<td><input name="volume" size="40" value="'||res.conference_volume||'">');
htp.p('<tr><td>Conference Pages<td><input name="pages" size="40" value="'||res.conference_pages||'">');
htp.p('<tr><td>Conference Editor<td><input name="editor" size="40" value="'||res.conference_editor||'">');
htp.p('<tr><td>Conference Publisher<td><input name="publisher" size="40" value="'||res.conference_publisher||'">');
htp.p('<tr><td>Publisher Address1<td><input name="addr1" size="40" value="'||res.publisher_address1||'">');
htp.p('<tr><td>Publisher Address2<td><input name="addr2" size="40" value="'||res.publisher_address2||'">');
htp.p('<tr><td>Publisher Phone<td><input name="phone" size="40" value="'||res.publisher_phone||'">');
htp.p('<tr><td>Publisher Fax<td><input name="fax" size="40" value="'||res.publisher_fax||'">');
htp.p('<tr><td>Publisher Email<td><input name="mail" size="40" value="'||res.publisher_email||'">');
htp.p('<tr><td>Conference Note<td><input name="note" size="40" value="'||res.conference_note||'">');
htp.p('</table>');
if (pat=1) then
	htp.p('<input type="submit" value="Insert">');
else 
	htp.p('<input type="submit" value="Update">');
end if;
htp.p('<input type="reset" name="Reset">');
htp.p('<input type="hidden" name="pat" value="'||pat||'">');
htp.p('</form></center>'); 
close info;
end;


procedure insert_conf_action(pat integer,fid varchar2,location varchar2,
	name varchar2,sponsor varchar2,mm1 char,dd1 char,yy1 char,
	isbn varchar2,pub varchar2,edit varchar2,series varchar2,
	volume varchar2,pages varchar2,editor varchar2,publisher varchar2,
	addr1 varchar2,addr2 varchar2,phone varchar2,fax varchar2,
	mail varchar2,note varchar2) is

conf_date date;

begin
 
conf_date := to_date(lpad(mm1,2,'0') ||lpad(dd1,2,'0')||lpad(yy1,2,'0'),'mmddyy');
if (pat=1) then
    insert into sccs_conf_proceedings(id,conference_location,conference_name,
	conference_sponsor,conference_date,isbn_#,published_by,edition,
	conference_series,conference_volume,conference_pages,conference_editor,
	conference_publisher,publisher_address1,publisher_address2,
	publisher_phone,publisher_fax,publisher_email,conference_note)
    values(fid,location,name,sponsor,conf_date,isbn,pub,edit,series,volume,
	pages,editor,publisher,addr1,addr2,phone,fax,mail,note);
else
    update sccs_conf_proceedings
	set id=fid,conference_location=location,conference_name=name,
	    conference_sponsor=sponsor,conference_date=conf_date,
	    isbn_#=isbn,published_by=pub,edition=edit,conference_series=series,
	    conference_volume=volume,conference_pages=pages,
	    conference_editor=editor,conference_publisher=publisher,
	    publisher_address1=addr1,publisher_address2=addr2,
	    publisher_phone=phone,publisher_fax=fax,publisher_email=mail,
	    conference_note=note
	where id=fid;
end if;
commit;

htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
htp.p('<center>');
	htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/ringyel.gif"><p>');
	if (pat=1) then
		htp.p('<p>The Additional Information for SCCS document (ID ='||htf.bold(fid)||') has been sucessfully added into the SCCS pending document DB.');
	else 
		htp.p('<p>The Additional Information for SCCS document (ID ='||htf.bold(fid)||') has been updated');
	end if;
end;


procedure show_journal(docid varchar2) is
res sccs_journal%ROWTYPE;
cursor info(oid varchar2) is select * from sccs_journal
	where id=oid;
begin

htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
htp.p('<center>');
htp.p('<b>The Additional Information For This Journal Paper</b>');
htp.p('<b><font size=+3>');
htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/forest.gif">');
htp.p('<b></font>');
open info(docid);
fetch info into res;
if (info%NOTFOUND) then
	htp.p('<br> Not Found');
else
htp.p('<table border=2 align="center">');
htp.p('<tr><th>Data Item</th><th>The Data Value</th>');
htp.p('<tr><td>SCCS ID<td><b>SCCS-'||docid||'</b>');
if (res.journal_name IS NOT NULL) then
   htp.p('<tr><td><b>Journal Name</b><td>'||res.journal_name);
end if; 
if (res.submitted_date IS NOT NULL) then
   htp.p('<tr><td><b>Submitted Date (mm/dd/yy)</b><td>'||
		to_char(res.submitted_date,'mm/dd/yy'));
end if;
if (res.revised_date IS NOT NULL) then
   htp.p('<tr><td><b>Revised Date (mm/dd/yy)</b><td>'||
		to_char(res.revised_date,'mm/dd/yy'));
end if;
if (res.accepted_date IS NOT NULL) then
   htp.p('<tr><td><b>Accepted Date (mm/dd/yy)</b><td>'||
		to_char(res.accepted_date,'mm/dd/yy'));
end if;
if (res.pub_date IS NOT NULL) then
   htp.p('<tr><td><b>Published Date (mm/dd/yy)</b><td>'||
		to_char(res.pub_date,'mm/dd/yy'));
end if;
if (res.isbn_# IS NOT NULL) then
   htp.p('<tr><td><b>ISBN Number</b><td>'||res.isbn_#);
end if;
if (res.volume_# IS NOT NULL) then
   htp.p('<tr><td><b>Volume Number</b><td>'||res.volume_#);
end if;
if (res.number_# IS NOT NULL) then
   htp.p('<tr><td><b>Number_#</b><td>'||res.number_#);
end if;
if (res.page_numbers IS NOT NULL) then
   htp.p('<tr><td><b>Page Numbers</b><td>'||res.page_numbers);
end if;
if (res.page_start IS NOT NULL) then
   htp.p('<tr><td><b>Page Start</b><td>'||res.page_start);
end if;
if (res.page_end IS NOT NULL) then
   htp.p('<tr><td><b>Page End</b><td>'||res.page_end);
end if;
if (res.editor IS NOT NULL) then
   htp.p('<tr><td><b>Editor</b><td>'||res.editor);
end if;
if (res.publisher IS NOT NULL) then
   htp.p('<tr><td><b>Publisher</b><td>'||res.publisher);
end if;
if (res.publisher_address1 IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Address1</b><td>'||res.publisher_address1);
end if;
if (res.publisher_address2 IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Address2</b><td>'||res.publisher_address2);
end if;
if (res.publisher_phone IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Phone</b><td>'||res.publisher_phone);
end if;
if (res.publisher_fax IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Fax</b><td>'||res.publisher_fax);
end if;
if (res.publisher_email IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Email</b><td>'||res.publisher_email);
end if;
if (res.journal_note IS NOT NULL) then
   htp.p('<tr><td><b>Journal Note</b><td>'||res.journal_note);
end if ;

htp.p('</table>');
htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/wavy.gif">');
end if;

htp.p('</center>');
close info;
end ;

procedure add_journal(bomid varchar2,fid varchar2,pat integer) is
res sccs_journal%ROWTYPE;
cursor info(oid varchar2) is select * from sccs_journal
	where id=oid;


begin

htp.p('<hr>');
htp.p('<form action="'||cgi_bin||'sccs2.insert_jour_action" method="POST">');
htp.p('<center>');
htp.bp('<table border=2 align="center">
<caption><font size=+2>Additional Information For Journal Paper</font>
</caption><tr><th>Data Item</th><th>New Value to be inserted</th>
<tr><td>SCCS ID<td><b>SCCS '||fid||'</b><input type="hidden" name="fid" value='||fid||'>');
open info(bomid);
fetch info into res;

if (pat=1) and (not (bomid=fid)) then
	htp.p('   (From SCCS-'||bomid||')');
end if;
htp.p('<tr><td>Journal Name<td><input name="name" size="40" value="'||res.journal_name||'">');
htp.p('<tr><td>Submitted date');
htp.bp('<td><input name="mm1" size=2 value="'||to_char(res.submitted_date,'mm')||'">
/<input name="dd1" size=2 value="'||to_char(res.submitted_date,'dd')||'" >/
<input size=2 name="yy1" value="'||to_char(res.submitted_date,'yy')||'"> (mm/dd/yy)');
htp.p('<tr><td>Revised Date');
htp.bp('<td><input name="mm2" size=2 value="'||to_char(res.revised_date,'mm')||'">
/<input name="dd2" size=2 value="'||to_char(res.revised_date,'dd')||'" >/
<input size=2 name="yy2" value="'||to_char(res.revised_date,'yy')||'"> (mm/dd/yy)');
htp.p('<tr><td>Accepted Date');
htp.bp('<td><input name="mm3" size=2 value="'||to_char(res.accepted_date,'mm')||'">
/<input name="dd3" size=2 value="'||to_char(res.accepted_date,'dd')||'" >/
<input size=2 name="yy3" value="'||to_char(res.accepted_date,'yy')||'"> (mm/dd/yy)');
htp.p('<tr><td>Publish Date');
htp.bp('<td><input name="mm4" size=2 value="'||to_char(res.pub_date,'mm')||'">
/<input name="dd4" size=2 value="'||to_char(res.pub_date,'dd')||'" >/
<input size=2 name="yy4" value="'||to_char(res.pub_date,'yy')||'"> (mm/dd/yy)');
htp.p('<tr><td>ISBN Number<td><input name="isbn" size="40" value="'||res.isbn_#||'">');
htp.p('<tr><td>Volume Number<td><input name="volume" size="40" value="'||res.volume_#||'">');
htp.p('<tr><td>Number_#<td><input name="number" size="40" value="'||res.number_#||'">');
htp.p('<tr><td>Page Numbers<td><input name="page_num" size="40" value="'||res.page_numbers||'">');
htp.p('<tr><td>Page Start<td><input name="start1" size="40" value="'||res.page_start||'">');
htp.p('<tr><td>Page End<td><input name="end1" size="40" value="'||res.page_end||'">');
htp.p('<tr><td>Editor<td><input name="ed_person" size="40" value="'||res.editor||'">');
htp.p('<tr><td>Publisher<td><input name="pub" size="40" value="'||res.publisher||'">');
htp.p('<tr><td>Publisher Address1<td><input name="addr1" size="40" value="'||res.publisher_address1||'">');
htp.p('<tr><td>Publisher Address2<td><input name="addr2" size="40" value="'||res.publisher_address2||'">');
htp.p('<tr><td>Publisher Phone<td><input name="phone" size="40" value="'||res.publisher_phone||'">');
htp.p('<tr><td>Publisher Fax<td><input name="fax" size="40" value="'||res.publisher_fax||'">');
htp.p('<tr><td>Publisher Email<td><input name="mail" size="40" value="'||res.publisher_email||'">');
htp.p('<tr><td>Journal Note<td><input name="note" size="40" value="'||res.journal_note||'">');
htp.p('</table>');
if (pat=1) then
	htp.p('<input type="submit" value="Insert">');
else 
	htp.p('<input type="submit" value="Update">');
end if;

htp.p('<input type="reset" name="Reset">');
htp.p('<input type="hidden" name="pat" value="'||pat||'">');
htp.p('</form></center>'); 
close info;
end;

procedure insert_jour_action(pat integer,fid varchar2,name varchar2,mm1 char,
	dd1 char,yy1 char,mm2 char,dd2 char,yy2 char,mm3 char,dd3 char,
	yy3 char,mm4 char,dd4 char,yy4 char,isbn varchar2,volume varchar2,
	number varchar2,page_num varchar2,start1 varchar2,end1 varchar2,
	ed_person varchar2,pub varchar2,addr1 varchar2,
	addr2 varchar2,phone varchar2,fax varchar2,mail varchar2,
	note varchar2) is
date1 date;
date2 date;
date3 date;
date4 date;

begin

date1 := to_date(lpad(mm1,2,'0') || lpad(dd1,2,'0') || lpad(yy1,2,'0'),'mmddyy');
date2 := to_date(lpad(mm2,2,'0') || lpad(dd2,2,'0') || lpad(yy2,2,'0'),'mmddyy');
date3 := to_date(lpad(mm3,2,'0') || lpad(dd3,2,'0') || lpad(yy3,2,'0'),'mmddyy');
date4 := to_date(lpad(mm4,2,'0') || lpad(dd4,2,'0') || lpad(yy4,2,'0'),'mmddyy');

if (pat=1) then
	insert into sccs_journal(id,journal_name,submitted_date,revised_date,
		accepted_date,pub_date,isbn_#,volume_#,number_#,page_numbers,
		page_start,page_end,editor,publisher,publisher_address1,
		publisher_address2,publisher_phone,publisher_fax,
		publisher_email,journal_note)
	values(fid,name,date1,date2,date3,date4,isbn,volume,number,page_num,
		start1,end1,ed_person,pub,addr1,addr2,phone,fax,mail,note);

else
	update sccs_journal
	  set id=fid,journal_name=name,submitted_date=date1,revised_date=date2,
	      accepted_date=date3,pub_date=date4,isbn_#=isbn,volume_#=volume,
	      number_#=number,page_numbers=page_num,page_start=start1,
	      page_end=end1,editor=ed_person,publisher=pub,
	      publisher_address1=addr1,publisher_address2=addr2,
	      publisher_phone=phone,publisher_fax=fax,publisher_email=mail,
	      journal_note=note
	  where id=fid;
end if;
commit;

htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
htp.p('<center>');
	htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/ringyel.gif"><p>');
	if (pat=1) then
		htp.p('<p>The Additional Information for SCCS document (ID ='||htf.bold(fid)||') has been sucessfully added into the SCCS pending document DB.');
	else 
		htp.p('<p>The Additional Information for SCCS document (ID ='||htf.bold(fid)||') has been updated');
	end if;
end;


procedure show_internal(docid varchar2) is
res sccs_contract%ROWTYPE;
cursor info(oid varchar2) is select * from sccs_contract
	where id=oid;
begin

htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
htp.p('<center>');
htp.p('<b>The Additional Information For This Internal Proposal</b>');
htp.p('<b><font size=+3>');
htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/forest.gif">');
htp.p('<b></font>');
open info(docid);
fetch info into res;
if (info%NOTFOUND) then
	htp.p('<br> Not Found');
else
htp.p('<table border=2 align="center">');
htp.p('<tr><th>Data Item</th><th>The Data Value</th>');
htp.p('<tr><td>SCCS ID<td><b>SCCS-'||docid||'</b>');

if (res.derived_from_v_id IS NOT NULL) then
   htp.p('<tr><td><b>Derived From Version ID</b><td>'||res.derived_from_v_id);
end if;
if (res.project_title IS NOT NULL) then
   htp.p('<tr><td><b>Project Title</b><td>'||res.project_title);
end if;
if (res.principal_investigator IS NOT NULL) then
    htp.p('<tr><td><b>Principal Investigator</b><td>'||res.principal_investigator);
end if;
if (res.contract_# IS NOT NULL) then
   htp.p('<tr><td><b>Contract Number</b><td>'||res.contract_#);
end if;
if (res.account_# IS NOT NULL) then
   htp.p('<tr><td><b>Account Number</b><td>'||res.account_#);
end if;
if (res.report_# IS NOT NULL) then
   htp.p('<tr><td><b>Report Number</b><td>'||res.report_#);
end if;
if (res.contractor IS NOT NULL) then
   htp.p('<tr><td><b>Contractor</b><td>'||res.contractor);
end if;
if (res.reporting_period_from IS NOT NULL) then
    htp.p('<tr><td><b>Reporting Period From</b><td>'||res.reporting_period_from);
end if;
if (res.reporting_period_to IS NOT NULL) then
   htp.p('<tr><td><b>Reporting Period To</b><td>'||res.reporting_period_to);
end if;
if (res.funding_source IS NOT NULL) then
   htp.p('<tr><td><b>Funding Source</b><td>'||res.funding_source);
end if;
if (res.collaborating_organization IS NOT NULL) then
   htp.p('<tr><td><b>Collaborating Organization</b><td>'||
	res.collaborating_organization);
end if;
if (res.contract_note IS NOT NULL) then
   htp.p('<tr><td><b>Contract Note</b><td>'||res.contract_note);
end if;
htp.p('</table>');
htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/wavy.gif">');
end if;

htp.p('</center>');
close info;
end ;



procedure add_internal(bomid varchar2,fid varchar2,pat integer) is
res sccs_contract%ROWTYPE;
cursor info(oid varchar2) is select * from sccs_contract
	where id=oid;
begin
	htp.p('<hr>');
	--htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
	htp.p('<form action="'||cgi_bin||'sccs2.insert_inter_action" method="POST">');
htp.p('<center>');
htp.bp('<table border=2 align="center">
<caption><font size=+2>Additional Information For Internal Proposal</font>
</caption><tr><th>Data Item</th><th>New Value to be inserted</th>
<tr><td>SCCS ID<td><b>SCCS '||fid||'</b><input type="hidden" name="fid" value='||fid||'>');
open info(bomid);
fetch info into res;

if (pat=1) and (not (bomid=fid)) then
	htp.p('   (From SCCS-'||bomid||')');
end if;
htp.p('<tr><td>Derived From Version ID<td><input name="org_id" size="40" value="'||res.derived_from_v_id||'">');
htp.p('<tr><td>Project Title<td><input name="title" size="40" value="'||res.project_title||'">');
htp.p('<tr><td>Principal Investigator<td><input name="investigator" size="40" value="'||res.principal_investigator||'">');
htp.p('<tr><td>Contract_#<td><input name="contract" size="40" value="'||res.contract_#||'">');
htp.p('<tr><td>Account_#<td><input name="account" size="40" value="'||res.account_#||'">');
htp.p('<tr><td>Report_#<td><input name="report" size="40" value="'||res.report_#||'">');
htp.p('<tr><td>Contractor<td><input name="con_person" size="40" value="'||res.contractor||'">');
htp.p('<tr><td>Reporting Period From<td><input name="period_from" size="40" value="'||res.reporting_period_from||'">');
htp.p('<tr><td>Reporting Period To<td><input name="period_to" size="40" value="'||res.reporting_period_to||'">');
htp.p('<tr><td>Funding Source<td><input name="fund" size="40" value="'||res.funding_source||'">');
htp.p('<tr><td>Collaborating Organization<td><input name="orga" size="40" value="'||res.collaborating_organization||'">');
htp.p('<tr><td>Contract Note<td><input name="note" size="40" value="'||res.contract_note||'">');
htp.p('</table>');
if (pat=1) then
	htp.p('<input type="submit" value="Insert">');
else
	htp.p('<input type="submit" value="Update">');
end if;
htp.p('<input type="reset" name="Reset">');
htp.p('<input type="hidden" name="pat" value="'||pat||'">');
htp.p('</form></center>'); 
close info;
end;

procedure insert_inter_action(pat integer,fid varchar2,org_id varchar2,
	title varchar2,investigator varchar2,contract varchar2,
	account varchar2,report varchar2,con_person varchar2,
	period_from varchar2,period_to varchar2,fund varchar2,orga varchar2,
	note varchar2) is

begin

if (pat=1) then
	insert into sccs_contract(id,derived_from_v_id,project_title,
		principal_investigator,contract_#,account_#,report_#,
		contractor,reporting_period_from,reporting_period_to,
		funding_source,collaborating_organization,contract_note)
	values(fid,org_id,title,investigator,contract,account,report,
		con_person,period_from,period_to,fund,orga,note);
else
	update sccs_contract
	   set id=fid,derived_from_v_id=org_id,project_title=title,
		principal_investigator=investigator,contract_#=contract,
		account_#=account,report_#=report,contractor=con_person,
		reporting_period_from=period_from,
		reporting_period_to=period_to,funding_source=fund,
		collaborating_organization=orga,contract_note=note
	   where id=fid;
end if;
commit;

htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
htp.p('<center>');
	htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/ringyel.gif"><p>');
	if (pat=1) then
		htp.p('<p>The Additional Information for SCCS document (ID ='||htf.bold(fid)||') has been sucessfully added into the SCCS pending document DB.');
	else 
		htp.p('<p>The Additional Information for SCCS document (ID ='||htf.bold(fid)||') has been updated');
	end if;
end;

procedure show_book(docid varchar2) is
res sccs_book%ROWTYPE;
cursor info(oid varchar2) is select * from sccs_book
	where id=oid;
begin

htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
htp.p('<center>');
htp.p('<b>The Additional Information For This Book</b>');
htp.p('<b><font size=+3>');
htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/forest.gif">');
htp.p('<b></font>');
open info(docid);
fetch info into res;
if (info%NOTFOUND) then
	htp.p('<br> Not Found');
else
htp.p('<table border=2 align="center">');
htp.p('<tr><th>Data Item</th><th>The Data Value</th>');
htp.p('<tr><td>SCCS ID<td><b>SCCS-'||docid||'</b>');
if (res.book_title IS NOT NULL) then
   htp.p('<tr><td><b>Book Title</b><td>'||res.book_title);
end if;
if (res.pub_date IS NOT NULL) then
   htp.p('<tr><td><b>Publish Date (mm/dd/yy)</b><td>'||res.pub_date);
end if;
if (res.isbn_# IS NOT NULL) then
   htp.p('<tr><td><b>ISBN Number</b><td>'||res.isbn_#);
end if;
if (res.edition IS NOT NULL) then
   htp.p('<tr><td><b>Editioen</b><td>'||res.edition);
end if;
if (res.series IS NOT NULL) then
   htp.p('<tr><td><b>Series</b><td>'||res.series);
end if;
if (res.volume_# IS NOT NULL) then
   htp.p('<tr><td><b>Volume Number</b><td>'||res.volume_#);
end if;
if (res.editor IS NOT NULL) then
   htp.p('<tr><td><b>Editor</b><td>'||res.editor);
end if;
if (res.publisher IS NOT NULL) then
   htp.p('<tr><td><b>Publisher</b><td>'||res.publisher);
end if;
if (res.publisher_address1 IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Address1</b><td>'||res.publisher_address1);
end if;
if (res.publisher_address2 IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Address2</b><td>'||res.publisher_address2);
end if;
if (res.publisher_phone IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Phone</b><td>'||res.publisher_phone);
end if;
if (res.publisher_fax IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Fax</b><td>'||res.publisher_fax);
end if;
if (res.publisher_email IS NOT NULL) then
   htp.p('<tr><td><b>Publisher Email</b><td>'||res.publisher_email);
end if;
if (res.book_note IS NOT NULL) then
   htp.p('<tr><td><b>Book Note</b><td>'||res.book_note);
end if;
htp.p('</table>');
htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/wavy.gif">');
end if;

htp.p('</center>');
close info;
end ;


procedure add_book(bomid varchar2,fid varchar2,pat integer) is
res sccs_book%ROWTYPE;
cursor info(oid varchar2) is select * from sccs_book
	where id=oid;

begin

	htp.p('<hr>');
	--htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
	htp.p('<form action="'||cgi_bin||'sccs2.insert_book_action" method="POST">');
htp.p('<center>');
htp.bp('<table border=2 align="center">
<caption><font size=+2>Additional Information For Book</font>
</caption><tr><th>Data Item</th><th>New Value to be inserted</th>
<tr><td>SCCS ID<td><b>SCCS '||fid||'</b><input type="hidden" name="fid" value='||fid||'>');
open info(bomid);
fetch info into res;

if (pat=1) and (not (bomid=fid)) then
	htp.p('   (From SCCS-'||bomid||')');
end if;
htp.p('<tr><td>Book Title<td><input name="title" size="40" value="'||res.book_title||'">');
htp.p('<tr><td>Publish Date');
htp.bp('<td><input name="mm1" size=2 value="'||to_char(res.pub_date,'mm')||'">
/<input name="dd1" size=2 value="'||to_char(res.pub_date,'dd')||'" >/
<input size=2 name="yy1" value="'||to_char(res.pub_date,'yy')||'"> (mm/dd/yy)');
htp.p('<tr><td>ISBN_#<td><input name="isbn" size="40" value="'||res.isbn_#||'">');
htp.p('<tr><td>Edition<td><input name="edit" size="40" value="'||res.edition||'">');
htp.p('<tr><td>Series<td><input name="ser" size="40" value="'||res.series||'">');
htp.p('<tr><td>Volume_#<td><input name="volume" size="40" value="'||res.volume_#||'">');
htp.p('<tr><td>Editor<td><input name="ed_person" size="40" value="'||res.editor||'">');
htp.p('<tr><td>Publisher<td><input name="pub" size="40" value="'||res.publisher||'">');
htp.p('<tr><td>Publisher Address1<td><input name="addr1" size="40" value="'||res.publisher_address1||'">');
htp.p('<tr><td>Publisher Address2<td><input name="addr2" size="40" value="'||res.publisher_address2||'">');
htp.p('<tr><td>Publisher Phone<td><input name="phone" size="40" value="'||res.publisher_phone||'">');
htp.p('<tr><td>Publisher Fax<td><input name="fax" size="40" value="'||res.publisher_fax||'">');
htp.p('<tr><td>Publisher Email<td><input name="mail" size="40" value="'||res.publisher_email||'">');
htp.p('<tr><td>Book Note<td><input name="note" size="40" value="'||res.book_note||'">');
htp.p('</table>');
if (pat=1) then
	htp.p('<input type="submit" value="Insert">');
else 
	htp.p('<input type="submit" value="Update">');
end if;
htp.p('<input type="reset" name="Reset">');
htp.p('<input type="hidden" name="pat" value="'||pat||'">');
htp.p('</form></center>'); 
close info;

end;

procedure insert_book_action(pat integer,fid varchar2,title varchar2,mm1 char,
	dd1 char,yy1 char,isbn varchar2,edit varchar2,ser varchar2,
	volume varchar2,ed_person varchar2,pub varchar2,addr1 varchar2,
	addr2 varchar2,phone varchar2,fax varchar2,mail varchar2,
	note varchar2) is 
date1 date;

begin
date1 := to_date(lpad(mm1,2,'0') ||lpad(dd1,2,'0')||lpad(yy1,2,'0'),'mmddyy');
if (pat=1) then
	insert into sccs_book(id,book_title,pub_date,isbn_#,edition,series,
		volume_#,editor,publisher,publisher_address1,
		publisher_address2,publisher_phone,publisher_fax,
		publisher_email,book_note)
	values(fid,title,date1,isbn,edit,ser,volume,ed_person,pub,addr1,
		addr2,phone,fax,mail,note);
else
	update sccs_book
	  set id=fid,book_title=title,pub_date=date1,isbn_#=isbn,edition=edit,
	      series=ser,volume_#=volume,editor=ed_person,publisher=pub,
	      publisher_address1=addr1,publisher_address2=addr2,
	      publisher_phone=phone,publisher_fax=fax,book_note=note
	  where id=fid;
end if;
commit;
htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
htp.p('<center>');
	htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/ringyel.gif"><p>');
	if (pat=1) then
		htp.p('<p>The Additional Information for SCCS document (ID ='||htf.bold(fid)||') has been sucessfully added into the SCCS pending document DB.');
	else 
		htp.p('<p>The Additional Information for SCCS document (ID ='||htf.bold(fid)||') has been updated');
	end if;
end;

procedure show_phd_thesis(docid varchar2) is
res sccs_phd_thesis%ROWTYPE;
cursor info(oid varchar2) is select * from sccs_phd_thesis
	where id=oid;
begin

htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
htp.p('<center>');
htp.p('<b>The Additional Information For This Phd Thesis</b>');
htp.p('<b><font size=+3>');
htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/forest.gif">');
htp.p('<b></font>');
open info(docid);
fetch info into res;
if (info%NOTFOUND) then
	htp.p('<br> Not Found');
else
htp.p('<table border=2 align="center">');
htp.p('<tr><th>Data Item</th><th>The Data Value</th>');
htp.p('<tr><td>SCCS ID<td><b>SCCS-'||docid||'</b>');
if (res.phd_date IS NOT NULL) then
   htp.p('<tr><td><b>Date (mm/dd/yy)</b><td>'||to_char(res.phd_date,'mm/dd/yy'));
end if;
if (res.school IS NOT NULL) then
   htp.p('<tr><td><b>School</b><td>'||res.school);
end if;
if (res.school_address IS NOT NULL) then
   htp.p('<tr><td><b>School Address</b><td>'||res.school_address);
end if;
if (res.phd_note IS NOT NULL) then
   htp.p('<tr><td><b>PHD Note</b><td>'||res.phd_note);
end if;
htp.p('</table>');
htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/wavy.gif">');
end if;

htp.p('</center>');
close info;
end ;

procedure add_phd(bomid varchar2,fid varchar2,pat integer) is
res sccs_phd_thesis%ROWTYPE;
cursor info(oid varchar2) is select * from sccs_phd_thesis
	where id=oid;
begin

htp.p('<hr>');
	--htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
htp.p('<form action="'||cgi_bin||'sccs2.insert_phd_action" method="GET">');
htp.p('<center>');
htp.bp('<table border=2 align="center">
<caption><font size=+2>Additional Information For PHD Thesis</font>
</caption><tr><th>Data Item</th><th>New Value to be inserted</th>
<tr><td>SCCS ID<td><b>SCCS '||fid||'</b><input type="hidden" name="fid" value='||fid||'>');
open info(bomid);
fetch info into res;

if (pat=1) and (not (bomid=fid)) then
	htp.p('   (From SCCS-'||bomid||')');
end if;
htp.p('<tr><td>Date');
htp.bp('<td><input name="mm1" size=2 value="'||to_char(res.phd_date,'mm')||'">
/<input name="dd1" size=2 value="'||to_char(res.phd_date,'dd')||'" >/
<input name="yy1" size=2 value="'||to_char(res.phd_date,'yy')||'"> (mm/dd/yy)');
htp.p('<tr><td>School<td><input name="school_name" size="40" value="'||res.school||'">');
htp.p('<tr><td>School Address<td><input name="addr" size="40" value="'||res.school_address||'">');
htp.p('<tr><td>PHD Note<td><input name="note" size="40" value="'||res.phd_note||'">');
htp.p('</table>');

if (pat=1) then
	htp.p('<input type="submit" value="Insert">');
else
	htp.p('<input type="submit" value="Update">');
end if;
htp.p('<input type="reset" name="Reset">');
htp.p('<input type="hidden" name="pat" value="'||pat||'">');
htp.p('</form></center>'); 
close info;
end;

procedure insert_phd_action(pat integer,fid varchar2,mm1 char,dd1 char,
	yy1 char,school_name varchar2,addr varchar2,note varchar2) is
date1 date;
begin

date1 := to_date(lpad(mm1,2,'0') ||lpad(dd1,2,'0')||lpad(yy1,2,'0'),'mmddyy');
if (pat=1) then
	insert into sccs_phd_thesis(id,phd_date,school,school_address,phd_note)
	values(fid,date1,school_name,addr,note);
else
	update sccs_phd_thesis
	   set id=fid,phd_date=date1,school=school_name,school_address=addr,
	       phd_note=note
	   where id=fid;
end if;
commit;
htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
htp.p('<center>');
	htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/ringyel.gif"><p>');
	if (pat=1) then
		htp.p('<p>The Additional Information for SCCS document (ID ='||htf.bold(fid)||') has been sucessfully added into the SCCS pending document DB.');
	else 
		htp.p('<p>The Additional Information for SCCS document (ID ='||htf.bold(fid)||') has been updated');
	end if;
end;

procedure modify_button(me varchar2, op integer, pat integer) is

begin
	htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
	htp.p('<CENTER>');
	htp.p(htf.bold('Please input the SCCS ID to be Modified:'));
	htp.p('<table border=0 align=center><tr><td colspan="2">');
	htp.formOpen(cgi_bin||'sccs2.modify_by_id');
	htp.p(htf.url_top('http://www.npac.syr.edu/','<img src="http://mira.npac.syr.edu:1210/sccs/search.gif" border=0 align="middle">'));
	htp.p('<input name="p" size="40" value=""> ');
	htp.p('<input type="submit" value="Search"> ');
	htp.p('</font></td></tr>');
	htp.p('<input type="hidden" name="me" value="'||me||'">');
	htp.p('<input type="hidden" name="pat" value="'||pat||'">');
	htp.p('<input type="hidden" name="op" value="'||op||'">');
	htp.p(htf.formClose);
	htp.p('</table></CENTER>');

end;
	

procedure modify_by_id(p varchar2,me varchar2,op integer,pat integer) is

cursor cdoc(docid varchar2) is
	select * from bom
	where (lower(id) like '%'||docid||'%') order by id desc;
cursor cdoc1(docid varchar2, user varchar2) is
	select * from bom
	where (lower(id) like '%'||docid||'%')
	and userid = user
	and status = 0 
	order by id desc;

num integer := 0;
n integer;
realid varchar2(50);
ch varchar2(10);
gid varchar2(50);
last integer := 0;
two bom%ROWTYPE;
h_time varchar2(50) := '<br>';

begin
	realid := substr(me,instr(uid,'~',1,4) + 1);
	loop
	   if (instr(realid,'~',1,1) = 0 ) then
		last := 1;
		ch := realid;
	   else
	   	ch := substr(realid,1,instr(realid,'~',1,1)-1);
	   	realid := substr(realid,instr(realid,'~',1,1) + 1);
	   end if;
	ch := chr(ch);
	   gid := concat(gid, ch);
	   if (last =1) then 
		exit;
	   end if;
        end loop;
	modify_button(me,op,pat);

	htp.p('<hr width=80%>');
	htp.p('<center>');
	num := 0;
	if (op=0) then
	   select count(*) into num from bom
		where (lower(id) like '%'||p||'%')
		and userid=gid 
		and status = 0;
	else
	   select count(*) into num from bom
		where  (lower(id) like '%'||p||'%');
	end if;
	htp.p('<caption> SCCS Document with SCCS ID = '||htf.bold(p)
		||'</caption></center>');
	htp.p('<hr><DL>');

	if (num=0) then
	    htp.p('<center>');
	    htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/ringyel.gif">');
	    htp.p('<p>The document with SCCS ID = '||htf.bold(p)||' does not exist!</cneter>');
	    return;
	end if;

	htp.p('<center><table border=1 align=center>');
	htp.p(tr(th('SCCS ID')||th('Author')||
		th('Title')||th('Pub. Date')||th('Sub. Date')||
	    	th('Effective Date')||th('Submitted By')));   
	if (op=0) then
		open cdoc1(p,gid);
	else
		open cdoc(p);
	end if;

	loop
		if (op=0) then
			fetch cdoc1 into two;
			exit when cdoc1%NOTFOUND;
		else
			fetch cdoc into two;
			exit when cdoc%NOTFOUND;
		end if;
		htp.p('<tr>'||td(htf.url(cgi_bin||'sccs.modify_doc?me='||me
			||'&bomid='||two.id||'&pat='||pat,two.id)));
		htp.p(td(two.author));
		if (two.url IS NOT NULL) then
			htp.p(td(htf.url(two.url,two.title)));
		else
			htp.p(td(two.title));
		end if;
		htp.p(td(to_char(two.pub_date,'mm/dd/yy')));
		htp.p(td(to_char(two.sub_date,'mm/dd/yy')));
		h_time := to_char(two.effective_date,'mm/dd/yy, hh24:mi');
		if (two.effective_date<=sysdate) then
			h_time := '<blink>'||h_time||'</blink>';
		end if;
		htp.p(td(h_time));
		htp.p(td(htf.url(cgi_bin||'sccs.user?me='||me||'&uid='||two.userid,two.userid)));
		htp.p('</tr>');
	end loop;	
	if (op=0) then
		close cdoc1;
	else
		close cdoc;
	end if;
	htp.p('</table>');
	htp.p('</DL>');
	htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/wavy.gif">');
end;


end sccs2;
/
show errors;
/
