drop package sccs3;
/
create or replace package sccs3 is

function tr(name varchar2) return varchar2;
function th(name varchar2) return varchar2;
function td(name varchar2) return varchar2;

procedure insert_project(userid varchar2,pat number,old_name varchar2);
procedure insert_project_action(userid varchar2, pat number, old_name varchar2,
	p_abbrev varchar2,p_name varchar2, p_account varchar2,p_sponsor varchar2);
procedure all_projects(userid varchar2);
procedure delete_project(userid varchar);
procedure delete_proj_action(userid varchar2,p_name varchar2);
procedure modify_project(userid varchar);
procedure by_project(p varchar2,fid varchar2,stat integer);
procedure more_project(total number, seed integer, p varchar2, fid varchar2,
		stat integer);
procedure publist;

end;
/
show errors;

create or replace package body sccs3 is

cgi_bin constant varchar2(60) := sccs.cgi_bin;
username constant varchar2(10) := sccs.username;
password constant varchar2(10) := sccs.password;
client varchar2(30) := sccs.client;
time_out number(8,5) := sccs.time_out;
USER_II constant integer := sccs.USER_II;
USER_III constant integer := sccs.USER_III;
ROOT constant integer := sccs.ROOT;
help_page constant varchar2(100) := sccs.help_page;

two bom%ROWTYPE;
h_caption varchar2(600);
total number(8);



function td(name varchar2) return varchar2 is
begin
	return ('<td>'||name||'</td>');
end;

function th(name varchar2) return varchar2 is
begin
	return ('<th>'||name||'</th>');
end;

function tr(name varchar2) return varchar2 is
begin
	return ('<tr>'||name||'</tr>');
end;

procedure publist is

cursor allpub is 
	select id, title,author from bom
	where status='1'
	order by id desc;
doc_id bom.id%TYPE;
doc_tit bom.title%TYPE;
doc_aut bom.author%TYPE;
 
begin
	htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
	htp.p('<hr>');

	open allpub;
        loop
	 	fetch allpub into doc_id,doc_tit,doc_aut;
		exit when allpub%NOTFOUND;
		htp.p('<font color=red><bold>SCCS-'||doc_id||': </font></bold>    '||doc_tit||'<br>  '||doc_aut||'<p>');
	end loop;
	htp.p('Total SCCS document: '||allpub%ROWCOUNT);
	close allpub;
end;

	

procedure insert_project(userid varchar2,pat number, 
			old_name varchar2) is

res_abbrev projects.proj_abbrev%TYPE := NULL;
res_name projects.proj_name%TYPE := NULL;
res_account projects.su_account%TYPE := NULL;
res_sponsor projects.sponsor%TYPE := NULL;

begin 
	htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
	htp.p('<hr>');
	if (not (sccs.validation(userid,USER_III))) then
		htp.p('You have no privilege to do this operation!!');
		return;
	end if;
	if (pat = 0) then
		htp.p('<center><h2>Insert a New Project Name</h2></center>');
	else
		htp.p('<center><h2>Modify a Project Name</h2></center>');
		select proj_abbrev,proj_name,su_account,sponsor 
			into res_abbrev,res_name,res_account,res_sponsor
			from projects
			where proj_name=replace(old_name,'^', ' ');
	end if;	
	htp.p('<form action="'||cgi_bin||'sccs3.insert_project_action" method="POST">');
	htp.p('<center><table>');
	htp.p('<tr><td align=right>Project Name:</td><td><input name="p_name" value="'||res_name||'" size="20"></td></tr>');
	htp.p('<tr><td align=right>Abbreviate :</td><td><input name="p_abbrev" value="'||res_abbrev||'" size="20"></td></tr>');
	htp.p('<tr><td align=right>SU Account:</td><td><input name="p_account" value="'||res_account||'" size="20"></td></tr>');
	htp.p('<tr><td align=right>Sponsors:</td><td><input name="p_sponsor" value="'||res_sponsor||'" size="20"></td></tr>');
	htp.p('<input type="hidden" name="userid" value="'||userid||'">');
	htp.p('<input type="hidden" name="pat"  value="'||pat||'">');
	htp.p('<input type="hidden" name="old_name" value="'||old_name||'">');
	htp.p('</table>');
	htp.p(htf.formDo('Submit')); 
	htp.p('<input type="reset" value="Reset">');
	htp.p('</form></center><hr>');
	all_projects(userid);
	wow.sig;
end;

procedure insert_project_action(userid varchar2,pat number,
		old_name varchar2,p_abbrev varchar2,
		p_name varchar2, p_account varchar2,p_sponsor varchar2) is
realid varchar2(50);
ch varchar2(10);
gid varchar2(50);
last integer := 0;

begin
	htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
	htp.p('<hr><center>');
	realid := substr(userid,instr(userid,'~',1,4) + 1);
	loop
	   if (instr(realid,'~',1,1) = 0 ) then
		last := 1;
		ch := realid;
	   else
	        ch := substr(realid,1,instr(realid,'~',1,1)-1);
	        realid := substr(realid,instr(realid,'~',1,1) + 1);
	   end if;
	   ch := chr(ch);
	   gid := concat(gid, ch);
	   if (last =1) then 
		exit;
	   end if;
         end loop;

-- htp.p('userid='||userid||'real_id='||gid);
	if (pat = 0 ) then
		insert into projects(proj_abbrev,proj_name,su_account,user_id,
			sponsor)
			values(p_abbrev,p_name,p_account, gid,p_sponsor);
		htp.p('The New Project Name Has Been Added!');
	else
		update projects set proj_abbrev=p_abbrev,proj_name=p_name,
			su_account=p_account,user_id=gid,sponsor=p_sponsor
			where proj_name=replace(old_name,'^',' ');
		htp.p('The Project Name Has Been Modified!');
	end if;
	commit;
	htp.p('</center>');
	all_projects(userid);
end;

procedure all_projects(userid varchar2) is

cursor procur is select * from projects order by proj_abbrev;
res projects%ROWTYPE;
num number;

begin

	if (not sccs.validation(userid,USER_III)) then
		return;
	end if;
	select count(*) into num from projects;
	if (num=0) then
		return;
	end if;
	htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
	htp.p('<p><center><table border=1>');
	htp.p('<bold>Projects</bold>');
	htp.p(tr(th('Name')||th('Abbreviate')||th('SU Account')||th('Sponsors')||th('Inserted By')));

	open procur;
	loop
		fetch procur into res;
		exit when procur%NOTFOUND;
		htp.p('<tr>'||td(res.proj_name));
		if (res.proj_abbrev IS NULL) then
			htp.p(td('N/A'));
		else
			htp.p(td(res.proj_abbrev));
		end if;
		if (res.su_account IS NULL) then
			htp.p(td('N/A'));
		else
			htp.p(td(res.su_account));
		end if;
		if (res.sponsor IS NULL) then
			htp.p(td('N/A'));
		else
			htp.p(td(res.sponsor));
		end if;
		htp.p(td(res.user_id)||'</tr>');
	end loop;
	htp.p('</table>	Total: '||procur%ROWCOUNT||'</center>');
	close procur;
end;

procedure modify_project(userid varchar) is
cursor procur is select * from projects order by proj_abbrev;
res projects%ROWTYPE;
num number;	

begin
	if (not sccs.validation(userid,USER_III)) then
		return;
	end if;
	select count(*) into num from projects;
	htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
	if (num=0) then
		htp.p('There is no project information in database');
		return;
	end if;
	htp.p('<center><h2>All projects you can modify</h2></center>');
	htp.p('<p><center><table border=1>');
	htp.p(tr(th('Abbreviate')||th('Name')||th('SU Account')||th('Sponsors')||th('Inserted By')));

	open procur;
	loop
		fetch procur into res;
		exit when procur%NOTFOUND;
		if (res.proj_abbrev IS NULL) then
			res.proj_abbrev := 'N/A';
		end if;
		htp.p('<tr>'||td(htf.url(cgi_bin||'sccs3.insert_project?userid='||userid||'&pat=1&old_name='||replace(res.proj_name,' ','^'),res.proj_name)));
		htp.p(td(res.proj_abbrev));
		if (res.su_account IS NULL) then
			htp.p(td('N/A'));
		else
			htp.p(td(res.su_account));
		end if;
		if (res.sponsor IS NULL) then
			htp.p(td('N/A'));
		else
			htp.p(td(res.sponsor));
		end if;
		htp.p(td(res.user_id)||'</tr>');
	end loop;
	htp.p('</table>	Total: '||procur%ROWCOUNT||'</center>');
	close procur;
			
end;


procedure delete_project(userid varchar) is

cursor procur is select * from projects order by proj_abbrev;
res projects%ROWTYPE;
num number;	

begin
	if (not sccs.validation(userid,USER_III)) then
		return;
	end if;
	select count(*) into num from projects;
	htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
	if (num=0) then
		htp.p('There is no project information in database');
		return;
	end if;
	htp.p('<center><h2>All projects you can delete</h2></center>');
	htp.p('<p><center><table border=1>');
	htp.p(tr(th('Name')||th('Abbreviate')||th('SU Account')||th('Sponsors')||th('Inserted By')));

	open procur;
	loop
		fetch procur into res;
		exit when procur%NOTFOUND;
		htp.p('<tr>'||td(htf.url(cgi_bin||'sccs3.delete_proj_action?userid='||userid||'&p_name='||replace(res.proj_name,' ','^'),res.proj_name)));
		if (res.proj_abbrev IS NULL) then
			htp.p(td('N/A'));
		else
			htp.p(td(res.proj_abbrev));
		end if;
		if (res.su_account IS NULL) then
			htp.p(td('N/A'));
		else
			htp.p(td(res.su_account));
		end if;
		if (res.sponsor IS NULL) then
			htp.p(td('N/A'));
		else
			htp.p(td(res.sponsor));
		end if;
		htp.p(td(res.user_id)||'</tr>');
	end loop;
	htp.p('</table>	Total: '||procur%ROWCOUNT||'</center>');
	close procur;
			
end;

procedure delete_proj_action(userid varchar2,p_name varchar2) is

begin
	
	if (not sccs.validation(userid,USER_III)) then
		return;
	end if;
	delete from projects where proj_name=replace(p_name,'^',' ');
	commit;
	htp.p('<body background="http://mira.npac.syr.edu:1210/sccs/bluestone.jpg">');
	htp.p('<p><center>');
	htp.p('The project <bold>'||replace(p_name,'^',' ')||'</bold> has been deleted!</center>');
	all_projects(userid);
end;

procedure by_project(p varchar2,fid varchar2,stat integer) is

cursor cuser(p varchar2,tat integer) is select * from bom where status=tat
	and (lower(project_abbrev) like '%'||p||'%') order by id desc;
cursor fcuser(p varchar2,tat integer,f_id varchar2) is 
	select * from bom where status=tat
	and type=f_id
	and (lower(project_abbrev) like '%'||p||'%') order by id desc;
num integer := 0;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	sccs1.search_button(4,fid,stat);
	htp.p('<hr width=80%>');
	if (fid=0) then
		open cuser(p,stat);
	else
		open fcuser(p,stat,fid);
	end if;
	h_caption := ' under project  *'||htf.bold(p)||'*';
	htp.p('<center><font size=+1>SCCS Production Documents');
	htp.p(h_caption||'</font></center>'); 	
	htp.p('<hr><DL>');
	loop
	   if (fid=0) then
		   fetch cuser into two;
		   exit when cuser%NOTFOUND;
	   else
		   fetch fcuser into two;
		   exit when fcuser%NOTFOUND;
	   end if;
	   num := num + 1;
	end loop;
	if ( num =0 ) then
	    htp.p('<center>');
	    htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/ringyel.gif">');
	    htp.p('<p>The document '||h_caption||' dose not exist!</cneter>'); 
	    return;
	end if;
	total := num;
	if (fid=0) then
		close cuser;
	else 
		close fcuser;
	end if;
	if (total > 0 ) then  
		next := 21;
		if ( next<=total) then
                    if ((next+20)<=total) then
                        next_str := (next+19);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
                else
                    curr_str := total;
                end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
		    htp.p(' <b>|</b> <td align=right>');
		    htp.p(htf.url(cgi_bin||'sccs3.more_project?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid||'&stat='||stat,
			'Next '||next_str));
		end if;
		htp.p('</table></center><dl>');
		if (fid=0) then
			open cuser(p,stat);
		else
			open fcuser(p,stat,fid);
		end if;
		num := 0;
		loop
		   if (fid=0) then
			   fetch cuser into two;
			   exit when cuser%NOTFOUND;
		   else
			   fetch fcuser into two;
			   exit when fcuser%NOTFOUND;
		   end if;
		   num := num + 1;
		   htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
		   if (two.url IS NOT NULL) then
			htp.ap('<i>'||htf.url(two.url,two.title)||'</i>');
		   else 
			htp.bp('<i>'||two.title||'</i>');
		   end if;
		   htp.p('<dd>');
		  	if (two.furl IS NOT NULL) then
				htp.p(htf.url(two.furl,'Full HTML'));
				htp.p('&nbsp &nbsp &nbsp &nbsp');
			end if;
			if (two.psurl IS NOT NULL) then
				htp.p(htf.url(two.psurl,'PostScript'));
				htp.p('&nbsp &nbsp &nbsp &nbsp');
			end if;
			if (two.pdfurl IS NOT NULL) then
				htp.p(htf.url(two.pdfurl,'PDF'));
				htp.p('&nbsp &nbsp &nbsp &nbsp');
			end if;
			if (two.rawurl IS NOT NULL) then
				htp.p(htf.url(two.rawurl,'Raw Text'));
			end if;
		   htp.ap('<br>'||two.author);
		   htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yy')||'</i>');
		   if (not ( two.type = 1)) then
			htp.p('<br>');
			htp.p(htf.url(cgi_bin||'sccs2.show_info?docid='||two.id
			||'&doctype='||two.type,'Addition Information'));
		   end if;
/*		   if (two.abs IS NOT NULL) then
			htp.p('<br>');
			htp.ap(two.abs);
		   end if;
*/
		   if ( num = 20 ) then
			exit;
		    end if;
	    	end loop;			

	htp.p('</DL>');
	htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/wavy.gif">');
		htp.p('<center>');
		htp.p(' p.');
       		n := ceil(total/20);
        	if (n > 20) then n := 20; end if;
		for i in 1..n loop
		   iseed := (i-1)*20 + 1;
		   if (iseed = 0 ) then
			htp.p(' '||i);
		   else
			htp.p(' '||htf.url(cgi_bin||'sccs3.more_project?total='
				||total||'&seed='||iseed||'&p='||p||'&fid='||
				fid||'&stat='||stat,i));
		   end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||htf.url(cgi_bin||'sccs3.more_project?total='||
			total||'&seed='||next||'&p='||p||'&fid='||fid
			||'&stat='||stat,'Next')||']');
		end if;
		htp.p('</center>');
	else
		htp.p('No SCCS Production Document Found');
	end if;
	if (fid=0) then
		close cuser;
	else
		close fcuser;
	end if;
	wow.sig;
end;


procedure more_project(total number, seed integer, p varchar2, fid varchar2,
		stat integer) is
cursor cuser(p varchar2,tat integer) is select * from bom where status=tat
	and (lower(project_abbrev) like '%'||p||'%') order by id desc;
cursor fcuser(p varchar2,tat integer,f_id varchar2) is 
	select * from bom where status=tat
	and type=f_id
	and (lower(project_abbrev) like '%'||p||'%') order by id desc;
num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	sccs1.search_button(4,fid,stat);
	htp.p('<hr width=80%>');

--	open cuser(p);
	h_caption := ' under project'||htf.bold(p);
	htp.p('<center><font size=+1>SCCS Production Documents');
	htp.p(h_caption||'</font></center>'); 	
	htp.p('<hr><DL>');	
	next := seed + 20;
	if (next<=total) then
                if ((next+20)<=total) then
                        next_str := (next+19);
                else
                        next_str := total;
                end if;
                next_str := next||'-'||next_str;
                curr_str := next - 1;
        else
                curr_str := total;
        end if;
        prev := seed - 20;
        if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
        elsif (seed > 1) then
                        prev := 1;
                        prev_str := '1-'|| 20;
        end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(htf.url(cgi_bin||'sccs3.more_project?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid
			||'&stat='||stat,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(htf.url(cgi_bin||'sccs3.more_project?total='||total||
			'&seed='||prev||'&p='||p||'&fid='||fid||'&stat='||stat,
			'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
	if (fid=0) then
		open cuser(p,stat);
	else
		open fcuser(p,stat,fid);
	end if;
	num := 0;
	loop
		if (fid=0) then
			fetch cuser into two;
			exit when cuser%NOTFOUND;
		else
			fetch fcuser into two;
			exit when fcuser%NOTFOUND;
		end if;
		num := num + 1;
		if (num >= seed) then
			htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
			if (two.url IS NOT NULL) then
				htp.ap('<i>'||htf.url(two.url,two.title)||'</i>');
			else 
				htp.bp('<i>'||two.title||'</i>');
			end if;
			htp.p('<dd>');
			if (two.furl IS NOT NULL) then
				htp.p(htf.url(two.furl,'Full HTML'));
				htp.p('&nbsp &nbsp &nbsp &nbsp');
			end if;
			if (two.psurl IS NOT NULL) then
				htp.p(htf.url(two.psurl,'PostScript'));
				htp.p('&nbsp &nbsp &nbsp &nbsp');
			end if;
			if (two.pdfurl IS NOT NULL) then
				htp.p(htf.url(two.pdfurl,'PDF'));
				htp.p('&nbsp &nbsp &nbsp &nbsp');
			end if;
			if (two.rawurl IS NOT NULL) then
				htp.p(htf.url(two.rawurl,'Raw Text'));
			end if;
			htp.ap('<br>'||two.author);
			htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yy')||'</i>');
			if (not ( two.type = 1)) then
				htp.p('<br>');
				htp.p(htf.url(cgi_bin||'sccs2.show_info?docid='					||two.id||'&doctype='||
				two.type,'Addition Information'));
		  	end if;
/*			if (two.abs IS NOT NULL) then
				htp.p('<br>');
				htp.ap(two.abs);
				htp.p('</h3>');
			end if;
*/
		end if;
		if ( num >= (seed + 19) ) then
		    	exit;
		end if;
	end loop;		
	if (fid=0) then
		close cuser;
	else
		close fcuser;
	end if;
	htp.p('</DL>');
	htp.p('<img src="http://mira.npac.syr.edu:1210/sccs/wavy.gif">');
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/20);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
	   iseed := (i-1)*20 + 1;
	   if (iseed = 0 ) then
		htp.p(' '||i);
	   else
		htp.p(' '||htf.url(cgi_bin||'sccs3.more_project?total='||
			total||'&seed='||iseed||'&p='||p||'&fid='||fid
			||'&stat='||stat,i));
	   end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||htf.url(cgi_bin||'sccs3.more_project?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid||
			'&stat='||stat,'Next')||']');
	end if;
	htp.p('</center>');
	wow.sig;
end;



end sccs3;
/
show errors;


	