/**
 * @author  Ashok S
 * @version 1.0
 *
 * Development Environment        :  JDeveloper 2.0
 * Name of the Application        :  gridBagConstraints2.java
 * Creation/Modification History  :
 *
 *    ashivaru.in       24-Dec-1998      Created
 *
 * Overview of Application        :
 *
 * An easy way to use GridBagConstraints. Avoids multiple method calls of
 * GridBagConstraint methods
 */
import java.awt.*;

public class GridBagConstraints2
extends GridBagConstraints
{

	/**
	*	Constructor. Initializes GridBagConstraints variables.
	*	@param	gx	gridx
	*	@param	gy	gridy	
	*	@param	gw	gridwidth
	*	@param 	gh	gridheight
	*	@param	wx	widthx
	*	@param	wy	widthy
	*	@param	anc	anchor
	*	@param	fil	fill
	*	@param	ins	Insets
	*	@see	java.awt.Insets
	*	@param	ix	ipadx
	*	@param	iy	ipady
	*
	**/
	public GridBagConstraints2(int gx, int gy, int gw, int gh,
			double wx, double wy, int anc, int fil, Insets ins, 
			int ix, int iy) {
		gridx = gx;
		gridy = gy;
		gridwidth = gw;
		gridheight = gh;

		weightx = wx;
		weighty = wy;

		anchor = anc;
		fill = fil;
		
		insets = ins;
		ipadx = ix;
		ipady = iy;

	}
}
