create or replace package wsms2 is

procedure insert_doc(uid varchar2);
procedure insert_doc_action(fid number,aut varchar2,tit varchar2,
		docpath varchar2,grp1 integer,uid varchar2);
procedure discard_doc(fid number);
procedure delete_doc(uid varchar2);
procedure all_del_doc(uid varchar2,w_grp integer,urole integer,
		doc_type integer,op integer);
procedure more_del_doc(uid varchar2,tot number,seed integer,w_grp integer,
			urole integer,doc_type integer,op integer);
procedure del_doc_action(uid varchar2, doc_id number);

procedure start1(keyword varchar2,uid varchar2,area integer);
procedure header_list(keyword varchar2,total number,seed number,qid integer,
		uid varchar2,area integer);

procedure update_doc(uid varchar2);
procedure no_update(fid number);
procedure update_doc_action(fid number,aut varchar2,tit varchar2,
		docpath varchar2,grp1 integer,uid varchar2);
procedure update_doc(uid varchar2,doc_id number);

procedure all_orphan_files(uid varchar2);
procedure more_orphan(tot number, seed integer, me varchar2);
procedure all_dead_links(uid varchar2);
procedure more_dead(tot number, seed integer, me varchar2);

function tr(name varchar2) return varchar2;
function th(name varchar2) return varchar2;
function td(name varchar2) return varchar2;

wsms_server constant varchar2(60) := wsms1.wsms_server;
cgi_bin constant varchar2(60) := wsms1.cgi_bin;
real_cgi constant varchar2(60) := wsms1.real_cgi;


ADMIN constant integer := wsms1.ADMIN;
REVIEWER constant integer := wsms1.REVIEWER;
DEVELOPER constant integer := wsms1.DEVELOPER;
READER constant integer := wsms1.READER;

end;
/
show errors;

create or replace package body wsms2 is

usr_query_id number;
key varchar2(200);
hits integer := 15;

total number(8);
one users%ROWTYPE;
doc docs%ROWTYPE;
s_role users.role_grp%TYPE;
write_no users.write_pri%TYPE;
read_no users.read_pri%TYPE;
usrgrp_no users.group_id%TYPE;

function td(name varchar2) return varchar2 is
begin
	return ('<td>'||name||'</td>');
end;

function th(name varchar2) return varchar2 is
begin
	return ('<th>'||name||'</th>');
end;

function tr(name varchar2) return varchar2 is
begin
	return ('<tr>'||name||'</tr>');
end;


procedure insert_doc(uid varchar2) is

fid number(8);
mm char(2);
dd char(2);
yy char(2);
tot number(8);

begin
	if (not wsms1.validation(uid,DEVELOPER,write_no,read_no,usrgrp_no,s_role)) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr>');
	htp.p('<center>');
	htp.p('<font size="-1">');
	htp.p('Please input the information about the new WSMS documents:');
	htp.p('<p></font>');
	htp.p('<hr height="5" width="90%">');
	htp.p('</center>');

	select count(*) into tot from docs;
	if (tot > 0) then 
 		select max(id) into fid from docs;
		fid := fid + 1;
	else
		fid := 1;
	end if;
	
	htp.p('<form action="'||cgi_bin||'wsms2.insert_doc_action" method="POST">');
--	htp.p('<form action="'||real_cgi||'loaddoc" method="GET">');
	htp.p('<table border=2 align="center">
		<caption>Insert a new WSMS document</caption>
		<tr><th>Data Item</th><th>New Value to be inserted</th>
		<tr><td>WSMS ID<td><b>WSMS '||fid||'</b><input type="hidden" name="fid" value='||fid||'>');
	htp.p('<tr><td>Authors (separate each authors with a comma)<td><input name="aut" size="40">');
	htp.p('<tr><td>Title<td><input name="tit" size="40">');
	htp.p('<tr><td>File Path<td><input name="docpath" size="40">');
	htp.p('<tr><td>WSMS Item Type<td><select name="grp1">
		<option value="1">MSRC
		<option value="2">PET
		</select>');
	htp.p('</table><input type="submit" value="Insert"><input type="reset" value="Reset">');
	htp.p('<input type="hidden" name="uid" value="'||uid||'">');
	htp.p('</form></center>');
end;

procedure insert_doc_action(fid number,aut varchar2,tit varchar2,
		docpath varchar2,grp1 integer,uid varchar2) is

gid varchar2(50);
w_pri number(1);

begin
	wsms1.get_realid(uid,gid);
	select write_pri into w_pri from users where gid=userid;
	if (not(w_pri=3) and not(w_pri=grp1)) then
		htp.p('Sorry, you have no write privilege in this group!');
		return;
	else
		insert into docs(id,author,title,path,group_no,type,submit_by)
			values(fid,aut,tit,docpath,grp1,1,gid);
		commit;
	end if;
	htp.p('Click the button to confirm inserting your file ...<p>');
/*	htp.p('<form action="'||real_cgi||'loaddoc?fid='||fid||'&aut='||aut
		||'&tit='||tit||'&docpath='||docpath||'&grp1='||grp1||
		'&uid='||uid||'" method="POST">');*/

	htp.p('<form action="'||real_cgi||'loaddoc?fid='||fid
		||'&docpath='||docpath||'&grp1='||grp1||'" method="POST">');

	htp.p('<input type=submit value="Confirm"></form>');
	htp.p('<form action="'||cgi_bin||'wsms2.discard_doc" method="POST">');
	htp.p('<input type="hidden" name="fid" value="'||fid||'">');
	htp.p('<input type=submit value="Discard"></form>');
	
end;

procedure discard_doc(fid number) is

begin
	delete from docs where id=fid;
	commit;
	htp.p('The inserted doc has been discarded!');
end;

procedure delete_doc(uid varchar2) is

begin
	if (not wsms1.validation(uid,DEVELOPER,write_no,read_no,usrgrp_no,s_role)) then
		return;
	end if;
	if (write_no = 0) then
		htp.p('There is no document that you can delete!');
		return;
	end if;
	htp.p('Choose a document to delete from the following list');
	all_del_doc(uid,write_no,s_role,1,0);
end;

procedure all_del_doc(uid varchar2,w_grp integer,urole integer,
		doc_type integer,op integer) is

cursor cdoc(w_no integer,subid varchar2,dtype integer) is
	select * from docs where group_no=w_no
	and submit_by=subid
	and type=dtype;

cursor alldoc(dtype integer) is
	select * from docs where type=dtype;

end_num integer;
h_count integer;

doc_ldate date;

num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

gid varchar2(50);

begin
	if ((w_grp = 0) or (not wsms1.validation(uid, DEVELOPER,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr>');
	wsms1.get_realid(uid,gid);
	if (urole = 4) then
		select count(*) into total from docs where type=doc_type;
	else
		select count(*) into total from docs where type=doc_type
			and submit_by=gid
			and group_no=w_grp;
	end if;
	next := 11;
	
	if (total > 0 ) then
	    	next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
		else
                    curr_str := total;
		end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
                	htp.p(' <b>|</b> <td align=right>');
			htp.p((wsms1.url(cgi_bin||'wsms2.more_del_doc?uid='||
				uid||'&tot='||total||'&seed='||next||'&w_grp='
				||w_grp||'&urole='||urole||'&doc_type='||
				doc_type||'&op='||op,'Next '||next_str)));
		end if;
		if (prev_str IS NOT NULL) then
                	htp.p(' <b>|</b><td align=right>');
			htp.p((wsms1.url(cgi_bin||'wsms2.more_del_doc?uid='||
				uid||'&tot='||total||'&seed='||prev||'&w_grp='
				||w_grp||'&urole='||urole||'&doc_type='||
				doc_type||'&op='||op,'Prev '||prev_str)));
		end if;
	   	htp.p('</table></center><dl>');

		htp.p('<center><table border=1 align=center>');
		htp.p('<tr>'||th('ID')||th('Author')||th('Title')||
			th('Doc_Group')||th('Last_update'));
		if (urole =4) then
			open alldoc(doc_type);
		else
			open cdoc(w_grp,gid,doc_type);
		end if;
		h_count := 0;

		for i in 1 .. 10 loop
			h_count := h_count + 1;
			if (urole = 4) then
				fetch alldoc into doc;
				exit when alldoc%NOTFOUND;
			else
				fetch cdoc into doc;
				exit when cdoc%NOTFOUND;
			end if;
			if (op=0) then
				htp.p('<tr>'||td(wsms1.url(cgi_bin||
					'wsms2.del_doc_action?uid='||uid||
					'&doc_id='||doc.id,doc.id)));
			elsif (op=1) then
				htp.p('<tr>'||td(wsms1.url(cgi_bin||
					'wsms2.update_doc?uid='||uid||
					'&doc_id='||doc.id,doc.id)));
			end if;
			htp.p(td(doc.author));
			htp.p(td(doc.title));
			htp.p(td(doc.group_name));
			select ldate into doc_ldate from texts
				where id=doc.id;
			htp.p(td(to_char(doc_ldate,'mm/dd/yyyy')));
			htp.p('</tr>');
		end loop;
		if (urole = 4) then
			close alldoc;
		else
			close cdoc;
		end if;
		htp.p('</table>');
		htp.p('<img src="'||wsms_server||'/wavy.gif">');
		htp.p('<br>');
		htp.p('<center>');
	   	htp.p(' p.');
       		n := ceil(total/10);
           	if (n > 20) then n := 20; end if;
	   	for i in 1..n loop
		  iseed := (i-1)*10 + 1;
		  if (iseed = 0 ) then
			htp.p(' '||i);
		  else
			htp.p(' '||wsms1.url(cgi_bin||'wsms2.more_del_doc?uid='||
				uid||'&tot='||total||'&seed='||iseed||'&w_grp='
				||w_grp||'&urole='||urole||'&doc_type='||
				doc_type||'&op='||op,i));
		  end if;
	    	end loop;
	    	if (next_str IS NOT NULL) then
		   htp.p('['||wsms1.url(cgi_bin||'wsms2.more_del_doc?uid='||
				uid||'&tot='||total||'&seed='||next||'&w_grp='
				||w_grp||'&urole='||urole||'&doc_type='||
				doc_type||'&op='||op,'Next')||']');
	     	end if;
	     	htp.p('</center>');
	else
		htp.p('No WSMS document for you to delete!');
	end if;
end;

procedure more_del_doc(uid varchar2,tot number,seed integer,w_grp integer,
			urole integer,doc_type integer,op integer) is

cursor cdoc(w_no integer,subid varchar2,dtype integer) is
	select * from docs where group_no=w_no
	and submit_by=subid
	and type=dtype;

cursor alldoc(dtype integer) is
	select * from docs where type=dtype;

end_num integer;
h_count integer;

doc_ldate date;

num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

gid varchar2(50);

begin
	if ((w_grp = 0) or (not wsms1.validation(uid, DEVELOPER,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	if (op=1) then
		htp.p('Choose a document to update from the following list');
	else
		htp.p('Choose a document to delete from the following list');
	end if;
	htp.p('<hr>');
	wsms1.get_realid(uid,gid);
	total := tot;
	next := seed + 10;
	if ( next<=total) then
		if ((next+10)<=total) then
			next_str := (next+9);
		else
			next_str := total;
		end if;
		next_str := next||'-'||next_str;
		curr_str := next - 1;
	else
		curr_str := total;
	end if;
	prev := seed - 10;
	if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
	elsif (seed > 1) then
		prev := 1;
		prev_str := '1-'|| 10;
	end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p((wsms1.url(cgi_bin||'wsms2.more_del_doc?uid='||
				uid||'&tot='||total||'&seed='||next||'&w_grp='
				||w_grp||'&urole='||urole||'&doc_type='||
				doc_type||'&op='||op,'Next '||next_str)));
		end if;
		if (prev_str IS NOT NULL) then
                	htp.p(' <b>|</b><td align=right>');
			htp.p((wsms1.url(cgi_bin||'wsms2.more_del_doc?uid='||
				uid||'&tot='||total||'&seed='||prev||'&w_grp='
				||w_grp||'&urole='||urole||'&doc_type='||
				doc_type||'&op='||op,'Prev '||prev_str)));
		end if;
	   	htp.p('</table></center><dl>');
			htp.p('<center><table border=1 align=center>');
		htp.p('<tr>'||th('ID')||th('Author')||th('Title')||
			th('Doc_Group')||th('Last_update'));
		if (urole =4) then
			open alldoc(doc_type);
		else
			open cdoc(w_grp,gid,doc_type);
		end if;
		h_count := 0;
		loop
			h_count := h_count + 1;
			if (urole = 4) then
				fetch alldoc into doc;
				exit when alldoc%NOTFOUND;
			else
				fetch cdoc into doc;
				exit when cdoc%NOTFOUND;
			end if;

			if (h_count >= seed) then
				if (op=0) then
					htp.p('<tr>'||td(wsms1.url(cgi_bin||
					'wsms2.del_doc_action?uid='||uid||
					'&doc_id='||doc.id,doc.id)));
				elsif (op=1) then
					htp.p('<tr>'||td(wsms1.url(cgi_bin||
					'wsms2.update_doc?uid='||uid||
					'&doc_id='||doc.id,doc.id)));
				end if;
				htp.p(td(doc.author));
				htp.p(td(doc.title));
				htp.p(td(doc.group_name));
				select ldate into doc_ldate from texts
					where id=doc.id;
				htp.p(td(to_char(doc_ldate,'mm/dd/yyyy')));
				htp.p('</tr>');
			end if;
			if (h_count >= (seed + 10)) then
		   		exit;
			end if;
		end loop;
		if (urole = 4) then
			close alldoc;
		else
			close cdoc;
		end if;
		htp.p('</table>');
	htp.p('<img src="'||wsms_server||'/wavy.gif">');
	htp.p('<br>');
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
		iseed := (i-1)*10 + 1;
		if (iseed = 0 ) then
			htp.p(' '||i);
		else
			htp.p(' '||wsms1.url(cgi_bin||'wsms2.more_del_doc?uid='||
				uid||'&tot='||total||'&seed='||iseed||'&w_grp='
				||w_grp||'&urole='||urole||'&doc_type='||
				doc_type||'&op='||op,i));
		end if;
	 end loop;
	 if (next_str IS NOT NULL) then
		   htp.p('['||wsms1.url(cgi_bin||'wsms2.more_del_doc?uid='||
				uid||'&tot='||total||'&seed='||next||'&w_grp='
				||w_grp||'&urole='||urole||'&doc_type='||
				doc_type||'&op='||op,'Next')||']');
	 end if;
	 htp.p('</center>');
end;

procedure del_doc_action(uid varchar2, doc_id number) is

begin
	if (not wsms1.validation(uid, DEVELOPER,write_no,read_no,usrgrp_no,s_role)) then
		return;
	end if;
	delete from texts where id = doc_id;
	delete from docs where id = doc_id;
	commit;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr><center>Document WSMS'||doc_id||' has been deleted.<hr></center>');
	all_del_doc(uid,write_no,s_role,1,0);
end;

procedure start1(keyword varchar2,uid varchar2,area integer) is

front boolean := true;
more boolean := false;
lastpath boolean := false;
ch char(1);
  
position integer;
total number(8) := 0;
ptotal number(8) := 0;
cursor_handle integer;
exect integer;

begin

	if (area = 2) then
	   if (not wsms1.validation(uid,READER,write_no,read_no,usrgrp_no,s_role)) then
		return;
	   end if;
	else
	   if (not wsms1.validation(uid, DEVELOPER,write_no,read_no,usrgrp_no,s_role)) then
		return;
	   end if;
	end if;

	if ((instr(keyword,'&') = 0) and (instr(keyword,'|') = 0) and 
		(instr(keyword,'-') = 0) and (instr(keyword,',') = 0)) then
	     for n in 1 .. length(keyword) loop
		ch := substr(keyword,n,1);
		if (ch != ' ') then
			if (front) then	
				key := ch;
				front := false;
			elsif (more) then 
				more := false; 
				key := key||'&'||ch;
			else key := key||ch;
			end if;
		else 
			if (not (front or more)) then more := true; end if;
		end if;
	     end loop;
	else
		key := replace(keyword,' ');
	end if;
        
/*	docpath := replace(document,'%2F','/');
        docpath := replace(docpath,'%25','%');*/

	if (key IS NULL) then 
		htp.p('Please type one or more keywords to start your search');
		return;
	end if;

	select query_id.nextval into usr_query_id from dual;
	ctx_query.contains('SEARCH_POLICY','('||key||'):500','QUERY_TEMP',1,usr_query_id,NULL);
	
	select count(*) into total from body_hitlist
		where conid=usr_query_id
		and type=area;

	if (total = 0) then
		wsms3.search_button(uid,area,4);
		htp.p('<center><u><blink>0 document found.</blink></u></center>');htp.p('</TD></TR></TABLE>');
	else
		key := replace(key,'&','~');
		header_list(key,total,1,usr_query_id,uid,area);
	end if;
end;
		
/*	while ( not lastpath ) loop
	if ( not (position=0)) then
	   perpath := substr(leftpath,1,position - 1);
	else
	   perpath := leftpath;
	end if;
	
	cursor_handle := DBMS_SQL.OPEN_CURSOR;
        DBMS_SQL.PARSE( cursor_handle,'select count(*) from body_hitlist 
		 where conid = '''|| usr_query_id ||''' and type = '''||
			area || '''',DBMS_SQL.V7);*/
	
	
procedure header_list(keyword varchar2,total number,seed number,qid integer,
		uid varchar2,area integer) is

cursor cresult(cid number,dtype integer) is 
		select * from body_hitlist 
		where conid=cid 
		and type=dtype
		order by score desc;

result_rec body_hitlist%ROWTYPE;
view_url varchar2(200) := real_cgi||'textview?keyword=';
tit docs.title%TYPE;
  next number(8);   
  prev number(8);
  next_str varchar2(20):=NULL;
  prev_str varchar2(20):=NULL;
  curr_str varchar2(20):=NULL;
  counter integer := 0;
  iseed integer;
  s_subject long;
  n integer; 
  rowcount integer;
  totalnum integer;
  article_rec docs%ROWTYPE;
  ii number;
  real_url varchar2(250);

begin
	wsms3.search_button(uid,area,4);
	key := keyword;
	next := seed+hits;
	if (next<=total) then
		if ((next+hits)<=total) then
			next_str := (next+hits-1);
		else
			next_str := total;
		end if;
		next_str := next||'-'||next_str;
		curr_str := (next-1);
	else
		curr_str := total;
	end if;
	prev := seed - hits;
        if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
        elsif (seed > 1) then
                        prev := 1;
                        prev_str := '1-'||hits;
        end if;

	htp.p('<center><table border=0><tr>');
	htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
	htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
		htp.p(' <b>|</b> <td align=right>');
		htp.p(wsms1.url(cgi_bin||'wsms2.header_list?keyword='||key||
			'&total='||total||'&seed='||next||'&qid='||qid||
			'&uid='||uid||'&area='||area,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
		htp.p(' <b>|</b><td align=right>');
		htp.p(wsms1.url(cgi_bin||'wsms2.header_list?keyword='||key||
			'&total='||total||'&seed='||prev||'&qid='||qid||
			'&uid='||uid||'&area='||area,'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');

	totalnum := 0;
	open cresult(qid,area);
	loop
	     fetch cresult into result_rec;
	     exit when cresult%NOTFOUND;
	     totalnum := totalnum + 1;
             if (totalnum >= seed) then
		tit := result_rec.title;
		tit := replace(tit,'<','&lt');
        	tit := replace(tit,'>','&gt');
        	tit := replace(tit,'"','&quot');
		if (tit IS NULL) then
			tit := 'No Title';
		end if;

		if (not((wsms1.to_url(uid,result_rec.path,real_url)))) then
			real_url := wsms_server;
		end if;

		htp.p('<p><dt>');
		htp.p('<img src="'||wsms_server||'/greendot.gif">'); 
			htp.p('<a href="'||view_url||key||'&f_id='||result_rec.id||'&r_url='||real_url||'&cid='||qid||
			'"><strong>');
		htp.p(tit);
		htp.p('</strong></a>');
		htp.p(' <font size=-1>(<cite>Score: '||result_rec.score||
			'; Size: '||round((result_rec.fsize/1024),1)||
			'KB; Date: '||to_char(result_rec.ldate,'dd Mon yy')||
			'</cite></font>)<dd>');
		htp.p(result_rec.subject);
		htp.p('<br><font size="-1">'||wsms1.url(real_url,real_url)||'</font>');
--		htp.p('<br><font size="-1">'||result_rec.path||'</font>');
		counter := counter + 1;
		if (counter >= hits ) then exit; end if; 
	     end if;
	end loop;
	htp.p('</dl>');
	close cresult;

	htp.p('<center>');
 	if (prev_str IS NOT NULL) then
		htp.p('['||wsms1.url(cgi_bin||'wsms2.header_list?keyword='||key||
			'&total='||total||'&seed='||prev||'&qid='||qid||
			'&uid='||uid||'&area='||area,'Prev')||']');
	end if;
	htp.p(' p.');
	n := ceil(total/hits);
	if (n > 20) then n := 20; end if;
	for i in 1..n loop
		iseed := (i-1)*hits + 1;
		if (iseed = seed) then
			htp.p(' '||i);
		else
			htp.p(' '||wsms1.url(cgi_bin||'wsms2.header_list?keyword='||
			key||'&total='||total||'&seed='||iseed||'&qid='||qid||
			'&uid='||uid||'&area='||area,i));
		end if;
	end loop;
	if (seed < ((n-1)*hits+1)) then
		htp.p('['||wsms1.url(cgi_bin||'wsms2.header_list?keyword='||key||
			'&total='||total||'&seed='||next||'&qid='||qid||
			'&uid='||uid||'&area='||area,'Next')||']');
        end if;
	htp.p('</center>');
	htp.p('</TD></TR></TABLE>');
end;

procedure update_doc(uid varchar2) is

begin
	if (not wsms1.validation(uid,DEVELOPER,write_no,read_no,usrgrp_no,s_role)) then
		return;
	end if;
	if (write_no = 0) then
		htp.p('There is no document that you can update!');
		return;
	end if;
	htp.p('Choose a document to update from the following list');
	all_del_doc(uid,write_no,s_role,1,1);
end;

procedure update_doc(uid varchar2,doc_id number) is

old_aut docs.author%TYPE;
old_tit docs.title%TYPE;
old_path docs.path%TYPE;
old_grp_no docs.group_no%TYPE;

fid number(8);

begin
	if (not wsms1.validation(uid,DEVELOPER,write_no,read_no,usrgrp_no,s_role)) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr>');
	htp.p('<center>');
	htp.p('<font size="-1">');
	htp.p('Please update the selected WSMS document information:');
	htp.p('<hr height="5" width="90%">');
	htp.p('</center>');
	fid := doc_id;
	select author,title,path,group_no
		into old_aut,old_tit,old_path,old_grp_no
		from docs
		where id=fid;
	htp.p('<form action="'||cgi_bin||'wsms2.update_doc_action" method="POST">');
	htp.p('<table border=2 align="center">
		<caption>Update a new WSMS document</caption>
		<tr><th>Data Item</th><th>Value to be updated</th>
		<tr><td>WSMS ID<td><b>WSMS '||fid||'</b><input type="hidden" name="fid" value='||fid||'>');
	htp.p('<tr><td>Authors (separate each authors with a comma)<td><input name="aut" size="40" value="'||old_aut||'">');
	htp.p('<tr><td>Title<td><input name="tit" size="40" value="'||
		old_tit||'">');
	htp.p('<tr><td>File Path<td><input name="docpath" size="40" value="'
		||old_path||'">');
	if (old_grp_no=1) then
		htp.p('<tr><td>WSMS Item Type<td><select name="grp1">
			<option value="1" selected>MSRC
			<option value="2">PET
			</select>');
	else
		htp.p('<tr><td>WSMS Item Type<td><select name="grp1">
		<option value="1">MSRC
		<option value="2" selected>PET
		</select>');
	end if;
	htp.p('</table><input type="submit" value="Update"><input type="reset" value="Reset">');
	htp.p('<input type="hidden" name="uid" value="'||uid||'">');
	htp.p('</form></center>');
end;

procedure update_doc_action(fid number,aut varchar2,tit varchar2,
		docpath varchar2,grp1 integer,uid varchar2) is

/*old_aut docs.author%TYPE;
old_tit docs.title%TYPE;
old_path docs.path%TYPE;
old_grp_no docs.group_no%TYPE;*/
grp_name docs.group_name%TYPE;

begin
/*	select author,title,path,group_no
		into old_aut,old_tit,old_path,old_grp_no
		from docs
		where id=fid;
*/
	if (grp1=1) then
		grp_name:='MSRA';
	else
	 	grp_name:='PET';
	end if;
		
	update docs set author=aut,title=tit,path=docpath,group_no=grp1,
		group_name=grp_name
		where id=fid;
	commit;
	htp.p('Do you need to update file itself? <p>');
			htp.p('<form action="'||real_cgi||'loaddoc?fid='||fid
		||'&docpath='||docpath||'&grp1='||grp1||'" method="POST">');

	htp.p('<input type=submit value="Update"></form>');
	htp.p('<form action="'||cgi_bin||'wsms2.no_update" method="POST">');
	htp.p('<input type="hidden" name="fid" value="'||fid||'">');
	htp.p('<input type=submit value="No"></form>');
end;
	
procedure no_update(fid number) is

begin
	htp.p('<center>');
	htp.p('The document WSMS '||fid||' information has been updated!');
	htp.p('</center>');
end;	

procedure all_orphan_files(uid varchar2) is

cursor corphan is
	select * from docs 
	where orphanflag=0
	order by id desc;

h_count integer;
num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

flag number(1);
real_url varchar2(250);
doc_area varchar2(20) := 'Prototype';

begin
	if (not(wsms1.validation(uid,DEVELOPER,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr>');
	select count(*) into total from docs where orphanflag=0;
	next := 11;
	
	if (total > 0 ) then
		htp.p('<center>');
		htp.p('<font size="+5" color=red>All Orphan Files');
		htp.p('<img src="'||wsms_server||'/wavy.gif">');
		htp.p('</font></center>');
	    	next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
		else
                    curr_str := total;
		end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
                	htp.p(' <b>|</b> <td align=right>');
			htp.p(wsms1.url(cgi_bin||'wsms2.more_orphan?tot='||total||
				'&seed='||next||'&me='||uid,'Next '||
				next_str));
		end if;
		if (prev_str IS NOT NULL) then
                	htp.p(' <b>|</b><td align=right>');
			htp.p(wsms1.url(cgi_bin||'wsms2.more_orphan?tot='||total||
				'&seed='||prev||'&me='||uid,'Prev '||
				prev_str));
		end if;
		htp.p('</table></center><dl>');

		htp.p('<center><table border=1 align=center>');
		htp.p('<tr>'||th('ID')||th('Author')||th('Title')||
			th('Group')||th('Reviewer')||th('Area'));
		open corphan;
		h_count := 0;
		for i in 1 .. 10 loop
			h_count := h_count + 1;
			fetch corphan into doc;
			exit when corphan%NOTFOUND;
			flag := 0;
			if (wsms1.to_url(uid,doc.path,real_url)) then
				flag := 1;
			end if;
			htp.p('<tr>');
			if (flag=1) then
				htp.p(td(wsms1.url(real_url,doc.id)));
			else
			   	 htp.p(td(doc.id));
			end if;
			htp.p(td(doc.author));
			htp.p(td(doc.title));
			htp.p(td(doc.group_name));
			htp.p(td(doc.reviewer));
			if (doc.type=2) then
				doc_area := 'Production';
			elsif(doc.type=3) then
				doc_area := 'Archival';
			end if;
			htp.p(td(doc_area));
			htp.p('</tr>');
		end loop;
		close corphan;
		htp.p('</table>');
		htp.p('<img src="'||wsms_server||'/wavy.gif">');
		htp.p('<br>');
		htp.p('<center>');
	   	htp.p(' p.');
       		n := ceil(total/10);
           	if (n > 20) then n := 20; end if;
	   	for i in 1..n loop
		  iseed := (i-1)*10 + 1;
		  if (iseed = 0 ) then
			htp.p(' '||i);
		  else
			htp.p(' '||wsms1.url(cgi_bin||'wsms2.more_orphan?tot='||total
				||'&seed='||iseed||'&me='||uid,i));
		  end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||wsms1.url(cgi_bin||'wsms2.more_orphan?tot='||total||
			'&seed='||next||'&me='||uid,'Next')||']');
	     	end if;
	     	htp.p('</center>');
	else
		htp.p('No Orphan Link Found!');
	end if;
end;

procedure more_orphan(tot number, seed integer, me varchar2) is

cursor corphan is
	select * from docs
	where orphanflag=0
	order by id desc;
num integer;
n integer;
h_count integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

flag number(1);
real_url varchar2(250);
doc_area varchar2(20) := 'Prototype';

begin
	if (not(wsms1.validation(me,DEVELOPER,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr>');
	htp.p('<center>');
	htp.p('<font size="+5" color=red>All Orphan Files');
	htp.p('<img src="'||wsms_server||'/wavy.gif">');
	htp.p('</font></center>');
	total := tot;
	next := seed + 10;
	if ( next<=total) then
		if ((next+10)<=total) then
			next_str := (next+9);
		else
			next_str := total;
		end if;
		next_str := next||'-'||next_str;
		curr_str := next - 1;
	else
		curr_str := total;
	end if;
	prev := seed - 10;
	if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
	elsif (seed > 1) then
		prev := 1;
		prev_str := '1-'|| 10;
	end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(wsms1.url(cgi_bin||'wsms2.more_orphan?tot='||tot||
			'&seed='||next||'&me='||me,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(wsms1.url(cgi_bin||'wsms2.more_orphan?tot='||tot||
			'&seed='||prev||'&me='||me,'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
	
	htp.p('<center><table border=1 align=center>');
	htp.p('<tr>'||th('ID')||th('Author')||th('Title')||
		th('Group')||th('Reviewer')||th('Area'));
	open corphan;
	h_count := 0;
	loop
		h_count := h_count + 1;
		fetch corphan into doc;
		exit when corphan%NOTFOUND;
		flag := 0;
		if (wsms1.to_url(me,doc.path,real_url)) then
			flag := 1;
		end if;
		if (h_count >= seed) then
			htp.p('<tr>');
			if (flag=1) then
				htp.p(td(wsms1.url(real_url,doc.id)));
			else
			   	 htp.p(td(doc.id));
			end if;
			htp.p(td(doc.author));
			htp.p(td(doc.title));
			htp.p(td(doc.group_name));
			htp.p(td(doc.reviewer));
			if (doc.type=2) then
				doc_area := 'Production';
			elsif (doc.type=3) then
				doc_area := 'Archival';
			end if;
			htp.p(td(doc_area));
			htp.p('</tr>');
		end if;
		if (h_count >= (seed + 10)) then
		   exit;
		end if;
	end loop;
	close corphan;
	htp.p('</table>');
	htp.p('<img src="'||wsms_server||'/wavy.gif">');
	htp.p('<br>');
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
		iseed := (i-1)*10 + 1;
		if (iseed = 0 ) then
			htp.p(' '||i);
		else
			htp.p(' '||wsms1.url(cgi_bin||'wsms2.more_orphan?tot='||tot
				||'&seed='||iseed||'&me='||me,i));
		end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||wsms1.url(cgi_bin||'wsms2.more_orphan?tot='||tot
			||'&seed='||next||'&me='||me,'Next')||']');
	end if;
	htp.p('</center>');
end;

procedure all_dead_links(uid varchar2) is

cursor cdead is
	select dfile,pid from deadlinks
	order by dfile desc;

doc_dir deadlinks.dfile%TYPE;
doc_parent deadlinks.pid%TYPE;

h_count integer;
pos integer;
p_id varchar2(6);

num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;
flag number(1);
real_url varchar2(250);
p_dir varchar2(250) := NULL;

begin
	if (not(wsms1.validation(uid,DEVELOPER,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr>');
	select count(*) into total from deadlinks;
	if (total > 0 ) then
		htp.p('<center>');
		htp.p('<font size="+5" color=red>All Dead Links');
		htp.p('<img src="'||wsms_server||'/wavy.gif">');
		htp.p('</font></center>');
	    	next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
		else
                    curr_str := total;
		end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
                	htp.p(' <b>|</b> <td align=right>');
			htp.p(wsms1.url(cgi_bin||'wsms2.more_dead??tot='||total||
				'&seed='||next||'&me='||uid,'Next '||
				next_str));
		end if;
		if (prev_str IS NOT NULL) then
                	htp.p(' <b>|</b><td align=right>');
			htp.p(wsms1.url(cgi_bin||'wsms2.more_orphan?tot='||total||
				'&seed='||prev||'&me='||uid,'Prev '||
				prev_str));
		end if;
		htp.p('</table></center><dl>');

		htp.p('<center><table border=1 align=center>');
		htp.p('<tr>'||th('Dead Link')||th('Parent Page'));
		open cdead;
		h_count := 0;
		for i in 1 .. 10 loop
			h_count := h_count + 1;
			fetch cdead into doc_dir,doc_parent;
			exit when cdead%NOTFOUND;
			flag := 0;
			if (wsms1.to_url(uid,doc_dir,real_url)) then
				flag := 1;
			end if;
			htp.p('<tr>');
			if (flag=1) then
 				htp.p(td(real_url));
			else
				htp.p(td(doc_dir));
			end if;
			doc_parent := concat(doc_parent,',99');
			htp.p('<td>');
			loop
				pos := instr(doc_parent,',');
				if (pos=0) then
					exit;
				end if;
				p_id := substr(doc_parent,1,pos-1);
				doc_parent := substr(doc_parent,pos+1);
				select path into p_dir from docs
					where id=p_id;
				flag := 0;
				if (wsms1.to_url(uid,p_dir,real_url)) then
					flag := 1;
				end if;
				if (flag=1) then
 					htp.p(wsms1.url(real_url,real_url)||'<br>');
				else
					htp.p(p_dir||'<br>');
				end if;
			end loop;
			htp.p('</td>');
			htp.p('</tr>');
		end loop;
		close cdead;
		htp.p('</table>');
		htp.p('<img src="'||wsms_server||'/wavy.gif">');
		htp.p('<br>');
		htp.p('<center>');
	   	htp.p(' p.');
       		n := ceil(total/10);
           	if (n > 20) then n := 20; end if;
	   	for i in 1..n loop
		  iseed := (i-1)*10 + 1;
		  if (iseed = 0 ) then
			htp.p(' '||i);
		  else
			htp.p(' '||wsms1.url(cgi_bin||'wsms2.more_dead?tot='||total
				||'&seed='||iseed||'&me='||uid,i));
		  end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||wsms1.url(cgi_bin||'wsms2.more_dead?tot='||total||
			'&seed='||next||'&me='||uid,'Next')||']');
	     	end if;
	     	htp.p('</center>');
	else
		htp.p('No Dead Link Found!');
	end if;
end;
			

procedure more_dead(tot number, seed integer, me varchar2) is
			
cursor cdead is
	select dfile,pid from deadlinks
	order by dfile desc;

doc_dir deadlinks.dfile%TYPE;
doc_parent deadlinks.pid%TYPE;

h_count integer;
pos integer;
p_id varchar2(6);

num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;
flag number(1);
real_url varchar2(250);
p_dir varchar2(250) := NULL;

begin
	if (not(wsms1.validation(me,DEVELOPER,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr>');
	htp.p('<center>');
	htp.p('<font size="+5" color=red>All Dead Links');
	htp.p('<img src="'||wsms_server||'/wavy.gif">');
	htp.p('</font></center>');
	total := tot;
	next := seed + 10;
	if ( next<=total) then
		if ((next+10)<=total) then
			next_str := (next+9);
		else
			next_str := total;
		end if;
		next_str := next||'-'||next_str;
		curr_str := next - 1;
	else
		curr_str := total;
	end if;
	prev := seed - 10;
	if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
	elsif (seed > 1) then
		prev := 1;
		prev_str := '1-'|| 10;
	end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(wsms1.url(cgi_bin||'wsms2.more_dead?tot='||tot||
			'&seed='||next||'&me='||me,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(wsms1.url(cgi_bin||'wsms2.more_dead?tot='||tot||
			'&seed='||prev||'&me='||me,'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
	
	htp.p('<center><table border=1 align=center>');
	htp.p('<tr>'||th('Dead Link')||th('Parent Page'));
	open cdead;
	h_count := 0;
	for i in 1 .. 10 loop
		h_count := h_count + 1;
		fetch cdead into doc_dir,doc_parent;
		exit when cdead%NOTFOUND;
		flag := 0;
		if (wsms1.to_url(me,doc_dir,real_url)) then
			flag := 1;
		end if;
		if (h_count >= seed) then
			htp.p('<tr>');
			if (flag=1) then
 				htp.p(td(real_url));
			else
				htp.p(td(doc_dir));
			end if;
			doc_parent := concat(doc_parent,',99');
			htp.p('<td>');
			loop
				pos := instr(doc_parent,',');
				if (pos=0) then
					exit;
				end if;
				p_id := substr(doc_parent,1,pos-1);
				doc_parent := substr(doc_parent,pos+1);
				select path into p_dir from docs
					where id=p_id;
				flag := 0;
				if (wsms1.to_url(me,p_dir,real_url)) then
					flag := 1;
				end if;
				if (flag=1) then
 					htp.p(wsms1.url(real_url,real_url)||'<br>');
				else
					htp.p(p_dir||'<br>');
				end if;
			end loop;
			htp.p('</td>');
			htp.p('</tr>');
		end if;
	end loop;
	close cdead;
	htp.p('</table>');
	htp.p('<img src="'||wsms_server||'/wavy.gif">');
	htp.p('<br>');
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
		iseed := (i-1)*10 + 1;
		if (iseed = 0 ) then
			htp.p(' '||i);
		else
			htp.p(' '||wsms1.url(cgi_bin||'wsms2.more_dead?tot='||tot
				||'&seed='||iseed||'&me='||me,i));
		end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||wsms1.url(cgi_bin||'wsms2.more_dead?tot='||tot
			||'&seed='||next||'&me='||me,'Next')||']');
	end if;
	htp.p('</center>');
end;



end wsms2;
/
show errors;
/









