create or replace package wsms1 is

procedure enter_index;
procedure get_realid(uid varchar2,rid out varchar2);
procedure wsms_admin(uid in varchar2,passwd in varchar2);
procedure wsms_admin_home1(uid varchar2);
procedure wsms_admin_home(uid varchar2);

procedure insert_url(uid varchar2);
procedure insert_url_action(f_dir varchar2, w_url varchar2,uid varchar2);
procedure all_url_pair(uid varchar2);
procedure more_url_pair(tot number,seed integer,me varchar2);

procedure insert_user_index(uid in varchar2);
procedure insert_user(uid in varchar2);
procedure insert_user_action(newid varchar2,passwd varchar2,new_name varchar2,
		new_email varchar2,wsms_role integer,grp integer,
		write_p integer,read_p integer,uid varchar2);
procedure delete_user(me varchar2);
procedure delete_user_action(me varchar2,uid varchar2);
procedure all_user1(uid varchar2);
procedure passwd2(uid varchar2);
procedure passwd_action2(p1 varchar2,p2 varchar2,uid varchar2);
procedure to_archival(uid varchar2);
procedure all_prod(uid in varchar2, op integer);
procedure more_prod(op integer,tot number, seed integer,me varchar2);
procedure to_archival_action(uid varchar2,doc_id varchar2);
procedure to_production(uid varchar2);
procedure all_prototype(uid varchar2, w_grp integer);
procedure more_prototype(op integer,tot number, seed integer,w_grp integer,
		me varchar2);
procedure move_action(op integer,uid varchar2,doc_id number);
procedure change_passwd(uid varchar2);
procedure passwd_action1(old varchar2,p1 varchar2,p2 varchar2,uid varchar2);

function to_url(uid varchar2,f_dir varchar2, w_url out varchar2) 
		return boolean;
function validation(uid in varchar2,grp integer,w_no out integer,
		r_no out integer,usr_no out integer,role_no out integer)
		return boolean;
function validation(uid in varchar2,passwd in varchar2,grp integer) 
		return boolean;

function tr(name varchar2) return varchar2;
function th(name varchar2) return varchar2;
function td(name varchar2) return varchar2;

function formDo(cname in varchar2) return varchar2;
function formDo return varchar2;

function url(curl in varchar2, cname in varchar2) return varchar2;
function url_top(curl in varchar2, cname in varchar2) return varchar2;
function url_right(curl in varchar2, cname in varchar2) return varchar2;
function url_right1(curl in varchar2, cname in varchar2) return varchar2;

wsms_server constant varchar2(60) := 'http://osprey7.npac.syr.edu:9706/wsms';
cgi_bin constant varchar2(60) := '/wsms/owa/';
real_cgi constant varchar2(60) := '/cgi-bin/wsms/';

ADMIN constant integer := 4;
REVIEWER constant integer := 3;
DEVELOPER constant integer := 2;
READER constant integer := 1;


end;
/
show errors;

create or replace package body wsms1 is

s_role users.role_grp%TYPE;
one users%ROWTYPE;
doc docs%ROWTYPE;
write_no users.write_pri%TYPE;
read_no users.read_pri%TYPE;
usrgrp_no users.group_id%TYPE;
total number(8);

flag number(1);
real_url varchar2(250);



function td(name varchar2) return varchar2 is
begin
	return ('<td>'||name||'</td>');
end;

function th(name varchar2) return varchar2 is
begin
	return ('<th>'||name||'</th>');
end;

function tr(name varchar2) return varchar2 is
begin
	return ('<tr>'||name||'</tr>');
end;

function formDo(cname in varchar2) return varchar2 is
begin return('<input type="submit" value="' || cname || '">'); end;

function formDo return varchar2 is
begin return(formDo('Submit')); end;

function url(curl   in varchar2, cname   in varchar2) return varchar2 is
begin 
	return('<a href="' || curl || '">' || cname || '</a>'); 
end;

function url_top(curl   in varchar2, cname   in varchar2) return varchar2 is
begin return('<a href="' || curl || '" TARGET="_top">' || cname || '</a>'); end;

function url_right(curl   in varchar2, cname   in varchar2) return varchar2 is
begin return('<a href="' || curl || '" TARGET="right">' || cname || '</a>'); end;

function url_right1(curl   in varchar2, cname   in varchar2) return varchar2 is
begin return('<a href="' || curl || '" TARGET="right1">' || cname || '</a>'); end;


function validation(uid in varchar2,grp integer,w_no out integer,
		r_no out integer,usr_no out integer,role_no out integer) 
		return boolean is

cursor cuser(u varchar2,g integer) is 
	select write_pri,read_pri,group_id,role_grp from users 
	where userid=u and role_grp>=g;
gid varchar2(50);

begin
	get_realid(uid,gid);
	if (uid IS NULL or grp <=0) then
		return false;
	end if;
	open cuser(gid,grp);
	fetch cuser into w_no, r_no,usr_no,role_no;
	if (cuser%NOTFOUND) then
		close cuser;
		htp.p('<body background="'||wsms_server||'/balloons.gif"');
		htp.p('<center>You <blink>do not have the privilege </blink>to perform this operation.<p>');
	   	htp.p('Go back.</center>');
		return false;
	end if;
	close cuser;
	return true;
end;
	

procedure enter_index is

begin
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<center><p>');
	htp.p('<img src="'||wsms_server||'/cewes.gif">');
	htp.p('<p><font size=+3><strong>CEWES Web Site Manage System</strong></font>');
	htp.p('<br><font color=red>This page is for authorized user only.</font>');
	htp.p('<form action="'||cgi_bin||'wsms1.wsms_admin" method="POST">');
	htp.p('<table>');
	htp.p('<tr><td align=right>User Id :</td><td><input name="uid" value="" size="20"></td></tr>');
	htp.p('<tr><td align=right>Password :</td><td><input type="password" name="passwd" value="" size="20"></td></tr>');
	htp.p('</table>');
	htp.p(formdo('Submit')); 
	htp.p('</form>'); 
	htp.p('<address><font size=-1>');
	htp.P('CEWES WSMS is developed by <a href="mailto:yuzhu@npac.syr.edu">Yuping Zhu</a>');
	htp.p(' at <a href="http://www.npac.syr.edu/">Northeast Parallel Architectures Center</a> Syracuse University.</font>');
	htp.p('</address></center>');
end;

procedure wsms_admin(uid in varchar2,passwd in varchar2) is
login_id varchar2(50);

begin
	if (validation(uid,passwd,READER)) then
		select h_id into login_id from users where userid=uid;
		for i in 1..length(uid) loop
		   login_id := concat(login_id,'~');
		   login_id := concat(login_id,ascii(substr(uid,i,1)));
		end loop;
		htp.p('<frameset cols="25%,75%">');
		htp.p('<frame src="'||cgi_bin||'wsms1.wsms_admin_home1?uid='||					login_id||'" name="left">');
		htp.p('<frame src="'||cgi_bin||'wsms1.wsms_admin_home?uid='||					login_id||'" name="right">');
		htp.p('</frameset>');
		htp.p('</html>');
	end if;
end;

function validation(uid in varchar2,passwd in varchar2,grp integer) return boolean is

cursor cuser(uid varchar2,pwd varchar2) is select role_grp from users 
	where userid=uid and password=pwd;

login_id varchar2(50);
login_time date;

begin
	if (uid IS NULL or grp<=0) then return true; end if;
	open cuser(uid,passwd);
	fetch cuser into s_role;

	if (cuser%NOTFOUND) then
	   close cuser;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<center>You have the wrong <blink>userid/password</blink> !</center>');
	   htp.p('Try again.');
	   return false;
	end if;
	close cuser;
	update users set time=sysdate where userid=uid;
	select time into login_time from users where userid = uid;
	login_id := to_char(login_time,'dd~hh24~mm~mi');
	update users set h_id=login_id where userid=uid;
	commit;
	return true;
end;

function to_url(uid varchar2,f_dir varchar2, w_url out varchar2) return boolean is

cursor curl(filedir varchar2) is
	select url from weburls
	where (instr(filedir,dir)=1);

tmp_url weburls.url%TYPE;
base_url weburls.url%TYPE;
tmp_dir weburls.dir%TYPE;

begin
	if (not (validation(uid,READER,write_no,read_no,usrgrp_no,s_role))) then
		return false;
	end if;
	open curl(f_dir);
	tmp_url := 'http';
	base_url := 'http';
	tmp_dir := '/';
	loop
		fetch curl into tmp_url;
		exit when curl%NOTFOUND;
		if (length(tmp_url) > length(base_url)) then
			base_url := tmp_url; 
		end if;
	end loop;
	close curl;
	select dir into tmp_dir from weburls
		where (url=base_url);
	w_url := replace(f_dir,tmp_dir,base_url);
	return true;
end;
			
		

procedure get_realid(uid varchar2,rid out varchar2) is

realid varchar2(50);
ch varchar2(10);
last integer := 0;
tmpid varchar2(50);

begin
	realid := substr(uid,instr(uid,'~',1,4) + 1);
	loop
	   if (instr(realid,'~',1,1) = 0 ) then
		last := 1;
		ch := realid;
	   else
	        ch := substr(realid,1,instr(realid,'~',1,1)-1);
	        realid := substr(realid,instr(realid,'~',1,1) + 1);
	   end if;
	   ch := chr(ch);	   
	   tmpid := concat(tmpid, ch);
	   if (last =1) then 
		exit;
	   end if;
        end loop;
	rid := tmpid;
end;


procedure wsms_admin_home1(uid varchar2) is

gid varchar2(50);

begin
	get_realid(uid,gid);
	select role_grp into s_role from users where userid=gid;
	htp.p('<body background="'||wsms_server||'/earthbk.jpg">');
	htp.p('<center>');
	htp.p('<a href="http://apollo.wes.hpc.mil/" target="right"><img src="'||wsms_server||'/cewes.gif" border=0 alt="CEWES" width=128></a><p></center>');
	if (s_role = ADMIN) then
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms1.insert_user_index?uid='||uid,
		'Insert a WSMS user'));
	   htp.p('<br>');
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms1.delete_user?me='||uid,
		'Delete a WSMS user'));
	   htp.p('<br>');
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms1.all_user1?uid='||uid,
		'List Users/Change Passwords'));
	   htp.p('<br>');
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms1.insert_url?uid='||uid,
		'Insert a new URL'));
	   htp.p('<br>');
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms1.to_archival?uid='||uid,
		'Change a document to archival from production'));
	   htp.p('<br>');
	end if;
	if (s_role >= REVIEWER) then
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms1.to_production?uid='||uid,
		'Change a document to production from prototype'));
	   htp.p('<br>');
	end if;
	if (s_role >= DEVELOPER) then
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms2.all_dead_links?uid='||uid,
		'List all dead links'));
	   htp.p('<br>');
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms2.all_orphan_files?uid='||uid,
	  	'List all orphan files'));
	   htp.p('<br>');
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms2.insert_doc?uid='||uid,
		'Insert a document'));
	   htp.p('<br>');
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms2.delete_doc?uid='||uid,
		'Delete a prototype document'));
	   htp.p('<br>');
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms2.update_doc?uid='||uid,
		'Update a prototype document'));
/*	   htp.p('<br>');
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms2.extrieve_doc?uid='||uid,
		'Extrieve a document'));
*/
	   htp.p('<br>');
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms3.search_archival?uid='||uid,
		'Search in archival area'));
	   htp.p('<br>');
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms3.search_prototype?uid='||uid,
		'Search in prototype area'));
	   htp.p('<br>');
	end if;
	if (s_role >= READER) then
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms3.search_production?uid='||uid,
		'Search in production area'));
	   htp.p('<br>');
	   htp.p('<img src="'||wsms_server||'/greendot.gif">');
	   htp.p(url_right(cgi_bin||'wsms1.change_passwd?uid='||uid,
		'Change your password'));
	end if;
end;

procedure wsms_admin_home(uid varchar2) is

gid varchar2(50);

begin
	get_realid(uid,gid);
	select role_grp into s_role from users where userid=gid;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<center><table border=2 cellspacing=2 cellpadding=4><caption>CEWES Web Site Management System<caption>');
	htp.p('<tr><th>Operation</th><th>Description</th></tr>');

	if (s_role = ADMIN) then
	   htp.p(tr(td(url(cgi_bin||'wsms1.insert_user_index?uid='||uid,
		'Insert a WSMS user'))||
		td('Insert a new WSMS user into the system')));
	   htp.p(tr(td(url(cgi_bin||'wsms1.delete_user?uid='||uid,
		'Delete a WSMS user'))||
		td('Delete an existing WSMS user from the system')));
	   htp.p(tr(td(url(cgi_bin||'wsms1.all_user1?uid='||uid,
		'List Users/Change Passwords'))||
		td('Show all WSMS users or change their passwords in the system')));
	   htp.p(tr(td(url(cgi_bin||'wsms1.insert_url?uid='||uid,
		'Insert a new URL'))||
		td('Insert a new file directory/URL pair')));
	   htp.p(tr(td(url(cgi_bin||'wsms1.to_archival?uid='||uid,
		'Change a document to archival from production'))||
		td('Move an old document from production to archival area')));
	   end if;
	if (s_role >= REVIEWER) then
	   htp.p(tr(td(url(cgi_bin||'wsms1.to_production?uid='||uid,
		'Change a document to production from prototype'))||
		td('Move a document from prototype to production area')));
	end if;
	if (s_role >= DEVELOPER) then
	   htp.p(tr(td(url(cgi_bin||'wsms2.all_dead_links?uid='||uid,
		'List all dead links'))||
		td('List all links that do not exist in the Database')));
	   
	   htp.p(tr(td(url(cgi_bin||'wsms2.all_orphan_files?uid='||uid,
	  	'List all orphan files'))||
		td('List all files that are not linked by any other file in the Database')));
	   htp.p(tr(td(url(cgi_bin||'wsms2.insert_doc?uid='||uid,
		'Insert a document'))||
		td('Insert a new WSMS document into the prototype area')));
	   htp.p(tr(td(url(cgi_bin||'wsms2.delete_doc?uid='||uid,
		'Delete a prototype document'))||
		td('Delete an existing WSMS document from the prototype area')));
	   htp.p(tr(td(url(cgi_bin||'wsms2.update_doc?uid='||uid,
		'Update a prototype document'))||
	        td('Update an existing document in prototype area')));
/*	   htp.p(tr(td(url(cgi_bin||'wsms2.extrieve_doc?uid='||uid,
		'Extrieve a document'))||
		 td('Extrieve an existing document in prototype or production area to file system')));
*/
	   htp.p(tr(td(url(cgi_bin||'wsms3.search_archival?uid='||uid,
		'Search in archival area'))||
		td('Search in WSMS arhcival area only')));
	   htp.p(tr(td(url(cgi_bin||'wsms3.search_prototype?uid='||uid,
		'Search in prototype area'))||
		td('Search in WSMS prototype area only')));
	end if;
	if (s_role >= READER) then
	   htp.p(tr(td(url(cgi_bin||'wsms3.search_production?uid='||uid,
		'Search in production area'))||
		td('Search in WSMS production area only')));
	   htp.p(tr(td(url(cgi_bin||'wsms1.change_passwd?uid='||uid,
		'Change your password'))||
		td('Create a new password for yourself')));
	end if;
	htp.p('</table>');
end;


procedure insert_url(uid varchar2) is

begin
	if (not (validation(uid,ADMIN,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<center><h2>Insert a new URL</h2></center>');	
	htp.p('<form action="'||cgi_bin||'wsms1.insert_url_action" method="POST">');
	htp.p('<center><table>');
	htp.p('<tr><td align=right>File directory:</td><td><input name="f_dir" value="" size="20"></td></tr>');
	htp.p('<tr><td align=right>URL :</td><td><input name="w_url" value="" size="20"></td></tr>');
	htp.p('<input type="hidden" name="uid" value="'||uid||'">');
	htp.p('</table>');
	htp.p(formdo('Submit')); htp.p('<input type="reset" value="Reset">');
	htp.p('</form></center><hr>');
	--all_url_pair(uid);
	htp.p('<center>');
	htp.p('<form action="'||cgi_bin||'wsms1.all_url_pair" method="POST">');
	htp.p('<input type="hidden" name="uid" value="'||uid||'">');
	htp.p('<input type="submit" value="List All Directory/URL Pair">');
	htp.p('</form>');
	htp.p('</center>');
end;

procedure insert_url_action(f_dir varchar2, w_url varchar2,uid varchar2) is

begin
	if (not (validation(uid,ADMIN,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	insert into weburls(dir,url)
		values(f_dir,w_url);
	commit;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('The new File Directory/URL pair has been inserted!');
end;

procedure all_url_pair(uid varchar2) is

cursor cpair is select * from weburls
	order by dir desc;

dir_url weburls%ROWTYPE;

h_count integer;
num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	if (not(wsms1.validation(uid,ADMIN,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr>');
	select count(*) into total from weburls;
	if (total > 0 ) then
	    	next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
		else
                    curr_str := total;
		end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
                	htp.p(' <b>|</b> <td align=right>');
			htp.p(url(cgi_bin||'wsms1.more_url_pair?tot='||total||
				'&seed='||next||'&me='||uid,'Next '||
				next_str));
		end if;
		if (prev_str IS NOT NULL) then
                	htp.p(' <b>|</b><td align=right>');
			htp.p(url(cgi_bin||'wsms1.more_url_pair?tot='||total||
			'&seed='||prev||'&me='||uid,'Prev '||
				prev_str));
		end if;
		htp.p('</table></center><dl>');

		htp.p('<center><table border=1 align=center>');
		htp.p('<tr>'||th('Directory in File System')||th('URL'));
		open cpair;
		h_count := 0;
		for i in 1 .. 10 loop
			h_count := h_count + 1;
			fetch cpair into dir_url;
			exit when cpair%NOTFOUND;
			htp.p('<tr>'||td(dir_url.dir));
			htp.p(td(dir_url.url));
			htp.p('</tr>');
		end loop;
		close cpair;
		htp.p('</table>');
		htp.p('<img src="'||wsms_server||'/wavy.gif">');
		htp.p('<br>');
		htp.p('<center>');
	   	htp.p(' p.');
       		n := ceil(total/10);
           	if (n > 20) then n := 20; end if;
	   	for i in 1..n loop
		  iseed := (i-1)*10 + 1;
		  if (iseed = 0 ) then
			htp.p(' '||i);
		  else
			htp.p(' '||url(cgi_bin||'wsms1.more_url_pair?tot='||total
				||'&seed='||iseed||'&me='||uid,i));
	     	  end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||url(cgi_bin||'wsms1.more_url_pair?tot='||total||
			'&seed='||next||'&me='||uid,'Next')||']');
	     	end if;
	     	htp.p('</center>');
	else
		htp.p('No Directory/URL Found!');
	end if;
end;

procedure more_url_pair(tot number,seed integer,me varchar2) is

cursor cpair is 
	select * from weburls
	order by dir desc;

dir_url weburls%ROWTYPE;

h_count integer;
num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	if (not(wsms1.validation(me,ADMIN,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr>');
	total := tot;
	next := seed + 10;
	if ( next<=total) then
		if ((next+10)<=total) then
			next_str := (next+9);
		else
			next_str := total;
		end if;
		next_str := next||'-'||next_str;
		curr_str := next - 1;
	else
		curr_str := total;
	end if;
	prev := seed - 10;
	if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
	elsif (seed > 1) then
		prev := 1;
		prev_str := '1-'|| 10;
	end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(url(cgi_bin||'wsms1.more_url_pair?tot='||tot||
			'&seed='||next||'&me='||me,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(url(cgi_bin||'wsms1.more_url_pair?tot='||tot||
			'&seed='||prev||'&me='||me,'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
	
	htp.p('<center><table border=1 align=center>');
	htp.p('<tr>'||th('Directory in File System')||th('URL'));
	open cpair;
	h_count := 0;
	loop
		h_count := h_count + 1;
		fetch cpair into dir_url;
		exit when cpair%NOTFOUND;
		if (h_count >= seed) then
			htp.p('<tr>'||td(dir_url.dir));
			htp.p(td(dir_url.url));
			htp.p('</tr>');
		end if;
		if (h_count >= (seed + 10)) then
		   exit;
		end if;
	end loop;
	close cpair;
	htp.p('</table>');
	htp.p('<img src="'||wsms_server||'/wavy.gif">');
	htp.p('<br>');
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
		iseed := (i-1)*10 + 1;
		if (iseed = 0 ) then
			htp.p(' '||i);
		else
			htp.p(' '||url(cgi_bin||'wsms1.more_url_pair?tot='||tot
				||'&seed='||iseed||'&me='||me,i));
		end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||url(cgi_bin||'wsms1.more_url_pair?tot='||tot
			||'&seed='||next||'&me='||me,'Next')||']');
	end if;
	htp.p('</center>');
end;

		
procedure insert_user_index(uid in varchar2) is
begin
	if (validation(uid,ADMIN,write_no,read_no,usrgrp_no,s_role)) then
	  insert_user(uid);
	end if;
end;

procedure insert_user(uid in varchar2) is

begin
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<center><h2>Insert a new WSMS user</h2></center>');	
	htp.p('<form action="'||cgi_bin||'wsms1.insert_user_action" method="POST">');
	htp.p('<center><table>');
	htp.p('<tr><td align=right>User Id :</td><td><input name="newid" value="" size="20"></td></tr>');
	htp.p('<tr><td align=right>Initial Password :</td><td><input type="password" name="passwd" value="" size="20"></td></tr>');
	htp.p('<tr><td align=right>Name :</td><td><input name="new_name" value="" size="20"></td></tr>');
	htp.p('<tr><td align=right>Email Address :</td><td><input name="new_email" value="" size="20"></td></tr>');
	htp.p('<tr><td align=right>Role :</td><td><select name="wsms_role">');
	htp.p('<option value="1">Reader');
	htp.p('<option value="2">Developer');
	htp.p('<option value="3">Reviewer');
        htp.p('<option value="4">DB Admin');
	htp.p('</select></td></tr>');
	htp.p('<tr><td align=right>Group :</td><td><select name="grp">');
	htp.p('<option value="1">MSRC');
	htp.p('<option value="2">PET');
	htp.p('<option value="3">Both');
	htp.p('</select></td></tr>');
	htp.p('<tr><td align=right>Write Privilege :</td><td><select name="write_p">');
	htp.p('<option value="1">MSRC');
	htp.p('<option value="2">PET');
	htp.p('<option value="3">Both');
	htp.p('</select></td></tr>');
	htp.p('<tr><td align=right>Read Privilege :</td><td><select name="read_p">');
	htp.p('<option value="1">MSRC');
	htp.p('<option value="2">PET');
	htp.p('<option value="3">Both');
	htp.p('</select></td></tr>');
	htp.p('<input type="hidden" name="uid" value="'||uid||'">');
	htp.p('</table>');
	htp.p(formdo('Submit')); htp.p('<input type="reset" value="Reset">');
	htp.p('</form></center><hr>');  
--	all_user(userid);
	htp.p('<center>');
	htp.p('<form action="'||cgi_bin||'wsms1.all_user1" method="POST">');
	htp.p('<input type="hidden" name="uid" value="'||uid||'">');
	htp.p('<input type="submit" value="List All User ID">');
	htp.p('</form>');
	htp.p('</center>');
end;

procedure insert_user_action(newid varchar2,passwd varchar2,new_name varchar2,new_email varchar2,wsms_role integer,grp integer,write_p integer,read_p integer,uid varchar2) is

cursor cuser(u varchar2) is select * from users where userid=u;
uu users%ROWTYPE;

begin
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	if ((newid||passwd||new_name) IS NULL) then
		htp.p('The field '||htf.bold('User Id/Name/Password')||' must not be blank.');
		htp.p('<p>Go back and correct it. Try again.');
		return;
	end if;
	open cuser(newid);
	fetch cuser into uu;
	if (cuser%FOUND) then
		htp.p('There is already a user with the userid = '||htf.bold(newid)||' in the system.');
		htp.p('<p>Go back and correct it. Try again.');
		return;
	else
		insert into users(userid,password,email,name,url,tel,office,login,time,creation_time,write_pri,read_pri,group_id,role_grp)
		values(newid,passwd,new_email,new_name,null,null,null,null,
			sysdate,sysdate,write_p,read_p,grp,wsms_role);
		COMMIT;
	end if;
	htp.p('<hr><p>The new user '||htf.bold(newid)||' ('||new_name||') has been sucessfully added into the WSMS user list.');
end;

procedure delete_user(me varchar2) is

cursor cuser is select * from users where group_id <= ADMIN order by userid;

begin
	if (validation(me,ADMIN,write_no,read_no,usrgrp_no,s_role)) then
		htp.p('<body background="'||wsms_server||'/balloons.gif">');
		htp.p('<hr>');
		select count(*) into total from users;
		htp.p('<center>Total '||total||' WSMS users. Which one to remove ?:<br>');
		open cuser;
		htp.p('<form action="'||cgi_bin||'wsms1.delete_user_action">');
		htp.p('<select name=uid>');
		loop
			fetch cuser into one;
			exit when cuser%NOTFOUND;
			htp.p('<option value="'||one.userid||'">'||one.userid||'('||one.name||')');
		end loop;
		htp.p('</select>');
		close cuser;		
		htp.p(formdo('Delete')); 
		htp.p('<input type="hidden" name="me" value="'||me||'">');
		htp.p('</center></form>');
		htp.p('<form action="'||cgi_bin||'wsms1.delete_user_action">');
		htp.p('<input type="hidden" name="me" value="'||me||'">');

	end if;
end;

procedure delete_user_action(me varchar2,uid varchar2) is

begin

	if (validation(me,ADMIN,write_no,read_no,usrgrp_no,s_role)) then
		htp.p('<body background="'||wsms_server||'/balloons.gif">');
		htp.p('<hr>');
		delete from users where userid=uid;
		commit;
		htp.p('User '||htf.bold(uid)||' has been removed.<hr>');
		all_user1(me);
	end if;
end;

procedure all_user1(uid varchar2) is
cursor cuser is select * from users order by userid;
role_name varchar2(20);
c_time varchar2(20);
write_name varchar2(20);
read_name varchar2(20);

begin
	if (not validation(uid,ADMIN,write_no,read_no,usrgrp_no,s_role)) then
		return;
	end if;

	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<center><hr>');
	htp.p('<font size="+5" color=red>All WSMS Users');
	htp.p('<img src="'||wsms_server||'/wavy.gif">');
	htp.p('</font>');
	htp.p('<table border=1>');
--	htp.p('<caption>WSMS Users</caption><p>');
	htp.p(tr(th('User ID')||th('Name')||th('Role')||th('Read Privillege')
		||th('Write Privillege')||th('Creation Time')));
	open cuser;
	loop
		fetch cuser into one;
		exit when cuser%NOTFOUND;
		if (one.role_grp = 1) then
			role_name := 'READER';
		elsif (one.role_grp = 2) then
			role_name := 'DEVELOPER';
		elsif (one.role_grp = 3) then
			role_name := 'REVIEWER';
		elsif (one.role_grp = 4) then
			role_name := 'WSMS DB ADMIN';
		else
			role_name := '<br>';
		end if;
		if (one.read_pri = 1) then
			read_name := 'MSRC';
		elsif (one.read_pri = 2) then
			read_name := 'PET';
		else
			read_name := 'MSRC and PET';
		end if;
		if (one.write_pri = 1) then
			write_name := 'MSRC';
		elsif (one.write_pri = 2) then
			write_name := 'PET';
		else
			write_name := 'MSRC and PET';
		end if;
		if (one.creation_time IS NOT NULL) then
			c_time := to_char(one.creation_time,'mm/dd/yy, hh24:mi');
		else
			c_time := '<br>';
		end if;
		htp.p('<tr>'||td(url(cgi_bin||'wsms1.passwd2?uid='||one.userid, one.userid)));
		htp.p(td(one.name));
		htp.p(td(role_name));
		htp.p(td(read_name));
		htp.p(td(write_name));
		htp.p(td(c_time)||'</tr>');
	end loop;
	htp.p('</table>');
	htp.p('<img src="'||wsms_server||'/wavy.gif">');
	htp.p('<br>Total: '||cuser%ROWCOUNT||'</center>');
	close cuser;
end;

procedure passwd2(uid varchar2) is

begin
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
		htp.p('<hr>');
	select * into one from users where userid = uid;
	htp.p('<form action="'||cgi_bin||'wsms1.passwd_action2" method=POST');
	htp.p('<center><table border=1>');
	htp.p('<caption>Change the password of user '||uid||'</caption>');
	htp.p(tr(td('User Id: ')||td(one.userid)));
	htp.p(tr(td('Name: ')||td(one.name)));
	htp.p(tr(td('New Password: ')||td('<input type="password" name="p1" value="">')));
	htp.p(tr(td('New Password Again: ')||td('<input type="password" name="p2" value="">')));
	htp.p('</table>');
	htp.p('<input type="hidden" name="uid" value="'||uid||'">');
	htp.p(formdo('Submit')); 
	htp.p('</center></form>');

end;

procedure passwd_action2(p1 varchar2,p2 varchar2,uid varchar2) is

begin
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<center>');
	htp.p('<img src="'||wsms_server||'ringyel.gif">');
	htp.p('<p>');
	if ( p1 != p2 ) then
		htp.p('Your second input is not the same as the first input!');
		htp.p('<form action="'||cgi_bin||'wsms.passwd2?" method="POST">');
		htp.p('<input type="hidden" name="uid" value="'||uid||'">');
		htp.p('<input type="submit" value="Try again">');
		htp.p('</form>');
		return;
	end if;

	update users set password=p1 where userid=uid;
	commit;
	htp.p('The password of user '||uid|| ' has been changed to '||p1||' !');
end;

procedure to_archival(uid varchar2) is

begin
	if (not validation(uid,ADMIN,write_no,read_no,usrgrp_no,s_role)) then
		return;
	end if;
	htp.p('Choose a document to move from the following list');
	all_prod(uid,0);
end;

procedure all_prod(uid in varchar2, op integer) is

cursor cdoc is 
	select * from docs where type=2 
	order by id desc;

end_num integer;
h_count integer;

num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	if ((op = 0) and (not(validation(uid,ADMIN,write_no,read_no,usrgrp_no,s_role)))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr>');
	select count(*) into total from docs where type=2;
	next := 11;
	
	if (total > 0 ) then
	    	next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
		else
                    curr_str := total;
		end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
                	htp.p(' <b>|</b> <td align=right>');
			htp.p(url(cgi_bin||'wsms1.more_prod?op='||op||
				'&tot='||total||'&seed='||next
				||'&me='||uid,'Next '||next_str));
		end if;
		if (prev_str IS NOT NULL) then
                	htp.p(' <b>|</b><td align=right>');
			htp.p(url(cgi_bin||'wsms1.more_prod?op='||op||
				'&tot='||total||'&seed='||prev
				||'&me='||uid,'Prev '||prev_str));
		end if;
	   	htp.p('</table></center><dl>');

		htp.p('<center><table border=1 align=center>');
		htp.p('<tr>'||th('Click ID<br>to Move')||th('Author')||th('Click Title<br>to View')||
			th('Group')||th('Reviewer'));
		open cdoc;
		h_count := 0;
		for i in 1 .. 10 loop
			h_count := h_count + 1;
			fetch cdoc into doc;
			exit when cdoc%NOTFOUND;
			flag := 0;
			if (wsms1.to_url(uid,doc.path,real_url)) then
				flag := 1;
			end if;
			htp.p('<tr>'||td(url(cgi_bin||'wsms1.to_archival_action?uid='||uid||'&doc_id='||doc.id,doc.id)));
			htp.p(td(doc.author));
			if (flag=1) then
			   htp.p(td(wsms1.url(real_url,doc.title)));
			else
			   htp.p(td(doc.title));
			end if;
			
			htp.p(td(doc.group_name));
			htp.p(td(doc.reviewer));
			htp.p('</tr>');
		end loop;
		close cdoc;
		htp.p('</table>');
		htp.p('<img src="'||wsms_server||'/wavy.gif">');
		htp.p('<br>');
		htp.p('<center>');
	   	htp.p(' p.');
       		n := ceil(total/10);
           	if (n > 20) then n := 20; end if;
	   	for i in 1..n loop
		  iseed := (i-1)*10 + 1;
		  if (iseed = 0 ) then
			htp.p(' '||i);
		  else
			htp.p(' '||url(cgi_bin||'wsms1.more_prod?op='||
				op||'&tot='||total||'&seed='||iseed
				||'&me='||uid,i));
		  end if;
	    	end loop;
	    	if (next_str IS NOT NULL) then
		   htp.p('['||url(cgi_bin||'wsms1.more_prod?op='||op||
			'&tot='||total||'&seed='||next||
			'&me='||uid,'Next')||']');
	     	end if;
	     	htp.p('</center>');
	else
		htp.p('No WSMS document in production area!');
	end if;
end;

procedure more_prod(op integer,tot number, seed integer,me varchar2) is

cursor cdoc is select * from docs where type=2 order by id desc;
h_count integer;

num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	if ((op = 0) and (not validation(me,ADMIN,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<center>Choose a document to move from the following list:<p></center>');
	htp.p('<hr>');
	total := tot;
	next := seed + 10;
	if ( next<=total) then
		if ((next+10)<=total) then
			next_str := (next+9);
		else
			next_str := total;
		end if;
		next_str := next||'-'||next_str;
		curr_str := next - 1;
	else
		curr_str := total;
	end if;
	prev := seed - 10;
	if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
	elsif (seed > 1) then
		prev := 1;
		prev_str := '1-'|| 10;
	end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(url(cgi_bin||'wsms1.more_prod?op='||op||
			'&tot='||tot||'&seed='||next
			||'&me='||me,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(url(cgi_bin||'wsms1.more_prod?op='||op||
			'&tot='||tot||'&seed='||prev
			||'&me='||me,'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');

	htp.p('<center><table border=1 align=center>');
	htp.p('<tr>'||th('Click ID<br>to Move')||th('Author')||th('Click Title<br>to View')||
			th('Group')||th('Reviewer'));
	open cdoc;
	h_count := 0;
	loop
		h_count := h_count + 1;
		fetch cdoc into doc;
		exit when cdoc%NOTFOUND;

		flag := 0;
		if (wsms1.to_url(me,doc.path,real_url)) then
			flag := 1;
		end if;
		if (h_count >= seed) then
			htp.p('<tr>'||td(url(cgi_bin||'wsms1.to_archival_action?uid='||uid||'&doc_id='||doc.id,doc.id)));
			htp.p(td(doc.author));
			if (flag=1) then
			   htp.p(td(wsms1.url(real_url,doc.title)));
			else
			   htp.p(td(doc.title));
			end if;
			
			htp.p(td(doc.group_name));
			htp.p(td(doc.reviewer));
			htp.p('</tr>');
		end if;
		if (h_count >= (seed + 10)) then
		   exit;
		end if;
	end loop;
	close cdoc;
	htp.p('</table>');
	htp.p('<img src="'||wsms_server||'/wavy.gif">');
	htp.p('<br>');
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
		iseed := (i-1)*10 + 1;
		if (iseed = 0 ) then
			htp.p(' '||i);
		else
			htp.p(' '||url(cgi_bin||'wsms1.more_prod?op='||
				op||'&tot='||total||'&seed='||iseed
				||'&me='||me,i));
		end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||url(cgi_bin||'wsms1.more_prod?op='||op||
			'&tot='||total||'&seed='||next||
			'&me='||me,'Next')||']');
	end if;
	htp.p('</center>');
end;

procedure to_archival_action(uid varchar2,doc_id varchar2) is

pp varchar2(10);

begin
	if (not validation(uid,ADMIN,write_no,read_no,usrgrp_no,s_role)) then
		return;
	end if;

	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr>');
	pp := replace(doc_id,'~',' ');
	update docs set type=3 where id=pp;
	update texts set type=3 where id=pp;
	commit;
	htp.p('The WSMS document ('||htf.bold(pp)||') has been sucessfully moved to the archival area.');
	all_prod(uid,0);
end;

procedure to_production(uid varchar2) is

begin
	if (not validation(uid,REVIEWER,write_no,read_no,usrgrp_no,s_role)) then
		htp.p('Sorry, you have no privilege to review docuemnt!');
		return;
	end if;
	if (write_no = 0) then
		htp.p('There is no document that you can move!');
		return;
	end if;
	htp.p('Choose a document to move from the following list');
	all_prototype(uid,write_no);
end;

procedure all_prototype(uid varchar2, w_grp integer) is

cursor cdoc(w_no integer) is 
	select * from docs where group_no=w_no
	and type=1
	order by id desc;
cursor alldoc is
	select * from docs where type=1
	order by id desc;

end_num integer;
h_count integer;

doc_ldate date;

num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

gid varchar2(50);

begin
	if ((w_grp = 0) or (not validation(uid, REVIEWER,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<hr>');
	if (w_grp = 3) then
		select count(*) into total from docs where type=1;
	else
		select count(*) into total from docs where group_no=w_grp
			and type=1;
	end if;
	next := 11;
	
	if (total > 0 ) then
		get_realid(uid,gid);
	    	next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
		else
                    curr_str := total;
		end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
                	htp.p(' <b>|</b> <td align=right>');
			htp.p(url(cgi_bin||'wsms1.more_prototype?op=0'||
				'&tot='||total||'&seed='||next||'&w_grp='||
				w_grp||'&me='||uid,'Next '||next_str));
		end if;
		if (prev_str IS NOT NULL) then
                	htp.p(' <b>|</b><td align=right>');
			htp.p(url(cgi_bin||'wsms1.more_prototype?op=0'||
				'&tot='||total||'&seed='||prev||'&w_grp='||
				w_grp||'&me='||uid,'Prev '||prev_str));
		end if;
	   	htp.p('</table></center><dl>');

		htp.p('<center><table border=1 align=center>');
		htp.p('<tr>'||th('Click ID<br>To Move')||th('Author')||
			th('Click Title<br> To Review')||
			th('Doc_Group')||th('Last_update'));
		if (w_grp = 3) then
			open alldoc;
		else
			open cdoc(w_grp);
		end if;
		h_count := 0;
		for i in 1 .. 10 loop
			h_count := h_count + 1;
			if (w_grp = 3) then
				fetch alldoc into doc;
				exit when alldoc%NOTFOUND;
			else
				fetch cdoc into doc;
				exit when cdoc%NOTFOUND;
			end if;
			flag := 0;
			if (wsms1.to_url(uid,doc.path,real_url)) then
				flag := 1;
			end if;

--			htp.p('<tr>'||td(url(real_cgi||'doc_view?uid='||gid||'&doc_id='||doc.id,doc.id)));
			htp.p('<tr>'||td(url(cgi_bin||'wsms1.move_action?op=2&uid='||uid||'&doc_id='||doc.id,'WSMS '||doc.id)));
			htp.p(td(doc.author));
			if (flag=1) then
			   htp.p(td(wsms1.url_right1(real_url,doc.title)));
			else
			   htp.p(td(doc.title));
			end if;
			
			htp.p(td(doc.group_name));
			select ldate into doc_ldate from texts
				where id=doc.id;
			htp.p(td(to_char(doc_ldate,'mm/dd/yyyy')));
			htp.p('</tr>');
		end loop;
		if (w_grp = 3) then
			close alldoc;
		else
			close cdoc;
		end if;
		
	htp.p('</table>');
		htp.p('<img src="'||wsms_server||'/wavy.gif">');
		htp.p('<br>');
		htp.p('<center>');
	   	htp.p(' p.');
       		n := ceil(total/10);
           	if (n > 20) then n := 20; end if;
	   	for i in 1..n loop
		  iseed := (i-1)*10 + 1;
		  if (iseed = 0 ) then
			htp.p(' '||i);
		  else
			htp.p(' '||url(cgi_bin||'wsms1.more_prototype?op=0'||
				'&tot='||total||'&seed='||iseed||'&w_grp='
				||w_grp||'&me='||uid,i));
		  end if;
	    	end loop;
	    	if (next_str IS NOT NULL) then
		   htp.p('['||url(cgi_bin||'wsms1.more_prototype?op=0'||
			'&tot='||total||'&seed='||next||'&w_grp='||w_grp||
			'&me='||uid,'Next')||']');
	     	end if;
	     	htp.p('</center>');
	else
		htp.p('No WSMS document for you to review!');
	end if;
end;

procedure more_prototype(op integer,tot number, seed integer,w_grp integer, 
			me varchar2) is
cursor cdoc(w_no integer) is 
	select * from docs where group_no=w_no
	and type=1
	order by id desc;
cursor alldoc is
	select * from docs where type=1
	order by id desc;

end_num integer;
h_count integer;
doc_ldate date;

num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

gid varchar2(50);

begin
	if ((w_grp = 0) or (not validation(me, REVIEWER,write_no,read_no,usrgrp_no,s_role))) then
		return;
	end if;
	htp.p('<body background="'||wsms_server||'/balloons.gif">');
	htp.p('<center>Choose a document to move from the following list:<p></center>');
	htp.p('<hr>');
	total := tot;
	next := seed + 10;
	if ( next<=total) then
		if ((next+10)<=total) then
			next_str := (next+9);
		else
			next_str := total;
		end if;
		next_str := next||'-'||next_str;
		curr_str := next - 1;
	else
		curr_str := total;
	end if;
	prev := seed - 10;
	if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
	elsif (seed > 1) then
		prev := 1;
		prev_str := '1-'|| 10;
	end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(url(cgi_bin||'wsms1.more_prototype?op='||op||
			'&tot='||tot||'&seed='||next||'&w_grp='||w_grp
			||'&me='||me,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(url(cgi_bin||'wsms1.more_prototype?op='||op||
			'&tot='||tot||'&seed='||prev||'&w_grp='||w_grp
			||'&me='||me,'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
	
	htp.p('<center><table border=1 align=center>');
	htp.p('<tr>'||th('Click ID<br> To Move')||th('Author')||
			th('Click Title<br> To Review')||
			th('Group')||th('Last_update'));
	if (w_grp = 3) then
		open alldoc;
	else
		open cdoc(w_grp);
	end if;
	get_realid(me,gid);
	h_count := 0;
	loop
		h_count := h_count + 1;
		if (w_grp = 3) then
			fetch alldoc into doc;
			exit when alldoc%NOTFOUND;
		else
			fetch cdoc into doc;
			exit when cdoc%NOTFOUND;
		end if;
		flag := 0;
		if (wsms1.to_url(me,doc.path,real_url)) then
			flag := 1;
		end if;
		if (h_count >= seed) then
--			htp.p('<tr>'||td(url(real_cgi||'doc_view?uid='||gid||'&doc_id='||doc.id,doc.id)));
			htp.p('<tr>'||td(url(cgi_bin||'wsms1.move_action?op=2&uid='||uid||'&doc_id='||doc.id,doc.id)));
			htp.p(td(doc.author));
			if (flag=1) then
			   htp.p(td(wsms1.url_right1(real_url,doc.title)));
			else
			   htp.p(td(doc.title));
			end if;
			htp.p(td(doc.group_name));
			select ldate into doc_ldate from texts
				where id=doc.id;
			htp.p(td(to_char(doc_ldate,'mm/dd/yyyy')));
			htp.p('</tr>');
		end if;
		if (h_count >= (seed + 10)) then
		   exit;
		end if;
	end loop;
	if (w_grp = 3) then
		close alldoc;
	else
		close cdoc;
	end if;
	htp.p('</table>');
	htp.p('<img src="'||wsms_server||'/wavy.gif">');
	htp.p('<br>');
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
		iseed := (i-1)*10 + 1;
		if (iseed = 0 ) then
			htp.p(' '||i);
		else
			htp.p(' '||url(cgi_bin||'wsms1.more_prototype?op='||
				op||'&tot='||total||'&seed='||iseed||'&w_grp='
				||w_grp||'&me='||me,i));
		end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||url(cgi_bin||'wsms1.more_prototype?op='||op||
			'&tot='||total||'&seed='||next||'&w_grp='||w_grp||
			'&me='||me,'Next')||']');
	end if;
	htp.p('</center>');
end;

procedure move_action(op integer,uid varchar2,doc_id number) is

realid varchar2(50);

begin
	
	if (op=2) then
 	   if (not validation(uid, REVIEWER,write_no,read_no,usrgrp_no,s_role)) then
		return;
	   end if;
	elsif (op=3) then
	   if (not validation(uid,ADMIN,write_no,read_no,usrgrp_no,s_role)) then
		return;
	   end if;
	end if;
	get_realid(uid,realid);
	update docs set type=op, reviewer=realid,reviewdate=sysdate where id=doc_id;
	update texts set type=op where id=doc_id;
	commit;
	if (op=2) then
		htp.p('The docuemnt WSMS '||doc_id||' has been move to production area!');
		all_prototype(uid,write_no);
	elsif (op=3) then
		htp.p('The docuemnt WSMS '||doc_id||' has been move to archival area!');
		all_prod(uid,0);
	end if;

end;

procedure change_passwd(uid varchar2) is

gid varchar2(50);

begin
	get_realid(uid,gid);
	if (validation(uid,READER,write_no,read_no,usrgrp_no,s_role)) then
		htp.p('<body background="'||wsms_server||'/balloons.gif">');
		htp.p('<hr>');
		select * into one from users where userid = gid;
		htp.p('<form action="'||cgi_bin||'wsms1.passwd_action1" method=POST');
		htp.p('<center><table border=1>');
	  	htp.p('<caption>Change your password</caption>');
		htp.p(tr(td('User Id: ')||td(one.userid)));
		htp.p(tr(td('Name: ')||td(one.name)));
		htp.p(tr(td('Old Password: ')||td('<input type="password" name="old" value="">')));
		htp.p(tr(td('New Password: ')||td('<input type="password" name="p1" value="">')));
		htp.p(tr(td('New Password Again: ')||td('<input type="password" name="p2" value="">')));
	--	htp.p(tr(td('Confirm Your Userid: ')||td('<input type="password" name="p2" value="">')));
		htp.p('</table>');
		htp.p('<input type="hidden" name="uid" value="'||uid||'">');
		htp.p(formdo('Submit')); 
		htp.p('</center></form>');
	end if;
end;

procedure passwd_action1(old varchar2,p1 varchar2,p2 varchar2,uid varchar2) is

gid varchar2(50);

begin
	get_realid(uid,gid);
	if (validation(uid,READER,write_no,read_no,usrgrp_no,s_role)) then
		select * into one from users where userid = gid;
		if (one.password != old or (p1!=p2)) then
			htp.p('Wrong password. Try again.<hr>');
			change_passwd(uid);
			return;
		end if;
		htp.p('<body background="'||wsms_server||'/balloons.gif">');
		htp.p('<hr>');
		update users set password=p1 where userid = gid;
		commit;
		htp.p('Your password has been changed.<hr>');
	end if;
end;

end wsms1;
/
show errors;
/
